/*							*
 *	^P & ^N disable/enable utility			*
 *							*/
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<dos.h>

static char	*version = "@(#) * ctrlp.c: $Revision: 0.2 $";
/********
	static char vdate[] = "$Date: 1997/02/06 23:50:00 $";
	static char vauther[] = "$Author: kohno $";
	static char vstate[] = "$State: Exp $";
 ********/

#define	strtolower(s)	strlwr(s)
#ifdef MSC51
#define FAR_PTR(s,f) (void far *)(((unsigned long)(s) << 16) | (unsigned)(f))
#else
#define FAR_PTR(s,f)	MK_FP(s,f)
#endif

/* Prototype declaration */
extern char	*cmdname(char *path);

static unsigned char	DOS5;
static unsigned int	DOS5dx;

static void check_dos5(void)
{
	union REGS	regs;
	regs.x.ax = 0x3306;
	intdos(&regs, &regs);
	DOS5 = 0;
	if (regs.h.al != 0xFF) {
		DOS5 = 1;
		DOS5dx = regs.x.dx;
	}
}

#if 0
/***  maybe original data  ***/
static char	data[] = {
	0x3C, 0x10,		/* CMP AL,10 */
	0x74, 0,		/* JZ ? */
	0x3C, 0x0E,		/* CMP AL,0E */
	0x74			/* JZ ? */
};
/***  modified data (0x74 -> 0xA8)  ***/
static char	s_data[] = {
	0x3C, 0x10,		/* CMP AL,10 */
	0xA8, 0,		/* TEST ? */
	0x3C, 0x0E,		/* CMP AL,0E */
	0xA8			/* TEST ? */
};
#endif
#define	DATA_SIZE	(7)
/***  char-code  ***/
#define	ctrl_P	(0x10)
#define	ctrl_N	(0x0E)
/***  8086 op-code  ***/
#define	CMP_AL	(0x3C)		/* CMP AL,? */
#define	JZ	(0x74)		/* JZ ? */
#define	TEST_AL	(0xA8)		/* TEST ? */

static unsigned char	setup_Data;	/* DOS modify data : TEST_AL or JZ */

static int cmp_data(unsigned char far *pdos)
{
	int	ret = 0;
	if ((pdos[0] == CMP_AL) && (pdos[1] == ctrl_P)) {
		if ((pdos[2] == JZ) || (pdos[2] == TEST_AL)) {
		  /* found ^P */
			if (setup_Data)
				pdos[2] = setup_Data;
			ret = 1;		/* match OK */
		}
	}
	if (ret) {
		/***  check ^N  ***/
		if ((pdos[4] == CMP_AL) && (pdos[5] == ctrl_N)) {
			if ((pdos[6] == JZ) || (pdos[6] == TEST_AL)) {
			  /* found ^N */
				if (setup_Data)
					pdos[6] = setup_Data;
				ret = 2;		/* match OK */
			}
		}
	}
	if (ret) {
		printf(" * = %Fp %s\n", pdos,
			((ret==2)?"(full match)":"(^P only match)") );
	}
	return ret;
}

static int scan_data(unsigned char far *pdos, unsigned char far *to,
	unsigned char far **ad)
{
	for (; pdos < to; pdos++) {
		if (cmp_data(pdos)) {	/* found */
			*ad = pdos;
			return 1;
		}
	}
	return 0;
}

static int scan_dos(void)
{
	union REGS	regs;
	struct SREGS	sregs;
	unsigned char	far *pdos, far *ctrlp, far *to_ad;
	int	found_total;

	regs.h.ah = 0x52;	/* ϐ̈AhX̎擾 */
	intdosx(&regs, &regs, &sregs);
	pdos = FAR_PTR(0x60, 0);
	to_ad = pdos + 0xFFFF;
/*	to_ad = FAR_PTR(sregs.es, regs.x.bx);
*/
	printf("Scan range = 0060:0000 to %Fp\n", to_ad);
	found_total = 0;
	while (scan_data(pdos, to_ad, &ctrlp)) {
		pdos = ctrlp + DATA_SIZE;
		found_total++;
	}
	if (DOS5 == 0) {
		return found_total;
	}
	/***  if DOS5 then  ***/
	if (DOS5dx & 0x1000) {		/* if DOS in HMA */
		if (DOS5dx & 0x0800) {	/* HMA is ROM DOS */
			puts("ROM-DOS on HMA");
			return found_total;
		}
		puts("Scan range in HMA = FFFF:0010 to FFFF:FFEF");
		pdos = FAR_PTR(0xFFFF, 0x10);
		to_ad = pdos + 0xFFEF;
		while (scan_data(pdos, to_ad, &ctrlp)) {
			pdos = ctrlp + DATA_SIZE;
			found_total++;
		}
	}
	return found_total;
}

static void print_help(char *name)
{
	printf("Usage: %s  [-de]\n", strtolower(cmdname(name)));
	printf("\t\t\t\t\t%s\n", strchr(version, '#')+2);
	puts("    Optinos:\n"
		"\tNo-option : scan patch location in the DOS\n"
		"\t-d : disable ^P & ^N\n"
		"\t-e : enable ^P & ^N\n");
}

/***  Not used ...
extern int	optopt;
extern char	*optarg;
 ***/
extern int	opterr;
extern int	optind;
extern int	egetopt(int ac, char **av, char *opts);

int main(int argc, char **argv)
{
	char	setup = 0;		/* disable/enable */
	int	och;
	opterr = 0;		/* No mesg */
	/* check option */
	while (EOF != (och = egetopt(argc, argv, "dehH"))) {
		switch (och) {
		case 'd': case 'D':
			setup = 1;
			break;
		case 'e': case 'E':
			setup = 2;
			break;
		case 'h': case 'H':
		case '?':
			print_help(argv[0]);
			exit(0);
			break;
		default:
			print_help(argv[0]);
			exit(1);
			break;
		}
	}
	argv += optind, argc -= optind;

	if (setup == 1) {		/* DOS image modify to disable */
		setup_Data = TEST_AL;
	} else if (setup == 2) {	/* DOS image modify to enable */
		setup_Data = JZ;
	} else {
		setup_Data = 0;
	}
	check_dos5();
	if (scan_dos() == 0)
		puts("܂ł");
	return 0;
}
