/***
 ***	getopt() routine from UNIX-like-tools 3.04c
 ***/
#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <string.h>

#define	_puterrmes(s)		fputs((s), stderr)
#define	_puterrmes_cr(s)	(_puterrmes(s), putc('\n', stderr))

  /* Public domain getopt킸Ɋg */
/***
 ***	"opts" of egetopt(ac, av, opts) is ...
 ***
 ***	"a:" : available "-axyz" and "-a xyz".
 ***	"a;" : available "-axyz" only.
 ***/
int	opterr = 1;
int	optind = 1;
int	optopt;
char	*optarg;

static void err_getopt(char *cmd, char *as)
{
	static	char	msgtail[ ] = {0, 0};

	if(opterr){
		_puterrmes(cmd), _puterrmes(as),
		*msgtail = (char)optopt, _puterrmes_cr(msgtail);
	}
}

 /* ʂgetoptƂĎgꍇgetopt()ƂŁAgłƂĎgꍇ
    egetopt()ƂŎgBDOSłgetopt()egetopt()Ƀ}N`BDOS
    ȊOłegetopt()͂ꂩƓ̂̂NAgetopt()͏n
    ̂g */ /* od.cɂ̑ */
int	egetopt(int ac, char **av, char *opts)
{
	static	char	*curopt = NULL;
	register char	*cp;

	if(curopt == NULL || !*curopt){
		if(optind >= ac || *(curopt = av[optind]) != '-' || !*++curopt)
			return EOF;
		if(*curopt == '-' && !curopt[1])
			return (++optind, EOF);
	}
	if(':' == (optopt = *curopt++) || ';' == optopt ||
	   NULL == (cp = strchr(opts, optopt))){
		err_getopt(*av, ": unknown option, -");
		if(!*curopt) ++optind;
		return '?';
	}
	if(*++cp == ':' || *cp == ';' && *curopt){
		++optind;
		if(*curopt){
			optarg = curopt;
			curopt = NULL;
		} else {
			if(optind >= ac){
				err_getopt(*av, ": argument missing for -");
				return '?';
			} else {
				optarg = av[optind++];
			}
			 /* now *curopt == '\0' */
		}
	} else {
		optarg = NULL;
		if(!*curopt) ++optind;
	}
	return optopt;
}

#ifdef DEBUG
main(ac, av)
int	ac;
char	**av;
{
	int	c;

	opterr = 1;
	while(EOF != (c = egetopt(ac, av, "ab;cd:"))){
		printf("ret %c, optopt %c, optarg %s, optind %d\n", c,
			optopt, optarg == NULL ? "(NULL)" : optarg, optind);
	}
	for(ac -= optind, av += optind; ac; --ac, ++av)
		printf("arg: '%s'\n", *av);
	return 0;
}
#endif /* DEBUG */
