#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "tools.h"

#ifndef MSDOS
#  define kstrnicmp strncasecmp
#endif

char	*cmdname = "basename";

static	void	usage_exit()
{
	_puterrmes_cr("Usage: basename [-sLS] PATH [EXT]");
	_puterrmes_cr("       basename -fe [-DpdsLS] PATH [EXT]");
	_puterrmes_cr("       basename [-DpdfesLS] PATH");
	exit(1);
}

main(ac, av)
int	ac;
char	**av;
{
	char	*p, *q, *r, *arg;
	extern	int	optind, opterr;
	extern	char	*optarg;
	bool	driveout = 0, dirout = 0, baseout = 0, extout = 0;
	bool	elimsep = 0, anyout = 0, dotout;
#ifdef SUPP_LFN
	int	lfn_sfn_flg = 0;
#endif
	int	c;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	if(!strcmp("dirname", cmdname)) anyout = dirout = driveout = 1;
	else
	if(!strcmp("extname", cmdname)) anyout = extout = 1;

	opterr = 0;
	while(EOF != (c = getopt(ac, av, "DpdfesLS"))){
		cswitch(c){
		case 'D': driveout ^= 1; goto common;
		case 'd': driveout ^= 1; /* FALLTHROUGH */
		case 'p': dirout ^= 1; goto common;
		case 'f': baseout ^= 1; goto common;
		case 'e': extout ^= 1; /* goto common; */
		common: anyout = 1; break;
		case 's': elimsep ^= 1; break;
#ifdef SUPP_LFN
		case 'L': lfn_sfn_flg = 2; break;
		case 'S': lfn_sfn_flg = 1; break;
#else
		case 'L': case 'S': break;
#endif
		default: usage_exit();
		}
	}
	if(!anyout) baseout = extout = 1;
	switch(av += optind, ac -= optind){
	case 1:
		break;
	case 2:
		if(baseout && extout) break;
		 /* FALLTHROUGH */
	default:
		usage_exit();
	}

	arg = *av;
#ifdef SUPP_LFN
	switch(lfn_sfn_flg){
	case 1:
		arg = strtolower(sfn_lfn_conv(arg, 0)); break;
	case 2:
		arg = sfn_lfn_conv(arg, 1); break;
	} /* sfn_lfn_conv()͕ĂяoƑO̖߂l󂷂̂ŒӁB
	     {vOłsfn_lfn_conv()1xĂ΂Ȃ */
#endif

	r = last_pathsep(p = arg, &q);
	if(is_alpha(*p) && p[1] == DRIVE_SEP){
		if(driveout) putchar(*p), putchar(p[1]);
		p += 2;
	}

	if(dirout){
		dotout = 0;
		if(!(baseout || extout)){
			if(p < q){
				*q = '\0';
				 /* ĂBxȂ͂ */
				r = last_pathsep(arg, NULL);
				if(elimsep || p < r) q = r;
			} else {
				if(!ispathsep(*p)){
					dotout = 1;
				} else {
					if(!elimsep) q += strlen(q);
				}
			}
		} /* else p, q, r͏Ȃ */
		fwrite(p, 1, q - p, stdout);
		if(dotout) putchar('.');
	}

	if(baseout || extout){
		dotout = 0;
#ifndef GNULIKE
		if(q == r) r += strlen(r);
#endif
		if((p = q) < r) q = r; else if(!*p) dotout = 1;
		if(!(baseout && extout)){
			char	*lastdot = NULL;

#ifdef MSDOS
			for(r = p; *r == '.'; ++r);
#else
			r = p;
#endif
			for(; r < q; ++r) if(*r == '.') lastdot = r;
			 /* '.' can't be 2nd byte of kanji. '.' at the top of
			    string is not treated as benning of ext */
			if(extout){
				p = (lastdot == NULL) ? q : ++lastdot;
				dotout = 0;
			} else {
				if(lastdot != NULL) q = lastdot;
			}
		}/* Ȍdotout͏Ȃ */
		if(ac > 1){ /* then (baseout && extout) == 1 */
			char	*ext;
			int	extl;

			extl = strlen(ext = av[1]);
			for(r = p; r < q; ++r){
				if(r + extl > q) break;
				if(r + extl == q){
					if(p < r && !kstrnicmp(r, ext, extl))
						q = r;
					break;
				}
				if(iskanjipos(r)) ++r;
			}
		}
		fwrite(p, 1, q - p, stdout);
#ifndef GNULIKE
		if(dotout) putchar('.');
#endif
	}

	putchar('\n');
	return 0;
}
