#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <fcntl.h>
/* #include <dos.h> */
#include "tools.h"

char	*cmdname = "cat";

#define CBUFSIZ 16384

#ifdef MSDOS
#  define MSKCODEONLY
#  define RDMODE "rb"
#else
#  define RDMODE "r"
#endif

static	long	lineno = 0L;
static	bool	itxt = 0, otxt = 0, reversible = 0, sqz_empl = 0;
static	int	num = 0;
#define NUM_NORMAL 1
#define NUM_EACH   2
#define NUM_NBLANK 4
static	int	vis = 0;
#define VIS_NORMAL 1
#define VIS_TAB	   2
#define VIS_EOL	   4
#define VIS_KNJ	   8
#define VIS_KSPC  16
#define VIS_EXCR  32

static	int	lasteol = 1; /* Os̎1BAt@Cׂ̏ꍇ2 */
static	char	*readbuf = NULL, *outbuf = NULL, *nbuf;
static	int	r_o_bufsiz = CBUFSIZ;

#define EOLMARK '$'

#if defined(TOOLS) && defined(MSDOS)
static	kmode()
{
	static	int	kflag = -1;

	return kflag >= 0 ? kflag : (kflag = iskanji(0x81));
}
#else
#  define kmode() 1
#endif
#ifndef MSKCODEONLY
static	int	mskmode = 0;
#else
#  define mskmode 1
#endif

#define iseucj1(c) (0xa1 <= (c) && (c) <= 0xfe || (c) == 0x8e) /* SS3Ή */
#define iseucj2(c) (0xa1 <= (c) && (c) <= 0xfe)
#define ismsk1(c) (0x81 <= (c) && ((c) <= 0x9f || 0xe0 <= (c) && (c) <= 0xfc))
#define ismsk2(c) (0x40 <= (c) && (c) <= 0xfc && 0x7f != (c))
#define ismskana(c) (0xa1 <= (c) && (c) <= 0xdf)

#define isk1st(c) (kmode() && (mskmode ? ismsk1(c) : iseucj1(c)))
#define isk2nd(c) (mskmode ? ismsk2(c) : iseucj2(c)) /* used only if kmode() */
#define is1bkana(c) (kmode() && mskmode && ismskana(c))
#define KSPC (mskmode ? 0x8140 : 0xa1a1) /* used only if kmode() */

typedef struct {
	int	lb, ub;
} ranges;

#ifndef MSKCODEONLY
static	ranges eucjvalid_range[ ] = {
	{0, 0}, /* ԕ */

	{0x8ea1, 0x8edf}, /* X0201Ji */

	{0xa1a1, 0xa2ae}, /* @- */
	{0xa2ba, 0xa2c1}, /* - */
	{0xa2ca, 0xa2d0}, /* - */
	{0xa2dc, 0xa2ea}, /* - */
	{0xa2f2, 0xa2f9}, /* - */

	{0xa2fe, 0xa2fe}, /* - */
	{0xa3b0, 0xa3b9}, /* O-X */
	{0xa3c1, 0xa3da}, /* `-y */
	{0xa3e1, 0xa3fa}, /* - */
	{0xa4a1, 0xa4f3}, /* - */

	{0xa5a1, 0xa5f6}, /* @- */
	{0xa6a1, 0xa6b8}, /* - */
	{0xa6c1, 0xa6d8}, /* - */
	{0xa7a1, 0xa7c1}, /* @-` */
	{0xa7d1, 0xa7f1}, /* p- */

	{0xa8a1, 0xa8c0}, /* - */
	{0xb0a1, 0xcfd3}, /* -r */
	{0xd0a1, 0xf4a6}, /* - */
};
#endif
static	ranges mskvalid_range[ ] = {
	{0, 0}, /* ԕ */

	{0x8140, 0x81ac}, /* MSCODE @- */
	{0x81b8, 0x81bf}, /* MSCODE - */
	{0x81c8, 0x81ce}, /* MSCODE - */
	{0x81da, 0x81e8}, /* MSCODE - */
	{0x81f0, 0x81f7}, /* MSCODE - */

	{0x81fc, 0x81fc}, /* MSCODE - */
	{0x824f, 0x8258}, /* MSCODE O-X */
	{0x8260, 0x8279}, /* MSCODE `-y */
	{0x8281, 0x829a}, /* MSCODE - */
	{0x829f, 0x82f1}, /* MSCODE - */

	{0x8340, 0x8396}, /* MSCODE @- */
	{0x839f, 0x83b6}, /* MSCODE - */
	{0x83bf, 0x83d6}, /* MSCODE - */
	{0x8440, 0x8460}, /* MSCODE @-` */
	{0x8470, 0x8491}, /* MSCODE p- */

	{0x849f, 0x84be}, /* MSCODE - */
	{0x889f, 0x9872}, /* MSCODE -r */
	{0x989f, 0xeaa4}, /* MSCODE - */
}; /* JIS X0208-1990 */

#define num_of(a) (sizeof(a) / sizeof(*(a)))
#ifndef MSKCODEONLY
#  define kvalid_range (mskmode ? mskvalid_range : eucjvalid_range)
#  define kvalid_num (mskmode? num_of(mskvalid_range): num_of(eucjvalid_range))
#else
#  define kvalid_range mskvalid_range
#  define kvalid_num num_of(kvalid_range)
#endif

static	int	isjisvalid(c)
int	c;
{
	int	imin = 0, imax = kvalid_num, imid = imax >> 1;

	do {
		(c < kvalid_range[imid]. lb) ? (imax = imid) : (imin = imid);
	} while(imin != (imid = (imin + imax) >> 1));
	return (unsigned)c <= (unsigned)kvalid_range[imid] . ub;
}

static	void	nowrite(f) /* check not done when f is terminal */
FILE	*f;
{
	if(!isatty(fileno(f))) (_cmdputerrmes_cr("Write error"), exit(1));
}

static	void	usage()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
#ifndef MSKCODEONLY
	_puterrmes_cr(" [-veaMSRnNbtTsgr] [FILE...]");
#else
	_puterrmes_cr(" [-veaSRnNbtTsgr] [FILE...]");
#endif
	exit(1);
}

#ifdef MSDOS
static	void	knjmod()
{
	FILE	*con;

	if(NULL == (con = fopen("con", "w"))){
		_cmdputerrmes_cr("? knjmod() error");
		exit(1);
	}
	fputs("\033)0", con);
	fclose(con);
}

static	void	knjmod_exit()
{
	knjmod(); exit(1);
}

static	void	grphmod()
{
	static	int	done = 0;
	FILE	*con;

	if(!done){
		done = 1;
		if(SIG_IGN != signal(SIGINT, SIG_IGN))
			signal(SIGINT, knjmod_exit);
		if(NULL == (con = fopen("con", "w")) || 0 != atexit(knjmod)){
			_cmdputerrmes_cr("? grphmod() error");
			exit(1);
		}
		fputs("\033)3", con);
		fclose(con);
	}
}
#endif

static	void	longintout(w, n)
int	w;
unsigned long	n;
{
	if(n >= 10) longintout(--w, n / 10); else while(--w > 0) putchar(' ');
	putchar((int)(n % 10) + '0');
}

static	void	buferr()
{
	_cmdputerrmes_cr("Can't setvbuf()"), exit(1);
}

#ifdef MSDOS
#  define is_eolmark(c) ((c) == '\n' || (c) == '\r')
#else
#  define is_eolmark(c) ((c) == '\n')
#endif
#define is_sptab(c) ((c) == ' ' || (c) == '\t')

static	void	pass_eols(f)
FILE	*f;
{
	int	c;

	while(c = getc(f), is_eolmark(c));
	if(c != EOF) ungetc(c, f);
}

static	void	outr(f) /* -rIvVoutv()ɂe */
FILE	*f;
{
	register int	c;

	for(;;){
		if(num & NUM_NORMAL){
			while(c = getc(f), is_sptab(c));
			if(c == EOF) return; else ungetc(c, f);
			while(c = getc(f), is_digit(c));
			if(c == EOF) return; else ungetc(c, f);
			c = getc(f);
			if(c == EOF) return; else if(!is_sptab(c))ungetc(c, f);
			   /* cat -vrbɑ΂Ăőv */
		}
		for(;;){
			switch(c = getc(f)){
			case '\\':
				if('M' != (c = getc(f))) goto norm_out;
				switch(c = getc(f)){
				case '-':
					c = getc(f);
#if 0 /* \M-^\ȂȂ邽߂̓ስ͂ */
					if('^' != c) goto meta_out;
					/* through */
#else
					goto meta_out;
#endif
				case '^':
					if('?' == (c = getc(f))) c = 0x7f;
					  else c &= 0x1f;
					/* through */
				default:
				meta_out:
					c |= 0x80;
					goto norm_out;
				}
				break;
			case '\n':
				putchar(c);
				goto cont;
			case '^':
				if('?' == (c = getc(f))) c = 0x7f;
				  else c &= 0x1f;
				goto norm_out;
			case EOLMARK:
				if(vis & VIS_EOL){
					int	d;

					switch(d = getc(f)){
					case '\n':
						c = d; break;
					case EOF:
						break;
					default:
						ungetc(d, f);
					}
				}
				goto norm_out;
			case EOF:
				return;
			default:
				if(isk1st(c)){
					putchar(c);
					c = getc(f);
				}
			norm_out:
				putchar(c);
				break;
			}
		}
	cont:	;
	}
}

static	int	when_lasteol(c, f) /* Os̏ꍇ̋ʏ */
int	c;
FILE	*f;
{
	if(is_eolmark(c)){
		if(sqz_empl){
			pass_eols(f);
			if(c == '\r') (putchar(c), c = '\n');
		}
		if(num & NUM_NBLANK) return c;
	}

	if(num & NUM_NORMAL){
		longintout(6, ++lineno), putchar('\t');
		 /* sԍ̌̋󔒂1oCgł邱Ƃ
		    cat -vrnɑ΂tϊ̎OɂĂ */
	}
	return c;
}

static	void	outv(f)
FILE	*f;
{
	register int	c, d;

	if(sqz_empl && lasteol > 1) pass_eols(f);
	while(EOF != (c = getc(f))){
		if(lasteol){
			c = when_lasteol(c, f);
			lasteol = (sqz_empl && feof(f));
			 /* ꂪ1̏ꍇA\no͎lasteol2ɂȂ
			    ̏Ԃwhile𔲂 */
		}

		if(is_print(c)){ /* ' '`'~' */
			if(reversible && (c == '\\' || c == '^'))
				putchar('\\');
			goto out1b;
		} else
		if(isk1st(c)){
			if((vis & VIS_KNJ) || EOF == (d = getc(f))){
				goto outmeta;
			} else if(!isk2nd(d) || !isjisvalid((c << 8) | d)){
			nonk:
				ungetc(d, f); goto outmeta;
			} else if((vis & VIS_KSPC) && KSPC == ((c << 8) | d)){
#ifndef MSKCODEONLY
				if(!mskmode){
					fputs(reversible ?
					    "\\M-!\\M-!" : "M-!M-!", stdout);
					continue;
				}
#endif
				goto nonk; /* d'@'Ȃ̂łł */
			} else {
				goto out2b;
			}
		} else
		if(c == '\t'){
			if(vis & VIS_TAB) goto outctrl;
			goto out1b;
		} else
		if(c == '\r'){
			if(vis & VIS_EXCR) goto out1b;
			goto outctrl;
		} else
		if(c == '\n'){
			if(vis & VIS_EOL) putchar(EOLMARK);
			++lasteol;
			goto out1b;
		} else
		if(isascii(c)){ /* printableȊO */
			goto outctrl;
		} else
		if(is1bkana(c)){
			if(vis & VIS_KNJ) goto outmeta;
			goto out1b;
		} else {
		outmeta:
			c = toascii(c);
			if(reversible){
				fputs("\\M", stdout);
				if(is_print(c)){
					putchar('-'); goto out1b;
				}
			} else {
				fputs("M-", stdout);
				if(is_print(c)) goto out1b;
			}
		outctrl:
			d = toascii('@' + c), c = '^';
		out2b:
			putchar(c), c = d;
		out1b:
			putchar(c);
		}
	}
}

static	void	outn(f)
 /* -nIvVoutv(), outr()ɂe -sIvVoutv()ɂe */
FILE	*f;
{
	register int	c;

	if(sqz_empl && lasteol > 1) pass_eols(f);
	while(EOF != (c = getc(f))){
		if(lasteol){
			c = when_lasteol(c, f);
			lasteol = (sqz_empl && feof(f));
		}

		putchar(c);
		if(c == '\n') ++lasteol;
	}
}

static	void	outc(f)
FILE	*f;
{
	register int	i;
	 /* int lasteol isn't used in this case */

	while(0 < (i = fread(nbuf, 1, BUFSIZ, f))) fwrite(nbuf, 1, i, stdout);
	 /* f͑Sǂݐ؂ */
}

static	void	out(f)
FILE	*f; /* f͂̊֐őSǂݐ؂ */
{
	if(num & NUM_EACH){
		lineno = 0L;
		if(!lasteol){
#ifdef MSDOS
			if(!itxt) putchar('\r');
			 /* s̓͂V~[gB!itxt̏ꍇCR₤ */
#endif
			putchar('\n');
			++lasteol;
		}
	}
	if(readbuf != NULL && 0 != setfbuf(f, readbuf, r_o_bufsiz)){
		buferr();
	}
	((vis & VIS_NORMAL) ? outv :
	  reversible ? outr :
	  sqz_empl || (num & NUM_NORMAL) ? outn : outc)(f);
}

#ifndef MSDOS
void	nomem_exit()
{
	_putnomemmes(), exit(1);
}

void	*chk_realloc(p, i)
void	*p;
unsigned int	i;
{
	if(NULL == (p = re_alloc(p, i))) nomem_exit();
	return p;
}
#endif

main(ac, av)
int	ac;
char	*av[];
{
	int	c, status = 0;
	FILE	*f;
	extern	int	optind, opterr;
	extern	char	*optarg;
	bool	t_opt = 0;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	opterr = 0;

	while(EOF != (c = getopt(ac, av, "veaMSRnNbtTsgr"))){
		cswitch(c){
		case 'v':
			vis |= VIS_NORMAL; break;
		case 'e':
			vis |= VIS_EOL; break;
		case 'a':
			vis |= VIS_KNJ; break;
#ifndef MSKCODEONLY
		case 'M':
			mskmode = 1; break;
#endif
		case 'S':
			vis |= VIS_KSPC; break;
		case 'R':
			vis |= VIS_EXCR; break;
		case 'n':
			num = NUM_NORMAL; break;
		case 'N':
			num |= (NUM_NORMAL | NUM_EACH); break; /* -bƋ */
		case 'b':
			num |= (NUM_NORMAL | NUM_NBLANK); break;
		case 't':
			t_opt = 1; break; /* -v̗LňӖႤ */
		case 'T':
			itxt = 1; break;
		case 's':
			sqz_empl = 1; break;
		case 'g':
#ifdef MSDOS
			grphmod();
#endif
			break;
		case 'r':
			reversible = 1; break;
		default:
			usage();
		}
	}
	av += optind, ac -= optind;

	if(vis & VIS_NORMAL){
		if(t_opt) vis |= VIS_TAB;
		if(!(vis & VIS_EXCR)) otxt = 1;
	} else {
		if(t_opt) otxt = itxt = 1;
		if(!(vis & VIS_EXCR)) itxt |= reversible;
	}
	itxt ? fsettext(stdin) : fsetbin(stdin);
	otxt ? fsettext(stdout) : fsetbin(stdout);

	nbuf = chk_malloc(BUFSIZ); /* used only in outc() */
	if(NULL != (readbuf = malloc(r_o_bufsiz)) ||
	   NULL != (readbuf = malloc(r_o_bufsiz >>= 1))){
		if(NULL == (outbuf = malloc(r_o_bufsiz))){
			outbuf = readbuf + (r_o_bufsiz >>= 1);
		} /* outbuf != NULL */
		if(0 != setfbuf(stdout, outbuf, r_o_bufsiz)) buferr();
	}

	if(ac){
		char	*p;

		for(; p = *av, ac; --ac, ++av){
			if(*p == '-' && !p[1]){
				out(stdin);
				clearerr(stdin);
			} else {
				if(NULL == (f = fopen(p, itxt? "r" : RDMODE))){
					_cmdputerrmes(conv_to_unix_format(p));
					 /* xȂ͂ */
					_puterrmes_cr(": Can't open");
					status = 1;
				} else {
					out(f);
					fclose(f);
				}
			}
		}
	} else {
		out(stdin);
	}
	if(0 != fclose(stdout)) nowrite(stdout);
	return status;
}
