/* Usage: cdate [-n] [[[[mm]dd]hh]mm[[.ss][yy]] [+format] */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#ifndef UX_COMPILE_TEST
#  include <dos.h>
#else
#  include <time.h>
#endif
#include "tools.h"

char	*cmdname = "cdate";

static	char	*monthname[] = {
	NULL,
	"January",	"February",	"March",
	"April",	"May",		"June",
	"July",		"August",	"September",
	"October",	"November",	"December",
};

static	char	*dofwkname[] = {
	"Sunday",	"Monday",	"Tuesday",	"Wednesday",
	"Thursday",	"Friday",	"Saturday",
};

#ifdef MSDOS
void	expand_hook()
 /* {vO͈WJE{̂ƂLFÑT|[g͕sv */
{
}
#endif

static	void	help_exit()
{
	_puterrmes("Usage: "), _puterrmes(cmdname), _puterrmes_cr(
		" [-n] [-e escchar] [[[[mm]dd]hh]mm[[.ss][yy]] [+format]"),
	exit(1);
}

static	void	badfmt()
{
	_cmdputerrmes_cr("Bad format character"), exit(1);
}

static	void	illdate()
{
	_cmdputerrmes_cr("Bad conversion"), exit(1);
}

static	void	cant()
{
	_cmdputerrmes_cr("Can't set date."), exit(1);
}

static	void	illesc()
{
	_cmdputerrmes_cr("Escape char must be single-byte."), exit(1);
}

static	void	chkdatearg(s, l1p, dsp, l2p)
char	*s, **dsp;
int	*l1p, *l2p;
{
	char	*p;

	for(p = s; *p && *p != '.'; ++p) if(!is_digit(*p)) illdate();
	*l1p = p - s;
	if(*p){
		for(*dsp = s = ++p; *p; ++p) if(!is_digit(*p)) illdate();
		*l2p = p - s;
	} else {
		*l2p = 0, *dsp = NULL;
	}
}

#undef ctoi
#define ctoi(c) ((c) - '0') /* cłƂ킩Ă鎞 */

static	scan2int(s)
char	*s; /* sȍ~2݂̂Ƃ킩Ă鎞 */
{
	return ctoi(*s) * 10 + ctoi(s[1]);
}

#ifdef UX_COMPILE_TEST
union REGS {
	struct XREGS {
		unsigned short	ax, bx, cx, dx;
	} x;
	struct HREGS {
		unsigned char	al, ah, bl, bh, cl, ch, dl, dh;
	} h;
};
#  define intdos(x, y) 0
#endif

static	void	strout(s, n)
char	*s;
int	n; /* ɂΗ]ȋ󔒂oȂ */
{
	for(; n && *s; --n, ++s) putchar(*s);
	for(; n > 0; --n) putchar(' ');
}

static	void	intoutz(i, n)
int	i, n; /* n>0̂ */
{
	if(--n) intoutz(i / 10, n);
	putchar(i % 10 + '0');
}

static	void	intout(i, n)
int	i, n; /* n>0̂ */
{
	if(--n){
		if(i >= 10) intout(i / 10, n);
		 else for(; n; --n) putchar(' ');
	}
	putchar(i % 10 + '0');
}

#define Disptime(fmt, y, m, d, h, mi, s, w, tz) \
	disptime(fmt, y, m, d, h, mi, s, w, tz, '%')

static	void	disptime(fmt, y, m, d, h, mi, s, w, tz, esc_char)
char	*fmt;
int	y, m, d, h, mi, s, w;
char	*tz, esc_char;
{
	if(fmt == NULL){
		Disptime("+%C", y, m, d, h, mi, s, w, tz);
		return;
	}
	if(*fmt++ != '+') badfmt();

	for(; *fmt; ++fmt){
		if(*fmt != esc_char){
			putchar(*fmt);
			if(iskanjipos(fmt)) putchar(*++fmt);
			continue;
		}
		if(*++fmt == esc_char){
			putchar(esc_char);
		} else switch(*fmt){
		case 'n': putchar('\n'); break;
		case 't': putchar('\t'); break;
		case 'A': strout(dofwkname[w], -1); break;
		case 'B': strout(monthname[m], -1); break;
		case 'C': Disptime("+%a %b %e %T %Z %Y",
				y, m, d, h,mi, s, w, tz); break;
		case 'D':
		case 'x': Disptime("+%m/%d/%y",	y, m, d, 0, 0, 0, 0, NULL);
			  break;
		case 'H': intoutz(h, 2); break;
		case 'I': intoutz((h + 11) % 12 + 1, 2); break;
		case 'M': intoutz(mi, 2); break;
		case 'R': Disptime("+%H:%M", 0, 0, 0, h,mi, 0, 0, NULL); break;
		case 'S': intoutz(s, 2); break;
		case 'T':
		case 'X': Disptime("+%H:%M:%S",	0, 0, 0, h,mi, s, 0, NULL);
			  break;
		case 'U': intoutz((int)(caldate(y, m, d) / 7 -
					caldate(y - 1, 12, 31) / 7), 2); break;
#if 0
		case 'V': /* ܂ */ break;
#endif
		case 'W': intoutz((int)(caldate(y, m, d - 1) / 7 -
					caldate(y - 1, 12, 30) / 7), 2); break;
		case 'Y': intoutz(y, 4); break;
		case 'Z': strout(tz, 3); break;
		case 'a': strout(dofwkname[w], 3); break;
		case 'b':
		case 'h': strout(monthname[m], 3); break;
		case 'c': Disptime("+%a %b %e %T %Y", y,m,d, h,mi,s, w, NULL);
			  break;
		case 'd': intoutz(d, 2); break;
		case 'e': intout(d, 2); break;
		case 'j': intoutz((int)(caldate(y, m, d)-caldate(y, 1, 0)), 3);
			  break;
		case 'k': intout(h, 2); break;
		case 'l': intout((h + 11) % 12 + 1, 2); break;
		case 'm': intoutz(m, 2); break;
		case 'p': strout(h < 12 ? "AM" : "PM", -1); break;
		case 'r': Disptime("+%I:%M:%S %p", 0, 0, 0, h,mi, s, 0, NULL);
			  break;
		case 'u': intoutz(w + 1, 1); break;
		case 'w': intoutz(w, 1); break;
		case 'y': intoutz(y % 100, 2); break;
		default:
			badfmt();
		}
	}
}

static	void	mod_disp_time(newt, fmt, omit_cr, esc_char)
char	*newt, *fmt;
bool	omit_cr;
char	esc_char;
{
	int	y, m, d, w, h, mi, s;
	union	REGS	in, out1, out2;
	char	*tz;

	for(d = 0; ; ){
		in . h . ah = 0x2a;
		intdos(&in, &out1);
		if(d == out1 . h . dl) break;
		d = out1 . h . dl;
		in . h . ah = 0x2c;
		intdos(&in, &out2);
	} /* dout1 . h . dlƓ */

	y = out1 . x . cx, m = out1 . h . dh; /* d = out1 . h . dl; */
	h = out2 . h . ch, mi= out2 . h . cl, s = out2 . h . dh;
	w = out1 . h . al;

	if(newt != NULL){
		int	l1, l2;
		us_long	ymd;
		char	*auxarg;

		s = 0;
		chkdatearg(newt, &l1, &auxarg, &l2);
		switch(l1){
		case 12:
			s = scan2int(newt + 8);
			/* through */
		case 10:
			y = -scan2int(newt + l1 - 2);
			/* through */
		case 8:
			m = scan2int(newt), newt += 2;
			/* through */
		case 6:
			d = scan2int(newt), newt += 2;
			/* through */
		case 4:
			h = scan2int(newt), newt += 2;
			/* through */
		case 2:
			mi= scan2int(newt);
			break;
		default:
			illdate();
		}

		if(auxarg != NULL){
			if(l1 > 8) illdate();

			switch(l2){
			case 4:
				y = -scan2int(auxarg + 2);
				/* through */
			case 2:
				s = scan2int(auxarg);
				break;
			default:
				illdate();
			}
		}

		if(y <= 0) out1 . x . cx = y = (y <= -80 ? 1900 : 2000) - y;
		w = (int)((ymd = caldate(y, m, d)) % 7);
		out1 . h . dh = (us_char)m, out1 . h . dl = (us_char)d;
		out2 . h . ch = (us_char)h, out2 . h . cl = (us_char)mi;
		out2 . h . dh = (us_char)s, out2 . h . dl = 0;

		if(!(1 <= m && m <= 12 &&
		     1 <= d && ymd < caldate(y, m + 1, 1) &&
					/* caldate13 */
		     0 <= h && h < 24 &&
		     0 <= mi && mi < 60 &&
		     0 <= s && s < 60)) illdate();

		out2 . h . ah = 0x2d;
		intdos(&out2, &in);
		if(in . h . al) cant();
		out1 . h . ah = 0x2b;
		intdos(&out1, &in);
		if(in . h . al) cant();
	}

	if(NULL == (tz = getenv("TZ"))) tz = "GMT";
#ifdef UX_COMPILE_TEST
	{
		char	buf[100];
		struct	tm	tt;

		tt . tm_sec = s;
		tt . tm_min = mi;
		tt . tm_hour = h;
		tt . tm_mday = d;
		tt . tm_mon = m - 1;
		tt . tm_year = y - 1900;
		tt . tm_wday = w;
		tt . tm_yday = caldate(y, m, d) - caldate(y, 1, 1);
		tt . tm_isdst = 0;
		strftime(buf, 100, fmt + 1, &tt);
		printf("%s\n", buf);
	}
#endif
	disptime(fmt, y, m, d, h, mi, s, w, tz, esc_char);
	if(!omit_cr) putchar('\n');
}

main(ac, av)
int	ac;
char	*av[];
{
	int	c;
	bool	omit_cr = 0;
	char	esc_char = '%';
	extern	int	optind, opterr;
	extern	char	*optarg;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg_tiny(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	opterr = 0;
	while(EOF != (c = getopt(ac, av, "ne:"))){
		cswitch(c){
		case 'e':
			if(!(esc_char = *optarg) || optarg[1]) illesc();
			break;
		case 'n':
			omit_cr = 1; break;
		default:
			help_exit();
		}
	}
	ac -= optind, av += optind;

	switch(ac){
	case 2:
		mod_disp_time(av[0], av[1], omit_cr, esc_char); break;
	case 1:
		if(*av[0] != '+'){
			mod_disp_time(av[0], NULL, omit_cr, esc_char);
		} else {
			mod_disp_time(NULL, av[0], omit_cr, esc_char);
		}
		break;
	case 0:
		mod_disp_time(NULL, NULL, omit_cr, esc_char); break;
	default:
		help_exit();
	}
	return 0;
}
