#include <stdio.h>
#include <ctype.h>
#include <dos.h>
#if defined(__WATCOMC__) || defined(MSC51)
#  include <direct.h>
#endif
#include <string.h>
#include "tools.h"
#define DISP_FD 1 /* fd of stdout. should be 2(stderr)? */

char	*cmdname = "chd";

#define FATALEXIT 2
#ifdef MSDOS
void	expand_hook()
{
	_expand_abendcode = FATALEXIT;
	expand_hook_default();
}
#endif

static	void	writetext(fd, s)
register int	fd;
register char	*s;
 /* [o͗pBLSI_C̏ꍇAŌȊO'\n'ƂCRLFɂȂȂ */
{
	register int	l = strlen(s);

#ifdef LSI_C
	if(l-- && s[l] == '\n'){
		write(fd, s, l);
		write(fd, "\r\n", 2);
	} else {
		write(fd, s, ++l);
	}
#else
	write(fd, s, l);
#endif
}

static	chdir_drive(s)
 /* sconv_to_dos_regpathĂ(sς)Bs-1 */
char	*s;
{
	unsigned char	curdrv, newdrv;

	conv_to_dos_regpath(s); /* regularize */
	curdrv = getcurdrv();
	if(is_alpha(*s) && s[1] == ':'){
		newdrv = to_lower(*s) - 'a';
		if(curdrv != newdrv){
			setcurdrv(newdrv);
			if(getcurdrv() != newdrv) return -1;
		}
		if(!*(s += 2)) return 0;
	}

	if(!chdir(s)) return 0;
	if(curdrv != newdrv) setcurdrv(curdrv);
	return -1;
}

static	chdir_with_cdpath(s)
 /* s:ACDPATHɐ:0ACDPATHĐ:BsDOS`ɏς */
char	*s;
{
	char	*cdpath, *p, pathbuf[PATHNAMELENGTH];
	int	ls, lp;

	if(!chdir_drive(s)) return 0;
	if(is_ancestor_dir(s) || ispathsep(*s) || *s && s[1] == ':' ||
	   NULL == (cdpath = getenv("CDPATH"))) return -1;
	ls = strlen(s);
	while(*cdpath){
		p = pathbuf;
		while(*cdpath && *cdpath != ENVPATH_SEP) *p++ = *cdpath++;
		if(*cdpath) cdpath++; /* u;v΂BCDPATHu;vŏI
		  ꍇłA̗vf݂͍̑lȂĂ */
		*p = '\0';

		if(pathbuf != (p = expand_tilde(pathbuf))) strcpy(pathbuf, p);
		p = pathbuf + (lp = strlen(pathbuf));

		if(!lp || lp == 1 && ispathsep(*pathbuf) ||
		   lp == 2 && p[-1] == ':' ||
		   lp == 3 && p[-2] == ':' && ispathsep(p[-1])){
		 /* Eu\vEua:vEua:\v̏ꍇ́u\vtȂB
		   u\v̏ꍇɕtȂ̂́Aconv_to_dos_regpath擪
		   u\\v𐳋KȂdl̂ */
		} else {
			++lp, *p++ = PATH_SEP;
		}
		if(ls + lp >= PATHNAMELENGTH) continue; /* ߂ */

		strcpy(p, s);
		if(!chdir_drive(pathbuf)) return 1;
	}
	return -1;
}

static	void	nosuch(s)
char	*s;
{
	writetext(2, cmdname), writetext(2, ": ");
	conv_to_unix_format(s), writetext(2, s);
	writetext(2, ": No such directory\n"), exit(1);
}

static	int	get_drv_wd(buf)
char	*buf;
{
	*buf++ = (char)'a' + getcurdrv(), *buf++ = ':', *buf++ = '/';
	return get_wdir(0, buf, 1); /* 0 */
}

static	void	pwd(fd)
int	fd;
{
	char	cwdbuf[PATHNAMELENGTH];

	if(!get_drv_wd(cwdbuf)){
		writetext(fd, cwdbuf), writetext(fd, "\n");
	} else { /* Nʂ͂ */
		writetext(2, cmdname);
		writetext(2, ": Can't print cwd due to DOS bug.\n"), exit(1);
	}
}

static	isdir(fnm)
char	*fnm;
{
	struct	Find_t	f;

	return !find_Fixedfile(fnm, &f, 0) && ((char)f . attrib & _A_SUBDIR);
}

main(ac, av)
int	ac;
char	*av[];
{
	char	*p;
	int	retval, dirargpos, i;
	bool	cdonly = 0;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	while(++av, ac-- && !strcmp(*av, "-o")) cdonly = 1;

	switch(ac){
	case 1:
		p = *av;
		if(cdonly){ /* does not see CDPATH */
			if(0 != chdir(p)){
				nosuch(p);
			}
		} else {
			if(0 > (retval = chdir_with_cdpath(p))){
				nosuch(p);
			} else
			if(retval > 0){
				pwd(DISP_FD);
			}
		}
		break;
	case 0:
		if(!cdonly && NULL != (p = getenv("HOME"))){
			if(chdir_drive(p)) nosuch(p);
		}
		pwd(DISP_FD);
		break;

	default: /* does not see CDPATH */
		for(dirargpos = -1, i = 0; i < ac; i++){
			if(!isdir(av[i])) continue;
			if(dirargpos >= 0) goto ambiguous;
			dirargpos = i;
		}
		if(dirargpos < 0 || 0 != chdir_drive(av[dirargpos])){
		ambiguous:
			writetext(2, cmdname);
			writetext(2, ": Directory ambiguous\n");
			return FATALEXIT; /* exit from main() */
		} /* chdir0ԂƂ͂ȂƎvꉞ̏ꍇ
		     Directory ambiguousŏI */
		pwd(DISP_FD);
	}
	return 0;
}
