#include <stdio.h>
#include <ctype.h>
#include <dos.h>
#include <fcntl.h>
#include <stdlib.h>
#include "tools.h"

char	*cmdname = "chmod";

static	bool	nodisp = 0, noerrm = 0;

static	void	help_exit()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
	_puterrmes_cr(" [-fn] [ua]{-|=|+}{o|w|h|s|a} files..."), exit(1);
}

#ifdef MSDOS
void	expand_hook()
{
	_dosfind_param = 0x37;
	expand_hook_default();
}
#endif

static	modarg(s, pa_p, ma_p)
char	*s;	/* [hłȂꍇ0Ԃ */
unsigned int	*pa_p, *ma_p;
{
	unsigned int	plusattr = *pa_p, minusattr = *ma_p, dattr;
	int	plusp;

	for(;;){
		if(*s == 'u' || *s == 'a') s++;
		switch(*s++){
		case '-':
			plusp = 0; break;
		case '=':
			minusattr = ~0, plusattr = 0; /* through */
		case '+':
			plusp = 1; break;
		default:
			return 0;
		}
		do{
			switch(*s){
			case 'o':
				dattr = 1; break;
			case 'h':
				dattr = 2; break;
			case 's':
				dattr = 4; break;
			case 'a':
				dattr = 32; break;
			case 'w': /* ̏ꍇt */
				plusp ? (minusattr |= 1) : (plusattr |= 1);
				dattr = 0; break;
			default:
				return 0;
			}
			plusp ? (plusattr |= dattr) : (minusattr |= dattr);
		} while(*++s && *s != ',');
		if(!*s++) break; /* ','Ȃcontinue */
	}
	*pa_p = plusattr, *ma_p = minusattr;
	return 1;
}

static	omodarg(s, pa_p, ma_p)
char	*s; /* 8i^[hłȂꍇ0Ԃ */
unsigned int	*pa_p, *ma_p;
{
	char	*p;
	int	attr = 0;

	for(p = s; is_octal(*p); p++) (attr <<= 3, attr |= *p - '0');
	return *p ? 0 : modarg((attr & 0200) ? "+w" : "-w", pa_p, ma_p);
}

main(ac, av)
int	ac;
char	**av;
{
	char	*p;
	int	status = 0;
	unsigned int	attr, plusattr = 0, minusattr = 0x18; /* dir&vol bit */
	struct	Find_t	dmy;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	for(--ac, ++av; ac && *(p = *av) == '-' && *++p; --ac, ++av){
		for(; *p; ++p){
			switch(*p){
			case 'n':
				nodisp = 1; continue;
			case 'f':
				noerrm = 1; continue;
			default:
				if(p != *av + 1) help_exit();
			}
			break;
		}
		if(*p) break;
	}
	if(!ac){
		help_exit();
	} else
	if(omodarg(*av, &plusattr, &minusattr)){
		--ac, ++av;
	} else
	if(modarg(*av, &plusattr, &minusattr)){
		while(++av, --ac && modarg(*av, &plusattr, &minusattr));
	} else {
		help_exit();
	}

	if(!ac) help_exit();
	for(; ac; --ac, ++av){
		p = conv_to_unix_format(*av);
		if(_dos_Find_soonclose(p, _osmajor < 7 ? 0x3f : 0x37, &dmy) ||
		 /* ̃`FbŃA[gchmod悤ƂƂȂ
		    Division by zeroňُI邱Ƃւ̑΍ */
		   0 != _dos_getfileattr(p, &attr)){
			if(!noerrm){
				char	tmpnul[PATHNAMELENGTH];
				int	n;

				expand_path(tmpnul, p, NULNAME);
				if(!_dos_open(tmpnul, O_RDONLY, &n)){
					_dos_close(n);
					goto cant; /* maybe root */
				} /* ǂɂG[bZ[W
				     oȂ̂ */

				_cmdputerrmes(p);
				_puterrmes_cr(": Not exist");
			}
			status = 1;
			continue;
		}
		attr &= ~minusattr;
		attr |= plusattr;
		if(0 != _dos_setfileattr(p, attr)){
			if(!noerrm){
			cant:
				_cmdputerrmes(p);
				_puterrmes_cr(": Can't change");
			}
			status = 1;
			continue;
		}
		if(!nodisp){
			_puterrmes(p), _puterrmes_cr(":");
		}
	}

	return status; /* exit from main */
}
