#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <io.h>
#include <ctype.h>
#include <string.h>
#include <memory.h>
#if defined(__WATCOMC__) || defined(MSC51)
#  include <direct.h>
#endif
#include "tools.h"

char	*cmdname = "chvol";

static	void	usage_exit()
{
	fputss(stderr, "Usage:\t",
		cmdname, " [d:]label\n\t",
		cmdname, " -s [d:]serial\n\t",
		cmdname, " -s [d:]label serial\n\t",
		cmdname, " -{l,d} [-s] [d:]\n", NULL);
	exit(1);
}

static	char	*strfill(dst, src, n)
char	*dst, *src;
int	n;
{
	char	*p;

	for(p = dst; n && *src; --n, ++src, ++p) *p = *src;
	for(; n; --n, ++p) *p = ' ';
	return dst;
}

static	void	convfcb(buf, s)
char	*buf, *s; /* sFCB`ɂbufɓBbuf12oCgKv */
{
	int	tmplen;
	char	*pdot;

	memset(buf, '\0', 8+1+3); /* buf[11] remains 0 */
	if(NULL == (pdot = strchr(s, '.'))){
		strfill(buf, s, 8+3);
	} else {
		if((tmplen = pdot - s) > 8) tmplen = 8;
		strncpy(buf, s, tmplen);
		strfill(buf + tmplen, NULSTR, 8 - tmplen);
		strfill(buf + 8, ++pdot, 3);
	}
}

static	int	get_orgvol_fcb(s) /* func11h, 12hłȒP? */
char	*s; /* s[-1]ɃhCuB0Jg 1A 2Bc */
{
	char	buf[8+1+3], *wildptn = ":\\*.*";
	struct	find_t	findbuf;
	int	volfound = 0; /* 1:vol 2:nonvol */

	if(!s[-1]) strcpy(buf, wildptn + 1);
	 else *buf = s[-1] + 'a' - 1, strcpy(buf + 1, wildptn);
	if(!_dos_findfirst(buf, _A_VOLID, &findbuf)) do {
		if(findbuf . attrib & 0x16){
			volfound |= 2;
		} else {
			volfound |= 1;
			convfcb(buf, findbuf . name);
			strfill(s, buf, 11);
		}
	} while(!_dos_findnext(&findbuf));
	if(!(volfound & 1)) return -1;

	if(!(volfound & 2) || _osmajor >= 7) memset(s, '*', 11);
	 /* DOS7ł"*.*"w肵ȂƏȂǂ̕ϑԃx폜
	    łȂBDOS6ȑOVFATGg폜邱Ƃ̂Ȃ悤
	    `FbNĂ */
	return 0;
}

static	void	lsvol(drv)
int	drv;
/* drv -1:Jg 0:A 1:B c */
{
	struct	find_t	findbuf;
	static	char	tmp[ ] = "?:\\*.*";
	char	*p;

	p = tmp;
	if(drv >= 0) *p = (char)drv + 'a'; else p += 2;
	if(0 == _dos_sfindfirst(p, _A_VOLID, &findbuf)){
		fputs(conv_to_unix_format(findbuf . name), stdout);
		putchar('\n');
	}
#if 0
	else {
		_puterrmes_cr("No volume lavel found."); /* not exit(1) */
	}
#endif
}

static	void	rw_volser(drv, buf, flg)
int	drv, flg; /* flg: 0 or 1 */
char	far	*buf;
/* drv -1:Jg 0:A 1:B c */
{
	union	REGS	in, out;
	struct	SREGS	segreg;

	if(_osmajor < 4){
		_cmdputerrmes_cr("Unavailable function under DOS3"), exit(1);
	}
	buf[0] = buf[1] = '\0';
	in . x . ax = 0x6900 | flg;
	in . h . bl = (char)drv + 1;
	in . x . dx = FP_OFF(buf);
	segreg . ds = FP_SEG(buf);
	intdosx(&in, &out, &segreg);
	if(out . x . cflag){
		_cmdputerrmes("Can't "), _puterrmes(flg ? "s" : "g"),
		_puterrmes_cr("et volume lavel & serial."), exit(1);
	}
}

static	void	lsvolser(drv)
int	drv;
/* drv -1:Jg 0:A 1:B c */
{
	char	buf[0x19], *p, *q;
	unsigned long	volser;
	int	i, c;

	rw_volser(drv, (char far *)buf, 0);
	for(q = (p = buf + 6) + 8; p <= --q && *q == ' '; );
	for(++q; p < q; ++p) putchar(*p);
	for(q = (p = buf + 14) + 3; p <= --q && *q == ' '; );
	if(p < ++q){
		putchar('.');
		for(; p < q; ++p) putchar(*p);
	}
	putchar('\n');
	for(volser = *(unsigned long *)(buf + 2), i = 32; i; ){
		i -= 4;
		c = (int)(volser >> i) & 0xf;
		c += (c < 10 ? '0' : 'a' - 10);
		putchar(c);
	}
	putchar('\n');
}

static	void	rmvol(drv)
int	drv;
/* drv -1:Jg 0:A 1:B c */
{
	char	xfcbbuf[44];
	union	REGS	in, out;
	struct	SREGS	segreg;

	xfcbbuf[0] = 0xff;
	xfcbbuf[6] = _A_VOLID;
	xfcbbuf[7] = (char)drv + 1;
	if(!get_orgvol_fcb(xfcbbuf + 8)){
#ifdef DEBUG
		int	i;

		for(i = 0; i < sizeof(xfcbbuf); i++)
			fprintf(stderr, "%02x-", xfcbbuf[i]);
		putc('\n', stderr);
#endif
		segreg . ds = FP_SEG((char far *)xfcbbuf);
		in . x . dx = FP_OFF(xfcbbuf);
		in . h . ah = 0x13;
		intdosx(&in, &out, &segreg);
		if(out . h . al != 0xff) return;
	}

	_cmdputerrmes_cr("Can't remove volume label");
	exit(1);
}

static	void	chvol(drv, s, retry)
char	*s;
int	drv, retry;
/* drv -1:Jg 0:A 1:B c */
{
	char	xfcbbuf[44], vname[16]/* "A:\12345678.9AB\0" */;
	static	char	buf[8+1+3];
	union	REGS	in, out;
	struct	SREGS	segreg;
	struct	find_t	findbuf;

	if(!retry){
		if(!contains_nowild(s)) goto cant;
		convfcb(buf, s), s = buf;
	}

	xfcbbuf[0] = 0xff;
	xfcbbuf[6] = _A_VOLID;
	xfcbbuf[7] = (char)drv + 1;
	strfill(xfcbbuf + 8, s, 11);
	segreg . ds = FP_SEG((char far *)xfcbbuf);
	in . x . dx = FP_OFF(xfcbbuf);
	in . h . ah = 0x16;
	intdosx(&in, &out, &segreg);
	if(out . h . al == 0) return;

	in . h . ah = 0x17;
	if(!get_orgvol_fcb(xfcbbuf + 8)){ /* ݃{[̉ */
		strfill(xfcbbuf + 24, s, 11);

		 /* Win95̃t@NV17hɂ̓oOA[gfBNg
		    ȊOŃ{[x̕tւƂ̃fBNg
		    {[xĂ܂ĂȂB̉ */
		{
			char	cwdbuf[PATHNAMELENGTH], rootbuf[4], *p;
			union	REGS	tmpin, tmpout;
			struct	SREGS	tmpseg;

#ifdef SUPP_LFN
			if(_lfnsupp_level >= LFN_NONE)
				tmpin . x . ax = 0x7147;
			/* getpwďʂsɂȂ悤7147hg */
			else
#endif
				tmpin . h . ah = 0x47;
			p = cwdbuf;
			if(0 != (tmpin . h . dl = (char)drv + 1)){
				*p++ = tmpin . h . dl + 'a' - 1, *p++ = ':';
			}
			*p++ = '\\';
			tmpin . x . si = FP_OFF(p);
			tmpseg . ds = FP_SEG((char far *)p);
			intdosx(&tmpin, &tmpout, &tmpseg);
			if(!tmpout . x . cflag){
				strncpy(rootbuf, cwdbuf, 3);
				rootbuf[tmpin . h . dl ? 3 : 1] = '\0';

				tmpin . x . ax = 0x3300;
				intdos(&tmpin, &tmpout);
				if(0 != (tmpin . h . dh = tmpout . h . dl)){
				 /* CTRL-C off */
					tmpin . h . dl = 0;
					tmpin . h . al++;
					intdos(&tmpin, &tmpout);
				}
				chdir(rootbuf);
				intdosx(&in, &out, &segreg);
				chdir(cwdbuf);
				if(0 != tmpin . h . dh){
				 /* CTRL-C on */
					tmpin . h . dl++;
					intdos(&tmpin, &tmpout);
				}
			} else out . h . al = 0xff; /* failed... */
		}
		if(out . h . al == 0) return;
	}

	 /* {[xA[gfBNgɑ݂t@C
	    Orename悤ƂƎs悤B̏ꍇ
	    U{[x폜ĕtƐ */
	if(!retry){
		if(drv < 0){
			*vname = '\\';
			strncpy(vname + 1, s, 9);
			if(strlen(s) <= 8) vname[9] = '\0';
			 else vname[9] = '.', strncpy(vname + 10, s + 8, 3),
			      vname[13] = '\0';
		} else {
			*vname = (char)drv + 'a', strcpy(vname + 1, ":\\");
			strncpy(vname + 3, s, 9);
			if(strlen(s) <= 8) vname[11] = '\0';
			 else vname[11] = '.', strncpy(vname + 12, s + 8, 3);
			      vname[15] = '\0';
		}
		if(0 == _dos_findfirst(vname, 0x37, &findbuf)){
			rmvol(drv);
			chvol(drv, s, 1); /* ͎sȂ͂ */
			return;
		}
	}

cant:
	_cmdputerrmes_cr("Can't set volume label");
	exit(1);
}

static	void	chvolser(drv, s, ser)
int	drv;
char	*s, *ser;
/* drv -1:Jg 0:A 1:B c */
{
	char	buf[0x19], cnvbuf[8+1+3], *p;
	unsigned long	volser;
	int	c;

	for(volser = 0L, p = ser; *p; ++p){
		if((c = *p) == '-') continue;
		if(!is_xdigit(c)){
			_cmdputerrmes_cr("Illegal serial"), exit(1);
		}
		c -= is_digit(c) ? '0' : is_lower(c) ? 'a'-10 : 'A'-10;
		volser <<= 4, volser |= c;
	}

	rw_volser(drv, (char far *)buf, 0);
	if(s != NULL){
		convfcb(cnvbuf, s);
		strfill(buf + 6, cnvbuf, 11);
	}
	memcpy(buf + 2, (char *)&volser, sizeof(volser));
	rw_volser(drv, (char far *)buf, 1);
}

main(ac, av)
int	ac;
char	**av;
{
	int	c, drvno;
	bool	rmflg = 0, lsflg = 0, serflg = 0;
	char	*arg;
	extern	int	optind, opterr;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg_tiny(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	opterr = 0;
	while((c = getopt(ac, av, "dls")) != EOF){
		cswitch(c){
		case 'd':
			rmflg = 1; break;
		case 'l':
			lsflg = 1; break;
		case 's':
			serflg = 1; break;
		default:
			usage_exit();
		}
	}
#ifndef DEBUG
	if(serflg && _osmajor < 4){
		_cmdputerrmes_cr("-s option requires DOS4 or later."), exit(1);
	}
#endif
	ac -= optind, arg = *(av += optind);

	if(lsflg || rmflg){
		switch(ac){
		case 0:
			drvno = -1; break;
		case 1:
			if(is_alpha(*arg) &&
			   (!arg[1] || arg[1] == DRIVE_SEP && !arg[2])){
				drvno = to_lower(*arg) - 'a'; break;
			}
			 /* FALLTHROUGH */
		default:
			usage_exit();
		}
		(lsflg ? (serflg ? lsvolser : lsvol) : rmvol)(drvno);
	} else {
		switch(ac){
		case 2:	case 1:
			if(is_alpha(*arg) && arg[1] == DRIVE_SEP){
				drvno = to_lower(*arg) - 'a';
				arg += 2;
			} else drvno = -1;

			if(++av, !--ac){ /* one arg */
				if(!serflg){
					chvol(drvno, arg, 0);
				} else {
					chvolser(drvno, NULL, arg);
				}
			} else { /* two args */
				if(!serflg) usage_exit();
				chvolser(drvno, arg, *av);
			}
			break;
		default:
			usage_exit();
		}
	}
	return 0;
}
