 /* for LSI-C only */
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <ctype.h>
#include "tools.h"
#define RBUFSIZ 8192

char	*cmdname = "ddump";

#ifdef MSDOS
void	expand_hook()
 /* {vO͈WJE{̂ƂLFÑT|[g͕sv */
{
}
#endif

static	void	usage()
{
	fprintf(stderr,
	 "Usage: %s [-fwyvn] drive [beginsector [howmanysectors]]\n", cmdname);
	exit(1);
}

static	us_long	xatol(s)
char	*s;
{
	us_long	x = 0;

	if(*s == '0'){
		if(++s, *s == 'x' || *s == 'X'){
			for(s++; is_xdigit(*s); s++){
				x <<= 4; x += ctoi(*s);
			}
		} else {
			for(; is_octal(*s); s++){
				x <<= 3; x += *s - '0';
			}
		}
		return x;
	} else {
		return atol(s);
	}
}

main(ac, av)
int	ac;
char	*av[];
{
	union	REGS	in, out;
	struct	SREGS	segreg; /* VXeR[p */
	us_long	beginsec, maxsec, restsec;
	us_int	rwsec, secsize, rwbyte, gotbyte;
		 /* ǂݏTCY */
	char	*buf; /* ǂݏobt@ */
	int	result; /* ǂݏ̌ */
	char	drv; /* hCuԍ a:0 b:1c */

	bool	rw = 0; /* 0:ǂ 1: */
	bool	nochk = 0; /* ݂̂Ƃ[UɊmF߂邩 */
	bool	force = 0; /* ZN^I[o[łs邩 */
	bool	vrbos = 0;
	bool	xwarn = 1;

	FILE	*con; /* [UɊmF߂邽conI[v */

	int	c;
	us_char	far	*dpb;
	extern	int	optind, opterr;
	extern	char	*optarg;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg_tiny(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif
	opterr = 0;
	while(EOF != (c = getopt(ac, av, "yfwvn"))){
		cswitch(c){
		case 'w': rw = 1; break;
		case 'f': force = 1; break;
		case 'y': nochk = 1; break;
		case 'v': vrbos = 1; break;
		case 'n': xwarn = 0; break;
		default:  usage();
		}
	}
	ac -= optind, av += optind;

	if(ac > 3 || ac < 1 ||
	   !(is_alpha(av[0][0]) &&
	     (!av[0][1] || av[0][1] == ':' && !av[0][2]))) usage();
	drv = tolower(av[0][0]) - 'a';

	 /* VXeR[0x32săZN^TCY߂ */
	in . h . dl = drv + 1; /* 0x32łahCu1 */
	in . h . ah = 0x32;
	intdosx(&in, &out, &segreg);
	if((char)out . h . al == (char)0xff){
		fprintf(stderr, "%s: Invalid drive\n", cmdname), exit(1);
	}
	dpb = (us_char far *)MK_FP(segreg . ds, out . x . bx);
	secsize = *(int far *)(dpb + 2);
	maxsec = ((us_long)(*(us_int far *)(dpb + 13) - 1) << dpb[5]) +
		 *(us_int far *)(dpb + 11);

	if(vrbos){
		us_int	rsvsec = *(us_int far *)(dpb + 6);
		us_int	fatsec = dpb[8] * (_osmajor >= 4 ?
					*(us_int far *)(dpb + 0xf) : dpb[0xf]);
		us_int	dbgnsec = *(us_int far *)(dpb + 0xb);

		fprintf(stderr,
  "Drive %c: %lu sectors (%u reserved, %u for FAT, %u for root directory)\n",
			drv + 'A', maxsec, rsvsec, fatsec,
			dbgnsec - rsvsec - fatsec);
		fprintf(stderr, "%u sector(s)/cluster, %u bytes/sector\n",
			dpb[4] + 1, *(us_int far *)(dpb + 2));
		fprintf(stderr,
			"sectorNo = (clusterNo_in_dir - 2) * %u + %u\n",
			dpb[4] + 1, dbgnsec);
	}

	beginsec = (ac > 1) ? xatol(av[1]) : 0L;
	restsec = (ac > 2) ? xatol(av[2]) : (maxsec - beginsec);
	if(!force && (beginsec >= maxsec || beginsec + restsec > maxsec)){
		fprintf(stderr, "%s: Sector number exceeded\n", cmdname);
		exit(1);
	}
	rwsec = secsize > RBUFSIZ ? 1 : RBUFSIZ / secsize;
	if(NULL == (buf = malloc(rwsec * secsize))){
		fputs("Memory not enough\n", stderr), exit(1);
	}

	if(!rw){
		fsetbin(stdout); /* write()sv */
		while(restsec){
			if(restsec < (us_long)rwsec) rwsec = (us_int)restsec;
			 /* INT25E26: 'a' is 0 */
			result = absdiskrw(0, drv, (char far *)buf,
					   beginsec, rwsec);
			if(result >> 8){
				fprintf(stderr,	"%s: Disk read error\n",
					cmdname);
				exit(1);
			}
			rwbyte = rwsec * secsize;
			if(rwbyte != write(1, buf, rwbyte)){
				fprintf(stderr, "%s: Can't write to stdout\n",
					cmdname);
				exit(1);
			}

			restsec -= (us_long)rwsec;
			beginsec += (us_long)rwsec;
		}
	} else {
		if(NULL != getenv("NODWRITE")){
			fprintf(stderr, "%s: Disk write not permitted\n",
				cmdname);
			exit(1);
		}
		if(!nochk){
			if(NULL == (con = fopen("con", "r"))){
				fprintf(stderr, "%s: Unknown error\n",
					cmdname);
				exit(1);
			}
			fflush(con), setbuf(con, NULL);

			fprintf(stderr,
			"Write to drive %c, sector %lu - %lu (%lu sectors).\n",
				drv + 'A',
				beginsec, beginsec + restsec - 1, restsec);
			for(;;){
				fputs("Sure? (y/n) ", stderr), fflush(stderr);
				if(NULL == fgets(buf, RBUFSIZ, con) ||
				   (*buf=='n' || *buf=='N') && buf[1] == '\n')
					exit(0);
				if((*buf=='y' || *buf=='Y') && buf[1] == '\n')
					break;
			}
		}

		fsetbin(stdin); /* read()sv */
		while(restsec){
			if(restsec < (us_long)rwsec) rwsec = (us_int)restsec;
			rwbyte = rwsec * secsize;
			gotbyte = read(0, buf, rwbyte);
			if(gotbyte != (us_int)(-1) && gotbyte >= secsize){
				if(no_diskwrt(drv + 1)){
					fprintf(stderr,
					 "%s: Can't write; Drive not locked\n",
					 cmdname);
					exit(1);
				}

				 /* INT25E26: 'a' is 0 */
				result = absdiskrw(1, drv, (char far *)buf,
						 beginsec, gotbyte / secsize);
				if(result >> 8){
					fprintf(stderr,
					  "%s: Disk write error\n", cmdname);
					exit(1);
				}
			} else gotbyte = 0;
			if(gotbyte < rwbyte){
				fprintf(stderr, "%s: Data insufficient\n",
					cmdname);
				exit(1);
			}

			restsec -= (us_long)rwsec;
			beginsec += (us_long)rwsec;
		}
		in . h . ah = 0xd; /* disk flush */
		intdos(&in, &out);

		if(xwarn && 0 < read(0, (char *)&out, 1)){
			fprintf(stderr, "%s: Warning: Extra data ignored\n",
				cmdname);
		}
	}
	return 0;
}
