#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <ctype.h>
#include <string.h>
#include <memory.h>
#ifdef LSI_C
#  include <farstr.h>
#endif
#include "tools.h"

char	*cmdname = "df";

static	unsigned char	maxdrv; /* set in dfall() and used in df() */
static	char	far	*infotbl;
static	char	*fmt = "%-15s %7ld %7ld %*ld %5ld%%   %7ld  %s\n";
static	bool	hdr_already, hdonly, unitisbyte, drv_explicit;
static	bool	except_flg[0x1a];
#ifdef SUPP_LFN
static	bool	prefer_lfn = 1;
#endif

#define div_round(x, y) (((x) + ((y) >> 1)) / (y)) /* y > 0 */
 /* for both long and int */

static	void	usage()
{
	fprintf(stderr,
		"Usage: %s [-BHS] [-E except_list] [d: ...]\n", cmdname);
	exit(1);
}

static	void	dfinit()
{
	union	REGS	in, out;
	struct	SREGS	segreg;

	notrap();
	in . h . ah = 0x52;
	intdosx(&in, &out, &segreg);
	infotbl = (char far *)MK_FP(segreg . es, out . x . bx);
	if((maxdrv = (unsigned char)*(infotbl + 0x21)) > 0x1a)
		maxdrv = 0x1a; /* ??? */
	infotbl = (char far *)MK_FP(*(int far *)(infotbl + 0x18),
				    *(int far *)(infotbl + 0x16));
}

static	void	dfhdr()
{
	if(hdr_already) return; else ++hdr_already;
	printf("lastdrive: %c", maxdrv + 'a' - 1);
	if(unitisbyte) printf("%25savail", NULSTR);
	  /*	  a:/usr/local	  0123456 0123456 01-9 --100%-- 0123456  c:\ */
	printf("\nFilesystem       Kbytes    used   %s capacity Cluster  Mounted on\n",
	    unitisbyte ? " (bytes)" : "avail");
}

static	void	erase()
{
	if(isatty(1)) (fputs("\r \b", stderr), fflush(stderr));
}

#define isjoined(k) ((k) & 0x2000)
#define isnetdrv(k) ((k) & 0x8000)

static	void	df(drv)
unsigned char	drv;
{
	char	*mntpath, *rootpath;
	char	mntpbuf[PATHNAMELENGTH];
	static	char	rootpbuf[] = "\0:/";
	char	far	*drvfarp;
#if 0
	char	far	*dpb;
#endif
	int	drvkind;
	us_long	CLperB;
	union	REGS	in, out;

	if(maxdrv <= drv) return;
	drvfarp = infotbl + (_osmajor >= 4 ? 0x58 : 0x51) * drv;
	if(0 == (drvkind = *(int far *)(drvfarp + 0x43))) return;
	 /* unused drive */
#if 0 /* ̃tÖӖ͖Ȃ̂ō̂Ƃ낱̏͂Ȃ */
	dpb = (char far *)MK_FP(*(int far *)(drvfarp + 0x47),
					*(int far *)(drvfarp + 0x45));
	if((char)0xff == *(dpb + (_osmajor >= 4 ? 0x18 : 0x17))) return;
#endif
	*rootpbuf = drv + 'a';
	 /* ܂ł̓΂ */

	if(!drv_explicit && ((_osmajor << 8) | _osminor) >= 0x0314){
		in . x . ax = 0x440e; /* v3.20ȍ~Ŏgp */
		in . h . bl = drv + 1;
		intdos(&in, &out);
		if(!out . x . cflag && out . h . al &&
		   out . h . al != in . h . bl) return;
		 /* cflagreturnĂ͂ȂȂ
		    ȂWinFSDEXTƂc[Ń}Eg
		    LinuxhCuƂĂ܂ */
	}
	if(isatty(1)){
		fprintf(stderr, "\r%c", drv + 'a'); fflush(stderr);
	} /* ȌA߂erase()Kv */

	if(hdonly && !isnetdrv(drvkind)){
		in . x . ax = 0x4408;
		in . h . bl = drv + 1;
		intdos(&in, &out);
		if(out . x . cflag){
			erase(); return;
		}
		if(!out . x . ax){
			erase(), dfhdr();
			printf("%-23s <exchangeable drive; output omitted>\n",
				rootpbuf);
			return;
		}
	}
	if(isjoined(drvkind)){ /* joined drive */
		far_strcpy((char far *)mntpbuf, drvfarp);
		rootpath = rootpbuf;
		mntpath = mntpbuf;
	} else {
		if(!can_cd_there(rootpbuf) ||
		   0 != abs_pathname(rootpbuf, mntpbuf,
#ifdef SUPP_LFN
				_lfnsupp_level > LFN_NONE && prefer_lfn ? -1 :
				 /* -1̏ꍇ7160-2h, 1h̏Ŏ */
#endif
				1)){
			erase(); return;
		}
		rootpath = mntpbuf;
		mntpath = rootpbuf;
	}
	conv_to_unix_format(mntpbuf); /* LFNłĂISFN
					̂ňꊇϊ */
	in . h . ah = 0x36;
	in . h . dl = (is_alpha(*rootpath) ? *rootpath - 'a' : drv) + 1;
	if(isnetdrv(drvkind)){ /* network drive */
		memset(&out, 0, sizeof(out));
	} else {
		intdos(&in, &out);
	}
	if((int)out . x . ax == -1){ /* offline, maybe */
		erase(); return;
	}

	CLperB = (us_long)out . x . ax * (us_long)out . x . cx;

	erase(), dfhdr();
	if(strlen(rootpath) > 15) (printf("%s\n", rootpath), *rootpath = '\0');
	printf(fmt, rootpath,
		div_round(CLperB * (us_long)out . x . dx, 1024L),
		div_round(CLperB * (us_long)(out . x . dx - out . x . bx),
			  1024L),
		unitisbyte ? 10 : 7,
		unitisbyte ? CLperB * (us_long)out . x . bx :
			     div_round(CLperB * (us_long)out . x . bx, 1024L),
		out . x . dx ?
		  div_round(100L * (us_long)(out . x . dx - out . x . bx),
			    (us_long)out . x . dx) :
		  0,
		CLperB,	mntpath
	);
}

static	void	clflg()
{
	int	i;

	for(i = 0; i < 0x1a; i++) except_flg[i] = FALSE;
}

main(ac, av)
int	ac;
char	**av;
{
	unsigned char	drv;
	int	c, i;
	extern	int	optind, opterr;
	extern	char	*optarg;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg_tiny(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif
	if(_osmajor < 3){
		fprintf(stderr, "%s: DOS3 or later required\n", cmdname);
		exit(1);
	}

	clflg();
	opterr = 0;
	while(EOF != (c = getopt(ac, av, "BHE:S"))){
		cswitch(c){
		case 'B':
			unitisbyte ^= 1; break;
		case 'H':
			hdonly ^= 1; break;
		case 'E':
			if(*optarg){
				for(i = 0; '\0' != (c = optarg[i]); i++){
					if(!is_alpha(c)) usage();
					except_flg[tolower(c)-'a'] = TRUE;
				}
			} else clflg();
			break;
		case 'S':
#ifdef SUPP_LFN
			prefer_lfn = 0;
#endif
			break;
		default:
			usage();
		}
	}
	ac -= optind, av += optind;

	dfinit();
	if(!ac){
		for(drv = 0; drv < maxdrv; ++drv) if(!except_flg[drv]) df(drv);
	} else { /* except_flg͌Ȃ */
		drv_explicit++;
		for(; ac; --ac, ++av){
			drv = **av;

			if(is_alpha(drv) && av[0][1] == ':' && !av[0][2]){
				drv = tolower(drv) - 'a';
				df(drv);
			} else usage();
		}
	}
	if(!hdr_already){
		fprintf(stderr, "%s: No drive found\n", cmdname);
		return 1; /* exit from main */
	}
	return 0;
}
