/*
   diff.c - public domain context diff program

  if you want to use this command as 'diff file dir', define DIRFCMP

  on VOS3, define VOS3
  on MSDOS, define MSDOS ('MSDOS', 'unix' infer 'DIRFCMP')

  with MSC, define MSC and link ssetargv.obj

  on VOS3, stdout is re-opened with RECFM(VB),LRECL(255).
*/

#ifndef MSDOS
#  define far
#  ifndef VOS3
#    ifndef unix
#      define unix
#    endif
#  endif
#endif

#ifdef unix
#  define DIRFCMP
#  define SIGNEED
#  define SIGTYPE void
#endif
#ifdef MSDOS
#  define DIRFCMP
#  define SIGNEED
#  define SIGTYPE void
#endif
#ifdef VOS3
#  define SIGNEED
#  define SIGTYPE int
#endif
 /* by Nide */

#ifdef TURBO
#  include <alloc.h>
#  include <errno.h>
#  include <process.h>
#  include <stdio.h>
#  include <stdlib.h>
#  include <string.h>
#else /* !TURBO */
#  include <stdio.h>
#  include <ctype.h>
#endif /* TURBO */
#if defined(MSC51) || defined(__WATCOMC__)
#  include <process.h>
#  include <stdarg.h>
#endif

#ifdef MSDOS
#  include <string.h>
#  include <dos.h>
#endif

#ifdef TOOLS
#  include "tools.h" /* must be included AFTER <dos.h> */
#else /* PƂłRpCł悤 */
#  define TRUE 1
#  define FALSE 0
#  define to_lower(c) (isascii(c) && isupper(c) ? tolower(c) : (c))
#  define is_space(c) (isascii(c) && isspace(c))
#endif

#ifdef MSDOS
static char *myalloc(), far *farmyalloc(), far *farcompact();
#  define Int long
 /* LSI Cłfar|C^longʂ͐KB
    `fpc'ƒ߂̂ӏfar|C^̔rŁA
    Kꂽ̓mōs˂΂ȂȂ */
#else /* non MS-DOS */
#  define farmalloc  malloc
#  define farmyalloc myalloc
#  define farfree    free
#  define farcompact compact
#  define Int int
static	char	*myalloc();		/* Storage allocator	 */
static	char	*compact();		/* Storage compactor	 */
#endif

#ifdef TOOLS
char	*cmdname = "diff";
#else
static	char	*cmdname = "diff";
#endif

static	Int	subseq(), newcand(), search();
static	isdir(), check(), get_line();
static	void	input(), squish(), sort(), unsort(), equiv(), unravel(),
	output(), change(), range(), fetch(), noroom(), cant(), differror();

#ifdef DIRFCMP
#  include <sys/types.h> /* these two are for isdir() */
#  include <sys/stat.h>
#endif /* DIRFCMP */

#ifdef SIGNEED /* Nide */
#  include <signal.h>
#endif

#ifdef vms
#  include <ssdef.h>
#  include <stsdef.h>
#  define IO_SUCCESS  (SS | STS)
#  define IO_ERROR  SS
#endif /* vms */

/*
 * Note: IO_SUCCESS and IO_ERROR are defined in the Decus C stdio.h file
 */
/*
#ifndef	 IO_SUCCESS
#  define IO_SUCCESS  0
#endif
#ifndef	 IO_ERROR
#  define IO_ERROR  1
#endif
*/ /* abolished Nide */

#ifdef IO_ERROR /* Nide */
#  define RET_FATAL	2
#  define RET_ERROR	IO_ERROR
#  define RET_SPURIOUS	1
#  define RET_DIFF	1
#  define RET_SAME	0
#else
#  define RET_FATAL	2
#  define RET_ERROR	2
#  define RET_SPURIOUS	1 /* 2? */
#  define RET_DIFF	1
#  define RET_SAME	0
#endif

#if defined(MSDOS) && defined(TOOLS)
void	expand_hook()
{
	_expand_abendcode = RET_FATAL;
	expand_hook_default();
}
#endif

#define	 EOS	'\0'

#ifdef unix
#  ifndef HAVE_NO_TMPFILE
#    define USE_TMPFILE
#  endif
#endif

#ifdef unix
#  ifndef USE_TMPFILE
#    if !is68k
static	char	temfile[L_tmpnam] = "";
char	*tmpnam();
#      define TEMPFILE ((temfile[0] || tmpnam(temfile)), (char *)temfile)
#    else /* is68k */
static	char	temfile[ ] = "/tmp/difftmpXXXXX";
#      define TEMPFILE \
	(((temfile-1)[strlen(temfile)] == 'X' &&	\
	  sprintf(&(temfile-5)[strlen(temfile)], "%05d",	\
		  (unsigned int)getpid() % 100000)),	\
	 (char *)temfile)
#    endif
#  endif /* !USE_TMPFILE */
#endif /* unix */

#ifdef MSDOS /* by Nide */
static	char	*difftmpnam();
#  define TEMPFILE  difftmpnam()
#endif

#ifdef VOS3 /* by Nide */
#  define ALCCMD "alloc dd(tmpdiff) temp(diff) reu"
#  define FREECMD "free dd(tmpdiff)"
#  define TMPDD  "tmpdiff/DDN"
static	char	tmpalcflg = 0;
#  define TEMPFILE  ((tmpalcflg ? 0 : (system(ALCCMD), tmpalcflg++)), TMPDD)
#endif

#ifndef	 TEMPFILE
#  define TEMPFILE  "diff.tmp"
#endif /* TEMPFILE */

#ifndef unix
#ifndef OSK
#ifndef MSC
#ifndef __WATCOMC__ /* for tools */
#  define unlink remove
#endif
#endif /* MSC */
#endif /* OSK */
#endif /* unix */
 /* MSC 4.0 does not understand disjunctive #if's.  */

#ifdef	pdp11
#  define short	int
#endif /* pdp11 */

static	int	diff_found = 0, diff_spurious = 0; /* add Nide */

typedef struct candidate {
	Int		b;			/* Line in fileB	 */
	Int		a;			/* Line in fileA	 */
	Int		link;			/* Previous candidate	 */
} CANDIDATE;

typedef struct line {
	unsigned short/*Int?*/	hash;	/* Hash value etc.	*/
	short/*Int?*/		serial;	/* Line number		*/
} LINE;

static	LINE	far	*file[2];	/* Hash/line for total file  */
#define	fileA	file[0]
#define	fileB	file[1]

static	LINE	far	*sfile[2];	/* Hash/line after prefix  */
#define	sfileA	sfile[0]
#define	sfileB	sfile[1]

static	Int	len[2];			/* Actual lines in each file  */
#define	lenA	len[0]
#define	lenB	len[1]

static	Int	slen[2];		/* Squished lengths	 */
#define	slenA	slen[0]
#define	slenB	slen[1]

static	Int	prefix;			/* Identical lines at start  */
static	Int	suffix;			/* Identical lenes at end  */

static	FILE	*infd[2] = {NULL, NULL};	/* Input file identifiers  */
static	FILE	*tempfd = NULL;	/* Temp for input redirection  */

#ifndef MSC51 /* already defined in *.h */
extern	long	ftell();
extern	FILE	*fopen();
# ifdef vms
extern	char	*strcpy();
# endif
#endif
#ifndef TOOLS
#  ifdef TURBO
extern	void	*malloc();
#  else /* !TURBO */
extern	char	*malloc();
#  endif /* TURBO */
#endif

static	char	*fgetss();
static	unsigned short	hash();
#ifdef DIRFCMP
static	char	*dircat();
#endif

#ifdef	AMIGA
/* Define these types for Amiga C */
static	char	*savptr;
static	int	savsiz;
static	char	*wrk;
static	char	*wrk2;
static	int	cpysiz;
#endif /* AMIGA */

/*
 * The following vectors overlay the area defined by fileA
 */

static	short	far	*class;		/* Unsorted line numbers  */
static	Int	far	*klist;		/* Index of element in clist  */
CANDIDATE far	*clist;			/* Storage pool for candidates	*/
static	Int	clength = 0;		/* Number of active candidates	*/
#define	CSIZE_INC 50		/* How many to allocate each time we have to */
static	Int	csize = CSIZE_INC;	/* Current size of storage pool */

static	Int	far	*match;		/* Longest subsequence	*/
static	long	far	*oldseek;	/* Seek position in file A  */

/*
 * The following vectors overlay the area defined by fileB
 */

static	short	far	*member;	/* Concatenated equiv. classes	*/
static	long	far	*newseek;	/* Seek position in file B  */
static	char	*textb;			/* Input from file2 for check  */

/*
 * Global variables
 */

static	int	eflag = FALSE;	/* Edit script requested  */
static	int	bflag = FALSE;	/* Blank supress requested  */
static	int	wflag = FALSE;	/* Blank ignore requested  */
static	int	cflag = FALSE;	/* Context printout	 */
static	int	iflag = FALSE;	/* Ignore case requested  */
static	char	text[257];	/* Input line from file1  */

#ifdef	DEBUG
#ifndef OSK
#  define TIMING
#endif /* OSK */
#endif /* DEBUG */
#ifdef	TIMING
extern	long	time();
extern	char	*4532mend;
long	totaltime;
long	sectiontime;
char	*mstart;
#endif /* TIMING */
void	free();
void	exit();
#ifndef OSK
void	perror();
#endif /* OSK */

#ifdef SIGNEED /* Nide */
static	SIGTYPE	(*orig_int)() = SIG_DFL;
#endif

#define fputs_cr(s, f) (fputs((s), (f)), putc('\n', (f)))

#ifdef VOS3 /* added by Nide */
static	void	v3exit(c){
	exit(c? 8:0);
}
#  define exit v3exit

 /* file-open function which can handle perfect dsn begins with '#' */
static	FILE	*efopen(fnm, mode)
char	*fnm, *mode;
{
	FILE	*f;
	char	*p, *buf;
	extern	char	*malloc();

	if(*fnm != '#') return(fopen(fnm, mode));
	if(NULL == (buf = malloc(strlen(fnm) + 2))){
		 /* Display error meesage and quit from diff */
		fprintf(stderr, "%s: Memory not enough.\n", cmdname);
		v3exit(RET_ERROR);
	}
	p = buf;

	++fnm; /* skip '#' */
	*p++ = '\'';
	while(*fnm && *fnm != '/') *p++ = *fnm++;
	*p++ = '\'';
	while(*p++ = *fnm++);

	f = fopen(buf, mode);
	free(buf);
	return(f);
}
#  define fopen efopen
#endif /* VOS3 */

static	void	unlink_tmp() /* on MSDOS, must close TEMPFILE first */
{
	if(tempfd != NULL){
		fclose(tempfd);
#ifndef USE_TMPFILE
#  ifndef VOS3
		unlink(TEMPFILE);
#  endif
#endif
	}
#ifdef VOS3
	if(tmpalcflg){
		system(FREECMD);
	}
#endif

#ifdef SIGNEED
	signal(SIGINT, orig_int);
#endif
}

#ifdef SIGNEED /* Nide */
static	SIGTYPE	intr_exit()
{
	unlink_tmp();
	exit(RET_ERROR);
}
#endif

/*
 * Diff main program
 */

main(ac, av)
	int		ac;
	char		**av;
{
	register int	i;	Int	li;
	register char	*ap;
#ifdef DIRFCMP
	char	*fname[2];
	char	flg = 0;
#endif

#ifdef TOOLS /* for tools */
#  ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#  endif
#  ifndef MSDOS
	setcmdname(av[0]);
#  endif
#endif

#ifdef OSK
	extern int	_memmins;
	_memmins = 16 * 1024;		/* tell OSK we will malloc a lot */
#endif /* OSK */
#ifdef	TIMING
	sectiontime = time(&totaltime);
#endif /* TIMING */
#ifdef vms
	ac = getredirection(ac, av);
#endif /* vms */
	while(ac > 1 && *(ap = av[1]) == '-' && *++ap != EOS){
		while(*ap != EOS){
			switch(*ap++){
			case 'b':
				bflag++;
				break;
			case 'c':
				if(*ap > '0' && *ap <= '9')
					cflag = *ap++ - '0';
				else
					cflag = 3;
				break;
			case 'e':
				eflag++;
				break;
			case 'i':
				iflag++;
				break;
			case 'w':
				wflag++;
				break;
			default:
				goto usage;
			}
		}
		ac--;
		av++;
	}

	if(ac != 3){
	usage:
		fprintf(stderr,
			"Usage: %s [-beiw] [-c[1-9]] file1 file2\n", cmdname);
		exit(RET_ERROR);
	}
	if(cflag && eflag){
		fprintf(stderr,
		  "%s: Warning, -c and -e are incompatible, -c supressed.\n",
		  cmdname);
		cflag = FALSE;
	}
	if(wflag) bflag = FALSE;
	av++;
#ifdef MSDOS /* for tools */
#  ifdef TOOLS
	for(i = 0; i <= 1; i++) conv_to_unix_format(av[i]);
#  endif
#endif
#ifdef DIRFCMP
	for(i = 0; i <= 1; i++) fname[i] = av[i];
#else
#  define fname av
#endif
#define isstdin(fnm) (fnm[0] == '-' && fnm[1] == EOS)

	if(isstdin(fname[0]) && isstdin(fname[1]))
		differror("Can't diff two things both on standard input.");
	for(i = 0; i <= 1; i++){
		if(isstdin(fname[i])){
			infd[i] = stdin;
#ifdef SIGNEED
			if(SIG_IGN != (orig_int = signal(SIGINT, SIG_IGN)))
				signal(SIGINT, (SIGTYPE (*)())intr_exit);
#endif
#ifdef unix
			signal(SIGPIPE, (SIGTYPE (*)())intr_exit);
#endif

#ifdef USE_TMPFILE
			if((tempfd = tmpfile()) == NULL)
				cant("(temporal file)", "work", RET_ERROR);
#else
			if((tempfd = fopen(TEMPFILE, "w")) == NULL)
				cant(TEMPFILE, "work", RET_ERROR);
#endif
		} else {
#ifdef DIRFCMP
			if(!flg && isdir(fname[i])){
				if(i == 0 && isdir(fname[!i])){
				 differror("Can't diff two directories. X-(");
				} else flg++;
				if(isstdin(fname[!i])){
				 differror("Can't diff directory and stdin.");
				}
				fname[i] = dircat(fname[i], fname[!i]);
			}
#endif
			infd[i] = fopen(fname[i], "r");
			if(!infd[i])
				cant(fname[i], "input", RET_FATAL);
					/* Fatal error */
		}
	}

	if(infd[0] == NULL && infd[1] == NULL){
		cant(fname[0], "input", 0);
		cant(fname[1], "input", RET_ERROR);
	}
#ifdef vms
	else if(infd[1] == NULL)
		opendir(1, &fname[1], infd[0]);
	else if(infd[0] == NULL)
		opendir(0, &fname[0], infd[1]);
#endif /* vms */

#ifdef VOS3
	if(isterm(stdout) &&
	   NULL == freopen(NULL, "w,RECFM(VB),LRECL(255)", stdout)){
		differror("? Can't change attribute of stdout.");
	}
#endif

	/*
	 * Read input, building hash tables.
	 */
	input(0);
	input(1);
	squish();
#ifdef	DEBUG
	printf("before sort\n");
	dumpsfile();
#endif /* DEBUG */
	sort(sfileA, slenA);
	sort(sfileB, slenB);
#ifdef	TIMING
	ptime("input");
#endif /* TIMING */
#ifdef	DEBUG
	printf("after sort\n");
	dumpsfile();
#endif /* DEBUG */

	/*
	 * Build equivalence classes.
	 */
	member = (short far *)fileB;
	equiv();
	member = (short far *)farcompact((char far *)member,
		(slenB + 2) * sizeof(int), "squeezing member vector");

	/*
	 * Reorder equivalence classes into array class[]
	 */
	class = (short far *)fileA;
	unsort();
	class = (short far *)farcompact((char far *)class,
		(slenA + 2) * sizeof(int), "compacting class vector");
#ifdef	TIMING
	ptime("equiv/unsort");
#endif /* TIMING */

	/*
	 * Find longest subsequences
	 */
	klist = (Int far *)farmyalloc((slenA + 2) * sizeof(Int), "klist");
	clist = (CANDIDATE far *)farmyalloc(csize * sizeof(CANDIDATE),"clist");
	li = subseq();
#ifndef OSK
	farfree((char far *)member);
	farfree((char far *)class);
#else /* OSK */
	free((char *)member - sizeof(int));
	free((char *)class - sizeof(int));
#endif /* OSK */
	match = (Int far *)farmyalloc((lenA + 2) * sizeof(Int), "match");
	unravel(klist[li]);
#ifndef OSK
	farfree((char far *)clist);
	farfree((char far *)klist);
#else /* OSK */
	free((char *)clist - sizeof(int));
	free((char *)klist - sizeof(int));
#endif /* OSK */
#ifdef	TIMING
	ptime("subsequence/unravel");
#endif /* TIMING */

	/*
	 * Check for fortuitous matches and output differences
	 */
	oldseek = (long far *)farmyalloc(
				(lenA + 2) * sizeof(*oldseek), "oldseek");
	newseek = (long far *)farmyalloc(
				(lenB + 2) * sizeof(*newseek), "newseek");
	textb = myalloc(sizeof text, "textbuffer");
	if(0 != (diff_spurious = check(fname[0], fname[1])))
		fprintf(stderr, "%s: Spurious match, output is not optimal\n",
			cmdname);
#ifdef	TIMING
	ptime("check");
#endif /* TIMING */
	output(fname[0], fname[1]);
#ifdef	TIMING
	ptime("output");
	printf("%ld seconds required\n", sectiontime - totaltime);
#endif /* TIMING */

	unlink_tmp();
	if(diff_spurious) return RET_SPURIOUS;
	if(diff_found) return RET_DIFF;
	if(cflag) printf("No differences encountered\n");
	return RET_SAME;
}


/*
 * Read the file, building hash table
 */

static	void	input(which)
	int		which;		/* 0 or 1 to redefine infd[]  */
{
	register LINE far *lentry;
	register Int	linect = 0;
	FILE		*fd;
#define	LSIZE_INC 200		     /* # of line entries to alloc at once */
	Int		lsize = LSIZE_INC;

	lentry = (LINE far *)farmyalloc(sizeof(LINE) * (lsize + 3), "line");
	fd = infd[which];
	while(!get_line(fd, text)){
		if(++linect >= lsize){
			lsize += 200;
			lentry = (LINE far *)farcompact((char far *)lentry,
			 (lsize + 3) * sizeof(LINE), "extending line vector");
		}
		lentry[linect].hash = hash(text);
	}

	/*
	 * If input was from stdin ("-" command), finish off the temp file.
	 */
	if(fd == stdin){
#ifdef USE_TMPFILE
		rewind(tempfd); infd[which] = tempfd;
#else
		tempfd = infd[which] = freopen(TEMPFILE, "r", tempfd);
#endif
	}

/*
 * If we wanted to be stingy with memory, we could realloc lentry down to
 * its exact size (+3 for some odd reason) here.  No need?
 */
	len[which] = linect;
	file[which] = lentry;
}


/*
 * Look for initial and trailing sequences that have identical hash values.
 * Don't bother building them into the candidate vector.
 */

static	void	squish()
{
	register Int	i;
	register LINE far *ap, far *bp;
	Int		j;
	Int		k;

	/*
	 * prefix -> first line (from start) that doesn't hash identically
	 */
	i = 0;
	ap = &fileA[(Int)1];
	bp = &fileB[(Int)1];
	while(i < lenA && i < lenB && ap->hash == bp->hash){
		++i, ap += (Int)1, bp += (Int)1;
	}
	prefix = i;

	/*
	 * suffix -> first line (from end) that doesn't hash identically
	 */
	j = lenA - i;
	k = lenB - i;
	ap = &fileA[lenA];
	bp = &fileB[lenB];
	i = 0;
	while(i < j && i < k && ap->hash == bp->hash){
		++i, ap -= (Int)1, bp -= (Int)1;
	}
	suffix = i;

	/*
	 * Tuck the counts away
	 */
	for(k = 0; k <= 1; k++){
		sfile[k] = file[k] + prefix;
		j = slen[k] = len[k] - prefix - suffix;

		for(i = 0, ap = sfile[k]; i <= slen[k];
		     ++i, ap += (Int)1){
			ap->serial = (unsigned short)i;
			 /* i\邪 */
		}
	}
}


/*
 * Sort hash entries
 */

static	void	sort(vector, vecsize)
	LINE	far	*vector;	/* What to sort		  */
	Int		vecsize;	/* How many to sort	 */
{
	register Int	j;
	LINE	far *ai, far *aim;
	Int		mid;
	Int		k;
	LINE		work;

#ifdef MSDOS
	vector += 0L; /* regularize far ptr */
#endif
	for(j = 1; j <= vecsize; j *= 2);
	mid = (j - 1);
	while((mid /= 2) != 0){
		k = vecsize - mid;
		for(j = 1; j <= k; j++){
			for(ai = &vector[j]; ai > vector /*fpc*/; ai -= mid){
				aim = &ai[mid];
				if(aim < ai) /* fpc */
					break;		/* ?? Why ??	 */
				if(aim->hash > ai->hash ||
					aim->hash == ai->hash &&
					aim->serial > ai->serial)
					break;
				work.hash = ai->hash;
				ai->hash = aim->hash;
				aim->hash = work.hash;
				work.serial = ai->serial;
				ai->serial = aim->serial;
				aim->serial = work.serial;
			}
		}
	}
}


/*
 * Build equivalence class vector
 */

static	void	equiv()
{
	LINE	far *ap;
	union {
		LINE	far	*bp;
		short	far	*mp;
	}		r;
	register Int	j;
	LINE	far	*atop;

#ifdef	DEBUG
	printf("equiv entry\n");
	for(j = 1; j <= slenA; j++)
		printf("sfileA[%ld] = %6d %06o\n",
			   (long)j, sfileA[j].serial, sfileA[j].hash);
	for(j = 1; j <= slenB; j++)
		printf("sfileB[%ld] = %6d %06o\n",
			   (long)j, sfileB[j].serial, sfileB[j].hash);
#endif /* DEBUG */
	j = 1;
	ap = &sfileA[(Int)1];
	r.bp = &sfileB[(Int)1];
	atop = &sfileA[slenA];
	while(ap <= atop /* fpc */ && j <= slenB){
		if(ap->hash < r.bp->hash){
			ap->hash = 0;
			ap += (Int)1;
		} else if(ap->hash == r.bp->hash){
			ap->hash = (unsigned short)j;
			 /* j\邪 */
			ap += (Int)1;
		} else {
			r.bp += (Int)1;
			j++;
		}
	}
	while(ap <= atop /* fpc */){
		ap->hash = 0;
		ap += (Int)1;
	}
	sfileB[slenB + 1].hash = 0;
#ifdef	DEBUG
	printf("equiv exit\n");
	for(j = 1; j <= slenA; j++)
		printf("sfileA[%ld] = %6d %06o\n",
			   (long)j, sfileA[j].serial, sfileA[j].hash);
	for(j = 1; j <= slenB; j++)
		printf("sfileB[%ld] = %6d %06o\n",
			   (long)j, sfileB[j].serial, sfileB[j].hash);
#endif /* DEBUG */
	ap = &sfileB[(Int)0];
	atop = &sfileB[slenB];
	r.mp = &member[(Int)0];
	while((ap += (Int)1) <= atop /* fpc */){
		*(r.mp += (Int)1) = -(ap->serial);
		while(ap[1].hash == ap->hash){
			ap += (Int)1, r.mp += (Int)1;
			*r.mp = ap->serial;
		}
	}
	r.mp[1] = -1;
#ifdef	DEBUG
	for(j = 0; j <= slenB; j++)
		printf("member[%ld] = %d\n", (long)j, member[j]);
#endif /* DEBUG */
}


/*
 * Build class vector
 */

static	void	unsort()
{
	register int	far	*temp;
	register int	far	*tp;
	union {
		LINE	far	*ap;
		short	far	*cp;
	}		u;
	LINE	far	*evec;
	short	far	*eclass;
#ifdef	DEBUG
	Int		i;
#endif /* DEBUG */

	temp = (int far *)farmyalloc((slenA+1)*sizeof(int), "unsort scratch");
	u.ap = &sfileA[(Int)1];
	evec = &sfileA[slenA];
	while(u.ap <= evec /* fpc */){
#ifdef	DEBUG
		printf("temp[%2d] := %06o\n", u.ap->serial, u.ap->hash);
#endif /* DEBUG */
		temp[(Int)u.ap->serial] = u.ap->hash;
		u.ap += (Int)1;
	}

	/*
	 * Copy into class vector and free work space
	 */
	u.cp = &class[(Int)1];
	eclass = &class[slenA];
	tp = &temp[(Int)1];
	while(u.cp <= eclass /* fpc */){
		*u.cp = *tp, u.cp += (Int)1, tp += (Int)1;
	}
#ifndef OSK
	farfree((char far *)temp);
#else /* OSK */
	free((char *)temp - sizeof(int));
#endif /* OSK */
#ifdef	DEBUG
	printf("unsort exit\n");
	for(i = 1; i <= slenA; i++)
		printf("class[%ld] = %d %06o\n", (long)i, class[i], class[i]);
#endif /* DEBUG */
}


/*
 * Generate maximum common subsequence chain in clist[]
 */

static	Int	subseq()
{
	Int		a;
	register unsigned Int	ktop;
	register Int	b;
	register Int	s;
	unsigned Int	r;
	Int		i;
	Int		cand;

	klist[0] = newcand((Int)0, (Int)0, (Int)0-1);
	klist[1] = newcand(slenA + 1, slenB + 1, (Int)0-1);
	ktop = 1;					/* -> guard entry  */
	for(a = 1; a <= slenA; a++){

		/*
		 * For each non-zero element in fileA ...
		 */
		if((i = class[a]) == 0)
			continue;
		cand = klist[0];		/* No candidate now  */
		r = 0;				/* Current r-candidate	*/
		do {
#ifdef	DEBUG
			printf("a = %ld, i = %ld, b = %d\n",
						(long)a, (long)i, member[i]);
#endif /* DEBUG */

			/*
			 * Perform the merge algorithm
			 */
			if((b = member[i]) < 0)
				b = -b;
#ifdef	DEBUG
			printf("search(%ld, %ld, %ld) -> %ld\n", (long)r,
				(long)ktop, (long)b, (long)search(r, ktop, b));
#endif /* DEBUG */
			if((s = search(r, ktop, b)) != 0){
				if(clist[klist[s]].b > b){
					klist[r] = cand;
					r = s;
					cand = newcand(a, b, klist[s - 1]);
#ifdef	DEBUG
					dumpklist(ktop, "klist[s-1]->b > b");
#endif /* DEBUG */
				}
				if(s >= ktop){
					klist[ktop + 1] = klist[ktop];
					ktop++;
#ifdef	DEBUG
					klist[r] = cand;
					dumpklist(ktop, "extend");
#endif /* DEBUG */
					break;
				}
			}
		} while(member[++i] > 0);
		klist[r] = cand;
	}
#ifdef	DEBUG
	printf("last entry = %ld\n", (long)ktop - 1);
#endif /* DEBUG */
	return (ktop - 1);			/* Last entry found  */
}


static	Int	newcand(a, b, pred)
	Int	 a;			/* Line in fileA	  */
	Int	 b;			/* Line in fileB	  */
	Int	 pred;		/* Link to predecessor, index in cand[]	 */
{
	register CANDIDATE far *new;

	if((clength += 2) >= csize){
		csize += CSIZE_INC;
		clist = (CANDIDATE far *)farcompact((char far *)clist,
				csize * sizeof(CANDIDATE), "extending clist");
	}
	new = &clist[clength - 1];
	new->a = a;
	new->b = b;
	new->link = pred;
	return (clength - 1);
}


/*
 * Search klist[low..top] (inclusive) for b.  If klist[low]->b >= b,
 * return zero.	 Else return s such that klist[s-1]->b < b and
 * klist[s]->b >= b.  Note that the algorithm presupposes the two
 * preset "fence" elements, (0, 0) and (slenA, slenB).
 */

static	Int	search(low, high, b)
	register unsigned Int low;
	register unsigned Int high;
	register Int	b;
{
	register Int	temp;
	register unsigned Int mid;

	if(clist[klist[low]].b >= b)
		return (0);
	while((mid = (low + high) / 2) > low){
		if((temp = clist[klist[mid]].b) > b)
			high = mid;
		else if(temp < b)
			low = mid;
		else {
			return (mid);
		}
	}
	return (mid + 1);
}


static	void	unravel(k)
	register Int	k;
{
	register Int	i;
	register CANDIDATE far *cp;
	Int		first_trailer;
	Int		difference;

	first_trailer = lenA - suffix;
	difference = lenB - lenA;
#ifdef	DEBUG
	printf("first trailer = %ld, difference = %ld\n",
		   (long)first_trailer, (long)difference);
#endif /* DEBUG */
	for(i = 0; i <= lenA; i++){
		match[i] = (i <= prefix) ? i
			: (i > first_trailer) ? i + difference
			: 0;
	}
#ifdef	DEBUG
	printf("unravel\n");
#endif /* DEBUG */
	while(k != -1){
		cp = &clist[k];
#ifdef	DEBUG
		if(k < 0 || k >= clength){
			fprintf(stderr, "[%ld]: Illegal link.\n", (long)k);
		}
		printf("match[%ld] := %ld\n",
			(long)cp->a + prefix, (long)cp->b + prefix);
#endif /* DEBUG */
		match[cp->a + prefix] = cp->b + prefix;
		k = cp->link;
	}
}


/*
 * Check for hash matches (jackpots) and collect random access indices to
 * the two files.
 *
 * It should be possible to avoid doing most of the ftell's by noticing
 * that we are not doing a context diff and noticing that if a line
 * compares equal to the other file, we will not ever need to know its
 * file position.  FIXME.
 */

static	check(fileAname, fileBname)
	char		*fileAname;
	char		*fileBname;
{
	register Int	a;			/* Current line in file A  */
	register Int	b;			/* Current line in file B  */
	int		jackpot;

/*
 * The VAX C ftell() returns the address of the CURRENT record, not the
 * next one (as in DECUS C or, effectively, other C's).	 Hence, the values
 * are "off by one" in the array.  OFFSET compensates for this.
 */

#ifdef vms
#  define OFFSET (-1)
#else /* !vms */
#  define OFFSET 0
#endif /* vms */

	b = 1;
	rewind(infd[0]);
	rewind(infd[1]);
/*
 * See above; these would be over-written on VMS anyway.
 */

#ifndef vms
	oldseek[0] = ftell(infd[0]);
	newseek[0] = ftell(infd[1]);
#endif /* vms */

	jackpot = 0;
#ifdef DEBUG
	printf("match vector\n");
	for(a = 0; a <= lenA; a++)
		printf("match[%ld] = %ld\n", (long)a, (long)match[a]);
#endif /* DEBUG */
	for(a = 1; a <= lenA; a++){
		if(match[a] == 0){
			/* Unique line in A */
			oldseek[a + OFFSET] = ftell(infd[0]);
			get_line(infd[0], text);
			continue;
		}
		while(b < match[a]){
			/* Skip over unique lines in B */
			newseek[b + OFFSET] = ftell(infd[1]);
			get_line(infd[1], textb);
			b++;
		}

	/*
	 * Compare the two, supposedly matching, lines. Unless we are going
	 * to print these lines, don't bother to remember where they are.  We
	 * only print matching lines if a context diff is happening, or if a
	 * jackpot occurs.
	 */
		/* if(cflag) */ {
		 /* s̐擪spurious matchNꍇA̍s
		    ʒuoĂ˂΂ȂȂ̂ŁAcflagUł
		    ͕Kv */
			oldseek[a + OFFSET] = ftell(infd[0]);
			newseek[b + OFFSET] = ftell(infd[1]);
		}
		get_line(infd[0], text);
		get_line(infd[1], textb);
		if(strcmp(text, textb)) /* was if(!streq(text, textb))c */
		{
			char *fmt = "line %ld in %s, \"%s\"\n";

			fprintf(stderr, "Spurious match:\n");
			fprintf(stderr, fmt, (long)a, fileAname, text);
			fprintf(stderr, fmt, (long)b, fileBname, textb);
			match[a] = 0;
			jackpot = 1; /* was jackpot++; originally */
		}
		b++;
	}
	for(; b <= lenB; b++){
		newseek[b + OFFSET] = ftell(infd[1]);
		get_line(infd[1], textb);
	}
/*
 * The logical converse to the code up above, for NON-VMS systems, to
 * store away an fseek() pointer at the beginning of the file.	For VMS,
 * we need one at EOF...
 */

#ifdef vms
	oldseek[lenA] = ftell(infd[0]);
	get_line(infd[0], text);		/* Will hit EOF...  */
	newseek[lenB] = ftell(infd[1]);
	get_line(infd[1], textb);	/* Will hit EOF...  */
#endif /* vms */

	return (jackpot);
}


static	void	output(fileAname, fileBname)
	char		*fileAname, *fileBname;
{
	register Int	astart;
	register Int	aend = 0;
	Int		bstart;
	register Int	bend;

	rewind(infd[0]);
	rewind(infd[1]);
	match[0] = 0;
	match[lenA + 1] = lenB + 1;
	if(!eflag){
	     /*
		if(cflag) printf("*** %s\n--- %s\n", fileAname, fileBname);
	     */ /* moved into change() */

		/*
		 * Normal printout
		 */
		for(astart = 1; astart <= lenA; astart = aend + 1){

			/*
			 * New subsequence, skip over matching stuff
			 */
			while(astart <= lenA
				   && match[astart] == (match[astart - 1] + 1))
				astart++;

			/*
			 * Found a difference, setup range and print it
			 */
			bstart = match[astart - 1] + 1;
			aend = astart - 1;
			while(aend < lenA && match[aend + 1] == 0)
				aend++;
			bend = match[aend + 1] - 1;
			match[aend] = bend;
			change(astart, aend, fileAname,
			       bstart, bend, fileBname);
		}
	} else {

	/*
	 * Edit script output -- differences are output "backwards" for the
	 * benefit of a line-oriented editor.
	 */
		for(aend = lenA; aend >= 1; aend = astart - 1){
			while(aend >= 1
				   && match[aend] == (match[aend + 1] - 1)
				   && match[aend] != 0)
				aend--;
			bend = match[aend + 1] - 1;
			astart = aend + 1;
			while(astart > 1 && match[astart - 1] == 0)
				astart--;
			bstart = match[astart - 1] + 1;
			match[astart] = bstart;
			change(astart, aend, fileAname,
			       bstart, bend, fileBname);
		}
	}
	if(lenA == 0)
		change((Int)1, (Int)0, fileAname, (Int)1, lenB, fileBname);
}


/*
 * Output a change entry: fileA[astart..aend] changed to fileB[bstart..bend]
 */

static	void	change(astart, aend, fileAname, bstart, bend, fileBname)
	Int		astart, aend;
	Int		bstart, bend;
	char		*fileAname, *fileBname;
{
	char		c;

	/*
	 * This catches a "dummy" last entry
	 */
	if(astart > aend && bstart > bend)
		return;
	if(!diff_found){ /* add Nide */
		diff_found = 1;
		if(!eflag && cflag){ /* moved from within output() */
		/*
		 * Should include ctime style dates after the file names, but
		 * this would be non-trivial on OSK. Perhaps there should be a
		 * special case for stdin.
		 */
			printf("*** %s\n--- %s\n", fileAname, fileBname);
		}
	}
	c = (char)((astart > aend) ? 'a' : (bstart > bend) ? 'd' : 'c');
	if(cflag)
		fputs("**************\n*** ", stdout);

	if(c == 'a' && !cflag)
		range(astart - 1, astart - 1, 0); /* Addition: just print one
								 * odd # */
	else
		range(astart, aend, 0);	/* Print both, if different */
	if(!cflag){
		putchar(c);
		if(!eflag){
			if(c == 'd')
				range(bstart - 1, bstart - 1, 1);
				 /* Deletion: just print * one odd # */
			else
				range(bstart, bend, 1);
				 /* Print both, if different */
		}
	}
	putchar('\n');
	if((!eflag && c != 'a') || cflag){
		fetch(oldseek, astart, aend, lenA, infd[0],
			  cflag ? (c == 'd' ? "- " : "! ") : "< ");
		if(cflag){
			fputs("--- ", stdout);
			range(bstart, bend, 1);
			fputs(" -----\n", stdout);
		} else if(astart <= aend && bstart <= bend)
			printf("---\n");
	}
	fetch(newseek, bstart, bend, lenB, infd[1],
		  cflag ? (c == 'a' ? "+ " : "! ") : (eflag ? "" : "> "));
	if(eflag && bstart <= bend)
		printf(".\n");
}


/*
 * Print a range
 */

static	void	range(from, to, w)
	Int		from;
	Int		to;
	int		w;
{
	if(cflag){
		if((from -= cflag) <= 0)
			from = 1;
		if((to += cflag) > len[w])
			to = len[w];
	}
	if(to > from){
		printf("%ld,%ld", (long)from, (long)to);
	} else if(to < from){
		printf("%ld,%ld", (long)to, (long)from);
	} else {
		printf("%ld", (long)from);
	}
}


/*
 * Print the appropriate text
 */

static	void	fetch(seekvec, start, end, trueend, fd, pfx)
	long	far	*seekvec;
	register Int	start;
	register Int	end;
	Int		trueend;
	FILE		*fd;
	char		*pfx;
{
	register Int	i;
	register Int	first;
	register Int	last;

	if(cflag){
		if((first = start - cflag) <= 0)
			first = 1;
		if((last = end + cflag) > trueend)
			last = trueend;
	} else {
		first = start;
		last = end;
	}
/* added by Nide */
	if(first == last + 1){ /* do nothing */
	} else
/* added by Nide end */
	if(fseek(fd, seekvec[first], 0) != 0){
		printf("?Can't read line %ld at %08lx (hex) in file%c\n",
		    (long)start, seekvec[first], (fd == infd[0])? 'A' : 'B');
	} else {
		for(i = first; i <= last; i++){
			if(fgetss(text, sizeof text, fd) == NULL){
				printf("** Unexpected end of file\n");
				break;
			}
#ifdef DEBUG
			printf("%5d: %s%s\n", i, pfx, text);
#else /* !DEBUG */
			fputs((cflag && (i < start || i > end)) ? "  " : pfx,
				stdout);
			fputs(text, stdout);
			putchar('\n');
#endif /* DEBUG */
		}
	}
}


/*
 * Input routine, read one line to buffer[], return TRUE on eof, else FALSE.
 * The terminating newline is always removed.  If "-b" was given, trailing
 * whitespace (blanks and tabs) are removed and strings of blanks and
 * tabs are replaced by a single blank.	 get_line() does all hacking for
 * redirected input files.
 */

static	int	get_line(fd, buffer)
	FILE		*fd;
	char		*buffer;
{
	register char	*top;
	register char	*fromp;
	register char	c;

	if(fgetss(buffer, sizeof text, fd) == NULL){
		*buffer = EOS;
		return (TRUE);
	}
	if(fd == stdin)
		fputs_cr(buffer, tempfd);
	if(bflag || wflag || iflag){
		top = buffer;
		fromp = buffer;
		while((c = *fromp++) != EOS){
			if(wflag && is_space(c)) continue;
			if(bflag && is_space(c)){
				c = ' ';
				while(is_space(*fromp))
					fromp++;
			}
			if(iflag){
#ifdef MSDOS
				if(iskanji(c)){ /* Nide */
					*top++ = c;
					if((c = *fromp++) == EOS) break;
				} else
#endif
					c = to_lower(c);
			}
			*top++ = c;
		}
		if(bflag && buffer < top /* Nide */ && top[-1] == ' ')
			top--;
		*top = EOS;
	}
	return (FALSE);
}


static unsigned short crc16a[] = {
					  0000000, 0140301, 0140601, 0000500,
					  0141401, 0001700, 0001200, 0141101,
					  0143001, 0003300, 0003600, 0143501,
					  0002400, 0142701, 0142201, 0002100,
};

static unsigned short crc16b[] = {
					  0000000, 0146001, 0154001, 0012000,
					  0170001, 0036000, 0024000, 0162001,
					  0120001, 0066000, 0074000, 0132001,
					  0050000, 0116001, 0104001, 0043000,
};


/*
 * Return the CRC16 hash code for the buffer
 * Algorithm from Stu Wecker (Digital memo 130-959-002-00).
 */

static	unsigned short	hash(buffer)
	char		*buffer;
{
	register unsigned short crc;
	register char	*tp;
	register short	temp;

	crc = 0;
	for(tp = buffer; *tp != EOS;){
		temp = *tp++ ^ crc;		/* XOR crc with new char  */
		crc = (crc >> 8)
			^ crc16a[(temp & 0017)]
			^ crc16b[(temp & 0360) >> 4];
	}
#ifdef	DEBUG_ALL
	printf("%06o: %s\n", (crc == 0) ? 1 : crc, buffer);
#endif /* DEBUG_ALL */
	return ((crc == 0) ? (unsigned short) 1 : crc);
}


#ifdef vms
static	opendir(which, arg, okfd)
	int		which;		/* Which file to open (0 or 1)	 */
	char		**arg;		/* File name argument, &argv[which]  */
	FILE		*okfd;		/* File name (already open)	 */
{
	register char	*tp;
	register int	c;
	register char	*newname;

	fgetname(okfd, text);

	/*
	 * Skip over device name
	 */
	for(tp = text; (c = *tp) && c != ':'; tp++);
	if(c)
		tp++;
	else
		tp = text;

	/*
	 * Skip over [UIC] or [PPN] if present
	 */
	if(*tp == '[' || *tp == '('){
		while((c = *tp++) && c != ']' && c != ')');
		if(c == 0){
			fprintf(stderr, "?Bug: bad file name \"%s\"\n",
					text);
			tp--;
		}
	}
	strcpy(text, tp);

	/*
	 * Don't include version
	 */
	for(tp = text; (c = *tp) && c != ';'; tp++);
	*tp = 0;

	/*
	 * Now, text has the file name, tp - text, its length, and *arg the
	 * (possible) directory name.  Create a new file name for opening.
	 */
#  ifndef OSK
	if((newname = malloc(tp - text + strlen(*arg) + 1)) == NULL)
		differror("Out of space at start");
#    ifdef AMIGA
	savsiz = tp - text + strlen(*arg) + 1;
	savptr = newname;
#    endif /* AMIGA */
#  else /* OSK */
	newname = myalloc(tp - text + strlen(*arg) + 1,
				"Out of space at start");
#  endif /* OSK */
	concat(newname, *arg, text, NULL);
	if((infd[which] = fopen(newname, "r")) == NULL)
		cant(*arg, "constructed input", RET_ERROR);
	else
		*arg = newname;
}
/* Amiga C doesn't have all these extensions for directory... */
#endif /* vms */


/*
 * Allocate or crash.
 */

static	char	*myalloc(amount, why)
	unsigned	amount;
	char		*why;
{
	register char	*pointer;

#ifdef OSK
	amount += sizeof(int);
#endif /* OSK */
	if((pointer = malloc((unsigned) amount)) == NULL)
		noroom(why);
#ifdef OSK
	*((int *)pointer) = amount;
	pointer += sizeof(int);
#  ifdef DEBUG
	fprintf(stderr, "Myalloc: %d at %06o\n", amount, pointer);
#  endif /* DEBUG */
#endif /* OSK */
#ifdef	AMIGA
	savsiz = amount;
	savptr = pointer;
#endif /* AMIGA */

	return (pointer);
}

#ifdef MSDOS
static	char	far	*farmyalloc(amount, why)
unsigned long	amount;
char	*why;
{
	char	far	*p;

	if(NULL == (p = farmalloc(amount))) noroom(why);
	 /* on MSC this causes error, but we really need long argument... */
	return p;
}

static	char	far	*farcompact(p, new_amount, why)
char	far	*p;
unsigned long	new_amount;
char	*why;
{
	 /* on MSC this causes error, but we really need long argument... */
	if(NULL == (p = farrealloc((char far *)p, new_amount))) noroom(why);
	return p;
}
#endif

/*
 * Reallocate pointer, compacting storage
 *
 * The "compacting storage" part is probably not relevant any more.
 * There used to be horrid code here that malloc'd one byte and freed
 * it at magic times, to cause garbage collection of the freespace
 * or something.  It's safely gone now, you didn't have to see it.
 *	-- John Gilmore, Nebula Consultants, Sept 26, 1986
 */

#ifndef MSDOS /* not used on MSDOS anymore */
static	char	*compact(pointer, new_amount, why)
	char		*pointer;
	unsigned	new_amount;
	char		*why;
{
	register char	*new_pointer;

#ifndef AMIGA
#  ifndef OSK
#    ifndef TOOLS /* if TOOLS, already defined in tools.h */
#      ifdef TURBO
	extern void	*realloc();
#      else /* !TURBO */
	extern char	*realloc();
#      endif /* TURBO */
#    endif

	if((new_pointer = realloc(pointer, (unsigned) new_amount)) == NULL){
		noroom(why);
	}
#  else /* OSK */
	register int	old_amount;
	new_amount += sizeof(int);
	if((new_pointer = malloc(new_amount)) == NULL)
		noroom(why);
	*(int *)new_pointer = new_amount;
	new_pointer += sizeof(int);
	old_amount = *(((int *)pointer) - 1);
	/* _strass is like bcopy with the first two arguments reversted */
	_strass(new_pointer, pointer, (new_amount <= old_amount ?
				   new_amount : old_amount) - sizeof(int));
#    ifdef DEBUG
	fprintf(stderr, "compact %d to %d from %06o to %06o\n",
			old_amount, new_amount, pointer, new_pointer);
#    endif /* DEBUG */
	free(pointer - sizeof(int));
#  endif /* OSK */
#else /* AMIGA */

/*
 * This routine is heavily dependent on C storage allocator hacks For
 * Amiga, we can't rely on storage being left alone "up to" the boundary
 * of allocation as in VMS or RSX. Therefore we have to be different here
 * and allocate a new larger segment, then free the old one. Messy but
 * hopefully it will work.
 */
	extern char	*malloc();

	/* No realloc().  Do a malloc and copy it.  */
	if((new_pointer = malloc((unsigned) new_amount)) == NULL){
		noroom(why);
	}
  /* This MUST assume the program calls compact using the old pointer as the
  last call of malloc... Reason is that RSX version is really simpleminded */
	cpysiz = savsiz;
  /* Complain if deallocate area not same as last allocate area */
	if(savptr != pointer)
		bogus(why);
	wrk2 = new_pointer;
	for(wrk = pointer; cpysiz > 0; cpysiz--){
  /* copy data to new area */
		*wrk2++ = *wrk++;
	}
  /* when done, free old memory area. */
	free(pointer);
#endif /* AMIGA */

#ifndef OSK
#  ifdef DEBUG
	if(new_pointer != pointer){
		fprintf(stderr, "moved from %06o to %06o\n",
				pointer, new_pointer);
	}
/*  rdump(new_pointer, why);
*/
#  endif /* DEBUG */
#endif /* OSK */
	return (new_pointer);
}
#endif

static	void	noroom(why)
	char		*why;
{
	fprintf(stderr, "?DIFF-F-out of room when %s\n", why);
	exit(RET_ERROR);
}


#ifdef	AMIGA
static	void	bogus(why)
	char		*why;
{
	fprintf(stderr, "?DIFF-F-invalid compaction when %s\n", why);
	exit(RET_ERROR);
}
#endif	/* AMIGA */


#ifdef	DEBUG
/*
 * Dump memory block
 */

static	void	rdump(pointer, why)
	int		*pointer;
	char		*why;
{
	int		*last;
	int		count;

	last = ((int **)pointer)[-1];
	fprintf(stderr, "dump %s of %06o -> %06o, %d words",
			why, pointer, last, last - pointer);
	last = (int *)(((int) last) & ~1);
	for(count = 0; pointer < last; ++count){
		if((count & 07) == 0){
			fprintf(stderr, "\n%06o", pointer);
		}
		fprintf(stderr, "\t%06o", *pointer);
		pointer++;
	}
	fprintf(stderr, "\n");
}
#endif /* DEBUG */


/*
 * Can't open file message
 */

static	void	cant(filename, what, fatalflag)
	char		*filename;
	char		*what;
	int		fatalflag;
{
	fprintf(stderr, "%s: Can't open %s file \"%s\": ",
		cmdname, what, filename);
#ifndef	OSK
	perror("");
#else
	prerr(0, errno);
#endif
	if(fatalflag){
		exit(fatalflag);
	}
}

#ifdef	DEBUG
static	void	dumpsfile()
{
	Int	li;

	for(li = 1; li <= slenA; li++)
		printf("sfileA[%ld] = %6d %06o\n",
			   (long)li, sfileA[li].serial, sfileA[li].hash);
	for(li = 1; li <= slenB; li++)
		printf("sfileB[%ld] = %6d %06o\n",
			   (long)li, sfileB[li].serial, sfileB[li].hash);
}

static	void	dump(d_linep, d_len, d_which)
	LINE		*d_linep;
	int		d_len;
	int		d_which;
{
	register int	i;

	printf("Dump of file%c, %d elements\n", "AB"[d_which], d_len);
	printf("linep @ %06o\n", d_linep);
	for(i = 0; i <= d_len; i++){
		printf("%3d  %6d  %06o\n", i,
			   d_linep[i].serial, d_linep[i].hash);
	}
}


/*
 * Dump klist
 */

static	void	dumpklist(kmax, why)
	int		kmax;
	char		*why;
{
	register int	i;
	register CANDIDATE far *cp;
	register int	count;

	printf("\nklist[0..%d] %s, clength = %d\n", kmax, why, clength);
	for(i = 0; i <= kmax; i++){
		cp = &clist[klist[i]];
		printf("%2d %2d", i, klist[i]);
		if(cp >= &clist[0] && cp < &clist[clength])
			printf(" (%2d %2d -> %2d)\n", cp->a, cp->b, cp->link);
		else if(klist[i] == -1)
			printf(" End of chain\n");
		else
			printf(" illegal klist element\n");
	}
	for(i = 0; i <= kmax; i++){
		count = -1;
		for(cp = (CANDIDATE far *)klist[i]; cp > &clist[0];
			 cp = (CANDIDATE far *)&cp->link){
#ifdef MSDOS
		    ??? farΉ̏C@悭킩B܂ADEBUG
		    defineȂΖ炢BNide
#endif
			if(++count >= 6){
				printf("\n    ");
				count = 0;
			}
			printf(" (%2d: %2d,%2d -> %d)",
				   cp - clist, cp->a, cp->b, cp->link);
		}
		printf("\n");
	}
	printf("*\n");
}
#endif	/* DEBUG */



#ifdef	TIMING

/*
 * Dump time buffer
 */

static	void	ptime(why)
	char		*why;
{
	long		ttemp;

	ttemp = time(NULL);
	printf("%ld seconds for %s\n",
		   ttemp - sectiontime, why);
	sectiontime = ttemp;
}
#endif	/* TIMING */

/*
 * Error message before retiring.
 */
static	void	differror(msg)
	char		*msg;
{
	fprintf(stderr, "%s: %s\n", cmdname, msg), exit(RET_ERROR);
}

/*
 * Fgetss() is like fgets() except that the terminating newline
 * is removed.
 */

static	char	*fgetss(s, n, iop)
	char		*s;
	int		n;
	register FILE	*iop;
{
	register char	*cs;

	if(fgets(s, n, iop) == NULL)
		return ((char *)NULL);
	cs = s + strlen(s) - 1;
	if(*cs == '\n')
		*cs = '\0';
	return (s);
}

 /* From here, added by Nide */
#ifdef MSDOS
#  define isdelim(c) ((c) == '\\' || (c) == '/' || (c) == ':')
#endif

#ifdef DIRFCMP
static	isdir(fnm)
 /* on TURBOC, which files are needed to be included? */
char	*fnm;
{
#  ifdef MSDOS
	struct	Find_t	f;

	return !find_Fixedfile(fnm, &f, 0) && ((char)f . attrib & _A_SUBDIR);
#  else
	struct	stat	statbuf;

	return !stat(fnm, &statbuf) &&
	       (statbuf . st_mode & S_IFMT) == S_IFDIR;
#  endif /* MSDOS */
}
#endif /* DIRFCMP */

#ifdef MSDOS
static	char	*difftmpnam() /* ad hoc */
{
	static	char	name[13], *temfile = NULL;
	extern	char	*getenv();
	union	REGS	in, out;

	if(temfile != NULL) return temfile;

	in . h . ah = 0x2c;
	in . h . dl = 0; /* Ô */
	intdos(&in, &out);
	sprintf(name, "_%07lx.$dt", 0xfffffffL & (getpid() +
				(3600L * 3000)	* out . h . ch +
				(60L * 3000)	* out . h . cl +
				3000L		* out . h . dh +
				30		* out . h . dl));
	if(NULL == (temfile = getenv("TMP")) &&
	   NULL == (temfile = getenv("TEMP"))) return(temfile = name);
	return(temfile = dircat(temfile, name));
}
#endif /* MSDOS */

#ifdef DIRFCMP
static	char	*basefname(fnm)
char	*fnm;
{
	char	*p, *q;

#  ifdef MSDOS
	for(p = NULL, q = fnm; *q; q += (iskanjipos(q) ? 2 : 1)){
		if(isdelim(*q)) p = q;
	}
#  else /* MSDOS */
	for(p = NULL, q = fnm; *q; q++){
		if(*q == '/') p = q;
	}
#  endif /* MSDOS */
	return(p == NULL ? fnm : ++p);
}

static	char	*dircat(dir, fnm)
char	*dir, *fnm;
{
	char	*buf, *p, *q;

	fnm = basefname(fnm);

	if(NULL == (buf = malloc(strlen(dir) + 1 + strlen(fnm) + 1))){
		fprintf(stderr, "%s: Memory not enough.\n", cmdname);
		exit(RET_ERROR);
	}
#  ifdef MSDOS
	for(p = NULL, q = dir; *q; p = q, q += (iskanjipos(q) ? 2 : 1));
	sprintf(buf, (p == NULL || !isdelim(*p)) ? "%s/%s" : "%s%s",
		dir, fnm);
#  else /* MSDOS */
	sprintf(buf, "%s/%s", dir, fnm);
#  endif /* MSDOS */

	return(buf);
}
#endif /* DIRFCMP */
