#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <string.h>
#include "tools.h"

char	*cmdname = "du";

static	bool	a_opt, s_opt, d_opt, o_opt, b_opt, c_opt;
static	us_long	fixclusz = 0;
static	char	exitcode;

struct	du_info	{
	us_long	sum;
	us_char	sum_h;
	 /* 1t@C̗eʂlongɎ܂ȂP[X͍lĂȂ(蔲)B
	    vlongɎ܂Ȃ͍̂lȀꍇsum_h
	    1oCgƂĎg */
};

static	void	usage()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
	_puterrmes_cr(" [-asdxoSbc] [-C clustersize] [FILE...]"), exit(1);
}

static	us_long	getclusize(drv) /* sȂ0Ԃ */
char	drv; /* s:-1 a:0 b:1c */
{
	union	REGS	in, out;

	if(!++drv) return 0;
	in . h . dl = (us_char)drv;
	in . h . ah = 0x36;
	if(-1 == intdos(&in, &out)) return 0;
	return (us_long)out . x . ax * out . x . cx;
}

static	us_long	occsize(size, truedrv, mode)
 /* LTCYubNPʂŕԂ b_opt̏ꍇ̓oCĝ܂
    Amode0b_optłNX^TCY̔{ɐ؂グ */
us_long	size;
char	truedrv, mode;
{
	us_long	clusize;
	static	us_long	*clusztbl = NULL;

	if((!b_opt || mode) && truedrv != (char)~0){
		if(0 != (clusize = fixclusz)) goto gotclusz;
		if(clusztbl == NULL)
			memset(clusztbl = chk_malloc(sizeof(us_long) * 26),
						'\0', sizeof(us_long) * 26);
		if((0 != (clusize = clusztbl[truedrv]) ||
		    0 != (clusize = clusztbl[truedrv] = getclusize(truedrv)))){
		gotclusz:
			if(size % clusize)
				size += clusize - size % clusize;
		}
	}
	return b_opt ? size : (size + BLOCK_SIZE - 1) / BLOCK_SIZE;
}

static	int	kstrlen(s)
char	*s;
{
	int	len = 0;

	for(; *s; ++s, ++len) if(iskanjipos(s)) ++s;
	return len;
}

#define addsize(info, size) \
	do { \
		if((size) > ((info) -> sum += (size))) ++(info) -> sum_h; \
	} while(0)

#define addsize_h(info, cinfo) \
	do { \
		addsize((info), (cinfo) -> sum); \
		(info) -> sum_h += (cinfo) -> sum_h; \
	} while(0)

static	void	out(name, info)
char	*name;
struct	du_info	*info;
{
	if(info -> sum_h)
		printf(">4G"); /* 蔲 */
	else
		printf("%lu", info -> sum);
	printf("\t%s\n", name);
}

static	void	du_dir(name, truedrv, info)
char	*name;
char	truedrv;
struct	du_info	*info;
{
	struct	Find_t	*fbuf;
	char	*childname, *base;
	us_long	selfamount;
	int	namelen;

	info -> sum = 0L, info -> sum_h = 0;
	selfamount = 64;
	 /* u.vu..v̕BƂ[gł */
	fbuf = chk_malloc(sizeof(struct Find_t));
	 /* dċAŃX^bNgʂ悤autoϐɂȂ */

	childname = chk_strduppathcat(name, PATH_SEP1, ALLNAME);
	namelen = filename_base(childname) - childname;
	if(!_dos_Findfirst(childname, 0x37, fbuf)){
		struct	du_info	childinfo;

		do {
#ifdef SUPP_LFN
			base = fbuf -> lname;
			if(is_self_or_parent_dir(base)) continue;
			if(*fbuf -> name) selfamount +=
					     (kstrlen(base) + 12) / 13 * 32;
			 /* LFN131Gg*/
#else
			if('.' == *(base = fbuf -> name)) continue;
#endif
			selfamount += 32; /* SFN */

			pathname_lower(base, 2);
			childname = chk_realloc(childname,
						namelen + strlen(base) + 1);
			strcpy(childname + namelen, base);
			if((char)fbuf -> attrib & _A_SUBDIR){
				char	childdrv;

				childdrv = gettruedrv(childname);
				if(d_opt && childdrv != truedrv ||
				   s_opt && o_opt) continue;

				du_dir(childname, childdrv, &childinfo);
				if(!s_opt) out(childname, &childinfo);

				if(o_opt) continue; /* doesn't addsize */
			} else {
				childinfo . sum = occsize(
#ifdef SUPP_LFN
							fbuf -> lsize,
#else
							fbuf -> size,
#endif
							truedrv, 0);
				childinfo . sum_h = 0;
				if(a_opt) out(childname, &childinfo);
			}
			addsize_h(info, &childinfo);
		} while(!_dos_Findnext(fbuf));
		_dos_Findclose(fbuf);
	}
	free(childname), free(fbuf);
	addsize(info, occsize(selfamount, truedrv, 1));
	 /* fBNg̃TCY͏ɃNX^TCYɐ؂グ */
}

static	void	du_arg(name, info)
char	*name;
struct	du_info	*info;
{
	struct	Find_t	fbuf;
	char	truedrv;

	if(find_Fixedfile(name, &fbuf, 0)){
		_cmdputerrmes(name), _puterrmes_cr(": Not found.");
		exitcode = 1;
		info -> sum = 0L, info -> sum_h = 0;
		return;
	}
	truedrv = gettruedrv(name);
	if((char)fbuf . attrib & _A_SUBDIR){
		du_dir(name, truedrv, info);
	} else {
		info -> sum = occsize(
#ifdef SUPP_LFN
			fbuf . lsize,
#else
			fbuf . size,
#endif
			truedrv, 0);
		info -> sum_h = 0;
	}
	out(name, info);
}

main(ac, av)
int	ac;
char	*av[];
{
	extern	int	optind, opterr;
	extern	char	*optarg;
	static	char	*self[2] = {".", NULL};
	struct	du_info	info, total;
	int	c;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	opterr = 0;
	while(EOF != (c = getopt(ac, av, "asdxoSbcC:"))){
		cswitch(c){
		case 'a':
			a_opt = 1; break;
		case 's':
			s_opt = 1; break;
		case 'd': case 'x':
			d_opt = 1; break;
		case 'o': case 'S':
			o_opt = 1; break;
		case 'b':
			b_opt = 1; break;
		case 'c':
			c_opt = 1; break;
		case 'C':
			fixclusz = atol(optarg); break;
		default:
			usage();
		}
	}
	if(s_opt) a_opt = 0;

	av += optind, ac -= optind;
	if(!ac) ac = 1, av = self;

	total . sum = 0L, total . sum_h = 0;
	for(; ac; --ac, ++av){
		du_arg(conv_to_unix_format(*av), &info);
		if(c_opt) addsize_h(&total, &info);
	}
	if(c_opt) out("(total)", &total);

	return exitcode;
}
