 /* fgrep.cegrep.c	u#define FGREPvƂfgrepɂȂ */

/* #define FGREP */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <fcntl.h>
#include "tools.h"
#ifndef FGREP
#  include "regexp.h"
#endif
#ifdef ORIG
#  define MAXLEN (1024*4)
#endif
#define BIGBUFSIZ 32767 /* MAX available size in setvbuf() is 32767 */

#ifdef FGREP
static	bool	nocase;
#else
extern	char	*regerr;
#endif

static	int	fnmdisp = -1, status = 1;
static	long	totallcount = 0L;
static	bool	linesonly = 0, fnmonly = 0, lnumdisp = 0, retonly = 0,
		reverse = 0, wholematch = 0, wordmatch = 0;
#ifdef MSDOS
static	char	*bigiobuf;
#endif

#ifdef ORIG
static	char	linbuf[MAXLEN];
#else
static	char	*linbuf = NULL;
#endif /* used in getfpat() and efgrep() */

#ifdef DEBUG
aexit(i){fprintf(stderr, "\nexit %d\n", i), exit(i);}
#  define exit aexit
#endif

#ifdef FGREP
#  ifdef LSI_C
static	char	*strichr(s, c)
register char	*s;
register int	c;
{
	char	tmp[3], *p = tmp;

	return !is_alpha(c) ? strchr(s, c) :
	       (*p++ = tolower(c), *p++ = toupper(c), *p = 0, strpbrk(s, tmp));
} /* ̂Ƃ늿Ή̂striXXX֌Wl */
#  else
static	char	*strichr(s, c)
register char	*s;
register int	c;
{
	c = to_lower(c);
	for(; *s; s++) if((char)to_lower(*s) == (char)c) return(s);
	return(NULL);
}
#  endif /* LSI_C */

#  ifndef MSDOS /* assume EUC */
static	char	*strchr_e(s, c)
register char	*s;
register int	c;
{
	while(*s){
		if(*s == (char)c) return s;
		(*s & 0x80) ? ++s : (s += 2);
	}
	return NULL;
}
static	char	*strichr_e(s, c)
register char	*s;
register int	c;
{
	c = to_lower(c);
	while(*s){
		if(to_lower(*s) == (char)c) return s;
		(*s & 0x80) ? ++s : (s += 2);
	}
	return NULL;
}
#  endif /* !MSDOS */
#endif /* FGREP */

static	void	malloc_err()
{
	perror("malloc"), exit(2);
}

static	char	*getfpat(fnm)
char	*fnm;
{
	char	*p = NULL;
	int	linlen;
	FILE	*f;

	conv_to_unix_format(fnm);
	if(NULL == (f = fopen(fnm, "r"))){
		perror(fnm), exit(2);
	}

#ifdef ORIG
	if(NULL == fgets(linbuf, MAXLEN, f)){
#else
	if(NULL == (linbuf = getline(linbuf, f))){
#endif
		fprintf(stderr, "%s: %s: empty\n", cmdname, fnm), exit(2);
	}
	for(;;){
		if(0 != (linlen = strlen(linbuf)) &&
		   '\n' == (linbuf - 1)[linlen]){ /* chop newline */
			(linbuf - 1)[linlen] = '\0';
		}
#ifdef ORIG
		else if(linlen == MAXLEN - 1){
			fprintf(stderr, "%s: %s: pattern too long\n",
				cmdname, fnm);
			exit(2);
		}
#endif
		if(!*linbuf){
			fprintf(stderr, "%s: Empty pattern found\n", cmdname);
			exit(2);
		}
#ifdef FGREP
		if(NULL == (p = strdup(linbuf))){
			perror("strdup"), exit(2);
		} else break;
#else /* FGREP */
		if(NULL == p){
			if(NULL == (p = malloc(strlen(linbuf) + 3)))
				malloc_err();
			sprintf(p, "(%s)", linbuf);
		} else {
			p = realloc(p, strlen(p) + strlen(linbuf) + 4);
			if(NULL == p){
				perror("realloc"), exit(2);
			}
			sprintf(p + strlen(p), "|(%s)", linbuf);
		}
#ifdef ORIG
		if(NULL == fgets(linbuf, MAXLEN, f)) break;
#else
		if(NULL == (linbuf = getline(linbuf, f))) break;
#endif
#endif /* FGREP */
	}

	fclose(f);
	return(p);
}

#ifdef MSDOS
void	expand_hook()
{
	_expand_abendcode = 2;
	expand_hook_default();
}
#endif

static	void	pempty()
{
	fprintf(stderr, "%s: Pattern empty\n", cmdname), exit(2);
}

#ifdef FGREP
#  ifdef NOTYET
static	isk2ndbyte(bgn, pos)
char	*bgn, *pos;
{
	char	c;
	int	hanten;

	if((unsigned char)(c = *pos) < (unsigned char)0x40 || c == 0x7f)
		return 0;
	for(hanten = 0; ; hanten ^= 1){
		if(bgn >= pos-- || !iskanji(*pos)) return hanten;
	}
}
#  endif
#endif

static	foundline(ptn, p)
register char	*ptn, *p;
/* ɓK邩ǂ(Δ0) */
{
	int	found;

#ifdef FGREP
  /* T[`̃ASY͂͂茾Ĉł */
	int	cmplen;
#  ifdef MSDOS
#    ifdef NOTYET
	char	*org = p;
#    endif
#  endif

	if(wholematch){
		found = !(nocase ? stricmp(ptn, p) : strcmp(ptn, p));
	} else
	if(nocase){
		cmplen = strlen(ptn) - 1;
		found = 0;
#ifdef MSDOS
		while(NULL != (p = strichr(p, *ptn)))
#else
		while(NULL != (p = strichr_e(p, *ptn)))
#endif
		{
			if(!strnicmp(++p, ptn + 1, cmplen)){
#ifdef MSDOS
#  ifdef NOTYET
				isk2ndbyte(p - 1, org) continue;
#  endif
#endif
				found = 1;
				break;
			}
		}
	} else {
		cmplen = strlen(ptn) - 1;
		found = 0;
#ifdef MSDOS
		while(NULL != (p = strchr(p, *ptn)))
#else
		while(NULL != (p = strchr_e(p, *ptn)))
#endif
		{
			if(!strncmp(++p, ptn + 1, cmplen)){
#ifdef MSDOS
#  ifdef NOTYET
				isk2ndbyte(p - 1, org) continue;
#  endif
#endif
				found = 1;
				break;
			}
		}
	}
#else /* !FGREP */
	static	int	first = 1;

	if(first) first = 0; else ptn = NULL; /* 񂩂̂T */
#ifdef DEBUG
	fprintf(stderr, "re_strcmp '%s' '%s'\n",
		ptn == NULL ? "(NULL)" : ptn, p);
#endif
	if((found = re_strcmp(ptn, p, NULL)) < 0){
		fprintf(stderr, "%s: Regular expression error", cmdname);
		fprintf(stderr, regerr != NULL ? ", %s\n" : "\n", regerr);
		exit(2);
	}
#endif
	if(reverse) found = !found;
	if(found && status == 1){
		status = 0;
		if(retonly) exit(status);
	}
	return(found);
}

static	void	efgrep(ptn, fnm)
char	*ptn, *fnm;
{
	register FILE	*f;
	int	linlen;
	long	lineno = 0L, lcount = 0L;
	char	*dispfnm;
	static	int	nulfd = -2;

#ifdef MSDOS
	if(nulfd < -1){ /* for DOS */
		nulfd = open(NULNAME, O_WRONLY);
	}
#endif
	if(fnm[0] == '-' && !fnm[1]){
		fnm = NULL;
		dispfnm = "(stdin)";
		f = stdin;
	} else {
		if(NULL == (f = fopen(dispfnm = fnm, "r"))){
			perror(fnm);
			status = 2;
			return;
		}
	}
#ifdef MSDOS
	if(bigiobuf != NULL && 0 != setvbuf(f, bigiobuf, _IOFBF, BIGBUFSIZ)){
		perror(NULL), exit(2);
	}
#endif
#ifdef ORIG
	while(NULL != fgets(linbuf, MAXLEN, f)){
#else
	while(NULL != (linbuf = getline(linbuf, f))){
#endif
		if(linlen = strlen(linbuf)){ /* chop newline */
			if('\n' == (linbuf - 1)[linlen]){
				(linbuf - 1)[linlen] = '\0';
			}
#ifdef ORIG
			else if(linlen == MAXLEN - 1){
				fprintf(stderr, "%s: %s: too long line\n",
					cmdname, dispfnm);
				exit(2);
			}
#endif
		}
		if(!(char)++lineno){
			if(nulfd >= 0) write(nulfd, (char *)&nulfd, 1);
		}

		if(foundline(ptn, linbuf)){
			if(linesonly){
				lcount++;
				continue;
			}
			if(fnmonly){
				fputs(dispfnm, stdout);
				putchar('\n');
				break;
			}

			if(fnmdisp){
				fputs(dispfnm, stdout);
				fputs(": ", stdout);
			}
			if(lnumdisp){
				printf("%ld: ", lineno);
			}
			fputs(linbuf, stdout), putchar('\n');
		}
	}

	totallcount += lcount;
	 /* totallcount is only used if (linesonly && !fnmonly) */
	if(linesonly && fnmonly && lcount){
		printf("%s: %ld\n", dispfnm, lcount);
	}
	if(fnm != NULL) fclose(f); else clearerr(f);
}

main(ac, av)
int	ac;
char	**av;
{
	int	c;
	extern	int	optind, opterr;
	extern	char	*optarg;
	char	*ptn = NULL;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
	opterr = 0;

#ifdef MSDOS
	bigiobuf = malloc(BIGBUFSIZ); /* if NULL, doesn't setvbuf() */
#endif

	 /* options: ef xvi s lc hLn */
	while(EOF != (c = getopt(ac, av, "ce:f:hilLnsvwx"))){
		cswitch(c){
		case 'c': linesonly = 1; break;
		case 'e': ptn = optarg; break;
		case 'f': ptn = getfpat(optarg); break;
		case 'h': fnmdisp = 0; break;
#ifdef FGREP
		case 'i': nocase = 1; break;
#endif
		case 'l': fnmonly = 1; break;
		case 'L': fnmdisp = 1; break;
		case 'n': lnumdisp = 1; break;
		case 's': retonly = 1; break;
		case 'v': reverse = 1; break;
#ifndef FGREP
		case 'w': wordmatch = 1; break;
#endif
		case 'x': wholematch = 1; break;
		default:
			fprintf(stderr, "%s: Illegal option.\n", cmdname);
			exit(2);
		}
	}

	ac -= optind, av += optind;
	if(ptn == NULL){
		if(!ac--) pempty();
		ptn = *av++;
	}
	if(!*ptn){
		pempty();
	}

#ifndef FGREP
	if(wholematch){
		char	*p;

		if(NULL == (p = malloc(strlen(ptn) + 5))) malloc_err();
		sprintf(p, "^(%s)$", ptn);
		ptn = p;
	} else
	if(wordmatch){
		char	*p, *aptn = "(^|[^A-Za-z0-9_])(%s)($|[^A-Za-z0-9_])";

		if(NULL == (p = malloc(strlen(ptn) + strlen(aptn) - 1)))
			malloc_err();
		sprintf(p, aptn, ptn);
		ptn = p;
	}
#endif
	if(!ac){
		if(fnmdisp == -1) fnmdisp = 0;
		efgrep(ptn, "-");
	} else {
		if(fnmdisp == -1) fnmdisp = (ac > 1);
		for(; ac; --ac, ++av){
			conv_to_unix_format(*av);
			efgrep(ptn, *av);
		}
	}
	if(linesonly && !fnmonly){
		printf("%ld\n", totallcount);
	}

	return status;
}
