#include <stdio.h>
#include <ctype.h>
#ifndef UX_COMPILE_TEST
#  include <dos.h>
#  include <process.h>
#endif
#include <errno.h>
#include <memory.h>
#include <string.h>
#include <stdlib.h>
#include <setjmp.h>
#include "tools.h"

#ifndef BLOCK_SIZE
#  define BLOCK_SIZE 512
#endif

static	us_int	maxdep = ~0 /* maxint */, mindep;
struct xFind_t {
	struct	Find_t	f;
	char	*findpath;
#ifdef SUPP_LFN
	char	*findpath_l; /* ƂɁAR}hCŗ^镔
	  Ɋi[ LFNT|[g̏ꍇfindpathƓ|C^ */
#endif
	struct	flags {
		us_int	level;
		unsigned prune : 1;
		unsigned depth : 1; /* global flag only */
		unsigned dayst : 1; /* global flag only */
		unsigned actex : 1; /* global flag only */
		char	truedrv;
	} fl;
};
#define NULL1 ((void *)NULSTR) /* used as a flag, distinct from NULL */
static	struct	flags	gflag;

#define div_up(x, y) (((x) + (y) - 1) / (y))

char	*cmdname = "findf";

static	char	*month_name[] = {
	 "???",
	 "Jan", "Feb", "Mar", "Apr", "May", "Jun",
	 "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
};

static	us_long	curtime;
static	jmp_buf	jmp_env;

static	char	*ops[ ] = {
 /* Iy[^͑SAu-v2ȏƉB擪̉̕7rbg
    ̌+1ŁAsȂ0BŏʃrbǵAu̗ĂIy[^
    1gĂȂ-printvƂ */
	/* 0 */	"\002type",	"\002attr",	"\000name",	"\000lname",
		"\000sname",	"\002mtime",	"\002atime",	"\002ctime",
	/* 8 */	"\201ls",	"\002newer",	"\002perm",	"\002size",
		"\001prune",	"\200exit",	"\002count",	"\201printms",
	/*16 */	"\201printq",	"\201printsfn",	"\201print",	"\200exec",
		"\200ok",	"\001depth",	"\002maxdepth",	"\002mindepth",
	/*24 */	"\001daystart",	"\002mmin",	"\002amin",	"\002cmin",
		"\001empty",	"\001next",	"\001true",	"\001false",
	/*32 */ "\001cut",	NULL
};
#define numberof(s) (sizeof(s) / sizeof(*s))

static	char	wildall[] = "********.***";
 /* LFN̏ꍇu????????.???v͂傤8+3ɂ}b`Ȃ */

#define ERREXIT (-1)
#ifdef MSDOS
void	expand_hook()
{
	_expand_abendcode = ERREXIT;
	expand_hook_default();
}
#endif

#ifdef OLD_C
static	int	stricmp(p, q)
char	*p, *q;
{
	for(; to_lower(*p) == to_lower(*q); p++, q++) if(!*p) return 0;
	return to_lower(*p) - to_lower(*q);
}
#endif

#ifndef UX_COMPILE_TEST
static	us_long	getclusize(drv) /* sȂ0Ԃ */
char	drv; /* s:-1 a:0 b:1c */
{
	union	REGS	in, out;

	if(!++drv) return 0;
	in . h . dl = (us_char)drv;
	in . h . ah = 0x36;
	if(-1 == intdos(&in, &out)) return 0;
	return (us_long)out . x . ax * out . x . cx;
}
#else
#  define getclusize(drv) 512
#endif

static	us_long	clucnt(xf) /* NX^Ԃ */
struct	xFind_t *xf;
{
	us_long	clusize, size; /* t@CTCYlongɎ܂ʃP[X͖ */
	char	truedrv = xf -> fl . truedrv;
	static	us_long	*clusztbl = NULL;

#ifdef SUPP_LFN
	size = xf -> f . lsize;
#else
	size = xf -> f . size;
#endif
	if(truedrv != (char)~0){
		if(clusztbl == NULL)
			memset(clusztbl = chk_malloc(sizeof(us_long) * 26),
						'\0', sizeof(us_long) * 26);
		if((0 != (clusize = clusztbl[truedrv]) ||
		    0 != (clusize = clusztbl[truedrv] =	getclusize(truedrv)))&&
		   (size % clusize))
			size += clusize - size % clusize;
	}
	return (size + BLOCK_SIZE - 1) / BLOCK_SIZE;
}

static	void	notfound(s)
char	*s;
{
	fprintf(stderr, "%s: %s: Not found\n", cmdname, s); /* not exit */
}

static	void	synerr(ac, av)
int	ac;
char	**av;
{
	if(ac){
		fprintf(stderr,
			"%s: Syntax error in expression; near \"%s\"\n",
			cmdname, *av);
	} else {
		fprintf(stderr, "%s: Incomplete expression\n", cmdname);
	}
	exit(ERREXIT);
}

#define longcmd() \
	(fprintf(stderr, "%s: Command too long in -exec or -ok\n", cmdname), \
	 exit(ERREXIT))

#define manyname() \
	(fprintf(stderr, "%s: Too many names in -name, -lname or -sname\n", \
		 cmdname), exit(ERREXIT))

#define nosemicolon() \
	(fprintf(stderr, "%s: Command not terminated with \";\"\n", cmdname), \
	 exit(ERREXIT))

#define cantexec(str) \
	fprintf(stderr, "%s: %s: Can't exec\n", cmdname, (str)) /* not exit */

#define is_OPENBR(s) !strcmp((s), "(")
#define is_CLOSEBR(s) !strcmp((s), ")")
#define is_COMMAOP(s) !strcmp((s), ",")
#define is_NOTOP1(s) !strcmp((s), "!")
#define is_NOTOP(s) (is_NOTOP1(s) || !strcmp((s), "-not"))
#define is_ANDOP(s) (!strcmp((s), "-a") || !strcmp((s), "-and"))
#define is_OROP(s) (!strcmp((s), "-o") || !strcmp((s), "-or"))
#define is_OPER1(s) (*(s) == '-' || is_OPENBR(s) || is_NOTOP1(s))
#define is_OPER(s) (is_OPER1(s) || is_CLOSEBR(s) || is_COMMAOP(s))
#define is_IFOP(s) !strcmp((s), "-if")
#define is_THENOP(s) !strcmp((s), "-then")
#define is_ELSEOP(s) !strcmp((s), "-else")

static	int	isexecok(cmd)
char	*cmd;
{
	char	*p, *q;

	for(q = NULL, p = cmd; *p; p++){
		if(iskanjipos(p)) p++; else
		if(*p == '.') q = p; else
		if(*p == '\\' || *p == '/') q = NULL;
	}
	return(q++ == NULL || !stricmp(q, "exe") || !stricmp(q, "com"));
}

#ifdef UX_COMPILE_TEST /* RpCeXgpBۂ̓͂Ȃ */
#  define xspawnvp(mode, cmd, av) (errno = ENOENT, -1)
#else
static	int	xspawnvp(mode, cmd, av)
int	mode;
char	*cmd, **av;
{
	return isexecok(cmd) ? spawnvp(mode, cmd, av) : (errno = ENOENT, -1);
}
#endif

static	void	printms(s)
char	*s;
{
	static	char	*buf = NULL;
#ifdef SUPP_LFN
	bool	flg = 0;
#endif

	if(buf != NULL) free(buf);
	conv_to_dos_regpath(conv_to_unix_format(buf = chk_strdup(s)));
	 /* buf͎ɌĂ΂ꂽƂfree */

#ifdef SUPP_LFN
	for(s = buf; *s; ++s){
		if(*s == ' '){
			flg = 1;
			break;
		}
		if(iskanjipos(s)){
			if((us_char)*s == 0x81 && s[1] == 0x40){/* 2byte SPC */
				flg = 1;
				break;
			}
			++s;
		}
	}
	printf(flg ? "\"%s\"\n" : "%s\n", buf);
#else
	printf("%s\n", buf);
#endif
}

static	char	*dgetenv(s)
char	*s;
 /* getenv̌ʂstaticɎĂƂAputenvƂ݂̂ł܂Ƃ
    N\Ô */
{
	return (NULL == (s = getenv(s))) ? NULL : chk_strdup(s);
}

static	us_char	*tsplit(d, t, s100)
unsigned int	d, t, s100;
 /* Œobt@ԂB̎sŏ㏑ */
{
	static	us_char	buf[7];
	char	*p = (char *)buf;

	*p   = (char)(d >> 9),	 *++p = (char)((d >> 5) & 0xf);
	*++p = (char)(d & 0x1f), *++p = (char)(t >> 11);
	*++p = (char)((t >> 5) & 0x3f);
	*++p = (char)(((t & 0x1f) << 1) + s100 / 100);
	*++p = (char)(s100 % 100);
	return buf;
	 /* N-1980     b b/100 */
}

static	us_long	tseq_to_tm(s)
us_char	*s;
{
	return caltime(1980 + s[0], (int)s[1], (int)s[2],
		(int)s[3], (int)s[4], (int)s[5]); /* 1b͐؂̂ */
}

static	int	fcount(s)
char	*s;
{
	static	unsigned long	cnt = 0;
	unsigned long	l;
	int	pm;

	if('+' == (pm = *s) || '-' == pm) s++;
	for(l = 0L; is_digit(*s); s++) l *= 10L, l += *s - '0';
	cnt++;
	return pm == '+' ? (cnt > l) : pm == '-' ? (cnt < l) : (cnt == l);
}

static	int	fnperm(f, s)
struct	Find_t	*f;
char	*s;
{
	short	curm, cmpm;
	bool	mflag = 0;
	char	attr = (char)f -> attrib;

	curm = (attr & _A_SUBDIR) ? 040555 :
	       (attr & _A_DEV)	  ? 020444 :
	       is_executable(f)	  ? 0100555 : 0100444;
	if(!(attr & _A_RDONLY)) curm |= 0222;

	if(*s == '-') (++mflag, ++s);
	for(cmpm = 0; is_octal(*s); s++) (cmpm <<= 3, cmpm |= *s - '0');
	return (mflag ? curm & cmpm : curm) == cmpm;
}

static	int	fnsize(size, s)
unsigned long	size;
char	*s;
{
	unsigned long	l;
	int	pm;

	if('+' == (pm = *s) || '-' == pm) s++;
	for(l = 0L; is_digit(*s); s++) l *= 10L, l += *s - '0';
	if(*s != 'c') size += BLOCK_SIZE - 1, size /= BLOCK_SIZE;
	return pm == '+' ? (size > l) : pm == '-' ? (size < l) : (size == l);
}

static	int	fntime(fcur, time_mode, s)
struct	Find_t	*fcur;
int	time_mode; /* 0,1,2:m,a,c 4:min */
char	*s;
{
	unsigned int	pmmode;
	unsigned char	*dt;
	long	days, tdif;
	us_long	cur, tm, timeunit = (time_mode & 04) ? 60L : 3600L * 24L;

	if('+' == (pmmode = *s) || '-' == pmmode) s++;
	days = (*s == '-') ? 0L : atol(s);
	if(*s){
		switch(s[strlen(s) - 1]){
		case 'h': timeunit = 3600L; break;
		case 'm': timeunit = 60L; break;
		}
	}

#ifdef SUPP_LFN
	switch(time_mode & ~04){
	case 2:
		dt = (us_char *)fcur -> ctime;
		goto chk_supp_tm;
	case 1:
		dt = (us_char *)fcur -> atime;
	chk_supp_tm:
		if(dt[2]) break;
	default:
		dt = (us_char *)fcur -> mtime;
	}
	dt = tsplit(((us_short *)dt)[1], ((us_short *)dt)[0], dt[4]);
#else
	dt = tsplit(fcur -> wr_date, fcur -> wr_time, 0);
#endif
	tm = tseq_to_tm(dt), cur = curtime;
	if(gflag . dayst) cur += 86399L - (cur % 86400L);
	 /* -daystart̏ꍇ͗̋N_1bOg */
	if(cur > tm) tdif = (long)((cur - tm) / timeunit);
	 else tdif = -(long)div_up(tm - cur, timeunit);
	  /* tmcur̔r͕Ȃōs timeunit1Ȃ
	     130N͑v */

	return (pmmode == '+') ? (tdif > days) :
	       (pmmode == '-') ? (tdif < days) : (tdif == days);
}

static	int	fnewer(fcur, fbuf)
struct	Find_t	*fcur, *fbuf;
{
#ifdef SUPP_LFN
	return(*((us_long *)fcur -> mtime) > *((us_long *)fbuf -> mtime));
#else
	return(fcur -> wr_date > fbuf -> wr_date ||
	       fcur -> wr_date == fbuf -> wr_date &&
	       fcur -> wr_time > fbuf -> wr_time);
#endif
}

static	int	fempty(xf)
struct	xFind_t	*xf;
{
	char	*tmp;
	struct	Find_t	buf;
	int	flg;

	if(xf -> f . attrib & (_A_VOLID | _A_DEV)) return 0; /* Ô߁c */
	if(xf -> f . attrib & _A_SUBDIR){
		flg = 1;
		tmp = chk_strduppathcat(xf -> findpath, PATH_SEP, wildall);
		if(!_dos_Findfirst(tmp, 0x37, &buf)){
			do {
				if(*(buf . name) == '.'
#ifdef SUPP_LFN
				   || !*(buf . name) && *(buf . lname) == '.'
#endif
				  ) continue;
				flg = 0;
				break;
			} while(!_dos_Findnext(&buf));
			_dos_Findclose(&buf);
		}
		free(tmp);
		return flg;
	} else {
#ifdef SUPP_LFN
		return !(xf -> f . lsize);
		 /* TCYlongɎ܂ȂP[X͖ */
#else
		return !(xf -> f . size);
#endif
	}
}

#define strconsthead(h, s) (!strncmp((h), (s), sizeof(h) - 1))

static	char	*repl_braces(arg, repl_brace, repl_paren)
char	*arg, *repl_brace, *repl_paren;
 /* arǵu{}vu()vt@C(Kvɉ)ɒuʂ(Kv
    NH[g)ԂBԂ̂arĝ̂A邢͐VK蓖ă */
{
	char	*p, *q, *ret;
	int	par, bra;
	static	char	STRBRACE[] = "{}", STRPAREN[] = "()";
	int	repl_bra_len, repl_par_len;

	for(bra = par = 0, p = arg; *p; p++){
		if(iskanjipos(p)) ++p;
		else if(strconsthead(STRBRACE, p)) ++bra, ++p;
		else if(strconsthead(STRPAREN, p)) ++par, ++p;
	}
	if(!par && !bra) return arg;
			/* u{}v̂Ȃꍇ̓NH[gȂ */

	ret = chk_malloc((p - arg) +
			 bra * ((repl_bra_len = strlen(repl_brace)) - 2) +
			 par * ((repl_par_len = strlen(repl_paren)) - 2) + 1);
	for(p = arg, q = ret; *q = *p; ++p, ++q){ /* '\0'܂ŃRs[ */
		if(iskanjipos(p)){
			*++q = *++p;
		} else
		if(strconsthead(STRBRACE, p)){
			strcpy(q, repl_brace);
#ifdef SUPP_LFN
			if(_lfnsupp_level <= LFN_NONE)
#endif
				strtolower(q);
			q += repl_bra_len, --q, ++p;
		} else
		if(strconsthead(STRPAREN, p)){
			strcpy(q, repl_paren);
			strtolower(q);
			q += repl_par_len, --q, ++p;
		}
	}

#ifdef SUPP_LFN
	if(bra && _lfnsupp_level > LFN_NONE){
		p = quote_str(ret);
		free(ret);
		return p;
	}
#endif
	return ret;
}

static	int	fnexec(f, av, argn, ynflg)
struct	xFind_t	*f;
char	**av;
int	argn, ynflg;
{
	int	c, d;
	char	**pp, *brace_repl;

#ifdef SUPP_LFN
	brace_repl = f -> findpath_l;
#else
	brace_repl = f -> findpath;
#endif

	av += argn;
	pp = (char **)*--av + argn--;
	while(--argn){
		*--pp = repl_braces(*--av, brace_repl,
#ifdef SUPP_LFN
					f -> findpath
#else
					brace_repl
#endif
				   );
	} /* -exec {} arg c ̂悤Ȃ̂e */
	if(ynflg){
		fprintf(stderr, "< %s ... ", s_conv_to_unix_format(*pp));
		fprintf(stderr, "%s >?   ", s_conv_to_unix_format(brace_repl));
		if(EOF != (c = getchar()) && c != '\n')
			while('\n' != (d = getchar()) && EOF != d);
		switch(to_lower(c)){
		case 'y':
			break;
		case 'q':
			exit(0);
		default:
			c = -1;
			goto free_return;
		}
	}
	if(0 > (c = xspawnvp(P_WAIT, *pp, pp)) &&
	   0 > (c = xspawnvp(P_WAIT, pp[-2], pp - 2))){
		cantexec(s_conv_to_unix_format(*pp));
		/* ̏ꍇc͕A!c0 */
	}

free_return:
	for(; *pp != NULL; ++av, ++pp){
		if(*pp != *av) free(*pp);
	}

	return !c; /* return 1 if success */
}

static	int	fntype(xf, s)
struct	xFind_t	*xf;
char	*s;
{
	struct	Find_t	*fcur;
	char	attr;

	attr = (char)((fcur = &xf -> f) -> attrib);
	for(; *s; s++){
		switch(*s){ /* ʂ́s1ts2tłĂ */
		case 'a':
			if(!(attr & _A_ARCH))	return 0; else break;
		case 'c':
			if(!(attr & _A_DEV))	return 0; else break;
		case 'd':
			if(!(attr & _A_SUBDIR)) return 0; else break;
		case 'f':
			if(attr & (_A_DEV | _A_SUBDIR | _A_VOLID)) return 0;
			break;
		case 'h':
			if(!(attr & _A_HIDDEN))	return 0; else break;
		case 'o':
			if(!(attr & _A_RDONLY)) return 0; else break;
		case 's':
			if(!(attr & _A_SYSTEM)) return 0; else break;
		case 'w':
			if(attr & _A_HIDDEN)	return 0; else break;
		case 'B':
			if((attr & (_A_DEV | _A_SUBDIR | _A_VOLID)) ||
			   is_textfile(xf -> findpath)) return 0;
			break;
		case 'T':
			if((attr & (_A_DEV | _A_SUBDIR | _A_VOLID)) ||
			   !is_textfile(xf -> findpath)) return 0;
			break;
		default: /* case 'x': */
			if(!is_executable(fcur)) return 0; else break;
		}
	}
	return 1;
}

static	void	fnls(xf)
struct	xFind_t *xf;
{
	us_char	mode[7], *dt;
	struct	Find_t	*f;
	us_long	file_tm;

	f = &(xf -> f);
	mode[0] = (us_char)((char)f -> attrib & _A_DEV	  ? 'c' :
			    (char)f -> attrib & _A_SUBDIR ? 'd' :
			    (char)f -> attrib & _A_VOLID  ? 'v' : '-');
	mode[1] = (us_char)((char)f -> attrib & _A_ARCH   ? 'a' : '-');
	mode[2] = (us_char)((char)f -> attrib & _A_SYSTEM ? 's' : '-');
	mode[3] = (us_char)((char)f -> attrib & _A_HIDDEN ? 'h' : '-');
	mode[4] =					    'r';
	mode[5] = (us_char)((char)f -> attrib & _A_RDONLY ? '-' : 'w');
	mode[6] = (us_char)(is_executable(f)		  ? 'x' : '-');
#ifdef SUPP_LFN
	dt = tsplit(((us_short *)f -> mtime)[1],
		    ((us_short *)f -> mtime)[0], f -> mtime[4]);
#else
	dt = tsplit(f -> wr_date, f -> wr_time, 0);
#endif

	printf("%4ld %.7s %8ld %s %2d ", clucnt(xf), mode,
#ifdef SUPP_LFN
	       f -> lsize,
#else
	       f -> size,
#endif
	       month_name[dt[1] <= 12 ? dt[1] : 0], dt[2]);
	file_tm = tseq_to_tm(dt);
	if(file_tm < curtime ? (curtime - file_tm < 3600L * 24L * 180L) :
			       (file_tm - curtime < 3600L)){
		printf("%02d:%02d", dt[3], dt[4]);
	} else {
		printf(" %4d", 1980 + dt[0]);
	}

#ifdef SUPP_LFN
	if(_lfnsupp_level > LFN_NONE){
		printf(" %-13s", s_conv_sfn_to_unix_format(xf -> findpath));
		printf(" %s\n", s_conv_to_unix_format(xf -> findpath_l));
	} else
#endif
		printf(" %s\n", s_conv_to_unix_format(xf -> findpath));
}

#ifdef SUPP_LFN
static	int	fnMatch(f, av, argn, flg)
struct	Find_t	*f;
char	**av;
int	argn, flg /* 0:sfn 1:lfn 2:both */;
{
	int	i, us_nospcl;
	char	*lname, *name;
	WILD_INTERNAL	*intrep_p;

	for(i = 1; i < argn; i++){
		intrep_p = (WILD_INTERNAL *)av[i];
		lname = f -> lname, name = f -> name;

		if(_lfnsupp_level <= LFN_NOWILD) flg = 2;
		 /* sfnlnameɓĂAꂾ */

		us_nospcl = -1;
		switch(flg){
		case 0:
			us_nospcl = 0; /* '_'̓ʈ */
			if(*name) lname = name;
				/* namelnameɓAꂾ */
			 /* FALLTHROUGH */
		case 1:
			name = NULSTR; /* lname */
			 /* FALLTHROUGH */
		default:
			if(!topdot_nomatch(lname, intrep_p, us_nospcl) &&
			   (name_match_pure(lname, intrep_p) ||
			    *name && name_match_pure(name, intrep_p)))
				return 1;
		}
	}
	return 0;
}
#else
static	int	fnmatch(f, av, argn)
struct	Find_t	*f;
char	**av;
int	argn;
{
	int	i;

	for(i = 1; i < argn; i++)
		if(name_match(f -> name, (WILD_INTERNAL *)av[i])) return 1;
	return 0;
}
#  define fnMatch(f, av, argn, dummy)	fnmatch((f), (av), (argn))
#endif /* SUPP_LFN */

static	int	synchk(acp, avp) /* Ok:1 NG:-1 */
int	*acp;
char	***avp;
{
	int	ac;
	char	**av;
	char	*op, **opp;
	unsigned char	*arg;
	unsigned int	opcnt;

	ac = *acp, av = *avp;
	if(!ac || *(arg = *av) != '-') return -1;

	for(opp = ops; (op = *opp) != NULL; opp++){
		if(!strcmp(op + 1, arg + 1)){
			if(*op & 0x80) gflag . actex = 1;
			 /* Œ̏ꍇ͌`FbN */
			opcnt = *(us_char *)op & ~0x80;
			if(opcnt && ac < opcnt) return -1;

			switch((char)(opp - ops)){
			 /* ̌ʃ`FbN όȂ`FbN */
			case 0: /* -type */
				switch(av[1][0]){
				case 'c': case 'd': case 'f':
				case 'B': case 'T': /* s1t*/
					break;
				default:
					return -1;
				}
				if(av[1][1]) return -1;
				break;
			case 1: /* -attr */
				{
					char	*p;

					for(p = av[1]; *p; p++){
						switch(av[1][0]){
						case 'a': case 'd': case 'h':
						case 'o': case 's': case 'w':
						case 'x': /* s2t*/
							break;
						default:
							return -1;
						}
					}
				}
				break;
			case 2: /* -name */
			case 3: /* -lname */
			case 4: /* -sname */
				{
					WILD_INTERNAL	*intrep;

					for(opcnt = 1; opcnt < ac; opcnt++){
						if(opcnt > 1 &&
						   is_OPER(av[opcnt])) break;
						intrep = (WILD_INTERNAL *)
						  chk_malloc(
							sizeof(WILD_INTERNAL));
						parse_wild(av[opcnt], intrep);
						av[opcnt] = (void *)intrep;
							/* xȂ͂ */
					}
					if(opcnt == 1) return -1;
					if(opcnt > 0xff) manyname();
					 /* opcnt used afterward */
				}
				break;
			case 9: /* -newer */
				{
					struct	Find_t	*fbuf;

					fbuf = chk_malloc(
							sizeof(struct Find_t));
					if(0 != find_Fixedfile(av[1], fbuf, 0))
						notfound(av[1]), exit(ERREXIT);
					av[1] = (void *)fbuf;
				}
				break;
			case 13: /* -exit */
				opcnt = (ac <= 1 || av[1][0] == '-' &&
					 !is_digit(av[1][1])) ? 1 : 2;
				break;
			case 19: /* -exec */
			case 20: /* -ok */
				for(opcnt = 1; ; opcnt++){
					if(opcnt >= ac) nosemicolon();
					if(!strcmp(av[opcnt], ";")) break;
				}
				if(opcnt == 1) return -1;
				 else {
					char	**pp;
					static	char	slac[ ] = "/C",
							cmd[ ] = "command";
					 /* 2ȏsĂxȂ */

					av[opcnt] = (char *)(pp = chk_malloc(
						sizeof(char *) * (opcnt + 2)));
					 /* +2 for "command" "/C" */
					if(NULL == (pp[0]= dgetenv("COMSPEC")))
						pp[0] = cmd;
					*(pp[1] = slac) = (char)swchar();
					 /* pp[2`opcnt]͂Ƃő */
					pp[++opcnt] = NULL;

					if(opcnt > 0xff) longcmd();
					 /* opcnt used afterward */
				}
				break;
			case 21: /* -depth */
				gflag . depth = 1;
				 /* UNIXfind-depth̎dlƓ */
				break;
			case 22: /* -maxdepth */
				maxdep = atoi(av[1]);
				break;
			case 23: /* -mindepth */
				mindep = atoi(av[1]);
				break;
			case 24: /* -daystart */
				gflag . dayst = 1;
				break;
			}
			break;
		}
	} /* now op == *opp */
	if(op == NULL) return -1;
	*arg++ = '\0', *arg++ = (us_char)(opp - ops);
	*arg = (us_char)opcnt;
	av += *arg, ac -= *arg;

	*avp = av, *acp = ac;
	return 1;
}

static	void	evalmain(), evalfile();
static	int	evalffmla(), evallfmla(), evalfmla(), evalterm(), evalsterm(),
		evalprim();
#ifdef USE_IFPRIM
static	int	evalqfmla();
#endif

static	void	evalmain(ac, av, fname)
int	ac;
char	**av, *fname;
{
	struct	xFind_t	fentry;

#ifdef SUPP_LFN
	fentry . findpath = _lfnsupp_level > LFN_NONE ?
					chk_strdup(sfn_of(fname)) : fname;
	fentry . findpath_l = fname;
#else
	fentry . findpath = fname;
#endif
	memcpy(&fentry . fl, &gflag, sizeof(struct flags));
	if(find_Fixedfile(fname, &(fentry . f), 0)){
		notfound(s_conv_to_unix_format(fname)); /* but not exit */
	} else {
		/* *fentry . f . name = '\0'; */
		evalfile(ac, av, &fentry);
	}
#ifdef SUPP_LFN
	free(fentry . findpath);
#endif
}

static	void	evalfile(ac, av, fentry)
int	ac;
char	**av;
struct	xFind_t *fentry;
{
	struct	xFind_t	*fchild;
	char	*fbase;

	if(fentry -> fl . level > maxdep) return;
	if(!fentry -> fl . level || ((char)fentry -> f . attrib & _A_SUBDIR))
		fentry -> fl . truedrv = gettruedrv(fentry -> findpath);

	 /* gflag.depth0ǂŎ̏ƍċÂǂɂ邩
	    ߂ */
	if(!gflag . depth) evalffmla(ac, av, fentry);
	if(!fentry -> fl . prune && ((char)fentry -> f . attrib & _A_SUBDIR)){
		fchild = chk_malloc(sizeof(struct xFind_t));
		fbase = fchild -> findpath = chk_strduppathcat(
				    fentry -> findpath, PATH_SEP, wildall);
		fbase += strlen(fbase) - (sizeof(wildall) - 1);
		 /* findpatȟɂ"????????.???"Ă */
		if(!_dos_Findfirst(fchild -> findpath, 0x37, &fchild -> f)){
			do {
				 /* findpath͏Ă͂ */
				strcpy(fbase, fchild -> f . name);
#ifdef SUPP_LFN
				if(!*fbase) strcpy(fbase, fchild -> f . lname);
#endif
				if(*fbase == '.') continue;
				/* conv_to_unix_format(fbase); */
					/* ł͏Ȃ */
#ifdef SUPP_LFN
				fchild -> findpath_l = (
				  _lfnsupp_level > LFN_NONE ?
					chk_strduppathcat(fentry -> findpath_l,
					    PATH_SEP, fchild -> f . lname) :
					fchild -> findpath);
#endif
				memcpy(&fchild -> fl, &fentry -> fl,
				       sizeof(struct flags));
				++(fchild -> fl . level);
				 /* ̂ƂRs[level1OK */
				evalfile(ac, av, fchild);
#ifdef SUPP_LFN
				if(fchild -> findpath != fchild -> findpath_l)
					free(fchild -> findpath_l);
#endif
			} while(!_dos_Findnext(&fchild -> f));
			_dos_Findclose(&fchild -> f);
		}
		free(fchild -> findpath), free(fchild);
	}
	if(gflag . depth) evalffmla(ac, av, fentry);
}

static	int	evalffmla(ac, av, fentry)
int	ac;
char	**av;
struct	xFind_t *fentry;
 /* ac0ɂȂȂsyntax errBevallfmlaԂac͓Ȃ */
{
	int	val;

	 /* `FbNłȂꍇmindep */
	if(fentry != NULL1 &&
	   (fentry -> fl . level < mindep || setjmp(jmp_env))) return 0;

	if((val = evallfmla(&ac, &av, fentry)) > 0 &&
	   fentry != NULL1 && !gflag . actex) /* -printk1l*/
		printf("%s\n",
#ifdef SUPP_LFN
			s_conv_to_unix_format(fentry -> findpath_l)
#else
			s_conv_to_unix_format(fentry -> findpath)
#endif
		       );

	if(ac) synerr(ac, av);
	return val;
}

static	int	evallfmla(acp, avp, fentry)
int	*acp;
char	***avp;
struct	xFind_t *fentry;
{
	int	first, val;
	int	ac;
	char	**av;

	ac = *acp, av = *avp;

	for(first = 1; ; first = 0){
		if(0 > (val = evalfmla(&ac, &av, fentry))){
			if(first) return val; else synerr(ac, av);
		}

		if(ac && is_COMMAOP(*av)){
			--ac, ++av;
		} else break;
	}

	*avp = av, *acp = ac;
	return val;
}

static	int	evalfmla(acp, avp, fentry)
int	*acp;
char	***avp;
struct	xFind_t *fentry;
 /* fentryNULLɂȂƔ]ac, av̂ݐival͂ȏςȂ
    fentryNULL1ac, avi߂Ȃsyntax chk
    formulaȂac, avi߂ɕԂ(fentryNULLNULL1ł) */
{
	int	first, val, tmpval, cut = 0;
	int	ac;
	char	**av;

	ac = *acp, av = *avp;

	for(first = 1, val = 0; ; first = 0){
		if(0 > (tmpval = evalterm(&ac, &av, fentry, &cut))){
			if(first) return tmpval; else synerr(ac, av);
			 /* return l Ƃƌac, av͓
			    cBłl */
		}
		if(fentry != NULL && !val) val = tmpval;
		if(val && fentry != NULL1 || cut) fentry = NULL;

		if(ac && is_OROP(*av)){
			--ac, ++av;
		} else break;
	}

	*avp = av, *acp = ac;
	return val;
}

static	int	evalterm(acp, avp, fentry, cut)
int	*acp, *cut;
char	***avp;
struct	xFind_t *fentry;
{
	int	first, needone, val, tmpval;
	int	ac;
	char	**av;

	ac = *acp, av = *avp;

	for(needone = 0, first = val = 1; ; first = 0){
		if(0 > (tmpval = evalsterm(&ac, &av, fentry, cut))){
			if(first) return tmpval;
			if(needone) synerr(ac, av);
			break;
		}
		if(fentry != NULL && val) val = tmpval;
		if(!val && fentry != NULL1) fentry = NULL;

		if(0 != (needone = (ac && is_ANDOP(*av)))){
			--ac, ++av;
		}
	}

	*avp = av, *acp = ac;
	return val;
}

static	int	evalsterm(acp, avp, fentry, cut)
int	*acp, *cut;
char	***avp;
struct	xFind_t *fentry;
{
	int	val, notcnt;
	int	ac;
	char	**av;

	ac = *acp, av = *avp;

#ifdef USE_IFPRIM
	if(ac && is_IFOP(*av))
		return evalqfmla(acp, avp, fentry);
#endif

	for(notcnt = 0; ac && is_NOTOP(*av); ){
		++notcnt, --ac, ++av;
	}
	if(ac && is_OPENBR(*av)){
		--ac, ++av;
		if(0 > (val = evallfmla(&ac, &av, fentry)) ||
		   !ac || !is_CLOSEBR(*av)){
			synerr(ac, av);
		}
		--ac, ++av;
	} else {
		if(0 > (val = (fentry == NULL1 ?
		   synchk(&ac, &av) : evalprim(&ac, &av, fentry, cut)))){
			if(notcnt) synerr(ac, av); else return val;
		}
	}

	*avp = av, *acp = ac;
	return (notcnt % 2) ? !val : val;
}

#ifdef USE_IFPRIM
static	int	evalqfmla(acp, avp, fentry)
int	*acp;
char	***avp;
struct	xFind_t *fentry;
{
	int	val, val1, val2;
	int	ac;
	char	**av;

	ac = *acp, av = *avp;

	--ac, ++av;
	if(0 > (val = evallfmla(&ac, &av, fentry)) || !(ac && is_THENOP(*av)))
		synerr(ac, av);
	--ac, ++av;
	if(0 > (val1 = evallfmla(&ac, &av,
		    fentry == NULL1 || val ? fentry : NULL))) synerr(ac, av);
	if(ac && is_ELSEOP(*av)){
		--ac, ++av;
		if(0 > (val2 = evallfmla(&ac, &av,
		    fentry == NULL1 || !val ? fentry : NULL))) synerr(ac, av);
	} else {
		val2 = 1;
	}

	*avp = av, *acp = ac;
	return val ? val1 : val2;
}
#endif

static	int	evalprim(acp, avp, fentry, cut)
int	*acp, *cut;
char	***avp;
struct	xFind_t *fentry;
{
	int	val = 0, ac;
	char	**av;
	unsigned char	*arg;

	ac = *acp, av = *avp;

	if(!ac || (arg = *av, *arg++)) return -1;
	if(fentry != NULL){
		switch(*arg){ /* comes here only if fentry != NULL */
		case 0: /* -type */
		case 1: /* -attr */
			val = fntype(fentry, av[1]);
			break;
		case 2: /* -name */
		case 3: /* -lname */
		case 4: /* -sname */
			val = fnMatch(&fentry -> f, av, arg[1], 4 - *arg);
			break;
		case 5: /* -mtime */
		case 6: /* -atime */
		case 7: /* -ctime */
		 /* ł-+݂ m,a,ĉǂł邩̃tOn */
			val = fntime(&fentry -> f, *arg - 5, av[1]);
			break;
		case 8: /* -ls */
			fnls(fentry);
			goto val_is_1;
		case 9: /* -newer */
			val = fnewer(&fentry -> f, (struct Find_t *)av[1]);
			break;
		case 10: /* -perm */ /* -݂ */
			val = fnperm(&fentry -> f, av[1]);
			break;
		case 11: /* -size */ /* -+݂ */
#ifdef SUPP_LFN
			val = fnsize(fentry -> f . lsize, av[1]);
			 /* TCYlongɎ܂ȂP[X͖ */
#else
			val = fnsize(fentry -> f . size, av[1]);
#endif
			break;
		case 12: /* -prune */
			fentry -> fl . prune = 1;
			goto val_is_1;
		case 13: /* -exit */
			exit(arg[1] ? atoi(av[1]) : 0);
		case 14: /* -count */ /* -+݂ */
			val = fcount(av[1]);
			break;
		case 15: /* -printms */
#ifdef SUPP_LFN
			printms(fentry -> findpath_l);
#else
			printms(fentry -> findpath);
#endif
			goto val_is_1;
		case 16: /* -printq */
			printf("\"%s\"\n",
#ifdef SUPP_LFN
				 s_conv_to_unix_format(fentry -> findpath_l)
#else
				 s_conv_to_unix_format(fentry -> findpath)
#endif
			      );
			goto val_is_1;
		case 17: /* -printsfn */
			printf("%s\n", s_conv_sfn_to_unix_format(
							fentry -> findpath));
			goto val_is_1;
		case 18: /* -print */ /* k1lł̂Ƃ */
			printf("%s\n",
#ifdef SUPP_LFN
				s_conv_to_unix_format(fentry -> findpath_l)
#else
				s_conv_to_unix_format(fentry -> findpath)
#endif
			      );
			goto val_is_1;
		case 19: /* -exec */
		case 20: /* -ok */ /* execok̃tOn */
			val = fnexec(fentry, av, arg[1], *arg == 20);
			break;
		case 21: /* -depth */
		case 22: /* -maxdepth */
		case 23: /* -mindepth */
		case 24: /* -daystart */ /* ̃`FbN͂ł͂Ȃ */
			goto val_is_1;
		case 25: /* -mmin */
		case 26: /* -amin */
		case 27: /* -cmin */
		 /* ł-+݂ m,a,ĉǂł邩̃tOn */
			val = fntime(&fentry -> f, *arg - 21, av[1]);
			break;
		case 28: /* -empty */
			val = fempty(fentry);
			break;
		case 29: /* -next */
			longjmp(jmp_env, 1);
		case 30: /* -true */
		val_is_1:
			val = 1;
			break;
		case 31: /* -false */
			val = 0;
			break;
		case 32: /* -cut */
			*cut = 1;
			goto val_is_1;
		default:
			fprintf(stderr, "%s: ? bug\n", cmdname), exit(ERREXIT);
		}
	}
	++arg, av += *arg, ac -= *arg;

	*avp = av, *acp = ac;
	return val;
}

main(ac, av)
int	ac;
char	*av[];
{
	int	fac;
	char	**fav;
	static	char	varg[] = "-print";
	static	char	*vav[] = {varg, NULL}, *vfav[] = {".", NULL};

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	curtime = getdostime();
	memset(&gflag, 0, sizeof(struct flags));

	for(--ac, fav = ++av; ac && !is_OPER1(*av); --ac, ++av);
	fac = av - fav;
#if 0
	if(!fac || !ac){
		fprintf(stderr, "Usage: %s path-list expression\n", cmdname);
		exit(ERREXIT);
	}
#endif
	if(!fac) fac = 1, fav = vfav;
	if(!ac) ac = 1, av = vav;
	evalffmla(ac, av, NULL1); /* syntax check */

	for(; fac; --fac, ++fav) evalmain(ac, av, *fav);
	return 0;
}
