#include <stdio.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <signal.h>
#include <stdlib.h>
#ifndef UX_COMPILE_TEST
#  include <dos.h>
#endif
#ifdef LSI_C
#  include <farstr.h>
#endif
#include "tools.h"

#define strconstlen(s) (sizeof(s) - 1)
#ifdef UX_COMPILE_TEST
#  define kstricmp strcasecmp
#  define kstrnicmp strncasecmp
#endif

char	*cmdname = "foreach";

#define fe_nest_envname "FOREACH_NEST" /* ͎̕1񂵂Ȃ */
static	char	fe_inf_envname[ ] = "FOREACH_INFILE";

#define DOSARGMAX 126
#define	LMAX	2048

#define ENVCHR '$'
#define MODCHR ':'
#define REMCHR ':'
#define IGNERR '-'

#define EXEC_ADDPARM	0
#define EXEC_DIRECT	1
#define EXEC_VIA_SHELL	2

static	char	ignerr = 0;
static	bool	noexec = 0, outexit = 0, verbos = 0;
static	int	fe_nest = 0 /* nest level in batmode */, envflag;

#define ERREXIT (-1)
#ifdef MSDOS
void	expand_hook()
{
	_expand_abendcode = ERREXIT;
	expand_hook_default();
}
#endif

static	void	cmexit(i)
int	i;
{
	if(noexec && outexit) fputs("exit\n", stdout);
	exit(i);
}

static	void	toolong()
{
	_cmdputerrmes_cr("Input line too long."), cmexit(ERREXIT);
}

static	void	usage()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
	_puterrmes_cr(" [-invec] [-f file] [-b tag] var names...");
	cmexit(ERREXIT);
}

static	void	putenv_err()
{
	_cmdputerrmes_cr("Can't set environment variable"), cmexit(ERREXIT);
}

static	void	illenv()
{
	_cmdputerrmes_cr("Undefined variable"), cmexit(ERREXIT);
}

static	void	illmod()
{
	_cmdputerrmes_cr("Bad modifier"), cmexit(ERREXIT);
}

#ifndef UX_COMPILE_TEST
 /* exec()spawn(), system()͎g킸ADOSt@NVŃR}hs
    ̂ł̍ێgϐ́APSP0x2cɏꂽZOgɂ{B
    ]āAtoolssetenvR}hł̏L */
static	char	*get_environ(s)
char	*s;
 /* w肵ϐ̒lA{̊ϐGATAVmalloc̈ɓ
    ԂBɂ̊֐ĂԂƐ̒lfreeBȎ啶͋ʁB
    l̔񑶍݂̏ꍇNULLԂBmallocs\̏ꍇG[exit̂Œ! */
{
	char	far *p, far *q;
	int	namelen;
	static	char	*ret = NULL;

	p = (char far *)MK_FP(*(short far *)MK_FP(_psp, 0x2c), 0);
	q = (char far *)s;
	namelen = strlen(s);
	for(; *p; p += far_strlen(p), ++p){
		if(!far_strncmp(p, q, namelen) && *(p += namelen) == '='){
			ret = chk_realloc(ret, far_strlen(++p) + 1);
			far_strcpy((char far *)ret, p);
			return ret;
		}
	}
	return NULL;
}

static	put_environ(s)
char	*s;
{
	char	*e;
	int	namelen, l;
	char	far *p, far *q, far *r, far *t;
	short	envseg;
	unsigned int	envsiz;

	if(NULL == (e = strchr(s, '='))) return -1;
	namelen = e - s;
	p = q = (char far *)MK_FP(envseg = *(short far *)MK_FP(_psp, 0x2c), 0);
	for(r = NULL; *p; p += far_strlen(p), ++p){
		if(!far_strncmp(p, (char far *)s, namelen)&& p[namelen] == '=')
			r = p;
	}
	envsiz = p - q + (l = strlen(s)) + 2;
				/* s̖'\0'ƊϐI'\0' */
	if(r != NULL) envsiz -= far_strlen(r) + 1;
	if(envsiz > 0x10 * *(short far *)MK_FP(envseg - 1, 3))
		return -1; /* ̈s */

	if(r != NULL){
		t = r + far_strlen(r) + 1;
		far_memmove(r, t, p - t);
		p -= t - r;
	}
	far_strcpy(p, (char far *)s);
	p[++l] = '\0';
	return 0;
}

static	void	mknewenv()
 /* {̊ϐ̈Aǉɔ炩ߊg(悤Ƃ) */
{
	short	envseg, envsiz, nenvseg, flg;
	union	REGS	in, out;
	struct	SREGS	segreg;
	void	(*osig)();

	in . x . ax = 0x5800;
	if(0 != intdos(&in, &out)) return; /* ߂ */

	osig = signal(SIGINT, SIG_IGN);/* XgeWςĂԂ͒f֎~ */
	in . x . ax = 0x5801;
	in . x . bx = 2;
	intdos(&in, &out);

	envseg = *(short far *)MK_FP(_psp, 0x2c);
	envsiz = *(short far *)MK_FP(envseg - 1, 3);

	in . h . ah = 0x48;
	in . x . bx = envsiz + 1024/0x10; /* 1Kʂł悩낤 */
	nenvseg = intdos(&in, &out);
	flg = out . x . cflag;

	in . x . ax = 0x5801;
	in . x . bx = 0;
	intdos(&in, &out); /* XgeW0ɖ߂ */
	signal(SIGINT, osig);

	if(flg) return; /* dȂ̂ł̂܂ */
	far_memcpy(MK_FP(nenvseg, 0), MK_FP(envseg, 0), 0x10 * envsiz);
	*(short far *)MK_FP(_psp, 0x2c) = nenvseg;

	in . h . ah = 0x49;
	segreg . es = envseg;
	intdosx(&in, &out, &segreg); /* ̊ϐ̈̉ */
}
#else
#  define get_environ getenv
#  define put_environ putenv
#  define mknewenv()
#endif

#if 0
static	char	*dup_getenv(s)
char	*s;
 /* putenvŉe󂯂Ȃ悤Agetenv̌ʂstaticɎĂ */
{
	return NULL == (s = getenv(s)) ? NULL : chk_strdup(s);
}
#else /* _łputenv()gȂ̂ */
#  define dup_getenv getenv
#endif

static	put_env_val(var, val)
char	*var, *val;
{
	int	l = strlen(var);
	char	*buf;

	buf = chk_malloc(l + strlen(val) + 2); /* '=' + '\0' */
	strcpy(buf, var)[l] = '=';
	strcpy(buf + ++l, val);
	l = put_environ(buf);
	free(buf);
	return l;
}

#ifndef UX_COMPILE_TEST
static	isacon(fd)
int	fd;
{
	union	REGS	in, out;
	int	i;

	in . x . ax = 0x4400;
	in . x . bx = fd;
	in . x . dx = 0; /* ??? */
	intdos(&in, &out);
	return !out . x . cflag && ((i = out . x . dx) & 0x80) && (i & 0x3);
}
#else
#  define isacon isatty
#endif

static	char	*envmod(envval, modifier, modlast)
char	*envval, *modifier, *modlast;
 /* envvalmodifierŏĈԂ
    Ԃ͎̂ɂ̊֐Ă΂鎞free */
{
	static	char	*modbuf = NULL;
	char	*retval, *p, *q, *lastsep, *lastdot;

	if(modbuf != NULL) free(modbuf);
	if(NULL == (retval = modbuf = strdup(envval))) _putnomemmes();
	while(modifier < modlast){
		if(*modifier != MODCHR || ++modifier == modlast) illmod();

		lastsep = lastdot = NULL, p = retval;
		if(is_alpha(*p) && p[1] == DRIVE_SEP) p += 2;
		for(q = p; *q; ++q){
			if(iskanjipos(q)) ++q;
			 else if(ispathsep(*q)) lastsep = q;
		}
		for((q = lastsep) != NULL ? ++q : (q = p); *q == '.'; ++q);
		for(; *q; ++q){
			if(iskanjipos(q)) ++q;
			 else if(*q == '.') lastdot = q;
		}
		switch(*modifier++){
		case 'h':
			if(lastsep != NULL){
				*lastsep = '\0';
			} else {
				if(*p) *p = '.', *++p = '\0'; /*  */
			}
			break;
		case 'e':
			retval = (lastdot != NULL ? ++lastdot : q);
			break;
		case 'r':
			if(lastdot != NULL) *lastdot = '\0';
			break;
		case 't':
			retval = (lastsep == NULL ? p : ++lastsep);
			break;
		default:
			illmod();
		}
	}
	return retval;
}

static	char	*rewrite(s, var, val)
char	*s, *var, *val;
 /* 񓯂obt@Ԃ serrnoENOMEMEINVALɃZbgNULLԂ
    s̒ĝϐ͑啶ɕς var͂炩ߑ啶ɂȂĂ͂ */
{
	char	*p, *envval;
	static	char	*buf = NULL;
	static	int	buflen;
	int	outlen;

	if(0 != put_env_val(var, val)) putenv_err();

	if(buf == NULL && NULL == (buf = malloc(buflen = 100))) goto nomem;
	 /* malloc size͓KɌ߂BƂł̑PʂK */
	for(outlen = 0, p = buf; ;){
		if(*s != ENVCHR || *++s == ENVCHR){
		 /* u$v͊R[hɍȂ */
			if(++outlen > buflen){
				buf = realloc(buf, buflen += 20);
				if(buf == NULL) goto nomem;
				p = buf + outlen - 1;
			}
			if(!(*p++ = *s++)) break;
		} else {
			char	*q, *r, tmpc;

			if(*s == '{' || *s == '('){
				char	closebr = (char)(*s == '{'? '}' : ')');

				for(q = NULL, r = ++s; *s != closebr; ++s){
					if(!*s){errno = EINVAL; return NULL;}
					if(iskanjipos(s)){
						++s;
					} else if(*s == MODCHR && q == NULL){
						q = s;
					}
				} /* ̂Ƃr[-1] == '{''(' */
				if(q == NULL) q = s;
			} else
			if(is_alpha(*s) || *s == '_'){
				for(r = s; is_alnum(*s) || *s == '_'; ++s);
				 /* ̂Ƃr[-1] == ENVCHR */
				q = s;
			} else {
				errno = EINVAL; return NULL;
			}
			tmpc = *q; *q = '\0'; /* ƂŌɖ߂ */
#if 0 /* ⃋[vϐɃZbg邩炱͕sv */
			if((envflag & 02) ?
			    !strcmp(var, r)) : !kstricmp(var, r)){
				envval = val;
			} else
#endif
			{
				if(!(envflag & 02)) /* no_casesens */
					strtoupper(r); /* ̊ϐ
						肤? 啶ɂ͒ */
				if(NULL == (envval = get_environ(r))){
					if(envflag & 04){ /* noundef */
						envval = NULSTR;
					} else {
						errno = EINVAL; return NULL;
					}
				}
			}
			*q = tmpc; /* ɖ߂ */

			if(q != s) envval = envmod(envval, q, s);

			if((outlen += strlen(envval)) > buflen){
				buf = realloc(buf, buflen = outlen + 20);
				if(buf == NULL) goto nomem;
			} /* ̏ꍇpړKv */
			p = buf + outlen;
			strcpy(p - strlen(envval), envval);

			if(r[-1] != ENVCHR) ++s;
		}
	}
	return buf;
nomem:
	buf = NULL, errno = ENOMEM; return NULL;
}

static	char	*spcpass(s)
char	*s;
{
	for(; is_space(*s); s++);
	return s;
}

static	char	*remchrpass(s, nest)
char	*s;
int	nest; /* őnest-1́u:v𓪂珜BłȂNULL */
{
	s = spcpass(s);
	while(--nest > 0){
		if(*s != REMCHR) return NULL;
		s = spcpass(++s);
	}
	return s;
}

static	char	*wordafter(line, word, len)
 /* ŏlenwordƂŎn܂Ȃ㑱̔󔒁AłȂNULLԂ
    啶ʂȂ */
char	*line, *word;
int	len;
{
	return (kstrnicmp(line, word, len) ||
		*(line += len) && !is_space(*line)) ? NULL : spcpass(line);
}
#define wordconstafter(line, word) wordafter((line), (word), strconstlen(word))

#if 0
static	char	*remafter(s)
char	*s; /* 擪u:vremȂ璼̔󔒁AłȂNULL */
{
#define REMSGN "rem"
	return (*s == REMCHR) ? spcpass(++s) : wordconstafter(s, REMSGN);
}
#endif
static	endline(s)
char	*s; /* uend+󔒁vƂsł邩Ԃ */
{
#define ENDSGN "end"
	return NULL != (s = wordconstafter(s, ENDSGN)) && !*s;
}
static	char	*gotoafter(s)
char	*s; /* 擪gotoȂ璼̔󔒁AłȂNULL */
{
#define GOTOSGN "goto"
	return wordconstafter(s, GOTOSGN);
}
#define isgotoline(s) (NULL != gotoafter(s))

static	issemicols(s)
char	*s;
{
	char	*p;

	for(p = s; *p; ++p) if(*p != ';') return 0;
	return p - s; /* 󕶎Ȃ0ƂȂ */
}

static	char	*chk_widow_semicol(s)
char	*s;
 /* u;vŋ؂ꍇ͋؂Ă̎̔󔒂Ԃ łȂNULL */
{
	char	*p, *q;

	for(p = s; *p; p++){
		if(*p != ';' || p != s && !is_space(p[-1])) continue;
		for(q = p; *q == ';'; q++);
		if(*q && !is_space(*q)){
			p = q; continue; /* ';'ł͂Ȃ̂Ŕ΂č\Ȃ */
		}
		if(q == p + 1){
			*p = '\0'; return spcpass(q);
		}
		for(p = --q; *q = q[1]; q++);
		 /* ̌*p';'ł͂ȂȂ̂Ŕ΂č\Ȃ */
	}
	return NULL;
}

static	void	argtocmdl(s, n, ac, av)
char	*s, **av;
int	n, ac;
{
	int	l;
	char	*p;

	if(!ac) s++;
	for(; ac; --ac, ++av){
		l = strlen(p = *av);
		if((n -= l + 1) < 0) toolong();
		strcpy(s, p); s += l; *s++ = ' ';
	}
	*--s = '\0';
}

static	chkvn(s)
char	*s; /* returns non0 if OK */
{
	if(is_digit(*s)) return 0;
	for(; *s; ++s) if(!is_alnum(*s) && *s != '_') return 0;
	return 1;
}

#ifdef UX_COMPILE_TEST
static	int	lexec1(cmd, parm)
char	*cmd, *parm;
{
	printf("cmd: '%s' param: %d'%s'\n", cmd, *parm, parm + 1);
	return 0;
}
#else
static	int	lexec1(cmd, parm)
char	*cmd, *parm;
 /* słȂerrnoENOMEM, ENOEXECENOENTɂreturn -1 */
{
	static	char	parmblk[14] = {
		0, 0,  0, 0, 0, 0,  0x5c, 0, 0, 0,  0x6c, 0, 0, 0,
	};
	static	char	first = 1;
	union	REGS	in, out;
	struct	SREGS	segreg;

#  ifdef DEBUG
	printf("cmd: '%s' param: %d'%s'\n", cmd, *parm, parm + 1);
#  endif
	if(first){
		*(us_int *)&parmblk[8] = *(us_int *)&parmblk[12] = _psp;
		 /* data alignment̖͂ȂƑO񂷂 */
		first = 0;
	 /* 4bh̃R[p^ubNargۑƂ͏ĂȂ̂c
	    ƕۑ̂낤 */
	}
	*(long *)&parmblk[2] = (long)(char far *)parm;
	 /* łƎv̂ */

	segreg . ds = FP_SEG((char far *)cmd);
	in . x . dx = FP_OFF(cmd);
	segreg . es = FP_SEG((char far *)parmblk);
	in . x . bx = FP_OFF(parmblk);
	in . x . ax = 0x4b00;
	intdosx(&in, &out, &segreg);
	if(out . x . cflag){
		errno = (out . h . ah == 2) ? ENOENT :
			(out . h . ah == 11) ? ENOEXEC : ENOMEM;
		return -1;
	}
	in . h . ah = 0x4d;
	intdos(&in, &out);
#  ifdef LSI_C
	return (int)(us_char)out . h . al;
#  else
	return (int)out . h . al & 0xff; /* Ö */
#  endif
}
#endif /* UX_COMPILE_TEST */

static	int	lexec0(cmd, cmdlen, modeflag, nopath, parm)
char	*cmd, *parm;
int	cmdlen, modeflag/* 0, 1, 2 */;
bool	nopath;
 /* słȂerrnoE2BIG, ENOMEMENOENTɂreturn -1
    nopathPATH邩ۂ̃tO */
{
	static	char	*path = NULL, *comspec = NULL;
	static	char	*cparmbuf = NULL, *parmbuf = NULL, *cmdbuf = NULL;
	static	int	cparmblen, parmblen, cmdblen;
	int	cparmlen, parmlen, retval;
	char	*p, *q, pathlast, *pcur = ".";

#ifdef DEBUG
	printf("cmd: <%s>[%d]\n", cmd, cmdlen);
#endif
	if(path == NULL){
		if(NULL == (path = dup_getenv("PATH"))) path = NULSTR;
		comspec = dup_getenv("COMSPEC"); /* NULL̂܂܂蓾 */
	}
	if(cmdbuf == NULL){
		if(NULL == (cmdbuf = malloc(cmdblen = 40)) ||
		   NULL == (cparmbuf = malloc(cparmblen = 100)) ||
		   NULL == (parmbuf = malloc(parmblen = 80))) goto nomem;
		 /* malloc size͓KɌ߂BƂł̑PʂK */
	}

	parmlen = strlen(parm);
	if(modeflag == EXEC_ADDPARM && parmlen){
		cparmlen = cmdlen + parmlen + 3;
	} else {
		cparmlen = (modeflag == EXEC_ADDPARM ?
						cmdlen : strlen(cmd)) + 2;
	} /* 2 for "/C" */

	if(parmblen < parmlen + 2 /* for len, 0x0d */){
		parmblen = parmlen + 40;
		if(NULL == (parmbuf = realloc(parmbuf, parmblen)))
			goto nomem;
	}
	if(cparmblen < cparmlen + 2 /* for len, 0x0d */){
		cparmblen = cparmlen + 40;
		if(NULL == (cparmbuf = realloc(cparmbuf, cparmblen)))
			goto nomem;
	}

	parmbuf[0] = (char)parmlen;
	strcpy(parmbuf + 1, parm);
	parmbuf[parmlen + 1] = 0x0d;

	cparmbuf[0] = (char)cparmlen;
	cparmbuf[1] = (char)swchar();
	cparmbuf[2] = 'C';
	strcpy(cparmbuf + 3, cmd);
	if(modeflag == EXEC_ADDPARM && parmlen){
		cparmbuf[3 + cmdlen] = ' ';
		strcpy(cparmbuf + cmdlen + 4, parm);
	}
	cparmbuf[cparmlen + 1] = 0x0d;

	if(modeflag != EXEC_VIA_SHELL){
		for(p = q = pcur; *p; p = q){
		 /* ŏ̓JgfBNgB̏ꍇqpcur+1ƂȂ*/

			for(/* ŏq == p */; *q && *q != ENVPATH_SEP; ++q){
				pathlast = *q;
				if(iskanjipos(q)) ++q;
			} /* q̒l̓[vXVɎg */
			if(cmdblen < q - p + cmdlen + 6){
			 /* 6 for '\\', ".exe"+'\0' */
				cmdblen = q - p + cmdlen + 40;
				if(NULL == (cmdbuf = realloc(cmdbuf, cmdblen)))
					goto nomem;
			}
			strncpy(cmdbuf, p, q - p);
			p = cmdbuf + (q - p); /* pꎞ̗prɎg */
			 /* pathlast̒lĝp̌̒l < q̏ꍇɌA
			    ̏ꍇŏ̃[vpathlast͕Kݒ肳Ă */
			if(cmdbuf < p && pathlast != '\\' && pathlast != '/'){
			 /* ':'KvȂBpath́ua:v́ua:\vƈ */
			 /* '/'Kv͂邩? */
				*p++ = '\\';
			}
			if(nopath) p = cmdbuf;
			strncpy(p, cmd, cmdlen);
			p += cmdlen;

			if(parmlen <= DOSARGMAX){
				strcpy(p, ".com");
				if(-1 != (retval = lexec1(cmdbuf, parmbuf)))
					return retval;
				strcpy(p, ".exe");
				if(-1 != (retval = lexec1(cmdbuf, parmbuf)))
					return retval;
			}
			if(cparmlen <= DOSARGMAX){
				strcpy(p, ".bat");
				if(0 == _dos_getfileattr(cmdbuf,
#ifdef __WATCOMC__ /* sigh */
						       (us_int *)&retval) &&
#else
								 &retval) &&
#endif
				   !(retval & 0x18) && comspec != NULL &&
				   -1 != (retval = lexec1(comspec, cparmbuf)))
					return retval;
			}
			 /* cparmbuf̓ɂ̓tpX͂Ȃ̂Acommand.com
			    PATHTĂ邩炢Ƃ悤 */

			if(nopath) break;
			if(q == pcur + 1) q = path; else if(*q) ++q;
		}
	}

	 /* command.com̓R}h̏ꍇ(łȂꍇreturn -1) */
	if(cparmlen > DOSARGMAX) return(errno = E2BIG, -1);
	if(comspec == NULL) return(errno = ENOENT, -1);
	retval = lexec1(comspec, cparmbuf);
	if(errno == ENOEXEC) errno = ENOENT; /* ? */
	return retval;

nomem:
	if(NULL != cmdbuf) free(cmdbuf);
	if(NULL != cparmbuf) free(cparmbuf);
	if(NULL != parmbuf) free(parmbuf);
	return(cmdbuf = cparmbuf = parmbuf = NULL, errno = ENOMEM, -1);
}

static	int	sysexec(cmdline, modeflag)
char	*cmdline;
int	modeflag; /* 1, 2 */
{
	char	*cmdend, *p;
	bool	nopath = FALSE;

#define SETCMD "set"

	 /* R}ht@C̏Iʒum */
	 /* ݂̕@ł̓R}hƈ̋؂͋󔒂ɌB
	    荞2ehg邪c */
	cmdline = spcpass(cmdline);
	for(cmdend = NULL, p = cmdline; *p && !is_space(*p); ++p){
		if(iskanjipos(p)){++p; continue;}
		if(*p == '.') cmdend = p;
		 else if(*p == '\\' || *p == '/') nopath = TRUE, cmdend = NULL;
	}
	if(cmdend == NULL) cmdend = p;
	/* if(*p) p++; */
	return lexec0(cmdline, cmdend - cmdline, modeflag, nopath, p);
}

static	cmdexec(cmdline)
char	*cmdline;
 /* command.comɂR}hC̎s */
{
	return sysexec(cmdline, EXEC_VIA_SHELL);
}

static	lineexec(cmdline)
char	*cmdline;
 /* R}hC̎sBu<>|vĂcommand.comŎs */
{
	char	*p, *q;

	for(p = cmdline; *p; ++p){ /* ȑ[uŏ\Ȃ */
		if(*p == '"'){
			for(q = p, ++q; *q; ++q){
				if(*q == '"'){
					p = q; break;
				} else
				if(iskanjipos(q)) ++q;
			}
			/* closing '"' not found, no special treatment */
		} else
		if(*p == '<' || *p == '>' || *p == '|'){
			return cmdexec(cmdline);
		} else
		if(iskanjipos(p)) ++p;
	}
	return sysexec(cmdline, EXEC_DIRECT);
}

#if 0
static	parmexec(cmd, parm)
char	*cmd, *parm;
 /* R}hparm^Ă̎sB̂Ƃsgp */
{
	cmd = spcpass(cmd);
	 /* łR}h̐擪̖󔒂ɌĂ */
	return lexec0(cmd, strlen(cmd), EXEC_ADDPARM, FALSE, parm);
	 /* ۂɎgꍇ͑4Ɛݒ肷邱 */
}
#endif

static	void	fe_main(ac, av, varname, lcnt, lines)
int	ac, lcnt;
char	**av, *varname, **lines;
{
	int	i, j, nulfd, retval;
	char	*exeline, ignerr_flg;

#ifndef UX_COMPILE_TEST
	nulfd = open(NULNAME, O_WRONLY);
#endif
	for(retval = j = 0; j < ac; ++j){
		for(i = 0; i < lcnt; ++i){
			exeline = rewrite(lines[i], varname, av[j]);
			if(NULL == exeline){
				errno == ENOMEM ? nomem_exit() : illenv();
			}
			if((ignerr_flg = *exeline) == IGNERR)
				exeline = spcpass(++exeline);
			if(noexec){
				fputs(exeline, stdout), putchar('\n');
			} else {
				if(verbos) _puterrmes_cr(exeline);
				if(-1 == (retval = lineexec(exeline))){
					if(errno == ENOMEM) nomem_exit();
					_cmdputerrmes_cr(errno == E2BIG ?
					  "Command line too long." :
					  "Failed to execute.");
				}
#ifndef UX_COMPILE_TEST
				if(nulfd >= 0) write(nulfd, (char *)&nulfd, 1);
#endif
				if(retval && ignerr_flg != IGNERR){
					switch(ignerr){
					case 0:
						goto fin;
					case 1:
						goto nextfile;
					}
				}
			}
		}
	nextfile:
		;
	}
fin:
	cmexit(ignerr ? 0 : retval);
	 /* this outputs "exit" when noexec&&outexit */
}

main(ac, av)
int	ac;
char	*av[];
{
	extern	int	optind, opterr;
	extern	char	*optarg;

	static	char	linbuf[LMAX];
	char	*linptr, *linrest = NULL, **lines = NULL;
	int	c, i, len, lcnt;
	char	*varname, *infname = NULL;
	FILE	*cmdinf;
	bool	cmdl_flg = 0;
	int	tmpdupo = -1;

	struct	{
		char	*tag;
		int	taglen;
		int	mode;
#define NON_BATMODE		0
#define PASS1_SEARCH_GOTOTAG	1
#define PASS1_RD_UNTIL_LABEL	2
	} batmode_tag
#ifndef MSC51
	= {
		NULL, 0, NON_BATMODE
	};
#else /* buggy MSC51, sigh */
	;
	batmode_tag . tag    = NULL;
	batmode_tag . taglen = 0;
	batmode_tag . mode   = NON_BATMODE;
#endif

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	mknewenv();
	envflag = expenv_flg();
#ifdef DEBUG2
	if(ac == 2){
		exit(lineexec(av[1]));
	} else
	if(ac == 3){
		exit(parmexec(av[1], av[2]));
	} else exit(-1);
#endif
	opterr = 0;

	while(EOF != (c = getopt(ac, av, "invecf:b:"))){
		cswitch(c){
		case 'i': ignerr = 2; break;
		case 'c': ignerr = 1; break;
		case 'n': noexec = 1; break;
		case 'e': outexit = 1; break;
		case 'v': verbos = 1; break;
		case 'f': infname = optarg; break;
		case 'b': batmode_tag . tag = optarg;
			  batmode_tag . taglen = strlen(optarg);
			  batmode_tag . mode = PASS1_SEARCH_GOTOTAG; break;
		default: usage();
		}
	}
	ac -= optind, av += optind;
	if(ac < 2) usage();

	varname = *av; --ac, ++av;
	if(!(envflag & 02)) /* no_casesens */
		strtoupper(varname); /* xȂ͂ */
	if(!chkvn(varname)){
		_cmdputerrmes_cr("Illegal variable name."), cmexit(ERREXIT);
	}

	if(batmode_tag . mode != NON_BATMODE){
	 /* batmodeȂfe_nest̐ݒƊϐւ̐ݒ */
		static	char	newenv[strconstlen(fe_nest_envname) + 8] =
				  fe_nest_envname; /* +'='++5+'\0' */

		if(infname == NULL){
			char	*nest_env;

			if(NULL != (infname = get_environ(fe_inf_envname)))
				infname = chk_strdup(infname);
			 /* get_environ()2Ăтinfnamêh~ */

			if(NULL != (nest_env = get_environ(newenv)))
				fe_nest = atoi(nest_env);

			if(NULL == (cmdinf = fopen(infname, "r")))
				goto notopen;
		} else { /* fe_nest0̂܂ */
			char	*tmpbuf;

			if(NULL == (cmdinf = batsearch(infname, &tmpbuf)))
				goto notopen;
			if(0 != put_env_val(fe_inf_envname,
					tmpbuf == NULL ? infname : tmpbuf))
				putenv_err();
			free(tmpbuf);
		}
#ifdef UX_COMPILE_TEST /* radix10Ɍ */
#  define itoa(v, b, r) (sprintf((b), "%d", (v)), (b))
#endif
		itoa(++fe_nest,
		  newenv + strconstlen(fe_nest_envname) + 1, 10)[-1] = '=';
		if(0 != put_environ(newenv)) putenv_err();
	} else {
		if(infname == NULL){
			cmdinf = stdin;
		} else {
			if(NULL == (cmdinf = fopen(infname, "r"))){
			notopen:
				_cmdputerrmes(infname);
				_puterrmes_cr(": Can't open"), cmexit(ERREXIT);
			}
		}
	}

	for(i = 0; i < ac; ++i){
		switch(issemicols(av[i])){
		case 0:
			continue;
		case 1:
			if(!i) usage();
			cmdl_flg = 1;
			argtocmdl(linrest = linbuf, LMAX,
						ac - i - 1, av + i + 1);
			ac = i; break; /* i>aĉfor甲 */
		default:
			++(av[i]); /* xȂ͂ */
		}
	}

	if(cmdinf == stdin&& isacon(fileno(stdin))&& !isacon(fileno(stdout))){
		fflush(stdout); /* Ô */
		if(0 <= (tmpdupo = dup(fileno(stdout)))){
			close(fileno(stdout));
			if(0 > open("con", O_WRONLY)){
				close(tmpdupo);
				tmpdupo = -1;
			} /* else result of open() should be fileno(stdout) */
		}
	}

	for(lcnt = 0; ;){
		if(linrest != NULL){
			linptr = linrest;
#ifndef UX_COMPILE_TEST
		} else
		if(cmdinf == stdin && isacon(fileno(stdin))){
			union	REGS	in, out;
			struct	SREGS	segreg;

			_puterrmes("? ");
			in . h . ah = 0x0a;
			in . x . dx = FP_OFF(linbuf);
			segreg . ds = FP_SEG((char far *)linbuf);
			linbuf[0] = 0xff; /* őǂݍݕ */
			intdosx(&in, &out, &segreg);
			(linptr = linbuf + 2)[(unsigned char)linbuf[1]] = '\0';
			_puterrmes_cr(NULSTR);
			if(*linptr == 0x1a/*^Z*/) break;
#endif
		} else {
			if(NULL == fgets(linptr = linbuf, LMAX, cmdinf)) break;

			if(!*linptr){ /* nothing */
			} else
			if(linptr[(len = strlen(linptr)) - 1] == '\n'){
				linptr[len - 1] = '\0';
			} else
			if(len == LMAX - 1) toolong();
		}
		if(NULL == (linptr = remchrpass(linptr, fe_nest)))
			continue;
		  /* ̎_linptr̐擪͔󔒁B܂A͍s̍Ō̉s
		     ĂBbatmodełȂfe_nest0 */

		switch(batmode_tag . mode){
		case NON_BATMODE:
			break;
		case PASS1_SEARCH_GOTOTAG: /* check "goto labal" */
			if(NULL == (linptr = gotoafter(linptr))) continue;
			if(*linptr == REMCHR) ++linptr; /* no spcpass */
			if(NULL != wordafter(linptr, batmode_tag . tag,
						      batmode_tag . taglen))
				batmode_tag . mode = PASS1_RD_UNTIL_LABEL;
			continue;
		default: /* case PASS1_RD_UNTIL_LABEL: /* check ":label" */
			if(*linptr == REMCHR &&
			   NULL != wordafter(spcpass(linptr + 1),
				     batmode_tag . tag, batmode_tag . taglen))
				goto loop_break;
			break;
		} /* ̎_łlinptr̐擪͔ */
		linrest = chk_widow_semicol(linptr);
		 /* ̌*linptr'\0'ɂȂ邱Ƃ͂ */
		if(endline(linptr)) break;
		if(*linptr && *linptr != REMCHR){
			lines = chk_realloc(lines, ++lcnt * sizeof(char *));
#if 0 /* ȑO̓R}h͂̒iKŊϐ̑݌Ă */
			if(NULL == rewrite(linptr, varname, NULSTR)){
				errno == ENOMEM ? nomem_exit() : illenv();
			} /* ϐ̑݌̂߂ɂ̂ݍsʂ̂Ă */
#endif
			lines[lcnt - 1] = chk_strdup(linptr);
		}

		if(cmdl_flg){
		 /* R}hCJԂs^ꍇŁAꂪu;v
		    IĂȂꍇAǂ܂Ȃ */
			if(linrest == NULL){
				if(cmdinf==stdin /* && isacon(fileno(stdin))*/)
					break;
				 /* ȑO͂̈[̏ꍇɌĂ */
			} else
			if(!*linrest) cmdl_flg = 0; /*u;vŏIĂꍇ */
		}
	}
loop_break:
	if(0 <= tmpdupo){
		fflush(stdout); /* Ô */
		close(fileno(stdout));
		dup(tmpdupo); /* should be fileno(stdout) */
		close(tmpdupo);
	}

	if(cmdinf != stdin) fclose(cmdinf); /* ɕKvȂƎv */
	fe_main(ac, av, varname, lcnt, lines); /* exitA߂ĂȂ */
	 /* NOTREACHED */
#ifndef LSI_C
	return 0;
#endif
}
