#include <stdio.h>
#include <ctype.h>
#include <math.h> /* for atol() */
#include "tools.h"
#ifndef BLOCK_SIZE
#  define BLOCK_SIZE 512
#endif

#ifdef MSDOS
#  define putcr() fputs("\r\n", stdout)
#else
#  define putcr() putchar('\n')
#endif

char	*cmdname = "head";

static	bool	disphdr = 1, inchar = 0, inblock = 0;

static	void	usage()
{
	fputs("Usage: ", stderr), fputs(cmdname, stderr);
	fputs(" [-[#][bclh]] [files...]\n", stderr), exit(1);
}

static	void	fhead(f, lines)
register FILE	*f;
long	lines;
{
	register int	c;

	while(EOF != (c = getc(f))){
		putchar(c);
		if(c == '\n') if(!--lines) return;
	}
}

static	void	fheadc(f, chars)
register FILE	*f;
long	chars;
{
	register int	c;

	while(EOF != (c = getc(f))){
		putchar(c);
		if(!--chars) return;
	}
}

static	void	head(fnm, lines)
char	*fnm;
long	lines;
{
	FILE	*f;

	if(fnm[0] == '-' && !fnm[1]){
		if(disphdr){
			putcr(), fputs("==> stdin <==", stdout), putcr();
		}
		(inchar ? fheadc : fhead)(stdin, lines);
		clearerr(stdin);
	} else {
		if(NULL == (f = fopen(fnm, "r"))){
			fputs(cmdname, stderr), fputs(": ", stderr);
			fputs(s_conv_to_unix_format(fnm), stderr);
			fputs(": Can't open\n", stderr), exit(1);
		} else fsetbin(f);
		if(disphdr){
			putcr(), fputs("==> ", stdout);
			fputs(s_conv_to_unix_format(fnm), stdout),
			fputs(" <==", stdout), putcr();
		}
		(inchar ? fheadc : fhead)(f, lines);
		fclose(f);
	}
}

main(ac, av)
int	ac;
char	**av;
{
	long	lines = 10;
	char	*p;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif
	--ac, ++av;
	if(ac && *(p = *av) == '-' && *++p){
		lines = atol(p);
		while(is_digit(*p)) p++;
		while(*p){
			switch(*p++){
			case 'b': inblock = inchar = 1; break;
			case 'c': inblock = 0, inchar = 1; break;
			case 'l': inblock = inchar = 0; break;
			case 'h': disphdr = 0; break;
			default: usage();
			}
		}

		--ac, ++av;
	}
	if(inblock) lines *= BLOCK_SIZE;
	if(ac <= 1) disphdr = 0;
	fsetbin(stdin), fsetbin(stdout);
	if(!ac){
		head("-", lines);
	} else {
		for(; ac; --ac, ++av) head(*av, lines);
	}
	return 0;
}
