### LSI Clibr̂̂awkŏ
### Usage: jgawk -f libr.awk -- [CC=compiler] [-o outfile] [cc-options] files...
### DOSł͑rswapKv
function fexist(s,    flg, tmp){
	flg = (getline tmp < s)
	close(s)
	return flg >= 0
}
function usage_exit(){
	print "Usage: jgawk -f libr.awk [-o outfile] [cc-options] files..." \
		> "/dev/stderr"
	exit(exitcode = -1)
}
BEGIN{
	if(fexist("/.\\NUL")){ # Maybe MS-DOS
		dosmode = 1
		outfile = "libr.out"; objext = ".obj"
		cc_c = "lcc -c"
		ar_qc = "oar qc"
		rm_f = "del"
	} else { # Maybe UNIX
		outfile = "libr.a"; objext = ".o"
		cc_c = "cc -c"
		ar_qc = "ar qc"
		rm_f = "rm -f"
		ranlib = "ranlib"
	}
	for(i = 1; i < ARGC; i++){
		if(ARGV[i] ~ /^-o$/){
			ARGV[i] = ""
			if(++i < ARGC){
				outfile = ARGV[i]
				ARGV[i] = ""
			} else {
				usage_exit()
			}
		} else
		if(ARGV[i] ~ /^-o/){
			outfile = substr(ARGV[i], 3)
			ARGV[i] = ""
		} else
		if(ARGV[i] ~ /^-/){
			if(ccoptions != ""){
				ccoptions = ccoptions " " ARGV[i]
			} else {
				ccoptions = ARGV[i]
			}
			ARGV[i] = ""
		} else
		if(ARGV[i] ~ /^CC=/){
			cc_c = substr(ARGV[i], 4) " -c"
			ARGV[i] = ""
		} else {
			break
		}
	}
}
FNR == 1{
	do_src()
	kind = "leading garbage"
}
/^--/{
	do_src()
	kind = "common header"
	hlines = 0
	headerNR = NR + 1
	next
}
/^-/{
	do_src()
	kind = "each source"
	sourcename = $0; gsub(/^-[ \t]*|[ \t]*$/, "", sourcename)
	if(!dosmode) printf "# %d \"%s\"\n", headerNR, FILENAME > sourcename
	for(i = 0; i < hlines; i++) print cheader[i] > sourcename
	if(!dosmode) printf "# %d \"%s\"\n", NR + 1, FILENAME > sourcename
	next
}
kind == "common header"{
	cheader[hlines++] = $0
	next
}
kind == "each source"{
	print > sourcename
	next
}
function lsystem(s){
	print s > "/dev/stderr"
	return system(s)
}
function do_src(    cmdl, cmdl2, obj, flg){ # sourcename is global
	if(sourcename == "") return

	close(sourcename)
	obj = sourcename; gsub(/(\.[^.]*)?$/, objext, obj)
	cmdl = cc_c " " ccoptions " " sourcename
	cmdl2 = ar_qc " " outfile " " obj
	if(dosmode || sourcename !~ /\.a86$/){
		flg = lsystem(cmdl); if(!flg) flg = lsystem(cmdl2)
	} else {
		printf "%s ignored.\n", sourcename > "/dev/stderr"
	}
	system(rm_f " " sourcename)
	system(rm_f " " obj)
	sourcename = ""
	if(flg) exit(exitcode = flg) # on DOS, cannot detect error
}
END{
	if(exitcode) exit(exitcode) # error-exit
	do_src()
	if(ranlib != ""){
		if(0 != lsystem(ranlib " " outfile)){
			print "If you use SystemV, no problem." > "/dev/stderr"
		}
	}
}
