/*
	Public domain: Original by Kaoru Maeda, March, 1989. (for Human68K)
	Modified for MS-DOS by Yasushi Saito, April, 1989.
	Modified by Isao Nishihara(saibara) Volume Label works good.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifndef UX_COMPILE_TEST
#  include <dos.h>
#  include <io.h>
#  include <direct.h>
#endif
#include <fcntl.h>
#include <time.h>
#include "tools.h"

#ifndef BLOCK_SIZE
#  define BLOCK_SIZE 512
#endif

#ifdef UX_COMPILE_TEST
#  define DEBUG
#endif

char	*cmdname = "ls";

typedef struct	file {
	struct	file	*next; /* Ggւ̃|C^ */

	 /* t@C */
	char	*name;
#ifdef SUPP_LFN
	char	*lname; /* SFNƓꍇ͏nameƓ|C^
			   ]*name0ǂŏ𕪂ȂĂ
			   lnamenametpX̏ꍇ 
			   Ɋi[(name) */
#endif

	 /* A1/100b */
	union {
		struct {
			struct {
				unsigned day:5;
				unsigned month:4;
				unsigned year:7;
			} bh;
			struct {
				unsigned sec2:5;
				unsigned minute:6;
				unsigned hour:5;
			} bl;
		} b;
		struct {
			unsigned short d;
			unsigned short t;
		} dt;
	} date; /* IWiォ炱unioñf[^ɈˑĂ邪A
		   ĂRpCˑł? (Nide) */
#ifdef SUPP_LFN
	us_char	date_dt_s100;
#  define date_b_s100 date_dt_s100
#endif

	 /* ̃t@C邢͂̐e݂hCu(-sIvVp)B
	    -1:s 0:a 1:bc	fBNg̏ꍇ҂͈قȂ邱Ƃ邪A
	    ̂ƂTCY0o͂̂łǂłx͂Ȃ */
	char	truedrv;

	 /* TCYƑ */
	char	attr; /* Win95łlonĝƂ뉺1oCggĂȂ */
	us_long	size; /* filesizelongɎ܂Ȃ\͖Ă */
} file;

typedef struct dirfile {
	struct	dirfile *next;
	char	*fullname;
} dirfile;

static	char	month_name[] = "???JanFebMarAprMayJunJulAugSepOctNovDec";
static	char	dyofwk_name[] = "SunMonTueWedThuFriSat";

static	file	*files = NULL;
static	dirfile *dirs = NULL, *dirs_last = NULL;

static	char	current_directory[PATHNAMELENGTH];

static	bool	d_opt, l_opt, s_opt, t_opt, x_opt, C_opt, F_opt, R_opt, e_opt;
static	bool	X_opt, S_opt, Sort_by_ext_opt, volgood, r_opt, disp_dir;
#ifdef SUPP_LFN
static	bool	sfn_opt;
#endif
static	int	c_opt, a_opt, time_mode; /* these are not booleans */
 /* all initially 0 */

static	int	filenum;		/* Nide, from inside main() */
static	int	err_code = 0;
static	us_long	curtime;
static	bool	first_dirout = 1, nolower = 0;

#define FATALEXIT 2
#ifdef MSDOS
void	expand_hook()
{
	if(getenv("LSWILDALL") != NULL)	_dosfind_param = 0x3f;
	_expand_abendcode = FATALEXIT;

	expand_hook_default();
}
#endif

static	void	usage_and_die()
{
	fprintf(stderr, "Usage: %s [-RaAdCxBXlrtFsU1cuOoe_V] [files...]\n",
		cmdname);
	exit(FATALEXIT);
}

#ifdef OLD_C
static	stricmp(p, q)
char	*p, *q;
{
	while(*p && to_lower(*p) == to_lower(*q)) ++p, ++q;
	return to_lower(*p) - to_lower(*q);
}
#endif

/* Allocate one space for dirfile. */
static	dirfile *allocate_dir(name)
char	*name;
{
	dirfile *p;

	p = chk_malloc(sizeof(dirfile));
	p -> fullname = chk_strdup(name), p -> next = NULL;
	return p;
}

/* Push the directory-chain to the directory stack.  top, last != NULL. */
static	void	link_dir_chain(top, last)
dirfile *top, *last;
{
#if 0 /* old ver. */
	last -> next = dirs;
	dirs = top;
#else
	if(dirs != NULL){
		dirs_last -> next = top;
	} else {
		dirs = top;
	}
	dirs_last = last;
#endif
}

/* Push one directory to the directory stack. */
static	void	add_dir_list(name)
char	*name;
{
	dirfile *p;

	p = allocate_dir(name);
	link_dir_chain(p, p);
}

static	void	say_noex(s, dirmode)
char	*s;
int	dirmode;
{
	fprintf(stderr, "%s: %s%s not exist.\n",
		cmdname, s_conv_to_unix_format(s), dirmode ? "/" : NULSTR);
	err_code = 1;
}

static	void	rm_vol_period(s)
char	*s;
{
	char	*p;

	if(NULL != (p = strrchr(s = filename_base(s), '.')) && p - s >= 8)
		strcpy(p, p + 1);
}

#ifdef SUPP_LFN
static	void	namefree(p)
file	*p;
{
	free(p -> lname);
	if(p -> lname != p -> name) free(p -> name);
}
#else
#  define namefree(p) free((p) -> name)
#endif

#ifndef UX_COMPILE_TEST
static	us_long	getclusize(drv) /* sȂ0Ԃ */
char	drv; /* s:-1 a:0 b:1c */
{
	union	REGS	in, out;

	if(!++drv) return 0;
	in . h . dl = (us_char)drv;
	in . h . ah = 0x36;
	if(-1 == intdos(&in, &out)) return 0;
	return (us_long)out . x . ax * out . x . cx;
}
#else
#  define getclusize(drv) 512
#endif

static	bool	add_file_list_sub(
			name, truedrv, fullname_p, volmask, nomsg, dir_p)
char	*name, truedrv;
bool	fullname_p, nomsg;
unsigned volmask;
int	dir_p;
/* separated from add_file_list() by Nide; ꂪĂ΂ƂAvolmask̑3
   rbgƂȊOɗƂ͂Ȃ(悤ɂ邱)Bnon-recursive */
{
	struct	Find_t	fb;
	file	*p, *q, *r;
	int	c;
	char	*rs;

#ifdef DEBUG
	fprintf(stderr, "dosxf %s %x -> %d\n", name, volmask,
		_dos_xFind_soonclose(name, volmask, &fb));
#endif
	/* Get file status */
	if(!_dos_xFind_soonclose(name, volmask, &fb)){
#if 0
		if(name(strlen[name] - 1) == '.' && !(fb.attrib & _A_SUBDIR)){
		 /* '.'ŏIfBNg͂ȂƌȂB'a/.'a
		    ʏt@CłꍇA'abc.'̔r */
			goto notexist;
		}
#endif /* ܂̂Ƃ낱̏͂ĂȂB̃c[Ǔ
	  Ă邩c */

		if(((char)fb.attrib & _A_VOLID) &&
		   kstricmp(filename_base(name),
#ifdef SUPP_LFN
			fb.lname
#else
			fb.name
#endif
		   )) goto notexist;
		 /* lbg[NhCuɑ΂A_dos_findfirst()͗^
		    t@CƊ֌WȂÕ{[x
		    Ƃ悤ĉ */
	} else {
		/* Failed to read the NAME as normal file. is it a special
		   file:-), or root??. Check it here. (volmask chk add Nide) */
		/* char buf[128]; */

		if(volmask & _A_VOLID){
		 /* ܂̕ςvolume labelΉB߂ǂ */
			char	tmp[10];

#ifdef DEBUG
			fprintf(stderr, "Checking label...\n");
#endif
			if(is_alpha(*name) && name[1] == ':'){
				strncpy(tmp, name, 2);
				strcpy(tmp+2, ALLNAME);
			} else strcpy(tmp, ALLNAME);
			if(_dos_Find_soonclose(tmp, _A_VOLID, &fb) || kstricmp(
#ifdef SUPP_LFN
			   fb.lname, /* SFNlnameɓĂ */
#else
			   fb.name,
#endif
			   filename_base(name))) goto notexist;
			 /* łȂꍇAςł͂邪volume label */
		} else
		if(can_cd_there(name)){
#ifdef DEBUG
			fprintf(stderr, "Treat as a root dir.\n");
#endif
			fb.attrib = _A_SUBDIR;
#ifdef SUPP_LFN
			fb.hsize = fb.lsize = 0L;
			memset(fb.ctime, '\0', 24);
			fb.mtime[2] = 0x21;
			fb.name[0] = '\0';
			strcpy(fb.lname, filename_base(name));
#else
			fb.size = 0L;
			fb.wr_date = 0x21; /* 1980/1/1 */
			fb.wr_time = 0;
			strcpy(fb.name, filename_base(name));
#endif /* SUPP_LFN */
		} else {
		notexist:
			if(!nomsg) say_noex(name, 0);
			return FALSE;
		}
	}

	/* Ignore the plain file, which is intended to be a directory
	   file(i.e. ends with '\').
	   By this,  LS will return error if the pathname is specified as
	   '\etc\passwd\', even if the plain file '\etc\passwd' exists. */
	if(!((char)fb.attrib & _A_SUBDIR) && dir_p){
		if(!nomsg) say_noex(name, 1);
		return FALSE;
	}
	if(fullname_p && !d_opt && ((char)fb.attrib & _A_SUBDIR)){
		add_dir_list(name);
		return TRUE;
	}
	p = chk_malloc(sizeof(file));
	rs = filename_base(name);
	if(!*current_directory){ /* Set current directory */
		strncpy(current_directory, name, rs - name);
		current_directory[rs - name] = 0;
	}
#ifdef SUPP_LFN
	if(fullname_p){
		p -> lname = chk_strdup(name);
		p -> name = (_lfnsupp_level <= LFN_NONE ?
					p -> lname : chk_strdup(sfn_of(name)));
	} else { /* ̏ꍇrsfindfirstŎ擾
		     "." ".." ̃`FbNŏ\ */
		if(!is_self_or_parent_dir(rs)){
			p -> lname = chk_strdup(fb . lname);
			p -> name = (*fb . name ?
					chk_strdup(fb . name) : p -> lname);
		} else {
			p -> name = p -> lname = chk_strdup(rs);
		}
	}
#else
	p -> name = chk_strdup(fullname_p ? name : rs);	/* Nide */
#endif
	p -> truedrv = truedrv;

	if(volgood && ((char)fb.attrib & _A_VOLID)){
		rm_vol_period(p -> name); /* same as p->lname if SUPP_LFN */
		 /* Based on Isao Nishihara(saibara)'s patch. */
	} /* else no_op; t@CXgւ̓o^ɂ͏Ȃ */

#ifdef SUPP_LFN
	p->attr = (char)fb.attrib;
	p->size = fb.lsize;
	{
		char	*timep;

		switch(time_mode){
		case 2:
			timep = fb . ctime;
			goto chk_supp_tm;
		case 1:
			timep = fb . atime;
		chk_supp_tm:
			if(timep[2]) break;
		default:
			timep = fb . mtime;
		}
		p->date.dt.d = ((us_short *)timep)[1];
		p->date.dt.t = ((us_short *)timep)[0];
		p->date_dt_s100 = timep[4];
	}
#else
	p->attr = (char)fb.attrib;
	p->size = fb.size;
	p->date.dt.d = fb.wr_date;
	p->date.dt.t = fb.wr_time;
	/* p->date_dt_s100͂Ȃ */
#endif

	/* Insert the file into the proper position */
	for(r = NULL, q = files; q; r = q, q = q->next){
		if(t_opt){
			us_short pd, qd;

			pd = p->date.dt.d, qd = q->date.dt.d;
			if(qd > pd) c = 1;
			else if(qd < pd) c = -1;
			else {
				pd = p->date.dt.t, qd = q->date.dt.t;
				if(qd > pd) c = 1;
				else if(qd < pd) c = -1;
#ifdef SUPP_LFN
				else if(q->date_dt_s100>p->date_dt_s100) c = 1;
				else if(q->date_dt_s100<p->date_dt_s100) c =-1;
#endif
				else goto name_comparison;
			}
		} else if(X_opt){
			off_t ps, qs;

			ps = p->size, qs = q->size;
			if(qs > ps) c = 1;
			else if(qs < ps) c = -1;
			else goto name_comparison;
		} else if(S_opt){
			c = 1;
		} else if(Sort_by_ext_opt){
			char	*dotpos[2];
			int	i;

			for(i = 0; i < 2; i++){
				file	*t;
				char	*u;

				t = i ? q : p;
				dotpos[i] = (NULL == (u = extent_of(
#ifdef SUPP_LFN
						sfn_opt ? t->name : t->lname
#else
						t -> name
#endif
					    , 1)) ? NULSTR : u);
			}
			if(!(c = kstricmp(dotpos[0], dotpos[1])))
				goto name_comparison;
		} else {
		name_comparison:
#ifdef SUPP_LFN
			c = (sfn_opt ? kstricmp(p->name, q->name) :
				       kstricmp(p->lname, q->lname));
#else
			c = kstricmp(p->name, q->name);
#endif
			if(!c) c = (q->attr & _A_VOLID) - (p->attr & _A_VOLID);
			 /* Add Nide,
			     volume labelfile݂ꍇɔ */
			if(!c){
				namefree(p), free(p);
				return FALSE;	/* FALSE ok? */
			}
		}
		if(r_opt) c = -c;
		if(c < 0) break;
	}
	if(r) r->next = p; else	files = p;
	p->next = q;
	return TRUE;
}

/* Add one file to the output file chain. */
static	void	add_file_list(name, truedrv, fullname_p, volmask)
char	*name; /* ChJ[h܂܂ȂWJς݂̃t@C */
char	truedrv; /* ̃t@C̐ȇhCu */
bool	fullname_p; /* main()璼ɌĂ΂鎞1Boutput_dirs()̎0
	 ̏ꍇname̍Ō̃pX؂ȍ~findfirstŎ擾 */
register unsigned volmask;
{
	/* changed Nide (separate main part as add_file_list_sub() */
	int	dir_p;
	register bool	c = FALSE;

	if(dir_p = conv_and_endtest_pathsep(name, PATH_SEP1))
		volmask &= ~_A_VOLID;
	if(!nolower) lfntolower(name);
	 /* fullname output͂ŏĂ */

	/* Add Nide */
	if((volmask & _A_VOLID) && (volmask & ~_A_VOLID)){
		if(0 != (c = add_file_list_sub(name, truedrv, fullname_p,
						_A_VOLID, TRUE, dir_p)))
			++filenum;
		volmask &= ~_A_VOLID;
	}
	add_file_list_sub(name, truedrv, fullname_p, volmask, c, dir_p);
}

static	int	executable_p(p)
file	*p;
{
	register char	*cp;

	if(p->attr & (_A_VOLID | _A_DEV)) return FALSE;
	if(p->attr & _A_SUBDIR) return TRUE;
	return (NULL != (cp = extent_of(p -> name, 1)) &&
	  (!stricmp(++cp, "bat")|| !stricmp(cp, "exe")|| !stricmp(cp, "com")));
		/* ++cpĂ邱Ƃɒ */
}

static	char	F_char(p)
file	*p;
{
	if(F_opt){
		if(p->attr & _A_SUBDIR) return '/';
		if(executable_p(p)) return '*';
	}
	return '\0'; /* Nide */
}

#ifndef SCREEN_WIDTH
#define SCREEN_WIDTH	80
#endif

static	void	nameout(p, flg)
file	*p;
bool	flg; /* 0: SFNLFN̕ЕBSUPP_LFN̏ꍇAsfn_optǂ
		   SFNLFN̂ǂo
		1: SFN LFN */
{
	char	attr = p->attr, F_ch = F_char(p);
	char	*name = p->name, *ext, color;
#ifdef SUPP_LFN
	bool	volflg = (volgood && (attr & _A_VOLID));
#else
#  define volflg (volgood && (attr & _A_VOLID))
#endif

	if(c_opt && 0 != (color = (
		attr & _A_VOLID	 ? 37 :
		attr & _A_DEV	 ? 34 :
		attr & _A_SUBDIR ? 36 :
		attr & (_A_SYSTEM | _A_HIDDEN) ? 35 :
		NULL != (ext = extent_of(name, 1)) ? (
		 /* ++extɒ */
		      !stricmp(++ext, "bak") || !stricmp(ext, "old") ? 31 :
			!stricmp(ext, "bat")			     ? 33 :
			!stricmp(ext, "exe") || !stricmp(ext, "com") ? 32 :
			!stricmp(ext, "sys") || !stricmp(ext, "drv") ? 35 : 0
		  ) : 0))){
		printf(attr & _A_VOLID ? "\033[%d;7m" : "\033[%dm", color);
	}
#ifdef SUPP_LFN
	if(_lfnsupp_level > LFN_NOWILD && flg){
		int	l;

		fputs(volflg ? name : s_conv_sfn_to_unix_format(name), stdout);
		if(c_opt && color) printf("\033[m");

		l = 14 - strlen(name); /* 8+1+3+(F_ch̕1)+1 */
		if(F_ch) putchar(F_ch), --l;
		if(1 >= l) l = 1;
		printf("%*s", l, NULSTR);

		if(c_opt && color) printf(
			attr & _A_VOLID ? "\033[%d;7m" : "\033[%dm", color);
		fputs(p -> lname, stdout);
		 /* name̓tpX̂Ƃ̂12ȓƂ͌Ȃ */
	} else {
		fputs(volflg ? name /* {[xSFNƑO */ :
		      sfn_opt ? s_conv_sfn_to_unix_format(name) :
		      nolower ? p -> lname : s_conv_to_unix_format(p->lname),
		    stdout);
	} /* p->namep->lnameꍇ̂ŏɂ͒ */
#else
	fputs(volflg ? name : s_conv_to_unix_format(name), stdout);
#endif
	if(c_opt && color) printf("\033[m");
	if(F_ch) putchar(F_ch);
}

static	void	sizeout(p) /* s_opt^̎̂݌Ă΂ */
file	*p;
{
	us_long	clusize, size; /* t@CTCYlongɎ܂ʃP[X͖ */
	char	truedrv = p -> truedrv;
	static	us_long	*clusztbl = NULL;

	size = p->size;
	if(truedrv != (char)~0){
		if(clusztbl == NULL)
			memset(clusztbl = chk_malloc(sizeof(us_long) * 26),
						'\0', sizeof(us_long) * 26);
		if((0 != (clusize = clusztbl[truedrv]) ||
		    0 != (clusize = clusztbl[truedrv] = getclusize(truedrv)))&&
		   (size % clusize))
			size += clusize - size % clusize;
	}

	printf("%4lu ", (size + BLOCK_SIZE - 1) / BLOCK_SIZE);
}

static	void	print_short(p, col) /* Changed Nide */
file	*p;
int	col;
{
	static	int	prev_sp = 0;

	if(p == NULL){
		prev_sp = 0, putchar('\n');
		return;
	}
	printf("%*s", prev_sp, NULSTR);
	 /* x_opt || C_opt̏ꍇȊOAprev_sp͂0 */

	if(s_opt) sizeout(p);
	nameout(p, FALSE);
	if(x_opt || C_opt){
		prev_sp = col - (s_opt ? 5 : 0) - ('\0' != F_char(p)) -
#ifdef SUPP_LFN
			strlen(sfn_opt ? p -> name : p -> lname);
#else
			strlen(p -> name);
#endif
	}
}

static	void	multi_output()
{
	register file	*p, *q;
	int	maxlen, nfil, ncol, wcol, nrow, scrwidth = SCREEN_WIDTH;

	if(NULL == files) return;
	{
		char	*p, *q;

		if((p = getenv("COLUMNS")) != NULL && *p){
			for(q = p; is_digit(*q); ++q);
			if(!*q) scrwidth = atoi(p);
		}
	}

	maxlen = nfil = 0;
	for(p = files; p; p = p->next){
#ifdef SUPP_LFN
		register int	l = strlen(sfn_opt ? p->name : p->lname);
#else
		register int	l = strlen(p->name);
#endif

		if(l > maxlen) maxlen = l;
		++nfil;
	}
	if(s_opt) maxlen += 5;
	wcol = maxlen + 2; /* F_opt, yы󔒍l */

	if(!(ncol = (scrwidth + 1) / wcol)){
		++ncol; /* ܂ */
	} else {
		wcol = (scrwidth + 1) / ncol; /* wcol\ȂL */
	}
	nrow = (nfil - 1) / ncol + 1;

	if(x_opt){ /* Changed NideAsɗ]ȋ󔒂tȂ悤 */
		int	j = 0;

		for(p = files; p; q = p->next, free(p), p = q){
			print_short(p, wcol);
			if(++j == ncol){
				print_short(NULL, 0);
				j = 0;
			}
			namefree(p);
		}
		if(nfil % ncol)	print_short(NULL, 0);
	} else { /* -C option */
	 /* Changed NideAsɗ]ȋ󔒂tȂ悤 */
		int	i, j, k;

		for(i = nrow; i--;){
			p = files;
			for(k = nrow - i; --k;)
				if(p) p = p->next;
			for(j = 0; j < ncol; ++j){
				if(p && (i || nfil % ncol == 0 ||
					 j < nfil % ncol))
					print_short(p, wcol);
				for(k = nrow - 1; k--;)
					if(p) p = p->next;
				if(nfil % ncol == 0 || j < nfil % ncol)
					if(p) p = p->next;
			}
			print_short(NULL, 0);
		}
		for(p = files; p; q = p->next, free(p), p = q) namefree(p);
		/* Nide, avoid "q used before set" */
	}
}

static	void	one_output()
{
	file	*p, *q;

	for(p = files; p; q = p->next, free(p), p = q){
		print_short(p, 0);
		putchar('\n');
		namefree(p);
		/* Nide, avoid "q used before set" */
	}
}

static	void	short_output()
{
	if(C_opt || x_opt) multi_output(); else one_output();
}

static	void	long_output()
{
	file	*p, *q;
	unsigned int	month;
	char	mode[7];

	mode[4] = 'r';
	for(p = files; p; q = p->next, free(p), p = q){
		/* Nide, to avold "q may used before set" */

		if(s_opt) sizeout(p); /* Add Nide */

		mode[0] = (char)(p->attr & _A_DEV	? 'c' :
				 p->attr & _A_SUBDIR	? 'd' :
				 p->attr & _A_VOLID	? 'v' : '-');
		mode[1] = (char)(p->attr & _A_ARCH	? 'a' : '-');
		mode[2] = (char)(p->attr & _A_SYSTEM	? 's' : '-');
		mode[3] = (char)(p->attr & _A_HIDDEN	? 'h' : '-');
		mode[5] = (char)(p->attr & _A_RDONLY	? '-' : 'w');
		mode[6] = (char)(executable_p(p)	? 'x' : '-');
		/* Nide, ANSIRpC̕ւ̂߂ɕAڂ߂ */
		if((month = p->date.b.bh.month) > 12) month = 0;
		printf("%.7s %8lu ", mode, p->size);
		if(e_opt){
			printf("%.3s %.3s %2d %02d:%02d:%02d.%02d %04d ",
			    dyofwk_name + (int)(caldate(p->date.b.bh.year+1980,
					    month, p->date.b.bh.day) % 7) * 3,
			    month_name + month * 3, p->date.b.bh.day,
			    p->date.b.bl.hour, p->date.b.bl.minute,
#ifdef SUPP_LFN
			    p->date.b.bl.sec2 * 2 + p->date_b_s100 / 100,
			    p->date_b_s100 % 100,
#else
			    p->date.b.bl.sec2 * 2, 0,
#endif
			    p->date.b.bh.year + 1980
			);
		} else {
			us_long	ftime;

			printf("%.3s %2d ",
				    month_name + month * 3, p->date.b.bh.day);

			ftime = caltime(p->date.b.bh.year + 1980,
				    p->date.b.bh.month, p->date.b.bh.day,
				    p->date.b.bl.hour, p->date.b.bl.minute,
				    p->date.b.bl.sec2 * 2
#ifdef SUPP_LFN
						+ p->date_b_s100 / 100
#endif
				);
			if(ftime < curtime ? (curtime-ftime < 3600L*24L*180L) :
					     (ftime - curtime < 3600L)){
				printf("%02d:%02d ",
				    p->date.b.bl.hour, p->date.b.bl.minute);
			} else {
				printf(" %4d ", p->date.b.bh.year + 1980);
			}
		}
		nameout(p, TRUE), putchar('\n');
		namefree(p);
	}
}

static	void	output_files()
{
	dirfile *top, *last;
	file	*f;
	char	*fn, *strip;

	if(!d_opt && R_opt){
		top = last = NULL;
		fn = current_directory + strlen(current_directory);
		for(f = files; f; f = f->next){
			if(f->attr & _A_SUBDIR){
#ifdef SUPP_LFN
				strip = filename_base(
						sfn_opt ? f->name : f->lname);
				if(!is_self_or_parent_dir(strip))
#else
				strip = filename_base(f->name);
				if(*strip != '.')
#endif
				{
					strcpy(fn, strip);
					if(top == NULL){
						top = last = allocate_dir(
							current_directory);
					} else {
						last -> next = allocate_dir(
							current_directory);
						last = last -> next;
					}
				}
			}
		}
		if(top != NULL)	link_dir_chain(top, last);
	}
	if(l_opt)
		long_output();
	else
		short_output();
	files = NULL, *current_directory = 0, first_dirout = 0;
}

static	void	output_dirs() /* no recursive */
{
	dirfile *p;
	char	buf[PATHNAMELENGTH], *cp, truedrv;
	struct	Find_t	fb;
	us_int	attr;

	while(NULL != (p = dirs)){
		dirs = p -> next;
		if(disp_dir){
			cp = p -> fullname;
#ifdef SUPP_LFN
			if(sfn_opt) cp = sfn_of(cp);
#endif
			if(!first_dirout) putchar('\n');
			first_dirout = 0;
			printf("%s:\n",
				nolower ? cp : s_conv_to_unix_format(cp));
		}

		cp = p -> fullname;
		if(s_opt) truedrv = gettruedrv(cp);
		 /* -sIvV́ÃfBNg̏hCu߂
		    B̉̊et@C̏hCúAꂪ
		    fBNg̏ꍇAefBNg̏hCuƈقȂ
		    Ƃ邪AfBNg̃TCY0Ȃ̂ŎxȂ */
		expand_path(buf, cp, ALLNAME);
		cp = filename_base(buf);

		if(!a_opt){
			attr = 0x30;
		} else switch(netdrv_bug(buf)){
		 /* lbg[NhCȕꍇDOSVXeR[̃oO΍ */
		case 1:
			if(!_dos_Findfirst(buf, _A_VOLID, &fb)){/* ^̂͂ */
#ifdef SUPP_LFN
				strcpy(cp, fb . lname); /* u*.*v̕
				  ꎞIɃ{[xɏ */
#else
				strcpy(cp, fb . name);
#endif
				add_file_list(buf, truedrv, FALSE, _A_VOLID);
				strcpy(cp, ALLNAME); /* u*.*vɖ߂ */
			} /* FALLTHROUGH */
		case -1:
			attr = 0x37;
			break;
		default:
			attr = 0x3f;
		}

#ifdef DEBUG
		fprintf(stderr, "dosf %s %x ->%d\n", buf, attr,
					_dos_Findfirst(buf, attr, &fb));
#endif
		if(_dos_Findfirst(buf, attr, &fb)){
			continue;
		} /* Changed Nide */
		do {
			char	*name;

			/* if(isVFATattr(fb.attrib)) continue; */
			 /* now this check is done in _dos_Findfirst() */
#ifdef SUPP_LFN
			name = fb.lname;
#else
			name = fb.name;
#endif
			switch(a_opt){
			case 0:
				if(topdot_nomatch(name, NULL, -1)) continue;
				break;
			case 1:
				if(is_self_or_parent_dir(name)) continue;
				break;
			}

			strcpy(cp,
#ifdef SUPP_LFN
			  (sfn_opt || _lfnsupp_level<=LFN_NOWILD) && *fb.name ?
				fb.name :
#endif
				name);
			add_file_list(buf, truedrv, FALSE,
				      ((char)fb.attrib & _A_VOLID) ? _A_VOLID :
				      a_opt ? 0x37 : 0x30); /* Changed Nide */
		} while(_dos_Findnext(&fb) == 0);
		_dos_Findclose(&fb);

		output_files();
		free(p->fullname);
		free(p);
	}
}

static	bool	process_options(c)
int	c;
{
	cswitch(c){
	case 'R':
		R_opt = TRUE;	/* list directory recursively */
		disp_dir = TRUE;
		d_opt = 0;
		break;
	case 'a':
		a_opt = 2;
		break;	/* list all files */
	case 'A':
		a_opt = 1;
		break;	/* list all files except '.' '..' */
	case 'd':
		d_opt = TRUE;	/* list directory itself */
		R_opt = 0;
		disp_dir = 0;
		break;
	case 'C':
		C_opt = TRUE;
		x_opt = 0;	/* multicolumn output */
		break;
	case 'x':
		x_opt = TRUE;
		C_opt = 0;	/* multicolumn across */
		break;
	case 'B':	/* sort by file size */
		X_opt = TRUE;
		t_opt = S_opt = FALSE;
		break;
	case 'l':
		l_opt = TRUE;
		break;	/* long listing */
	case 'r':
		r_opt ^= 1;
		break;	/* reverse sort */
	case 't':
		t_opt = TRUE;
		X_opt = S_opt = FALSE;
		break;	/* use timestamp to sort */
	case 'F':
		F_opt = TRUE;
		break;	/* list with / and * */
	case 's':	/* append file size in KB. */
		s_opt = TRUE;
		break;	/* output block size */
	case '1':
		C_opt = 0;	/* no multicolumn */
		x_opt = 0;
		break;
	case 'U':	/* no sort */
		S_opt = TRUE;
		t_opt = X_opt = FALSE;
		break;
	case 'X':	/* sort by extention */
		Sort_by_ext_opt = TRUE;
		break;
	case 'O':
		c_opt |= 2; /* color-if-tty mode set */
		break;
	case 'o':
		c_opt ^= 4; /* color-force mode toggle */
		break;
	case 'V':
		volgood = TRUE;
		break;
	case '_':
#ifdef SUPP_LFN
		sfn_opt = TRUE;
#endif
		break;
	case 'c':
		time_mode = 2; /* ctime */
		break;
	case 'u':
		time_mode = 1; /* atime */
		break;
	case 'e':
		e_opt = 1;
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

main(ac, av)
int	ac;
char	*av[];
{
	extern	int	opterr;
	static	char	stdout_buf[BUFSIZ];

	int	c;	/* filenum is changed to be extern */
	char	*opt, **wwargv;
	static	char	tmparg[] = "\0:.";
	extern	int	optind;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif
	opterr = 0;

	setbuf(stdout, stdout_buf);

	if(isatty(1)){
		c_opt = 1;
		C_opt = TRUE;
	}
	*current_directory = 0;

	/* Process option string from LSOPTIONS and from the command line. */
	if(NULL != (opt = getenv("LSOPTIONS"))){
		for(; *opt; ++opt) process_options(*opt);
	}
	while((c = getopt(ac, av, "RaAdCxBXlrtFsU1cuOoe_V")) != EOF)
		if(process_options(c) == FALSE) usage_and_die();

	c_opt = (c_opt >= 3); /* bit 04 is on, or 01 and 02 are both on */
	filenum = 0;
	if(l_opt && !e_opt) curtime = getdostime();

	if(getenv("LSNOCONVLOWER") != NULL) nolower = 1;

	if(optind == ac){ /* tmparg+2: "." */
		add_file_list(tmparg+2, gettruedrv(tmparg+2), TRUE,
							a_opt ? 0x37 : 0x30);
		 /* Changed Nide. In this case we must ignore volume label */
	} else {
		av += optind;
		/* ̌AIWił͈납珈ĂBȂ? */
		for(wwargv = av; *av != NULL; ++av){
			char	*onearg, *argbase; /* int len; */

#ifdef DEBUG
			fprintf(stderr, "[%s]\n", *av);
#endif
			onearg = *av;
			if(is_alpha(*onearg) && onearg[1] == ':' &&
			   onearg[2] == '\0'){
				tmparg[0] = *onearg;
				onearg = tmparg;
			}
			argbase = filename_base(onearg);
			add_file_list(onearg, gettruedrv(onearg), TRUE,
			  !a_opt ? 0x30 :
			  is_self_or_parent_dir(argbase) ? 0x37 : 0x3f);
			/* Changed Nide (so that 'ls -a /volname' works).
			   '.' is not SJIS 2nd byte. */

			++filenum;
		}
		/* discard_wildcard(wwargv); */
	}
	if(filenum > 1)	disp_dir = TRUE;

	output_files();
	output_dirs();
	return err_code;		/* return from main() */
}
