#include <stdio.h>
#include <direct.h>
#include <string.h>
#include "tools.h"

char	*cmdname = "makedir";

static	int	makedir(path)
char	*path; /* path separator must be '\\'. return non0 if fail. */
{
	char	*x, *lastsep;
	int	flg;

	/* No problem if succeeded to mkdir PATH. */
	if(0 == mkdir(path)) return 0;

	/* Recursively makedir parent, then mkdir path itself. */
	for(x = path, lastsep = NULL; *x; ++x){
		if(iskanjipos(x)) ++x;
		 else if(*x == PATH_SEP) lastsep = x;
	}
	/* Return error if failed to split PATH. */
	if(lastsep == NULL) return -1;

	*lastsep = '\0';
	flg = makedir(path);
	*lastsep = PATH_SEP;
	if(flg != 0) return -1; /* failed to mkdir "A/B/C". */
	return mkdir(path);
}

main(ac, av)
int	ac;
char	**av;
{
	int	i;
	int	error = 0;
	bool	recur = 0;	/* Add Nide */

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
	 /* ChJ[h̓T|[gAԐڈT|[g */
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	if(ac >= 2 && !strcmp("-p", av[1])){
		--ac, ++av, recur = 1;
	}			/* Add Nide */
	if(ac < 2){
		_puterrmes("Usage: "), _puterrmes(cmdname),
		_puterrmes_cr(" [-p] DIRECTORY..."), exit(1);
		 /* Changed Nide */
	}
	for(i = 1; i < ac; i++){
		conv_to_dos_regpath(av[i]);
		if((recur ? makedir : mkdir)(av[i])){ /* Changed Nide */
			_cmdputerrmes(s_conv_to_unix_format(av[i]));
			_puterrmes_cr(": Can't make directory");
			error = 1;
		}
	}
	return error;
}
