#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <memory.h>
#ifndef MSDOS
#  include <sys/types.h>
#  include <sys/stat.h>
#  include <time.h>

#  define far
#  define farmalloc malloc
#else
#  include <dos.h>
#endif
#include "tools.h"

#ifndef MSDOS
#  define EUCJMODE
#endif

#ifdef EUCJMODE
#  define SS2 0x8e
#  define iskanji(c) ((c) & 0x80) /* ꉞ */
#  define is2bytec(c) (iskanji(c) || (c) == SS2)
#else
#  define is2bytec(c) iskanji(c)
#endif

char	*cmdname = "pr";

static	int	got_err = 0;
#ifdef MSDOS
typedef struct {
	struct	dosdate_t d;
	struct	dostime_t t;
} dosdt;
static	dosdt	begintm;
#else
static	time_t	begintm;
#endif

static	char	TABSTR[] = "\t";

 /*---- public domaingetopt()g ----------------------------*/
static	int	opterr = 1, optind = 1, optopt;
static	char	*optarg;

static	void	err_getopt(cmd, as)
char	*cmd, *as;
{
	static	char	msgtail[ ] = {0, 0};

	if(opterr){
		_puterrmes(cmd), _puterrmes(as),
		*msgtail = (char)optopt, _puterrmes_cr(msgtail);
	}
}

 /* toolslib.lɂ̂̂ɊgA"+" "-"IvV */
static	int	egetopt(ac, av, opts)
int	ac;
char	**av, *opts;
{
	static	char	*curopt = NULL;
	register char	*cp;

	if(curopt == NULL || !*curopt){
		if(optind >= ac) return EOF;
		switch(curopt = av[optind], *curopt++){
		case '+': /* "+c"̏ꍇ */
			++optind;
			optarg = (*curopt ? curopt : NULL);
			 /* PƂ"+"̏ꍇoptargNULL */
			curopt = NULL;
			return optopt = '\0'; /* Ԃl'\0' */
		case '-':
			switch(*curopt){
			case '\0':
				return EOF;
			case '-':
				if(!curopt[1]) return (++optind, EOF);
			}
			break;
		default:
			return EOF;
		}
	}
	if(':' == (optopt = *curopt++) || ';' == optopt ||
	   NULL == (cp = strchr(opts, optopt))){
		if(is_digit(optopt)){
		 /* "-" ̏ꍇ ɕʃIvVꍇ */
			optarg = curopt - 1;
			 /* ̔񐔎܂߂optargɓ̂Œ */
			while(is_digit(*curopt)) ++curopt;
			if(!*curopt) ++optind;
			return optopt = '0'; /* Ԃl'0' */
		}

		err_getopt(*av, ": unknown option, -");
		if(!*curopt) ++optind;
		return '?';
	}
	if(*++cp == ':' || *cp == ';' && *curopt){
		++optind;
		if(*curopt){
			optarg = curopt;
			curopt = NULL;
		} else {
			if(optind >= ac){
				err_getopt(*av, ": argument missing for -");
				return '?';
			} else {
				optarg = av[optind++];
			}
			 /* now *curopt == '\0' */
		}
	} else {
		optarg = NULL;
		if(!*curopt) ++optind;
	}
	return optopt;
}
 /*---- public domaingetopt()g ܂ -------------------*/

static	void	putnchar(n, c, f)
int	n, c;
FILE	*f;
{
	for(; n; --n) putc(c, f);
}

static	void	putncr(n, f)
int	n;
FILE	*f;
{
	putnchar(n, '\n', f);
}

static	void	putnsp(n, f)
int	n;
FILE	*f;
{
	putnchar(n, ' ', f);
}

static	int	cwidth(c)
int	c; /* wchar_t */
{
#ifdef EUCJMODE
	switch(c >> 8){
	case 0:
	case SS2: /* JIS X0201Ji */
		return 1;
	default:
		return 2;
	}
#else
	return (c >> 8 ? 2 : 1);
#endif
}

typedef	struct	{
	FILE	*f;
	int	ungetwc; /* wchar_t */
	int	restspc, curpos, prev_eolpos /* Ō̍s̍sʒu */;
} dFILE;

typedef	struct {
	int	width;
	char	far	*buf; /* mȂ̂far */
} eachline;

static	struct {
	bool	use_ff, fold, nohdr, no_openerr_msg, dblsp;
	bool	mulfmulc, horzmulc;
	bool	dsp_evnl; /* _uXy[X̏ꍇÃy[Ws */

	FILE	*pause_tty; /* pause鎞CRǂނ߂̒[t@C */

	int	beginpage;
	int	lines;
	  /* y[WsAɃwb_s(_uXy[Xl) */
	int	columns;
	  /* 1t@CJ̏ꍇBȊO0(Ƀt@C) */
	int	width; /* sA1J */
	int	lmgn; /* }[W */
	char	*header; /* ^ĂȂNULL */
	struct tabinfo {
		int	tabch; /* wchar_t */
		int	tabwidth;
		bool	valid; /* VOJ̏ꍇɃ^uϊL
		    ǂB}`J̏ꍇ͂̒lI1ɂ */
	} i_tabinfo, o_tabinfo, o_lnuminfo;
		/* o_lnuminfo͕֋XケɉĊǗ */
	struct sepinfo {
		char	*sep;
		int	sepwidth;
	} o_sepinfo;
} prinfo = {
	0, 0, 0, 0, 0,
	0, 0, 0,
	NULL,
	1, 66, 0, 72, 0,
	NULL,
	{'\t', 8, 0}, {'\t', 8, 0}, {'\t', 5, 0},
	{" ", 1},
};

static	struct {
	int	befsp, aftsp;
} o_curpos = {
	0, 0,
};

#define putnsp_etab(n) (o_curpos . aftsp += (n))

 /* putnl(), putwc_etab(), putfars_etab()o_curpos, prinfo.o_tabinfo
    O[oƂĎgpB̊֐ňقȂo̓t@Cɑ΂
    ݂ɏo͂Ȃ */
static	void	putnl(f)
FILE	*f;
{
	o_curpos . befsp = o_curpos . aftsp = 0;
	putc('\n', f);
}

static	void	putwc_etab(c, f)
int	c; /* wchar_t */
FILE	*f;
 /* o_tabinfo.valid1̏ꍇAʒûcEOF^邱ƂA
    ꍇo͂ȂB
    o_tabinfo.valid0̏ꍇcEOFɂȂƁB̏ꍇo_curpos͂Ȃ */
{
	int	i, j, d;

	if(prinfo . o_tabinfo . valid){
		if(c == ' '){
			putnsp_etab(1);
			return;
		}
		if(/* c == prinfo . o_tabinfo . tabch || */ c == '\t'){
		 /* UNIX prɑ */
			putnsp_etab(prinfo . o_tabinfo . tabwidth -
			    o_curpos . aftsp % prinfo . o_tabinfo . tabwidth);
			return;
		}
		if(c == '\n'){ /* ]ȋ󔒃Jbg(^u\tłȂĂ) */
			putnl(f);
			return;
		}

		if((i = o_curpos . befsp) < (j = o_curpos . aftsp)){
			int	k, l;

			k = i / prinfo . o_tabinfo . tabwidth;
			l = j / prinfo . o_tabinfo . tabwidth;
			if(k < l){
				char	e = (char)(prinfo.o_tabinfo.tabch>> 8);

				++i;
#if 1 /* UNIX pr͂ĂȂ */
				if(i % prinfo . o_tabinfo . tabwidth == 0)
					putc(' ', f), ++k;
#endif
				for(; k < l; ++k){
					if(e) putc(e, f);
					putc(prinfo . o_tabinfo . tabch, f);
				}
				i = l * prinfo . o_tabinfo . tabwidth;
			}
			putnsp(j - i, f);
		}
		if(c == EOF) return;
		o_curpos . befsp = o_curpos . aftsp = j + cwidth(c);
		 /* ɏo͂1Aʒui߂Ă */
	}

	if((d = c >> 8) != '\0') putc(d, f);
	putc(c, f);
}

static	void	putfars_etab(s, f)
char	far	*s;
FILE	*f;
{
	int	c; /* wchar_t */
	int	d;

	while('\0' != (c = (unsigned char)*s)){
		++s;
		if(is2bytec(c) && '\0' != (d = (unsigned char)*s))
			c <<= 8, c |= d, ++s;
		putwc_etab(c, f);
	}
}

#define isstdinnm(s) (*(s) == '-' && !(s)[1])

static	int	df_open(df, s)
 /* s͕KvɉbZ[WoĔ0ԂB"-"̓ስ */
dFILE	*df;
char	*s;
{
	if(NULL == (df -> f = (isstdinnm(s) ? (FILE *)stdin : fopen(s, "r")))){
		if(!prinfo . no_openerr_msg)
			_cmdputerrmes(s), _puterrmes_cr(": Can't open");
		got_err = 1;
		return -1;
	}
	df -> ungetwc = EOF;
	df -> restspc = df -> curpos = df -> prev_eolpos = 0;
	return 0;
}

static	int /* wchar_t */ getc_utab(df)
dFILE	*df;
 /* df->curposXVBi_taninfo.valid0̏ꍇA^ul̂܂curpos
    XV̂ŁAcurpos͐MpłȂ */
{
	int	c; /* wchar_t */
	FILE	*f = df -> f;

	if(EOF != (c = df -> ungetwc)){
		df -> ungetwc = EOF;
	} else if(df -> restspc > 0){
		--(df -> restspc), c = ' ';
	} else { /* ɗ̂ungetwcrestspcȂ */
		c = getc(f);
		if(is2bytec(c)) (c <<= 8, c |= getc(f));
		if(prinfo . i_tabinfo . valid &&
		   (c == '\t' || c == prinfo . i_tabinfo . tabch)){
		   /* UNIX prɑ */
			df -> restspc = prinfo . i_tabinfo . tabwidth -
			  df -> curpos % prinfo . i_tabinfo . tabwidth;
			return getc_utab(df);
		}
	}

	switch(c){
	case EOF:
	case '\n':
		df -> prev_eolpos = df -> curpos, df -> curpos = 0;
		break;
	default: /* EOF, '\n'ȊO */
		df -> curpos += cwidth(c);
	}

	return c;
	 /* ߂鎞_ŁAungetwc͂ȂBrestspc͂肤(̏ꍇc' ') */
}

static	void	ungetwc_df(c, df)
int	c; /* wchar_t */
 /* c'\n'̏ꍇcurpos̖߂͍lĂȂBcEOF'\n'ɂȂ */
dFILE	*df;
{
	df -> ungetwc = c;
	df -> curpos -= cwidth(c);
}

static	void	pass_untilcr(df)
dFILE	*df;
{
	int	c;
	FILE	*f = df -> f;

	while(EOF != (c = getc(f)) && c != '\n');
	df -> restspc = df -> curpos = 0, df -> ungetwc = EOF;
	 /* getc_utabłׂ̂ */
}

static	int	getl_utab(lp, n, df, fold)
eachline far	*lp; /* lp->buf̓TCYn+1(EUCJ̏ꍇ2*n+1)Kv */
int	n;
dFILE	*df;
bool	fold; /* s܂邩BUƍs܂Ŏ̂Ă */
 /* 2JAȊO1JƂꍇ̕lp->widthɓB
    EOFȂlp->bufɋ󕶎ꂽŔ0ԂBprinfo.i_tabinfo
    O[oƂĎgp */
{
	int	c/* wchar_t */, opos = df -> curpos;
	char	far	*s = lp -> buf;

	for(;;){
		switch(c = getc_utab(df)){ /* ungetcȂ restspc͂肤 */
		case EOF:
		case '\n':
			*s = '\0';
			return 0 == (lp -> width = df -> prev_eolpos - opos) &&
			       c == EOF ? -1 : 0;
		default: /* EOF, '\n'ȊO */
			if(df -> curpos - opos > n){
				ungetwc_df(c, df), *s = '\0';
				lp -> width = df -> curpos - opos;
				 /* ungetwĉnȉɂȂĂ͂ */
				if(!fold) pass_untilcr(df);
				return 0;
			} else {
				if('\0' != (*s = (char)(c >> 8))) ++s;
				*s++ = (char)c;
			}
		}
	}
}

static	eachline far	*lbuf_alloc(n, l)
long	n;
int	l;
{
	eachline far	*p;
	char	far	*allbuf;

#ifdef EUCJMODE
	l <<= 1; /* JIS X0201Ji2oCg邪1J */
#endif

	if(NULL == (allbuf = farmalloc(++l * n)) ||
	   NULL == (p = farmalloc(n * sizeof(eachline)))) nomem_exit();
	while(n--) p[n] . buf = allbuf + n * l;
	return p;
}

 /* printfsgp o̓[` */
static	void	fputulong(f, w, z, n)
FILE	*f;
int	w, z; /* z: 0tBǂ */
us_long	n;
{
	--w;
	if(n >= 10)
		fputulong(f, w, z, n / 10);
	else if(w > 0)
		putnchar(w, z ? '0' : ' ', f);
	putc((int)(n % 10) + '0', f);
}

static	void	fputuint(f, w, z, n)
FILE	*f;
int	w, z; /* z: 0tBǂ */
us_int	n;
{
	fputulong(f, w, z, (us_long)n);
}

static	void	open_tty()
 /* stdoutttyłconI[vprinfo.pause_ttyɓB
    NULL邱Ƃ */
{
	if(prinfo . pause_tty != NULL || !isatty(1)) return;
	prinfo . pause_tty =
#ifdef MSDOS
		fopen("con", "r");
#else
		fopen("/dev/tty", "r");
#endif
}

static	void	do_pause()
{
	FILE	*f;
	int	c;

	if((f = prinfo . pause_tty) == NULL) return;
	putchar('\007'), fflush(stdout);
	while(EOF != (c = getc(f)) && '\n' != c);
	/* fclose(f), prinfo . pause_tty = NULL; */
}

 /* wb_o͂ɂputfars_etab()͎gȂ */
static	void	hdrout(fd, s, n, f)
int	fd; /* ׂt@C DOS̏ꍇ{t@Cnhv */
char	*s; /* t@C-hŎw肵́BNULLȂo͂ */
int	n;
FILE	*f; /* o͐ */
{
#define SAMP_FMT "\n\nOct 01 12:00 1963  "
#ifdef MSDOS
#  ifdef __WATCOMC__
	us_short f_d_pk, f_t_pk;
#  else
	us_int	f_d_pk, f_t_pk;
#  endif
	dosdt	f_dt;
	static	char	month_name[] =
		"Jan\0Feb\0Mar\0Apr\0May\0Jun\0Jul\0Aug\0Sep\0Oct\0Nov\0Dec";

	do_pause();
	if(prinfo . nohdr) return;
	if(fd < 0 || 0 != _dos_getftime(fd, &f_d_pk, &f_t_pk)){
		memcpy(&f_dt, &begintm, sizeof(dosdt));
	} else {
		f_dt . d . year	  =	     ((f_d_pk >> 9)  & 0x7f) + 1980;
		f_dt . d . month  = (us_char)((f_d_pk >> 5)  & 0xf);
		f_dt . d . day	  = (us_char)( f_d_pk	     & 0x1f);
		f_dt . t . hour	  = (us_char)((f_t_pk >> 11) & 0x1f);
		f_dt . t . minute = (us_char)((f_t_pk >> 5)  & 0x3f);
		 /* second not used... */
	}

	putncr(2, f), putnsp(prinfo . lmgn, f);
	fputs(month_name - 4 + (f_dt . d . month << 2), f), putc(' ', f);
	fputuint(f, 2, 0, f_dt . d . day), putc(' ', f);
	fputuint(f, 2, 1, f_dt . t . hour), putc(':', f);
	fputuint(f, 2, 1, f_dt . t . minute), putc(' ', f);
	fputuint(f, 4, 0, f_dt . d . year), putnsp(2, f);
#else
	struct	stat	statbuf;
	time_t	tt;
	char	strfbuf[sizeof(SAMP_FMT)];

	do_pause();
	if(prinfo . nohdr) return;
	tt = (fd < 0 || 0 != fstat(fd, &statbuf) ?
					begintm : statbuf . st_mtime);
	 /* mtimeg */

	putncr(2, f), putnsp(prinfo . lmgn, f);
	strftime(strfbuf,
		    sizeof(SAMP_FMT), "%b %e %H:%M %Y  ", localtime(&tt));
	fputs(strfbuf, f);
#endif

	if(s != NULL) fputs(s, f), putc(' ', f);
	fputs("Page ", f), fputuint(f, 0, 0, n), putncr(3, f);
}

static	void	ftrout(line, f)
int	line; /* y[W̌ݍs */
FILE	*f;
{
	line = prinfo . lines - line;
	if(prinfo . dblsp) line <<= 1, line += prinfo . dsp_evnl;
	 /* Ssōs̔{dblspnohdȑꍇAŌ1s
	    soĂ܂ */
	if(!prinfo . nohdr) line += 5;
	if(line) prinfo . use_ff ? (void)putc('\f', f) : putncr(line, f);
}

static	void	lnum_out(line, f)
long	line;
FILE	*f; /* sԍóBo_tabinfo.valid1̏ꍇo_curpos𒲐 */
{
	if(prinfo . o_tabinfo . valid){
		putwc_etab(EOF, f);

		 /* fputulongŏo͂镝̕ */
		o_curpos . befsp =
		o_curpos . aftsp += prinfo . o_lnuminfo . tabwidth;
	}
	fputulong(f, prinfo . o_lnuminfo . tabwidth, 0, line);
	 /* sԍ̋󔒂o_tabinfo.valid1ł^uȂB
	    P͂܂ */
	putwc_etab(prinfo . o_lnuminfo . tabch, f);
}

static	void	pr_normal(ac, av)
int	ac;
char	*av[];
{
	int	c; /* wchar_t */
	dFILE	df;
	int	curpage, curpgline;
	long	curline; /* t@CʎZs */
	bool	outflg;

	for(; ac; --ac, ++av){
		if(df_open(&df, conv_to_unix_format(*av)) != 0) continue;

		for(outflg = 0, curpgline = curpage = 0, curline = 0L; ; ){
			if(EOF == (c = getc_utab(&df))) break;

			if(!curpgline){
				if(++curpage == prinfo . beginpage) outflg = 1;
				if(outflg) hdrout(fileno(df . f),
				  prinfo . header != NULL ? prinfo . header :
				    isstdinnm(*av) ? NULL : *av,
				  curpage, stdout);
			} else {
				if(outflg && prinfo . dblsp) putchar('\n');
			}
			++curline, ++curpgline;
			if(!outflg){
				if(c != '\n') pass_untilcr(&df);
			} else {
				prinfo . o_tabinfo . valid ?
					(void)putnsp_etab(prinfo . lmgn) :
					putnsp(prinfo . lmgn, stdout);
				if(prinfo . o_lnuminfo . valid)
					lnum_out(curline, stdout);
				for(;;){
					putwc_etab(c, stdout);
					if(c == '\n') break;
					if(EOF == (c = getc_utab(&df)))
						c = '\n';
				}
			}
			if(curpgline == prinfo . lines){
				if(outflg) ftrout(curpgline, stdout);
				curpgline = 0;
			}
		} /* Ō܂œǂ */
		if(outflg && curpgline && !(prinfo . nohdr && ac == 1))
			ftrout(curpgline, stdout);

		if(df . f == stdin) clearerr(stdin); else fclose(df . f);
	}
}

static	void	pr_multl(ac, av) /* 1t@C}`J */
int	ac;
char	*av[];
{
	long	l = 0, k;
	int	i, n;
	eachline far	*linep;
	dFILE	df;
	int	curpage, curpgline, vlines, vlines1, hrests;
	long	curline; /* t@CʎZs */
	long	pcollines = prinfo . columns * (long)prinfo . lines;

	linep = lbuf_alloc(pcollines, prinfo . width);
	for(; ac; --ac, ++av){
		if(df_open(&df, conv_to_unix_format(*av)) != 0) continue;

		 /* curpagecurlinet@CׂʎZł͂Ȃ̂ */
		for(curline = curpage = 0; ; curline += l){
			for(l = 0L; l < pcollines; ++l){
				if(0 != getl_utab(&linep[l], prinfo . width,
						&df, prinfo . fold)) break;
			} /* l: {ŗpɓǂ߂s */
			if(!l) break;
			if(++curpage < prinfo . beginpage) continue;

			hdrout(fileno(df . f),
			       prinfo . header != NULL ? prinfo . header :
				 isstdinnm(*av) ? NULL : *av,
			       curpage, stdout);
			vlines = vlines1 = (int)(l / prinfo . columns);
			 /* <= prinfo.lines */
			if(0 != (hrests = (int)(l % prinfo . columns)))
				++vlines1;
			for(curpgline = 0; curpgline < vlines1; ){
				if(curpgline && prinfo . dblsp) putchar('\n');
				++curpgline;
				putnsp_etab(prinfo . lmgn);

				i = 0;
				if(hrests) for(;;){
					k = (prinfo . horzmulc ?
						(long)(curpgline - 1) *
						  prinfo . columns + i + 1 :
						curpgline + i * (long)vlines1);
					if(prinfo . o_lnuminfo . valid)
						lnum_out(curline + k, stdout);
					putfars_etab(linep[--k] . buf, stdout);
					n = prinfo . width - linep[k] . width;

					if(++i == hrests) break;
					putnsp_etab(n);
					putfars_etab((char far *)prinfo .
						    o_sepinfo . sep, stdout);
				} /* hrests < prinfo.columns */
				if(curpgline <= vlines) for(;;){
					if(hrests || i){
						putnsp_etab(n);
						putfars_etab((char far *)
						    prinfo . o_sepinfo . sep,
						    stdout);
					}

					k = (prinfo . horzmulc ?
						(long)(curpgline - 1) *
						  prinfo . columns + i + 1 :
						curpgline + i * (long)vlines +
						  hrests);
					if(prinfo . o_lnuminfo . valid)
						lnum_out(curline + k, stdout);
					putfars_etab(linep[--k] . buf, stdout);
					n = prinfo . width - linep[k] . width;

					if(++i == prinfo . columns) break;
				}
				putnl(stdout);
			}

			if(prinfo . nohdr && vlines1 < prinfo.lines && ac == 1)
				break; /* Ō܂œǂ񂾏ꍇ̂break */
			ftrout(vlines1, stdout);
		}
		if(df . f == stdin) clearerr(stdin); else fclose(df . f);
	}
	 /* 1񂵂Ă΂ȂƂOɁAfree͂Ȃ */
}

static	void	pr_multf(ac, av) /* t@C ac>0̂ */
int	ac;
char	*av[];
{
	int	i, n, k;
	eachline far	*linep;
	dFILE	*df;
	int	curpage = 0, curpgline = 0;
	bool	outflg = 0;
	long	curline = 0L; /* ʎZ */

	linep = lbuf_alloc((long)ac, prinfo . width);
	df = chk_malloc(sizeof(dFILE) * ac);
	for(i = 0; i < ac; ++i){
		if(df_open(&df[i], conv_to_unix_format(av[i])) != 0) exit(1);
	}
	for(;;){
		for(k = i = 0; i < ac; ++i){
			if(0 == getl_utab(&linep[i], prinfo . width,
						&df[i], prinfo . fold)) k = 1;
		}
		if(!k){ /* St@CEOF [vEo */
			if(outflg && curpgline && !prinfo . nohdr)
				ftrout(curpgline, stdout);
			break;
		}

		if(!curpgline){
			if(++curpage == prinfo . beginpage) outflg = 1;
			if(outflg) hdrout(-1, prinfo.header, curpage, stdout);
				 /* ͌ݎ t@C\Ȃ */
		} else {
			if(outflg && prinfo . dblsp) putchar('\n');
			 /* _uXy[X̏ꍇśAŐ擪ȊO̍s
			    OƁAŒs̏ꍇ̃tb^̒Oɏo */
		}
		++curline, ++curpgline;
		if(outflg){
			putnsp_etab(prinfo . lmgn);
			if(prinfo . o_lnuminfo . valid)
				lnum_out(curline, stdout);
			for(i = 0; ; ){
				putfars_etab(linep[i] . buf, stdout);
				n = prinfo . width - linep[i] . width;
				if(++i < ac){
					putnsp_etab(n);
					putfars_etab((char far *)prinfo .
						    o_sepinfo . sep, stdout);
				} else {
					putnl(stdout);
					break;
				}
			}
		}
		if(curpgline == prinfo . lines){
			if(outflg) ftrout(curpgline, stdout);
			curpgline = 0;
		}
	}
	 /* 1񂵂Ă΂ȂƂOɁAfclosefree͂Ȃ */
}

static	void	settabinfo(infop, s, defw)
struct	tabinfo	*infop;
char	*s;
int	defw;
{
	int	c; /* wchar_t */

	if(s == NULL) s = NULSTR;
	if((c = (unsigned char)*s) != '\0' && !is_digit(c)){
		int	d;

		++s;
		if(is2bytec(c) && '\0' != (d = (unsigned char)*s))
			(c <<= 8, c |= d, ++s);
	} else c = '\t';
	infop -> tabch = c, infop -> tabwidth = (*s ? atoi(s) : defw);
	infop -> valid = 1;
}

static	void	do_opt(c, optarg)
int	c;
char	*optarg;
{
	cswitch(c){
	case 'm':
		prinfo . i_tabinfo . valid = prinfo . o_tabinfo . valid = 1;
		prinfo . mulfmulc = 1; break;
	case 't':
		prinfo . nohdr = 1; break;
	case 'h':
		prinfo . header = optarg; break;
	case 'l':
		prinfo . lines = atoi(optarg); break;
	case 's':
		if(optarg == NULL) optarg = TABSTR;
		 /* \t-eIvVLɂ͕ϊ */
		prinfo . o_sepinfo . sep = optarg;
		prinfo . o_sepinfo . sepwidth = strlen(optarg);
		break;
	case 'w':
		prinfo . width = atoi(optarg); break;
	case '0': /* numeral opt */
		prinfo . i_tabinfo . valid = prinfo . o_tabinfo . valid = 1;
		prinfo . columns = atoi(optarg); break;
	case '\0': /* plus... */
		prinfo . beginpage = atoi(optarg); break;
	case 'a': /* mIvVƂƂɎw肵ȂƖӖ */
		prinfo . horzmulc = 1; break;
	case 'd':
		prinfo . dblsp = 1; break;
	case 'f':
		prinfo . use_ff = 1; /* FALLTHROUGH */
	case 'p':
		open_tty(); break;
	case 'r':
		prinfo . no_openerr_msg = 1; break;
	case 'e':
		settabinfo(&prinfo . i_tabinfo, optarg, 8); break;
	case 'i':
		settabinfo(&prinfo . o_tabinfo, optarg, 8); break;
	case 'n':
		settabinfo(&prinfo . o_lnuminfo, optarg, 5); break;
	case 'o':
		prinfo . lmgn = atoi(optarg); break;
	case 'F':
		prinfo . fold = 1; break;
	default:
		_cmdputerrmes_cr("Illegal option.");
		exit(1);
	}
}

static	void	lnum_adjwidth() /* sԍo͂̏ꍇ̕ */
{
	if(!prinfo . o_lnuminfo . valid) return;
	prinfo . width -= prinfo . o_lnuminfo . tabwidth +
	  (prinfo . o_lnuminfo . tabch == '\t' ?
	    8 - prinfo . o_lnuminfo . tabwidth % 8 :
	    cwidth(prinfo . o_lnuminfo . tabch));
}

main(ac, av)
int	ac;
char	*av[];
{
	static	char	*defav[] = {"-"};
	int	c;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

#ifdef MSDOS
	fclose(stdaux), fclose(stdprn);
	{
		us_char	prvd = 0;

		for(;;){
			_dos_getdate(&begintm . d);
			if(prvd == begintm . d . day) break;
			prvd = begintm . d . day;
			_dos_gettime(&begintm . t);
		}
	}
#else
	time(&begintm);
#endif

	opterr = 0;
	while(EOF != (c = egetopt(ac, av, "fmth:l:s;w:adpre;i;n;o:F"))){
		do_opt(c, optarg);
	}
	ac -= optind, av += optind;
	if(!ac) ++ac, av = defav;

	if(prinfo . mulfmulc){
		if(prinfo . columns){
			_cmdputerrmes_cr("equivocal options: -m and -column");
			exit(1);
		} else prinfo . columns = ac;

		 /* ̏ꍇAsԍo݂͂width͂ */
		lnum_adjwidth();
	}

	if(prinfo . columns > 1){
		if(!strcmp(TABSTR, prinfo . o_sepinfo . sep)){
			int	tmp = prinfo . o_tabinfo . tabwidth -
				prinfo . width % prinfo . o_tabinfo . tabwidth;

			if((prinfo . width += tmp) %
			   (prinfo . columns * prinfo . o_tabinfo . tabwidth))
				tmp = 1;
			prinfo . width /= prinfo . columns;
			prinfo . width -=
			  prinfo . width % prinfo . o_tabinfo . tabwidth + tmp;
		} else { /* rɃ^uꍇ͔l */
			prinfo . width =
			    (prinfo . width + prinfo . o_sepinfo . sepwidth) /
			     prinfo . columns - prinfo . o_sepinfo . sepwidth;
		}
	}
	if(!prinfo . mulfmulc) lnum_adjwidth();
		 /* mulfmulcłȂꍇAsԍo݂͂width͂ */
	if(0 >= prinfo . width)
		_cmdputerrmes_cr("Width too narrow"), exit(1);

	if(!prinfo . nohdr){
		if(prinfo . lines <= 10) prinfo . nohdr = 1;
		 else prinfo . lines -= 10;
	}
	if(prinfo . dblsp){
		prinfo . dsp_evnl = (bool)(++prinfo . lines & 1);
		prinfo . lines >>= 1;
	}

	if(prinfo . mulfmulc){
		pr_multf(ac, av);
	} else
	if(prinfo . columns){
		pr_multl(ac, av);
	} else {
		pr_normal(ac, av);
	}

	if(fclose(stdout) != 0 && !isatty(fileno(stdout))){
		_cmdputerrmes_cr("Write error. (Disk full?)");
		exit(1);
	}
	return got_err;
}
