#include <stdio.h>
#include <ctype.h>
#include <dos.h>
#include <io.h>
#include <errno.h>
#include <string.h>
#if defined(__WATCOMC__) || defined(MSC51)
#  include <direct.h>
#endif
#include <fcntl.h>
#include "tools.h"
#define DISP stdout /* should be stderr? */

char	*cmdname = "pushd";

#ifdef MSDOS
void	expand_hook()
{
	_expand_abendcode = 2;
	expand_hook_default();
}
#endif

static	void	nodeep()
{
	fputs("Directory stack not that deep.\n", stderr), exit(1);
}

static	void	nomod()
{
	fputss(stderr, cmdname, ": Can't modify directory stack.\n", NULL);
	exit(1);
}

static	void	toomany()
{
	fputss(stderr, cmdname, ": Too many arguments.\n", NULL), exit(1);
}

static	char	*tmpfname(flg)
bool	flg;
 /* ϐDIRSTKƂ̒lԂBłȂƁA1ڂTMP̒l
    ꎞt@C̖OĕԂA2ڈȍ~͂Ɠ̂ԂB
    flg0̏ꍇAɂĈႤt@C𐶐悤ƂB
    -mIvVt̏ꍇɌflg0ŌĂ΂B*/
{
	char	*p;
	static	char	tmpfbase[] = "_dstktmp.$$$";
	static	char	*buf = NULL;

	if(!flg && NULL != (p = getenv("DIRSTK"))) return p;

	if(buf == NULL){
		if(NULL == (p = getenv("TMP")) &&
		   NULL == (p = getenv("TEMP"))){
			fputss(stderr,
				cmdname, ": Environment TMP not set\n", NULL);
			exit(1);
		}
		buf = chk_malloc(strlen(p) + 1 + sizeof(tmpfbase));
		 /* sizeof(tmpfbase) includes '\0' */
		strcpy(buf, p);
		for(p = buf; *p; p++){
			if((
#if 0 /* comment outƁATMP̒luA:v̂悤ȏꍇuA:\vƂ݂Ȃ */
			    *p == ':' ||
#endif
			    *p == '\\' || *p == '/') && !p[1])
				break;
			if(iskanjipos(p)) p++;
		}
		if(p != buf){
			if(!*p) *p = '\\';
			p++;
		}
		if(!flg){
			strcpy(p, tmpfbase);
		} else {
			union	REGS	in, out1, out2;
			static	char	tmpfbase2[] = "_ds$";
			int	d, s3; /* day & sec*3 */
			int	i, dmyfd;
			us_long	clktim;
			char	*q;

			strcpy(p, tmpfbase2);
			p += sizeof(tmpfbase2) - 1;
			for(;;){
				 /* func2cŁAdlɂPC-98̏ꍇ0Ȃł
				    b/100ƑO */
				q = p;
				for(d = 0; ; ){
					in . h . ah = 0x2a;
					intdos(&in, &out1);
					if(d == out1 . h . dl) break;
					d = out1 . h . dl;
					in . h . ah = 0x2c;
					in . h . dl = 0; /* dlĝŔÖ */
					intdos(&in, &out2);
				} /* dout1 . h . dlƓ */
				s3 = out2 . h . dh * 3 + out2 . h . dl / 34;
				clktim =
					(out1. x. cx -1980)*(3*3600L*24*31*12)+
					(out1. h. dh - 1) * (3*3600L*24*31) +
					(d	     - 1) * (3*3600L*24) +
					(out2. h. ch)	  * (3*3600L) +
					(out2. h. cl)	  * (3*60) + s3;
				for(i = 0; i < 6; i++){
					*q = (char)(clktim % 37L);
					clktim /= 37L;
					*q += (char)(*q < 10 ? '0' :
					    *q == 36 ? '_' - 36 : 'a' - 10);
					if(i == 3) *++q = '.', *++q = '$';
					++q;
				} /* 26N܂ŏz */
				*q = '\0';

				dmyfd = open(buf, O_CREAT | O_EXCL, 0644);
				if(dmyfd < 0) close(dmyfd);
				do {
					in . h . ah = 0x2c;
					in . h . dl = 0; /* dlĝŔÖ */
					intdos(&in, &out2);
				} while(s3 == out2.h.dh * 3 + out2.h.dl / 34);
				 /* dmyfdƂ񕉂łA1/3b(PC-98ł1b)
				    ҂Bʂpushdꎞt@C
				    ԂȂ悤ȍ׍H */
				if(dmyfd >= 0){
					unlink(buf);
					break;
				}
			}
		}
	}
	return buf;
}

static	FILE	*recf_open()
{
	char	*p;
	FILE	*retf;

	p = tmpfname(FALSE);
	if(NULL == (retf = fopen(p, "r+")) &&
	   NULL == (retf = fopen(p, "w+"))){
		fputss(stderr, cmdname, ": ? Can't open tmpfile\n", NULL);
		exit(1);
	}
	return retf;
}

static	chdir_drive(s)
 /* sconv_to_dos_regpathĂ(sς)Bs-1 */
char	*s;
{
	unsigned char	curdrv, newdrv;

	conv_to_dos_regpath(s); /* regularize */
	curdrv = getcurdrv();
	if(is_alpha(*s) && s[1] == ':'){
		newdrv = to_lower(*s) - 'a';
		if(curdrv != newdrv){
			setcurdrv(newdrv);
			if(getcurdrv() != newdrv) return -1;
		}
		if(!*(s += 2)) return 0;
	}

	if(!chdir(s)) return 0;
	if(curdrv != newdrv) setcurdrv(curdrv);
	return -1;
}

static	chdir_with_cdpath(s)
 /* s:ACDPATHɐ:0ACDPATHĐ:BsDOS`ɏς */
char	*s;
{
	char	*cdpath, *p, pathbuf[PATHNAMELENGTH];
	int	ls, lp;

	if(!chdir_drive(s)) return 0;
	if(is_ancestor_dir(s) || ispathsep(*s) || *s && s[1] == ':' ||
	   NULL == (cdpath = getenv("CDPATH"))) return -1;
	ls = strlen(s);
	while(*cdpath){
		p = pathbuf;
		while(*cdpath && *cdpath != ENVPATH_SEP) *p++ = *cdpath++;
		if(*cdpath) cdpath++; /* u;v΂BCDPATHu;vŏI
		  ꍇłA̗vf݂͍̑lȂĂ */
		*p = '\0';

		if(pathbuf != (p = expand_tilde(pathbuf))) strcpy(pathbuf, p);
		p = pathbuf + (lp = strlen(pathbuf));

		if(!lp || lp == 1 && ispathsep(*pathbuf) ||
		   lp == 2 && p[-1] == ':' ||
		   lp == 3 && p[-2] == ':' && ispathsep(p[-1])){
		 /* Eu\vEua:vEua:\v̏ꍇ́u\vtȂB
		   u\v̏ꍇɕtȂ̂́Aconv_to_dos_regpath擪
		   u\\v𐳋KȂdl̂ */
		} else {
			++lp, *p++ = PATH_SEP;
		}
		if(ls + lp >= PATHNAMELENGTH) continue; /* ߂ */

		strcpy(p, s);
		if(!chdir_drive(pathbuf)) return 1;
	}
	return -1;
}

static	void	nosuch(s)
char	*s;
{
	conv_to_unix_format(s);
	fputss(stderr, cmdname, ": ", s, ": No such directory\n", NULL);
	exit(1);
}

static	int	get_drv_wd(buf)
char	*buf;
{
	char	*p = buf;

	*p++ = (us_char)'a' + getcurdrv(), *p++ = ':', *p++ = '/';
	if(!get_wdir(0, p, 1)) return 0;

	 /* ͋Nʂ͂ */
	*(p = buf) = '.', *++p = '\0';
	fputss(stderr, cmdname, ": Can't get cwd due to DOS bug.\n", NULL);
	return 1;
}

static	char	**read_recf(f)
FILE	*f; /* 1񂵂Ă΂ȂƂz肵ppȂǂstaticɂĂȂ */
{
	char	**pp;
	int	count;
	char	linbuf[PATHNAMELENGTH + 1]; /* includes '\n' */

	pp = (char **)chk_malloc(sizeof(char *));
	for(count = 0; NULL != fgets(linbuf, PATHNAMELENGTH + 1, f); count++){
		if(*linbuf) linbuf[strlen(linbuf) - 1] = '\0';
		pp = (char **)chk_realloc((void *)pp,
						sizeof(char *) * (count + 2));
		pp[count] = chk_strdup(linbuf);
	}
	pp[count] = NULL;
	return pp;
}

#if defined(EXPAND_TILDE) && defined(SUPP_LFN)
 /* LFNT|[gł̂ݗp邱 */
static	char	*dispdir_sub(s, home, f)
char	*s, *home;
FILE	*f;
{
	union	REGS	in, out;
	struct	SREGS	segreg;
	char	l_s_nmbuf[2][PATHNAMELENGTH], *l_s_names[4], *nmsep[4];
	int	i, l;
	bool	flg;

	if(!*home) return s; /* NȂƎv */
	for(i = 0; i < 2; i++){
		in . x . ax = 0x7160;
		in . x . cx = i + 0x8001;
		in . x . si = FP_OFF(s);
		segreg . ds = FP_SEG((char far *)s);
		in . x . di = FP_OFF(l_s_nmbuf[i]);
		segreg . es = FP_SEG((char far *)l_s_nmbuf[i]);
		intdosx(&in, &out, &segreg);
		l_s_names[i] = (out . x . cflag ? NULL : l_s_nmbuf[i]);
	}
	for(i = 0; i < 2; i++)
		if(l_s_names[i] == NULL) l_s_names[i] = l_s_names[1 - i];
	if(l_s_names[0] == NULL) return s;

	l_s_names[2] = s, l_s_names[3] = home;
	 /* 0:SFN 1:LFN 2:̖ 3:HOME(regularized) */
	for(;;){
		for(i = 0; i < 4; i++) nmsep[i] = next_pathsep(l_s_names[i]);
		 /* ŏl_s_names[i]"a:/c"nmsep[i]"/c"
		    񂩂"/"1؂ */
		l = nmsep[3] - l_s_names[3];
		for(flg = FALSE, i = 0; i < 2; i++){
			if(l == nmsep[i] - l_s_names[i] &&
			   !kstrnicmp(l_s_names[3], l_s_names[i], l))
				flg = TRUE;
		}

		if(!*nmsep[3]){ /* homeŏ󕶎ł邱Ƃ͂Ȃ */
			if(!*l_s_names[2]) return s;
			s = (flg ? nmsep : l_s_names)[2];
			break;
		}
		if(!flg) return s;
		for(i = 0; i < 4; i++){
			if(*nmsep[i]) ++nmsep[i];
			l_s_names[i] = nmsep[i];
		}
	}

	putc(HOMEDIR_CHR, f);
	return s;
}
#endif

static	void	dispdir(s, f, usetilde)
char	*s;
FILE	*f;
int	usetilde;
 /* sɓ̂dirstackɐς܂ꂽ̂ŁAregularized unix format̔ */
{
#ifdef EXPAND_TILDE
	if(usetilde){
		static	char	*home, *usr = NULL, *homeend;

		if(usr == NULL){
			if(NULL != (home = getenv("HOME"))){
				home = chk_strdup(home);
				conv_to_dos_regpath(home); /* regularized */
				conv_to_unix_format(home);
				homeend = last_pathsep(home, &usr);
			} else usr = NULSTR;
		}

		if(home != NULL){
			int	c, l;

#ifdef SUPP_LFN
 /* ł邾SFN̏ꍇƎdl낦 ȂSFN̏ꍇ'~'̓WJHOME
    lfunc60hŏ͂ĂȂ(Jfunc̎gpȂׂ}邽) */
			if(_lfnsupp_level > LFN_NONE){
				s = dispdir_sub(s, home, f);
			} else
#endif
			if(!strncmp(home, s, l = usr - home)){
				putc(HOMEDIR_CHR, f), s += l;
				if(!strncmp(usr, s, l = homeend - usr) &&
				   ((c = s[l]) == '/' || c == ':' || !c))
					s += l;
			}
		}
	}
#endif /* EXPAND_TILDE */
	fputs(s, f);
}

static	void	pushd(f, s, usetilde, nocdpath) /* normal pushd */
char	*s;
FILE	*f;
int	usetilde, nocdpath;
{
	char	cwdbuf[PATHNAMELENGTH];
	char	**pp, **pq;

	if(get_drv_wd(cwdbuf)) exit(1);
	if(0 > (nocdpath ? chdir_drive : chdir_with_cdpath)(s)) nosuch(s);

	fseek(f, 0L, 2), fputs(cwdbuf, f), putc('\n', f);
	if(fflush(f) == EOF) nomod();
	rewind(f);

	get_drv_wd(cwdbuf);
	for(pq = pp = read_recf(f); *pq != NULL; pq++);
	*pq = cwdbuf;

	 /* display dirstack */
	for(; pq >= pp; pq--){
		dispdir(*pq, DISP, usetilde);
		putc(pq == pp ? '\n' : ' ', DISP);
	}
}

static	void	pushd0(f, usetilde) /* pushd with no argument */
FILE	*f;
int	usetilde;
{
	char	cwdbuf[PATHNAMELENGTH];
	char	**pp, **pq;

	for(pq = pp = read_recf(f); *pq != NULL; pq++);
	if(*pp == NULL) nodeep();
	fseek(f, -(strlen(*--pq) + 2L), 2); /* 'dirname CRLF' from tail */

	if(get_drv_wd(cwdbuf)) exit(1);
	if(chdir_drive(*pq)) nosuch(*pq);
	conv_to_unix_format(*pq);
	pq[1] = *pq, *pq = cwdbuf;

	fputs(*pq++, f), putc('\n', f);
	if(fflush(f) == EOF) nomod();
	ftruncate(fileno(f), ftell(f));

	 /* display dirstack */
	for(; pq >= pp; pq--){
		dispdir(*pq, DISP, usetilde);
		putc(pq == pp ? '\n' : ' ', DISP);
	}
}

static	void	pushd1(f, n, usetilde) /* pushd +n */
FILE	*f;
int	n, usetilde; /* n͔ */
{
	char	cwdbuf[PATHNAMELENGTH];
	char	**pp, **pq, **pt, **ps;

	for(pq = pp = read_recf(f); *pq != NULL; pq++);
	if(pq - pp < n) nodeep();
	if(get_drv_wd(cwdbuf)) exit(1);
	*(ps = pq) = cwdbuf;

	if(n){
		if(chdir_drive(*(pq -= n))) nosuch(*pq);
		conv_to_unix_format(*pq);

		rewind(f);
		for(pt = pq, ++pt; pt <= ps; pt++){
			fputs(*pt, f), putc('\n', f);
		}
		for(pt = pp; pt < pq; pt++){
			fputs(*pt, f), putc('\n', f);
		}
		if(fflush(f) == EOF) nomod();
		ftruncate(fileno(f), ftell(f));
	}

	 /* display dirstack */
	for(pt = pq; pt >= pp; pt--){
		dispdir(*pt, DISP, usetilde);
		putc(pp == pt && !n ? '\n' : ' ', DISP);
	}
	for(++pq, pt = ps; pt >= pq; pt--){
		dispdir(*pt, DISP, usetilde);
		putc(pq == pt ? '\n' : ' ', DISP);
	}

	if(pp == ps){
		fclose(f), unlink(tmpfname(FALSE));
	}
}

static	void	popd(f, n, usetilde)
 /* popd +nBŌfcloseAȂ폜 */
FILE	*f;
int	n, usetilde; /* n͔ */
{
	char	cwdbuf[PATHNAMELENGTH];
	char	**pp, **pq;
	long	l;

	for(pq = pp = read_recf(f); *pq != NULL; pq++);
	if(pq == pp){
		fputs("Directory stack empty.\n", stderr);
		fclose(f), unlink(tmpfname(FALSE));
		exit(1);
	}
	if(!n){
		fseek(f, -(strlen(*--pq) + 2L), 2);
		 /* 'dirname CRLF' from tail */

		if(chdir_drive(*pq)) nosuch(*pq);
		conv_to_unix_format(*pq);

		 /* display dirstack */
		for(; pq >= pp; pq--){
			dispdir(*pq, DISP, usetilde);
			putc(pq == pp ? '\n' : ' ', DISP);
		}
	} else {
		if(pq - pp < n) nodeep();
		for(l = 0L, pq -= n; *pq != NULL; pq++)
			l += strlen(*pq) + 2L; /* 'dirname CRLF' from tail */
		fseek(f, -l, 2);
		for(pq -= n, ++pq; *pq != NULL; pq++){
			fputs(*pq, f), putc('\n', f);
		}

		get_drv_wd(cwdbuf);
		*pq = cwdbuf;

		 /* display dirstack */
		for(; n; --n, --pq){
			dispdir(*pq, DISP, usetilde);
			putc(pq == pp + 1 ? '\n' : ' ', DISP);
		}
		for(pq--; pq >= pp; pq--){
			dispdir(*pq, DISP, usetilde);
			putc(pq == pp ? '\n' : ' ', DISP);
		}
	}
	if(fflush(f) == EOF) nomod();
	ftruncate(fileno(f), l = ftell(f)), fclose(f);
	if(!l) unlink(tmpfname(FALSE));
}

static	isdir(fnm)
char	*fnm;
{
	struct	Find_t	f;

	return !find_Fixedfile(fnm, &f, 0) && ((char)f . attrib & _A_SUBDIR);
}

main(ac, av)
int	ac;
char	*av[];
{
	FILE	*recf;
	int	popdf = 0, usetilde = 1, rotate = -1, init = 0, maktmp = 0;
	int	dirargpos, i;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	if(!strcmp(cmdname, "popd")) popdf = 1;
	else if(!strcmp(cmdname, "dirs")) rotate = 0;

	for(--ac, ++av; ac; --ac, ++av){
		if(**av == '-'){
			char	*p;

			for(p = *av + 1; *p; p++){
				switch(*p){
				case 'i':
					init = 1; break;
				case 'm':
					maktmp = 1; break;
				case 'l':
					usetilde = 0; break;
				case 'p':
					popdf = 1; break;
				default:
					fputss(stderr, cmdname,
						": No such option.\n", NULL);
					exit(1);
				}
			}
		} else
		if(**av == '+'){
			if(rotate >= 0) toomany();
			 /* no multipul '+num' arguments */

			if(0 > (rotate = atoi(*av + 1))){
				rotate = 0;
			}
		} else {
			break;
		}
	}
	if(maktmp){
		if(ac) toomany();
		fputs(tmpfname(TRUE), stdout);
		exit(0);
	}
	if(init){
		if(ac) toomany();
		if(0 != unlink(tmpfname(FALSE)) && errno == EACCES){
			fputss(stderr, cmdname, ": Can't initial.\n", NULL);
			exit(1);
		} else exit(0);
	}

	recf = recf_open();
	if(popdf){
		if(ac) toomany();
		if(rotate < 0) rotate = 0;
		popd(recf, rotate, usetilde);
	} else {
		switch(ac){
		case 0:
			if(rotate >= 0) pushd1(recf, rotate, usetilde);
			 else pushd0(recf, usetilde);
			break;
		case 1:
			if(rotate >= 0) toomany();
			pushd(recf, *av, usetilde, 0);
			break;
		default:
			if(rotate >= 0) toomany();
			for(dirargpos = -1, i = 0; i < ac; i++){
				if(!isdir(av[i])) continue;
				if(dirargpos >= 0) toomany();
				dirargpos = i;
			}
			if(dirargpos < 0) toomany();
			pushd(recf, av[dirargpos], usetilde, 1);
			 /* cdƈႢAۂchdirłȂ̃bZ[W
			    u߂vłȂufBNg݂v*/
		}
	}
	return 0;
}
