#include <stdio.h>
#include <ctype.h>
#include <dos.h>
#include <string.h>
#include "tools.h"

char	*cmdname = "pwd";

static	void	writetext(fd, s)
register int	fd;
register char	*s;
 /* [o͗pBLSI_C̏ꍇAŌȊO'\n'ƂCRLFɂȂȂ */
{
	register int	l = strlen(s);

#ifdef LSI_C
	if(l-- && s[l] == '\n'){
		write(fd, s, l);
		write(fd, "\r\n", 2);
	} else {
		write(fd, s, ++l);
	}
#else
	write(fd, s, l);
#endif
}

static	void	writechar(fd, c)
register int	fd;
register char	c;
{
	char	buf[2];

	*buf = c, buf[1] = '\0'; writetext(fd, buf);
}

static	void	usage()
{
	writetext(2, "Usage: "), writetext(2, cmdname);
	writetext(2, " [-dpls] [drive[:]]\n"), exit(1);
}

static	void	illdrv(drvarg)
char	*drvarg;
{
	writetext(2, cmdname), writetext(2, ": Illegal drive --- ");
	writetext(2, drvarg), writechar(2, '\n');
	exit(1);
}

main(ac, av)
int	ac;
char	*av[];
{
	register unsigned char	drvnm;
	register char	*drvarg, drv;
	char	p[PATHNAMELENGTH];
	int	c;

	bool	nopath = 0, nodrv = 0;
	extern	int	optind, opterr;
	extern	char	*optarg;
	int	longname_flg = 1;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg_tiny(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	opterr = 0;
	while(EOF != (c = getopt(ac, av, "dpls"))){
		cswitch(c){
		case 'd':
			nopath = 1; break;
		case 'p':
			nodrv = 1; break;
		case 'l':
			longname_flg = 2; break;
		case 's':
			longname_flg = 0; break;
		default:
			usage();
		}
	}
	if(nopath && nodrv){
		writetext(2, cmdname);
		writetext(2, ": equivocal options: -d and -p\n"), exit(1);
	}
	av += optind, ac -= optind;

	switch(ac){
	case 0:
		drvnm = 0;
		drv = (char)'a' + getcurdrv();
		break;
	case 1:
		drvarg = *av;
		drv = to_lower(*drvarg);
		if(!is_alpha((unsigned char)drv) ||
		   !(!drvarg[1] || drvarg[1] == ':' && !drvarg[2]))
			illdrv(drvarg);
		drvnm = drv - 'a' + 1;
		break;
	default:
		usage();
	}

	if(nopath){
		writechar(1, drv), writechar(1, '\n');
	} else {
		switch(get_wdir(drvnm, p, longname_flg)){
		case 0:
			if(!nodrv){
				writechar(1, drv), writechar(1, ':');
			}
			writechar(1, '/'), writetext(1, p), writechar(1, '\n');
			break;
		default:
			if(drvnm) illdrv(drvarg);

			 /* ͋Nʂ͂ */
			writetext(2, cmdname);
			writetext(2, ": Can't print cwd due to DOS bug.\n");
			exit(1);
		}
	}

	return 0; /* exit from main */
}
