/*
	Original by Yasushi Saito, TAIST.
	This program is NOT COPYRIGHTED, used, modified, re-distributed
		with no restriction,and no warranty.
*/

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <fcntl.h>
#include <ctype.h>
#ifndef UX_COMPILE_TEST
#  include <dos.h>
#  if defined(__WATCOMC__) || defined(MSC51)
#    include <direct.h>
#  endif
#endif
#include <string.h>
#include <stdarg.h>
#include <signal.h>
#include "tools.h"

#define YES_OR_NO_P yn_p_with_ret	/* y/nœƂ^[v */
/* #define YES_OR_NO_P yes_or_no_p */	/* y/nœƂ^[sv */

char	*cmdname = "rm";

static	int	error_code;
static	bool	opt_recursive, opt_verbose, opt_interactive, opt_force,
		opt_dcontent; /* initially all 0 */

#define FATALEXIT 2
#ifdef MSDOS
void	expand_hook()
{
	_expand_abendcode = FATALEXIT;
	expand_hook_default();
}
#endif

static	void	fputx(i, f)
int	i;
FILE	*f;
{
	if(i >> 4) fputx(i >> 4, f);
	i &= 0xf;
	putc(i + (i <= 10 ? '0' : 'a' - 10), f);
}

static	void	rm_error(s, reason)
char	*s, *reason;
{
	if(opt_force) return;
	fputss(stderr, cmdname, ": ", s_conv_to_unix_format(s), ": ",
		reason, ".\n", NULL);
	error_code = 1;
}

static	void	io_error(msg, s)
char	*msg, *s;
{
	fputss(stderr, cmdname, ": ", msg, s_conv_to_unix_format(s), ": ",
		strerror(errno), ".\n", NULL);
	if(opt_force) return;
	error_code = 1;
}

/*
 * Actually remove PATH. PATH is a normal file (not directory).
 */
static	void	remove_file(path)
char	*path;
{
	if(opt_interactive){
		fputss(stderr,
			"remove ", s_conv_to_unix_format(path), " ? ", NULL);
		if(!YES_OR_NO_P()) return;
	}

	if(nonshare_chk_unlink(path) < 0){
		unsigned attr;

		if(_dos_getfileattr(path, &attr)){
			rm_error(path, strerror(ENOENT));
			return;
		}
		if(attr & _A_SUBDIR){
			rm_error(path, "Is a directory");
			return;
		}
		if(errno == EACCES && !(attr & _A_RDONLY)){
		 /* RDONLYłȂ̂ɎscLᔽ̂ */
			goto error;
		}

		if(!opt_force){
			fputs("override protection 0x", stderr);
			fputx(attr, stderr);
			fputss(stderr, " for ",
				s_conv_to_unix_format(path), " ? ", NULL);
			if(!YES_OR_NO_P()) return;
		}
		_dos_setfileattr(path, attr & ~7);
		if(unlink(path) < 0){
			_dos_setfileattr(path, attr); /* nen no tame. Nide */
		error:
			io_error("Can't remove ", path);
			return;
		}
	}
	if(opt_verbose){
		fputss(stderr, s_conv_to_unix_format(path), "\n", NULL);
	}
}

/* used as a SIGINT handler in delete_all_using_FCB() ONLY */
static	char	*restore_cwd;
static	void	inthndl()
{
#if 0
	fputs("Inturrupt\n", stderr);
#endif
	chdir(restore_cwd), exit(1);
}

/* Remove all files under the directory s

   Same as performing "del s\*.*"(s is the parameter) from commandline.
   Returns immediately with files left untouched if failed to chdir to s
   (hence s need not be a directory, in which case this procedure performs
   nothing).

   Hidden files and readonly files may not be removed by this procedure,
   so this is used as preprocess for whole-directory remove. */
#ifndef UX_COMPILE_TEST
static	void	delete_all_using_FCB(s)
char	*s;
{
	unsigned char	fcbbuf[37];
	unsigned char	cwdbuf[PATHNAMELENGTH];	/* LFN̊i[ɏ\Ȓ */
	union	REGS	in, out;
	struct	SREGS	segreg;
	void	(*orighndl)();
	char	*p;

	/* Set the drive name */
	if(is_alpha(*s) && s[1] == ':'){
		fcbbuf[0] = tolower(*s) - 'a' + 1;
		cwdbuf[0] = *s;
		cwdbuf[1] = ':';
		cwdbuf[2] = '\\';
		p = cwdbuf + 3;
	} else {
		/* Current drive : fcbbuf[0]==0 */
		fcbbuf[0] = 0;
		cwdbuf[0] = '\\';
		p = cwdbuf + 1;
	}
	/*
	 * Save the current directory. CWDBUF holds the current directory (of
	 * the drive where S resides) after intdos call.
	 */
#ifdef SUPP_LFN
	if(_lfnsupp_level >= LFN_NONE)
		in.x.ax = 0x7147;
		 /* getpwďʂrmsɂȂ悤7147hg */
	else
#endif
		in.h.ah = 0x47;
	in.x.si = FP_OFF(p);
	segreg.ds = FP_SEG((char far *)p);
	in.h.dl = fcbbuf[0];
	intdosx(&in, &out, &segreg);
	if(out.x.cflag) return; /* add Nide, getcwdɎsbuggyDOSɑ΍*/

	/* S may not be a directory. Return immediately(with no errror) if
	   failed to chdir S. */
	restore_cwd = cwdbuf; /* cwdbufautozł悢 restore_cwdĝ
	  {֐sɊ荞܂ꂽꍇɌ̂ */
	if(SIG_IGN != (orighndl = signal(SIGINT, SIG_IGN)))
		signal(SIGINT, inthndl);
	if(!chdir(s)){
		/* delete all the files using BDOS call. */
		strcpy(&fcbbuf[1], "*       *  ");
		in.h.ah = 0x13;
		in.x.dx = FP_OFF(fcbbuf);
		segreg.ds = FP_SEG((char far *)fcbbuf);
		intdosx(&in, &out, &segreg);

		/* Restore the current directory. */
		chdir(cwdbuf);
	}
	signal(SIGINT, orighndl);
}
#else
#  define delete_all_using_FCB(s) 0
#endif

/*
 * Delete the file PATH. Delete recursively if PATH is a directory and
 * OPT_RECURSIVE option is TRUE.
 */
static	void	r_remove_file(path, noself)
char	*path;
bool	noself;
{
	if(!conv_to_dos_regpath(path)){	/* PATH does not end with \ */
		if(!opt_recursive){
			if(!noself) remove_file(path);
			return;
		}
	} else {
		if(!opt_recursive){
		 /* ݂̂Ƃ낱ɗꍇnoself0̂͂ł͂邪 */
			if(!noself) rm_error(path, "Directory not removed");
			return;
		}
	}

	/* Delete directory files. */
	{
		struct	Find_t	*f;
		char	*temp;

		 /* drecursivẽX^bNsh~̂autozɂȂ */
		f = chk_malloc(sizeof(struct Find_t) + PATHNAMELENGTH);
		temp = ((char *)f) + sizeof(struct Find_t);

		/* First, perform BDOS file remove for speedups. */
		if(!opt_interactive){
			if(opt_verbose){
				fputss(stderr, s_conv_to_unix_format(path),
								"/*\n", NULL);
			}
			delete_all_using_FCB(path);
		}
		/*
		 * Delete remaining files(hidden files, readonly files) by
		 * searching each files.
		 */
		expand_path(temp, path, ALLNAME);
		if(_dos_Findfirst(temp, 0x37, f)){
			int	tmpfd;

			expand_path(temp, path, NULNAME);
			if(!_dos_open(temp, O_RDONLY, &tmpfd)){
			 /* :maybe empty root */
				_dos_close(tmpfd);
				goto rm_dir_itself;
			}

			/* Unable to interpret PATH as a directory. Treat it
			   as a plain file, and remove it */
			if(!noself) remove_file(path);
			goto free_return;
		} else {
			char	*name;

			do {
			 /* If the first character of the filename is '.',
			    then the filename must be "." or ".." in MSDOS. */
				if(
#ifdef SUPP_LFN
				   name = f -> lname,
				   is_self_or_parent_dir(name)
#else
				   *(name = f -> name) == '.'
#endif
				) continue;

				expand_path(temp, path, name);
				(char)f -> attrib & _A_SUBDIR ?
					r_remove_file(temp, FALSE) :
					remove_file(temp);
			} while(!_dos_Findnext(f));
			_dos_Findclose(f);
		}
	rm_dir_itself:
		if(!noself){
			if(opt_interactive){
				fputss(stderr, "remove ",
				  s_conv_to_unix_format(path), "/ ? ", NULL);
				if(!YES_OR_NO_P()) goto free_return;
			}
			if(rmdir(path) < 0)
				io_error("Can't remove directory ", path);
			if(opt_verbose){
				fputss(stderr,
				  s_conv_to_unix_format(path), "/\n", NULL);
			}
		}
	free_return:
		free(f); /* then return */
	}
}

main(ac, av)
int	ac;
char	*av[];
{
	int	c, i;
	extern	int	optind, opterr;
	extern	char	*optarg;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif
	opterr = 0;

	while((c = getopt(ac, av, "rvifd")) != EOF){
		cswitch(c){
		case 'r':
			opt_recursive = TRUE;
			break;
		case 'v':
			opt_verbose = TRUE;
			break;
		case 'i':
			opt_interactive = TRUE;
			break;
		case 'f':
			opt_force = TRUE;
			break;
		case 'd':
			opt_dcontent = TRUE;
			break;
		default:	/* Add Nide */
			goto synerr;
		}
	}
	ac -= optind;
	av += optind;
	if(opt_dcontent) opt_recursive = TRUE;

	if(ac < 1){
	synerr:
		fputss(stderr,
		    "Usage: ", cmdname, " [-rfivd] file1 ... filen\n", NULL);
		exit(FATALEXIT);
	}
	for(i = 0; i < ac; i++){
		r_remove_file(av[i], opt_dcontent);
	}
	return error_code;
}
