#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <string.h>
#include <math.h> /* for atof() */
#ifdef MSDOS
#  include <dos.h>
#endif
#include "tools.h"
#define	LINMAX	(1024*4)
#define L_1ST	400
#define L_INC	200

#ifndef MSDOS
#  define iskanji(c) ((c) & 0x80)
#  define kstricmp strcasecmp
#  define kstrnicmp strncasecmp
#endif

char	*cmdname = "sort";

typedef	struct {
	unsigned int	numsort : 1;
	unsigned int	pblankign : 1;
	unsigned int	mblankign : 1;
	unsigned int	reverse : 1;
	unsigned int	foldcase : 1;
	 /* ȉ2globalp */
	unsigned int	usegopt : 1;
	unsigned int	donormcmp : 1;
} optstr;
typedef struct {
	unsigned int	beginf, beginc; /* -1𖳌刵邽unsigned */
	unsigned int	endf, endc;
	optstr	opt;
} parmstr;
static	parmstr	*sortparm; /* tB[hwƂւ̃IvVB
	  ŏ1global optionAfield optionւ̃Rs[ɂgp */
static	int	parmcnt = 1;
  /* tB[hw̌Bglobal option̂ōŒ1 */

static	char	**lines; /* es̃f[^ */
static	unsigned int	linecnt = 0, linealloc;
 /* ł邾I[o[t[hunsigned */

static	char	global_sep[2] = {'\0', '\0'};
 /* '\0'̓Xy[XB؂蕶̂2oCgΉB]'\0'Ŗ߂邱
    Ƃ','+','CSVΉ */
static	char	*otfnm = NULL;
static	bool	uniq_flg = 0;

static	char	linbuf[LINMAX], joinbuf[LINMAX];

static	struct {
	FILE	*f;
	char	*name;
	int	dirlen;
} sorttmpf[2];
static	int	tmpfsw = 0;

#define umin(x, y) ((x) < (y) ? (x) : (y))
 /* unsigned int min. LSI-Cmin()intƂĂ̔r */

static	void	rmstmp_exit(code)
int	code;
{
	int	i;

	for(i = 0; i < 2; i++){
		if(sorttmpf[i] . f != NULL){
#ifdef DEBUG3
			fprintf(stderr, "close&rm %s\n", sorttmpf[i] . name);
#endif
			fclose(sorttmpf[i] . f);
			unlink(sorttmpf[i] . name);
		}
	}
	exit(code);
}

static	void	userintr()
{
	fputss(stderr, cmdname, ": User interrupt\n", NULL);
	rmstmp_exit(1);
}

static	void	usage()
{
	fputss(stderr, "Usage: ", cmdname, " [-brnfu] [-t c] [-o outfile]\n",
		"\t    [+n1[.m1][brnf] [-n2[.m2][b]] ...] [files...]\n", NULL);
	rmstmp_exit(1);
}

static	void	nomem()
{
	_putnomemmes(), rmstmp_exit(1);
}

static	void	nodisk()
{
	fputss(stderr, cmdname, ": Output error (maybe disk full) \
while outputting or making temporal file\n", NULL);
	rmstmp_exit(1);
}

/*
static	void	memor(d, s, n)
char	*d, *s;
int	n;
{
	while(n--) *d++ |= *s++;
}
*/

static	void	addfieldparm(p)
char	*p;
{
	char	pm;

	if('+' == (pm = *p++)){
		if(NULL == (sortparm = (parmstr *)(realloc((char *)sortparm,
					 sizeof(parmstr) * (parmcnt + 1))))){
			nomem();
		}
		memcpy((char *)&(sortparm[parmcnt]),
		       (char *)&(sortparm[0]), sizeof(parmstr));
		 /* global optionbeginfEc, endfEc0 0 -1 0̂͂ */

		if(!is_digit(*p)) usage();
		sortparm[parmcnt] . beginf = atoi(p);
		 /* should be a-to-uint? */
		while(is_digit(*p)) p++;
		if(*p == '.'){
			p++; if(!is_digit(*p)) usage();
			sortparm[parmcnt] . beginc = atoi(p);
			while(is_digit(*p)) p++;
		} else sortparm[parmcnt] . beginc = 0;

		if(*p && sortparm[parmcnt] . opt . usegopt){
			memset((char *)&sortparm[parmcnt] . opt, 0,
			       sizeof(optstr));
		}
		for(; *p; p++){
			switch(*p){
			case 'b':
				sortparm[parmcnt] . opt . pblankign = 1; break;
			case 'f':
				sortparm[parmcnt] . opt . foldcase = 1; break;
			case 'n':
				sortparm[parmcnt] . opt . numsort = 1; break;
			case 'r':
				sortparm[parmcnt] . opt . reverse = 1; break;
			default:
				usage();
			}
		}
	} else {
		parmcnt--;

		if(!is_digit(*p)) usage();
		sortparm[parmcnt] . endf = atoi(p);
		while(is_digit(*p)) p++;
		if(*p == '.'){
			p++; if(!is_digit(*p)) usage();
			sortparm[parmcnt] . endc = atoi(p);
			while(is_digit(*p)) p++;
		} else sortparm[parmcnt] . endc = 0;

		if(*p && sortparm[parmcnt] . opt . usegopt){
			memset((char *)&sortparm[parmcnt] . opt, 0,
			       sizeof(optstr));
		}
		for(; *p; p++){
			switch(*p){
			case 'b':
				sortparm[parmcnt] . opt . mblankign = 1; break;
			 /* Ƃ+̎ƈꏏ */
			case 'f':
				sortparm[parmcnt] . opt . foldcase = 1; break;
			case 'n':
				sortparm[parmcnt] . opt . numsort = 1; break;
			case 'r':
				sortparm[parmcnt] . opt . reverse = 1; break;
			default:
				usage();
			}
		}
	}

	parmcnt++;
}

#define isdelim(c) ((c) == '\\' || (c) == '/')

static	void	makestmpbase()
 /* ȂȂĂꎞt@ĈÂ߂
    ̈炩ߎĂ */
{
	char	*tmpdir, *s_tmpdir = NULL;
#ifdef SUPP_LFN
	char	s_tmpd_buf[PATHNAMELENGTH];
#endif
	char	*p, yobi[5]/* "a:\\." */;
	int	i;
	FILE	*opntest;

	if(NULL == (tmpdir = getenv("TMP")) &&
	   NULL == (tmpdir = getenv("TEMP"))){
		tmpdir = ".";
	} else
	if(isdelim(*tmpdir) && !tmpdir[1] ||
	   is_alpha(*tmpdir) && tmpdir[1] == ':' &&
	     (!tmpdir[2] || isdelim(tmpdir[2]) && !tmpdir[3])){
	 /* "\\" "a:\\" "a:" ̏ꍇ */
		strcpy(yobi, tmpdir);
		strcat(tmpdir = yobi, ".");
	} else {
#if defined(SUPP_LFN) && !defined(UX_COMPILE_TEST)
		if(!abs_pathname(tmpdir, s_tmpd_buf, 1))
			tmpdir = s_tmpd_buf;
		else
#endif
			tmpdir = s_tmpdir = chk_strdup(tmpdir);
			 /* getenv()̕Ԃl̒ڏ邽 */
		for(p = tmpdir; *p; ){
			if(isdelim(*p) && !p[1]){
				*p = '\0';
				break;
			}
			if(iskanjipos(p)) p++;
			p++;
		}
	}
	p = malloc(strlen(tmpdir) + 5); /* "\\nul" */
	if(p == NULL) nomem();
	strcpy(p, tmpdir), strcat(p, "\\nul"), opntest = fopen(p, "r");
	if(opntest == NULL) tmpdir = "."; else fclose(opntest);
	free(p);

#ifdef DEBUG3
	fprintf(stderr, "gotdir %s\n", tmpdir);
#endif
	for(i = 0; i < 2; i++){
		sorttmpf[i] . dirlen = strlen(tmpdir);
		sorttmpf[i] . name = malloc(sorttmpf[i] . dirlen + 1+8+1+3+1);
		 /* 1+8+1+3+1 for "\\xxxxxxxx.xxx\0" */
		if(NULL == sorttmpf[i] . name) nomem();
		strcpy(sorttmpf[i] . name, tmpdir);
		sorttmpf[i] . f = NULL;
#ifdef DEBUG3
		fprintf(stderr, "dir %s\n", sorttmpf[i] . name);
#endif
	}
	if(s_tmpdir != NULL) free(s_tmpdir);
}

 /* macros to move pointer */
#define spcpass(p) {while(is_space(*p)) p++;}
#define nonspcpass(p) {while(!is_space(*p)){if(!*p) break; else p++;}}
#define fieldpass(p) fieldcharpass(&p)
#define ncharpass(p, n) {unsigned int _n; \
	for(_n = n; _n; _n--){if(!*p) break; p++;}}

static	void	fieldcharpass(pp)
char	**pp;
{
	char	*p;

	p = *pp;
	if(*global_sep){
		if(global_sep[1] == ','){ /* ','͊2oCgڂɂȂȂ */
			bool	dqflg = 0;

			for(;; iskanjipos(p) ? (p += 2) : p++){
				if(!*p){
					*pp = p; return;
				}
				if(*p == '"'){
					dqflg ^= 1;
					continue;
				}
				if(dqflg || *p != ',') continue;
				*pp = ++p; return;
			}
		} else {
			for(;; iskanjipos(p) ? (p += 2) : p++){
				if(!*p){
					*pp = p; return;
				}
				if(*p != *global_sep) continue;
				if(!global_sep[1]){
					*pp = ++p; return;
				} else {
					if(p[1] != global_sep[1]) continue;
					*pp = p + 2; return;
				}
			}
		}
	} else {
		spcpass(p); nonspcpass(p);
	}
	*pp = p;
}

static	compare(pp, qp)
char	**pp, **qp;
{
	char	*p, *pe, *q, *qe;
	int	i;
	unsigned int	minf, u;
	int	rsl = 0;

	 /* parmcnt1Ȃ0A1Ȃ1`parmcnt-1 */
	for(i = (parmcnt > 1); i < parmcnt; i++){
		p = *pp, q = *qp;

		minf = umin(sortparm[i] . beginf, sortparm[i] . endf);
		for(u = minf; u; u--){
			fieldpass(p); fieldpass(q);
		}
		pe = p, qe = q;
		 /* if endf is -1, pe and qe are not used */

		for(u = sortparm[i] . beginf - minf; u; u--){
			fieldpass(p); fieldpass(q);
		}
		if(sortparm[i] . opt . pblankign){
			spcpass(p); spcpass(q);
		}
		ncharpass(p, sortparm[i] . beginc);
		ncharpass(q, sortparm[i] . beginc);

		if(sortparm[i] . opt . numsort){ /* endf, endc are not used */
			static	double	a, b;

			a = atof(p); b = atof(q);
			 /* atof͏ɋ󔒂΂ */
			rsl = (a < b ? -1 : a > b ? 1 : 0);
#ifdef DEBUG
			fprintf(stderr, "cmp %f %f rsl=%d\n", a, b, rsl);
#endif
		} else if((unsigned int)-1 != (u = sortparm[i] . endf)){
#ifndef __WATCOMC__ /* ?? */
			unsigned
#endif
				 int	plen, qlen;

			for(u -= minf; u; u--){
				fieldpass(pe); fieldpass(qe);
			}
			if(sortparm[i] . opt . mblankign){
				spcpass(pe); spcpass(qe);
			}
			ncharpass(pe, sortparm[i] . endc);
			ncharpass(qe, sortparm[i] . endc);

			plen = pe - p; if(plen < 0) plen = 0;
			qlen = qe - q; if(qlen < 0) qlen = 0;
#ifndef MSC51
			rsl = (sortparm[i] . opt . foldcase ?
				kstrnicmp : strncmp)(p, q, umin(plen, qlen));
#else /* MSC51͌^錾const̗LłԂԂď̏łȂ*/
			if(sortparm[i] . opt . foldcase){
				rsl = kstrnicmp(p, q, umin(plen, qlen));
			} else {
				rsl = strncmp((const char *)p, (const char *)q,
							    umin(plen, qlen));
			}
#endif
			if(rsl == 0) rsl = plen - qlen;
#ifdef DEBUG
			fprintf(stderr, "cmp '%.*s' '%.*s' rsl=%d\n",
				plen, p, qlen, q, rsl);
#endif
		} else {
#ifndef MSC51
			rsl = (sortparm[i] . opt . foldcase ?
						    kstricmp : strcmp)(p, q);
#else /* ƓRB */
			if(sortparm[i] . opt . foldcase){
				rsl = kstricmp(p, q);
			} else {
				rsl = strcmp((const char *)p, (const char *)q);
			}
#endif
#ifdef DEBUG
			fprintf(stderr, "cmp '%s' '%s' rsl=%d\n",
				p, q, rsl);
#endif
		}

		if(rsl){
			return sortparm[i] . opt . reverse ? -rsl : rsl;
		}
	}

	 /* tȂ΍sŜ𕁒ʂɔr */
	if(sortparm -> opt . donormcmp){
		rsl = strcmp(*pp, *qp);
#ifdef DEBUG
		fprintf(stderr, "cmp '%s' '%s' rsl=%d\n", *pp, *qp, rsl);
#endif
		return sortparm -> opt . reverse ? -rsl : rsl;
	}
	return 0;
}

static	void	do_sort()
{
	qsort((char *)lines, linecnt, sizeof(char *), compare);
}

static	void	join_output(otf, midf)
 /* lines[]midfotfցBuniq̏ꍇmidfɂ͏dsȂ̂Ƃ */
FILE	*otf, *midf;
{
	unsigned int	i = 0;
	char	*jbufp;
	int	comp_out;

	jbufp = joinbuf;
	if(midf != NULL) while(NULL != fgets(jbufp, LINMAX, midf)){
		jbufp[strlen(jbufp) - 1] = '\0';
		for(; i < linecnt &&
		      (comp_out = compare(&lines[i], &jbufp)) < 0; i++){
			if(uniq_flg && i &&
			   !(compare(&lines[i - 1], &lines[i]))) continue;
			fputs(lines[i], otf), putc('\n', otf);
		}
		if(uniq_flg && !comp_out) continue;
		fputs(jbufp, otf);
		if(EOF == putc('\n', otf)) nodisk();
	}
	for(; i < linecnt; i++){
		if(uniq_flg && i && !(compare(&lines[i - 1], &lines[i])))
			continue;
		fputs(lines[i], otf), putc('\n', otf);
	}
	if(fflush(otf) == EOF || ferror(otf)) nodisk();
}

#ifdef MSDOS
static	FILE	*dtmpfile(dir) /* dir */
char	*dir;
{
	union	REGS	in, out;
	struct	SREGS	segreg;

	in . h . ah = 0x5a;
	in . x . cx = 0;
	in . x . dx = FP_OFF(dir);
	segreg . ds = FP_SEG((char far *)dir);
	intdosx(&in, &out, &segreg);
#if 0 /* ǂĂł͂܂Ȃ񂾂낤 */
	return out . x . cflag ? NULL : fdopen(out . x . ax, "w+b");
#else
	return out . x . cflag ? NULL :
	       (_dos_close(out . x . ax), fopen(dir, "w+b"));
#endif
}

static	void	midproc() /* ȂȂ̂Œԏ */
{
	unsigned int	i;
	int	(*thndl)();

#ifdef DEBUG2
	fprintf(stderr, "midproc() invoked\n");
#endif
	do_sort();

	thndl = (int (*)())signal(SIGINT, SIG_IGN);
	if(NULL == (sorttmpf[tmpfsw] . f = dtmpfile(sorttmpf[tmpfsw] . name))){
		fputss(stderr, cmdname, ": Can't open tmpfile\n", NULL);
		rmstmp_exit(1);
	}
#ifdef DEBUG3
	fprintf(stderr, "creat %s\n", sorttmpf[tmpfsw] . name);
#endif
	signal(SIGINT, (void (*)())thndl);

	join_output(sorttmpf[tmpfsw] . f, sorttmpf[!tmpfsw] . f);

	thndl = (int (*)())signal(SIGINT, SIG_IGN);
	rewind(sorttmpf[tmpfsw] . f);
#ifdef DEBUG3
	fprintf(stderr, "reopen %s\n", sorttmpf[tmpfsw] . name);
#endif
	tmpfsw ^= 1;
	if(sorttmpf[tmpfsw] . f != NULL){
		fclose(sorttmpf[tmpfsw] . f);
		sorttmpf[tmpfsw] . f = NULL;
		unlink(sorttmpf[tmpfsw] . name);
#ifdef DEBUG3
		fprintf(stderr, "close&rm %s\n", sorttmpf[tmpfsw] . name);
#endif
		sorttmpf[tmpfsw] . name[sorttmpf[tmpfsw] . dirlen] = '\0';
#ifdef DEBUG3
		fprintf(stderr, "dir reset %s\n", sorttmpf[tmpfsw] . name);
#endif
	}
	signal(SIGINT, (void (*)())thndl);

	for(i = 0; i < linecnt; i++) free(lines[i]);
	free(lines);
	if(NULL == (lines = (char **)malloc(
		(linealloc = L_1ST) * sizeof(char *)))) nomem();
	linecnt = 0;
#ifdef DEBUG2
	fprintf(stderr, "midproc() finished\n");
#endif
}
#else
static	void	midproc()
{
	nomem();
}
#endif

 /* 1s̓eۑBIɂ̓tB[ḧʒu킹ĕۑ */
static	void	linereg(s)
char	*s;
{
	char	**tmplines;

	if(linecnt >= linealloc){
		linealloc += L_INC;
		if(linealloc * sizeof(char *) / sizeof(char *) != linealloc ||
		    /* reallocƎsɌ̓eۏ؂Ȃ */
		   NULL == (tmplines = (char **)malloc(
						linealloc * sizeof(char *)))){
			midproc();
		} else {
			memcpy((char *)tmplines, (char *)lines,
			       linecnt * sizeof(char *));
			free((char *)lines);
			lines = tmplines;
		}
#ifdef DEBUG2
		fprintf(stderr, "linealloc incremented to %d\n", linealloc);
#endif
	}

	if(NULL == (lines[linecnt] = strdup(s))){
		midproc(); /* linecnt0ɂȂ */
		if(NULL == (lines[0] = strdup(s))) nomem();
	}
	linecnt++;
}

static	void	readfile(fnm)
char	*fnm;
{
	int	len;
	FILE	*inf;

	if(fnm == NULL){
		inf = stdin, fnm = "(stdin)";
	} else {
		conv_to_unix_format(fnm);
		if(NULL == (inf = fopen(fnm, "r"))){
			fputss(stderr,
				cmdname, ": ", fnm, ": Can't open\n", NULL);
			rmstmp_exit(1);
		}
	}

	while(NULL != fgets(linbuf, LINMAX, inf)){
		if(!*linbuf){ /* nothing */
		} else
		if(linbuf[(len = strlen(linbuf)) - 1] != '\n'){
			fputss(stderr, cmdname, ": ", fnm, NULL);
			if(len == LINMAX - 1){
				fputs(": line too long\n", stderr);
				rmstmp_exit(1);
			} else {
				fputs(": missing line-feed character \
added at the end of file\n", stderr);
			}
		} else {
			linbuf[len - 1] = '\0';
		}
		linereg(linbuf);
	}
	if(inf != stdin) fclose(inf); else clearerr(inf);
}

main(ac, av)
int	ac;
char	*av[];
{
	char	*p;
	bool	optend = 0;
	FILE	*otf;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	makestmpbase(); /* signalݒSrmstmp_exitOɂ邱 */
	if(SIG_IGN != signal(SIGINT, SIG_IGN)) signal(SIGINT, userintr);

	if(NULL == (sortparm = (parmstr *)malloc(sizeof(parmstr)))) nomem();
	memset(sortparm, 0, sizeof(parmstr));
	sortparm -> beginf = sortparm -> beginc =
	sortparm -> endc = 0; sortparm -> endf = (unsigned int)-1;
	sortparm -> opt . usegopt = 1;

	while(++av, --ac){
		p = *av;
		switch(*p){
		case '+':
			addfieldparm(p);
			if(ac == 1 || av[1][0] != '-' || !is_digit(av[1][1]))
				break;
			++av, --ac, addfieldparm(*av);
			break;
		case '-':
			if(!p[1]){optend++; break;}
			while(*++p){
				switch(*p){
				case 't':
					if(!*++p){
						if(++av, !--ac) usage();
						p = *av;
						if(!*p) usage();
					}
					if(!kstricmp(p, "csv")){
						global_sep[0] =
						global_sep[1] = ',';
						p += 2; /* len of "csv" - 1 */
					} else {
						global_sep[0] = *p;
						if(iskanji(*p))
							global_sep[1] = *++p;
						 else
							global_sep[1] = '\0';
						if(p[1]) usage();
					}
					break;
				case 'o':
					if(!*++p){
						if(++av, !--ac) usage();
						p = *av;
					}
					otfnm = p;
					p = "?";
					break;
				case 'f':
					sortparm -> opt . donormcmp =
					sortparm -> opt . foldcase = 1; break;
				case 'n':
					sortparm -> opt . donormcmp =
					sortparm -> opt . numsort = 1; break;
				case 'b':
					sortparm -> opt . donormcmp =
					sortparm -> opt . pblankign =
					sortparm -> opt . mblankign = 1; break;
				case 'r':
					sortparm -> opt . reverse = 1; break;
				case 'u':
					uniq_flg = 1; break;
				default:
					usage();
				}
			}
			break;
		default:
			optend++; break;
		}
		if(optend) break;
	}
	if(parmcnt > 1) sortparm -> opt . donormcmp = 1;
	 /* field option1łΌōsŜ̒ʏr
	    (̏ꍇglobal optionKpĂ̍sŜ̔r͂Ȃ)
	    field optionȂĂ-b-n̏ꍇ͍sŜ̒ʏr
	    -ȑꍇȂǂ͉߂čsŜ̒ʏrKvȂ */
	if(uniq_flg) sortparm -> opt . donormcmp = 0;

	if(NULL == (lines = (char **)malloc(
		(linealloc = L_1ST) * sizeof(char *)))) nomem();

#ifdef DEBUG2
	fprintf(stderr, "reading\n");
#endif
	if(!ac){
		readfile(NULL);
	} else for(; ac; --ac, ++av){
		if(**av == '-' && !av[0][1]){
			readfile(NULL);
		} else {
			readfile(*av);
		}
	}

#ifdef DEBUG2
	fprintf(stderr, "sorting\n");
#endif
	do_sort();

#ifdef DEBUG2
	fprintf(stderr, "outputting\n");
#endif
	if(NULL != otfnm){
		conv_to_unix_format(otfnm);
		if(NULL == (otf = fopen(otfnm, "w"))){
			fputss(stderr, cmdname, ": ",
				otfnm, ": Can't open output\n", NULL);
			rmstmp_exit(1);
		}
	} else otf = stdout;
	join_output(otf, sorttmpf[!tmpfsw] . f);
	rmstmp_exit(0);
	 /* NOTREACHED */
#ifndef LSI_C
	return 0;
#endif
}

/*  future plan:
  tB[hTʂ悤r܂ւ
  tmpfile()֌Wōւ(̏ꍇintr܂̐b)
  save֌Wւ邩
*/
