#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <fcntl.h>
#include <string.h>
#include <errno.h>
#ifdef MSDOS
#  include <dos.h>
#else
#  include <sys/stat.h>
#endif
#include "tools.h"

#ifdef MSDOS
#  define CON "con"
#else
#  define CON "/dev/tty"
#endif

char	*cmdname = "split";

#ifndef MSDOS
void	nomem_exit()
{
	_putnomemmes(), exit(1);
}

void	*chk_realloc(p, i)
void	*p;
unsigned int	i;
{
	if(NULL == (p = re_alloc(p, i))) nomem_exit();
	return p;
}
#endif

 /*---- public domaingetopt()g ----------------------------*/
static	int	opterr = 1, optind = 1, optopt;
static	char	*optarg;

static	void	err_getopt(cmd, as)
char	*cmd, *as;
{
	static	char	msgtail[ ] = {0, 0};

	if(opterr){
		_puterrmes(cmd), _puterrmes(as),
		*msgtail = (char)optopt, _puterrmes_cr(msgtail);
	}
}

 /* toolslib.lɂ̂̂ɊgA"-"IvV */
static	int	egetopt(ac, av, opts)
int	ac;
char	**av, *opts;
{
	static	char	*curopt = NULL;
	register char	*cp;

	if(curopt == NULL || !*curopt){
		if(optind >= ac || *(curopt = av[optind]) != '-' || !*++curopt)
			return EOF;
		if(*curopt == '-' && !curopt[1])
			return (++optind, EOF);
	}
	if(':' == (optopt = *curopt++) || ';' == optopt ||
	   NULL == (cp = strchr(opts, optopt))){
		if(is_digit(optopt)){
		 /* "-" ̏ꍇ ɕʃIvVꍇ */
			optarg = curopt - 1;
			 /* ̔񐔎܂߂optargɓ̂Œ */
			while(is_digit(*curopt)) ++curopt;
			if(!*curopt) ++optind;
			return optopt = '0'; /* Ԃl'0' */
		}

		err_getopt(*av, ": unknown option, -");
		if(!*curopt) ++optind;
		return '?';
	}
	if(*++cp == ':' || *cp == ';' && *curopt){
		++optind;
		if(*curopt){
			optarg = curopt;
			curopt = NULL;
		} else {
			if(optind >= ac){
				err_getopt(*av, ": argument missing for -");
				return '?';
			} else {
				optarg = av[optind++];
			}
			 /* now *curopt == '\0' */
		}
	} else {
		optarg = NULL;
		if(!*curopt) ++optind;
	}
	return optopt;
}
 /*---- public domaingetopt()g ܂ -------------------*/

static	void	help_exit()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
	_puterrmes_cr(
		" [-[l]lines] [-{b|C}[0][x]n[bkm]] [-fivt] [file [basename]]");
	exit(1);
}

static	void	invalid_exit()
{
	_cmdputerrmes_cr("Invalid number of lines or bytes"), exit(1);
}

#define OPT_FORCE	01
#define OPT_BCHARS	02
#define OPT_CLINES	04
#define OPT_VISUAL	010
#define OPT_MANUAL	020
#define OPT_TXTMOD	040

static	long	chkxknon0lnum(s)
char	*s;
{
	long	l = 0L;

	switch(to_lower(*s)){
	case '0':
		if(++s, to_lower(*s) == 'x') goto hex;
		for(; is_octal(*s); s++){
			l <<= 3; l += ctoi(*s);
		}
		break;
	case 'x':
	hex:
		for(s++; is_xdigit(*s); s++){
			l <<= 4; l += ctoi(*s);
		}
		break;
	default:
		for(; is_digit(*s); s++){
			l *= 10; l += ctoi(*s);
		}
	}

	switch(to_lower(*s)){
	case 'k':
		l <<= 10; break;
	case 'b':
		l <<= 9; break;
	case 'm':
		l <<= 20; break;
	case 0:
		break;
	default:
		l = 0L; break;
	}
	return l;
}

#ifdef MSDOS
static	fexist(s)
char	*s;
{
	struct	Find_t	dmy;

	return !find_Fixedfile(s, &dmy, 0);
}
#else
static	fexist(s)
char	*s;
{
	struct	stat	sbuf;

	return(stat(s, &sbuf) == 0);
}
#endif

static	void	cantopen(s)
char	*s;
{
	conv_to_unix_format(s);
	_cmdputerrmes(s), _puterrmes_cr(": Can't open"), exit(1);
}

static	void	writefail()
{
	_cmdputerrmes_cr("Write failed (disk full?)"), exit(1);
}

#define imax(x, y) ((x) > (y) ? (x) : (y))
#define imin(x, y) ((x) < (y) ? (x) : (y))

static	void	nextext(ext)
char	*ext;
{
#ifdef MSDOS
	int	i = 3;
#else
	int	i = 2;
#endif

	while(i--){
		if(++ext[i] <= 'z') return;
		ext[i] = 'a';
	}
	_cmdputerrmes_cr("Too many output files"), exit(1);
}

#ifndef MSDOS
 /*---- toolslib.l̂ƓBPƂŃRpCł悤ɂ邽 --------- */
char	*getline(s, f)
char	*s;
FILE	*f;
 /* srealloc(NULLȂmalloc)A1sǂݍŕԂ
    ǂݐssfreeNULLBȊȌꍇK1ȏ̕񂪕Ԃ
    Ō̍słsɉsȂꍇfeof(f)藧ԂŕԂ */
{
	int	lsize, i = 0, c;

	s = chk_realloc(s, lsize = 160);
	while(EOF != (c = getc(f))){
		s[i++] = (char)c;
		if(lsize <= i) s = chk_realloc(s, lsize += 80);
		if('\n' == c) break;
	}
	if(!i){
		free(s);
		return NULL;
	} else {
		s[i++] = '\0';
		return chk_realloc(s, i);
	}
}
 /*---- ܂ toolslib.l̂Ɠ -------------------------------------- */
#endif

static	FILE	*prepare_nextfile(flag, base, ext, inf)
int	flag;
char	*base, *ext;
FILE	*inf; /* stdinǂׂ邾 */
{
	FILE	*otf;

	if(flag & OPT_MANUAL){
		static	FILE	*con = NULL;

		if(con == NULL){
			con = (FILE *)NULSTR;
		} else {
			if(con == (FILE *)NULSTR){
				if(inf != stdin) con = stdin;
				else {
					char	*p = CON;
					if(NULL == (con = fopen(p, "r")))
						cantopen(p);
				}
			}

			_puterrmes("Push return if ready ");
			for(;;){
				switch(getc(con)){
				case EOF:
					clearerr(con); /* through */
				case '\n':
					break;
				default:
					continue;
				}
				break;
			}
		}
	}

	if(!(flag & OPT_FORCE) && fexist(base)){
		conv_to_unix_format(base);
		_cmdputerrmes(base), _puterrmes_cr(": exist"), exit(1);
	}
	if(NULL == (otf = fopen(base, "w"))) cantopen(base);
	if(flag & OPT_VISUAL){
		_puterrmes(s_conv_to_unix_format(base)), _puterrmes_cr(":");
	}

	nextext(ext);
	return otf;
}

static	void	do_split(flag, linemax, bytemax, inf, base)
int	flag, linemax;
long	bytemax;
FILE	*inf;
char	*base;
{
	register FILE	*otf = NULL;
	char	*ext, *readbuf;
	int	lines = 0, rdbyte;
	long	bytes = 0L;

	ext = base + strlen(base);
#ifdef MSDOS
	strcpy(ext++, ".aaa");
#else
	strcpy(ext, "aa");
#endif

	if(flag & OPT_BCHARS){
#define RBUFSIZ imax(BUFSIZ, 8192)
		fsetbin(inf);
		readbuf = chk_malloc(RBUFSIZ);

		for(;;){
			rdbyte = (int)imin(bytemax - bytes, (long)RBUFSIZ);
			 /* RBUFSIZintlongɂȂ邱Ƃ͂Ȃ */
			rdbyte = fread(readbuf, 1, rdbyte, inf);
			if(!rdbyte) break;

			if(NULL == otf){
				otf = prepare_nextfile(flag, base, ext, inf);
				fsetbin(otf);
			}

			if(rdbyte > fwrite(readbuf, 1, rdbyte, otf))
				writefail();
			if(bytemax > (bytes += rdbyte)) continue;

			bytes = 0;
			if(fclose(otf) == EOF) writefail();
			otf = NULL;
		}
		free(readbuf); /* ꉞ */
	} else
	if(flag & OPT_CLINES){
		char	*outpos;
		int	needcr;

		readbuf = NULL;

		while(NULL != (outpos = readbuf = getline(readbuf, inf))){
			rdbyte = strlen(readbuf);
			needcr = (!(flag & OPT_TXTMOD) &&
				    *readbuf && readbuf[rdbyte - 1] == '\n');

			for(;;){
				if(NULL == otf)	otf = prepare_nextfile(flag,
							       base, ext, inf);

				if(bytes + rdbyte + needcr <= bytemax){
					if(EOF == fputs(outpos, otf))
						writefail();
					bytes += rdbyte + needcr;
				} else {
					if(!bytes){ /* bytemaxintɎ܂ */
						int	n = (int)bytemax;

						if(n ==	rdbyte) --n;
						if(fwrite(outpos, 1, n, otf)
							< n) writefail();
						rdbyte -= n;
						outpos += n;
					}

					bytes = 0;
					if(fclose(otf) == EOF) writefail();
					otf = NULL;
					continue; /* getlineɂ蒼 */
				}
				break;
			}
		} /* readbufgetline()̍Ō̌Ăяofree */
	} else {
		readbuf = chk_malloc(BUFSIZ);

		while(NULL != fgets(readbuf, BUFSIZ, inf)){
			if(otf == NULL)
				otf = prepare_nextfile(flag, base, ext, inf);

			if(EOF == fputs(readbuf, otf)) writefail();
			if(!*readbuf || readbuf[strlen(readbuf) - 1] != '\n' ||
			   ++lines < linemax) continue;

			lines = 0;
			if(fclose(otf) == EOF) writefail();
			otf = NULL;
		}
		free(readbuf); /* ꉞ */
	}
}

main(ac, av)
int	ac;
char	**av;
{
	int	c;
#ifdef MSDOS
	int	flag = 0;
#else
	int	flag = OPT_TXTMOD;
#endif
	int	linemax = 1000;
	long	bytemax = 0L;
	FILE	*inf;
#ifdef MSDOS
#  define EXT_LEN 5 /* ".aaa" + '\0' */
#else
#  define EXT_LEN 3 /* "aa" + '\0' */
#endif
	char	*base, *base_origin = "x";

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	opterr = 0;
	while(EOF != (c = egetopt(ac, av, "l:b:C:fivt"))){
		cswitch(c){
		case '0': /* numeral opt */
		case 'l':
			flag &= ~(OPT_BCHARS | OPT_CLINES);
			if(0 >= (linemax = atoi(optarg))) invalid_exit();
			break;
		case 'b':
		case 'C':
			flag &= ~(OPT_BCHARS | OPT_CLINES);
			flag |= (c == 'b' ? OPT_BCHARS : OPT_CLINES);
			if(0 >= (bytemax = chkxknon0lnum(optarg)))
				invalid_exit();
			break;
		case 'f':
			flag ^= OPT_FORCE; break;
		case 'i':
			flag ^= OPT_MANUAL; break;
		case 'v':
			flag ^= OPT_VISUAL; break;
		case 't':
			flag ^= OPT_TXTMOD; break;
		default:
			help_exit();
		}
	}
	av += optind, ac -= optind;
		
	switch(ac){
	case 0:
		inf = stdin; break;
	case 2:
		base_origin = av[1];
		/* through */
	case 1:
		if(av[0][0] == '-' && !av[0][1]){
			inf = stdin;
		} else {
			if(NULL == (inf = fopen(*av, "r"))) cantopen(*av);
		}
		break;
	default:
		help_exit();
	}

	strcpy(base = chk_malloc(strlen(base_origin) + EXT_LEN), base_origin);
	do_split(flag, linemax, bytemax, inf, base);
	return 0;
}
