#include <stdio.h>
#include <ctype.h>
#include <math.h> /* for atol() */
#include <string.h>
#ifdef MSDOS
#  include <dos.h> /* for farmalloc */
#else
#  define far
#  define farmalloc malloc
#  define farrealloc realloc
#  define farfree free
#endif
#include "tools.h"

#ifndef BLOCK_SIZE
#  define BLOCK_SIZE 512
#endif

char	*cmdname = "tail";

static	us_long	num = (us_long)-1; /* -1͖m */
static	bool	nohdr, fromtop, reverse, unitisbyte, countblock; /* l0 */

#ifdef MSDOS
#  define isCTLZ(c) ((c) == ('Z' & 0x1f)) /* 01 */
#  define putcr() fputs("\r\n", stdout)
#else
#  define isCTLZ(c) 0
#  define putcr() putchar('\n')
#endif

#define Readsize(l)/* us_long l; */((l) < (us_long)BUFSIZ ? (int)(l) : BUFSIZ)
#define rReadsize(l)/* us_long l; l0ł͂Ȃ */(((l) - 1) % BUFSIZ + 1)

#ifndef MSDOS
void	nomem_exit()
{
	fputs("Memory Exhausted\n", stderr), exit(1);
}

void	*chk_realloc(p, i)
void	*p;
unsigned int	i;
{
	if(NULL == (p = re_alloc(p, i))) nomem_exit();
	return p;
}
#endif

#ifndef MSDOS
 /*---- toolslib.l̂ƓBPƂŃRpCł悤ɂ邽 --------- */
char	*getline(s, f)
char	*s;
FILE	*f;
 /* srealloc(NULLȂmalloc)A1sǂݍŕԂ
    ǂݐssfreeNULLBȊȌꍇK1ȏ̕񂪕Ԃ
    Ō̍słsɉsȂꍇfeof(f)藧ԂŕԂ */
{
	int	lsize, i = 0, c;

	s = chk_realloc(s, lsize = 160);
	while(EOF != (c = getc(f))){
		s[i++] = (char)c;
		if(lsize <= i) s = chk_realloc(s, lsize += 80);
		if('\n' == c) break;
	}
	if(!i){
		free(s);
		return NULL;
	} else {
		s[i++] = '\0';
		return chk_realloc(s, i);
	}
}
 /*---- ܂ toolslib.l̂Ɠ -------------------------------------- */
#endif

static	void	usage()
{
	fputs("Usage: ", stderr), fputs(cmdname, stderr),
	fputs(" [{-,+}[#][blcrh]] [file...]\n", stderr);
	exit(1);
}

static	void	cmd_errmsg(s)
char	*s;
{
	fputs(cmdname, stderr), fputs(": ", stderr), fputs(s, stderr);
}

static	void	nowrite(f) /* f[ȂG[ƂȂ */
FILE	*f;
{
	if(!isatty(fileno(f))) (cmd_errmsg("Write error\n"), exit(1));
}

static	void	fseek_chk(f, l, n)
FILE	*f;
long	l;
int	n;
{
	if(0 != fseek(f, l, n))
		(cmd_errmsg("? Can't seek (maybe BUG)\n"), exit(1));
}

static	void	hdrout(s)
char	*s;
{
	if(!nohdr){
		fputs("<<<", stdout), fputs(s, stdout),
		fputs(">>>", stdout), putcr();
	}
}

static	void	output_rest(f)
FILE	*f; /* f݈̌ʒuȉo */
{
	int	readbytes;
	char	buf[BUFSIZ];

	while(0 < (readbytes = fread(buf, 1, BUFSIZ, f))){
		fwrite(buf, 1, readbytes, stdout);
	}
}

static	void	output_nbytes(f, n)
FILE	*f;
long	n; /* f݈̌ʒuȉnoCgóBrŐs͂ȂƑO */
{
	int	readbytes;
	char	buf[BUFSIZ];

	while(n){
		readbytes = Readsize(n);
		fread(buf, 1, readbytes, f);
		fwrite(buf, 1, readbytes, stdout);
		n -= readbytes;
	}
}

static	void	tail_l_fromtop(f)
FILE	*f;
{
	int	c;
	us_long	i;

	if(0L < (i = num)) i--;
	for(; i; --i){
		for(;;){
			if(EOF == (c = getc(f))) return;
			if(c == '\n') break;
		}
	}
	output_rest(f);
}

static	void	seq_tail_b_fromtop(f)
FILE	*f;
{
	us_long	i;
	int	readbytes; /* <= BUFSIZ */
	char	buf[BUFSIZ];

	if(0L < (i = num)) i -= (countblock ? BLOCK_SIZE : 1);
	while(i){
		readbytes = Readsize(i);
		if(0 >= (readbytes = fread(buf, 1, readbytes, f))) return;
		i -= readbytes;
	}
	output_rest(f);
}

static	void	tail_b_fromtop(f)
FILE	*f;
{
	us_long	i;
	long	filesize;

	if(0L < (i = num)) i -= (countblock ? BLOCK_SIZE : 1);
	fseek_chk(f, 0L, 2), filesize = ftell(f);
	if(filesize <= i) return;
	fseek_chk(f, i, 0), output_rest(f);
}

static	void	tail_b_fromtail(f)
FILE	*f;
{
	long	filesize;

	fseek_chk(f, 0L, 2), filesize = ftell(f);
	fseek_chk(f, -(filesize < num ? filesize : num), 1);
	output_rest(f);
}

static	void	tail_l_fromtail(f)
FILE	*f;
{
	us_long	l = num;
	long	curpos;
	int	k, n;
	char	buf[BUFSIZ], *p;

	fseek_chk(f, 0L, 2);
	while(l){
		if(!(curpos = ftell(f))) break;
		k = (int)rReadsize(curpos); /* intɎ܂ */
		fseek_chk(f, (long)-k, 1);
		fread(buf, 1, k, f);
		fseek_chk(f, curpos - k, 0);
		for(p = buf + (n = k); n; n--){
			if(*--p != '\n') continue;
			if(l) --l; else {
				fwrite(++p, 1, k - n, stdout);
				fseek_chk(f, (long)k, 1);
				break;
			}
		}
	}
	output_rest(f);
}

static	void	tail_r_fromtop(f)
FILE	*f; /* UNIXɂȂ */
{
	us_long	i;
	int	c;
	us_int	lsize, lines;
	long	far	*positions;

	if(0L < (i = num)) i--;
	for(; i; --i){
		for(;;){
			if(EOF == (c = getc(f))) return;
			if(c == '\n') break;
		}
	}
	if(NULL == (positions =
			(long far *)farmalloc(sizeof(long) * (lsize = 200))))
		nomem_exit();
	lines = 0, positions[lines++] = ftell(f);
	for(;;){
		if('\n' == (c = getc(f)) || c == EOF || isCTLZ(c)){
			if(lines >= lsize){
				lsize += 100;
				if(NULL == (positions = (long far *)farrealloc
				    (positions, sizeof(long)* (us_long)lsize)))
					nomem_exit();
			}
			if(c == '\n'){
				positions[lines++] = ftell(f);
			} else {
				positions[lines++] = ftell(f) - isCTLZ(c);
				break;
			}
		}
	} /* lines͕K2ȏ */

	for(lsize = --lines; lines--; ){
		fseek_chk(f, positions[lines], 0);
		output_nbytes(f, positions[lines + 1] - positions[lines]);
		if(lines == lsize - 1 &&
		   positions[lines + 1] > positions[lines]) putcr();
	}
	farfree(positions);
}

static	void	seq_tail_b_fromtail(f)
FILE	*f;
{
	char	*fullbuf;
	int	c;
	bool	roundflg = 0;
	us_int	i_num, i = 0;

	i_num = (us_int)num; /* num͏\ƑO񂷂邱Ƃɂ */
	fullbuf = chk_malloc(i_num);
	while(EOF != (c = getc(f))){
		fullbuf[i++] = (char)c;
		if(i == i_num) (roundflg = 1, i = 0);
	}
	if(roundflg) fwrite(fullbuf + i, 1, i_num - i, stdout);
	fwrite(fullbuf, 1, i, stdout);
	free(fullbuf);
}

static	void	seq_tail_l_fromtail(f)
FILE	*f;
{
	char	**lines, *p;
	us_int	i_num, i = 0, j;

	 /* num͏\ƑO񂷂邱Ƃɂ */
	if(0 == (i_num = (us_int)num)) return;
	lines = chk_malloc(sizeof(char *) * i_num);
	for(i = i_num; i; ) lines[--i] = NULL; /* here i == 0 */
	while(NULL != (p = getline(NULL, f)) && p[strlen(p) - 1] == '\n'){
		if(lines[i] != NULL) free(lines[i]);
		lines[i++] = p;	if(i == i_num) i = 0;
	}
	if(lines[i] != NULL) for(j = i; j < i_num; j++){
		fputs(lines[j], stdout), free(lines[j]);
	}
	for(j = 0; j < i; j++){
		fputs(lines[j], stdout), free(lines[j]);
	}
	if(p != NULL){
		fputs(p, stdout), free(p);
	}
	free(lines);
}

static	void	tail_r_fromtail(f)
FILE	*f;
{
	us_long	l = num;
	long	curpos, lastpos;
	int	k, n;
	char	buf[BUFSIZ], *p;
	char	lastnoLF = 0;

	fseek_chk(f, 0L, 2);
	if((lastpos = ftell(f)) > 0){ /* ŌCTLZ̐b */
		int	c;

		fseek_chk(f, -1L, 2), c = getc(f);
		if(isCTLZ(c)) (fseek_chk(f, -1L, 2), --lastpos);
	}
	if(lastpos > 0){ /* Ōオs */
		fseek_chk(f, -1L, 2);
		if(getc(f) != '\n') lastnoLF++; else l++;
	}
	for(curpos = lastpos, n = 0; l; --n){
		if(!n){
			if(!curpos){
				output_nbytes(f, lastpos);
				return;
			}
			k = (int)rReadsize(curpos);
			curpos -= k;
			fseek_chk(f, curpos, 0);
			fread(buf, 1, k, f);
			fseek_chk(f, curpos, 0);
			p = buf + (n = k);
		}
		if(*--p != '\n') continue;
		if(curpos + k < lastpos){
			fwrite(p + 1, 1, k - n, stdout);
			fseek_chk(f, curpos + k, 0);
			output_nbytes(f, lastpos - curpos - k);
			fseek_chk(f, curpos, 0);
		} else {
			fwrite(p+1, 1, (us_int)(lastpos - curpos - n), stdout);
			 /* write sizeunsigned intɎ܂ */
		} /* sŏIĂꍇŏ̏o͂0oCg */
		if(lastnoLF) (putcr(), lastnoLF = 0);
		--l, lastpos = curpos + n;
	}
}

static	void	seq_tail_r_fromtail(f)
FILE	*f;
{
	char	**lines, *p;
	us_int	i_num, i = 0, j;

	 /* num͏\ƑO񂷂邱Ƃɂ */
	if(0 == (i_num = (us_int)num)) return;
	lines = chk_malloc(sizeof(char *) * i_num);
	for(i = i_num; i; ) lines[--i] = NULL; /* here i == 0 */
	while(NULL != (p = getline(NULL, f))){
		if(lines[i] != NULL) free(lines[i]);
		lines[i++] = p;	if(i == i_num) i = 0;
	}
	if(p = lines[(i ? i : i_num) - 1], p[strlen(p) - 1] != '\n'){
		fputs(p, stdout), putcr(), *p = '\0';
	}
	for(j = i; j--; ){
		fputs(lines[j], stdout), free(lines[j]);
	}
	if(lines[i] != NULL) for(j = i_num; j-- > i; ){
		fputs(lines[j], stdout), free(lines[j]);
	}
	free(lines);
}

static	void	seq_tail_r_fromtop(f)
FILE	*f;
{
	us_long	l;
	int	c, i, i_num;
	char	**lines, *p;

	if(0L < (l = num)) l--;
	for(; l; --l){
		for(;;){
			if(EOF == (c = getc(f))) return;
			if(c == '\n') break;
		}
	}
	lines = chk_malloc(sizeof(char *) * (i_num = 100));
	for(i = 0; NULL != (p = getline(NULL, f)); i++){
		if(i_num <= i) lines = chk_realloc(lines,
					    sizeof(char *) * (i_num += 100));
		lines[i] = p;
	}
	if(i && (p = lines[i-1], p[strlen(p) - 1] != '\n')){
		fputs(p, stdout), free(p), putcr(), --i;
	}
	while(i--){
		fputs(p = lines[i], stdout);
		free(p);
	}
	free(lines);
}

static	void	tail(f)
FILE	*f;
{
#ifdef MSDOS
	int	seq = isatty(fileno(f)); /* łƎv */
#else
	int	seq = (0 != lseek(fileno(f), 0L, 1));
	 /* seekłȂ́AJnɊɈʒu擪łȂ([A
	    ꕔ𑼂̃vOɓǂ܂Ă܂t@CȂ)ɂ
	    seekg킸ɑΏ */
#endif

	if(fromtop){
		if(unitisbyte){
			(seq ? seq_tail_b_fromtop : tail_b_fromtop)(f);
		} else
		if(reverse){
			(seq ? seq_tail_r_fromtop : tail_r_fromtop)(f);
		} else {
			tail_l_fromtop(f);
		}
	} else {
		if(unitisbyte){
			(seq ? seq_tail_b_fromtail : tail_b_fromtail)(f);
		} else
		if(reverse){
			(seq ? seq_tail_r_fromtail : tail_r_fromtail)(f);
		} else {
			(seq ? seq_tail_l_fromtail : tail_l_fromtail)(f);
		}
	}
	if(ferror(stdout)) nowrite(stdout); /* `FbN͊et@C */
}

main(ac, av)
int	ac;
char	**av;
{
	char	*p;
	bool	plus_opt;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	for(--ac, ++av; ac && (*(p = *av) == '-' || *p == '+'); --ac, ++av){
		plus_opt = (bool)(*p++ == '+');
		if(plus_opt){
			fromtop = plus_opt;
		} else {
			if(!*p) break; /* '-' */
			if(*p == '-' && !p[1]){ /* '--' */
				--ac, ++av; break;
			}
		}
		if(is_digit(*p)){
			num = atol(p);
			do ++p; while(is_digit(*p));
		}
		while(*p){
			switch(*p++){
			case 'b': unitisbyte = countblock = 1; break;
			case 'c': unitisbyte = 1, countblock = 0; break;
			case 'l': unitisbyte = countblock = 0; break;
			case 'r': reverse = 1; break;
			case 'h': nohdr = 1; break;
			default: usage();
			}
		}
	}
	if(reverse && unitisbyte){
		cmd_errmsg("Can't use '-r' option with '-c' or '-b'\n");
		exit(1);
	}
	if(num == (us_long)-1){
		if(reverse){
			num = 0L, fromtop = 1;
		} else {
			num = 10L;
		}
	}
	if(countblock) num *= BLOCK_SIZE;

	if(ac <= 1) nohdr = 1;

	fsetbin(stdin); fsetbin(stdout);
	 /* o͂seek͑SăoCi[hōs */
	if(!ac){
		tail(stdin);
	} else for(; ac; --ac, ++av){
		if(*(p = *av) == '-' && !p[1]){
			hdrout("(stdin)");
			tail(stdin);
			clearerr(stdin);
		} else {
			FILE	*f;

			if(NULL == (f = fopen(p, "r"))){
				cmd_errmsg(s_conv_to_unix_format(p));
				fputs(": Can't open\n", stderr);
				exit(1);
			}
			hdrout(s_conv_to_unix_format(p));
			fsetbin(f); tail(f);
			fclose(f);
		}
	}
	if(fclose(stdout) != 0 || ferror(stdout)) nowrite(stdout);
	return 0;
}
