#include <stdio.h>
#include <errno.h>
#include "tools.h"
#define XBUFSIZ 8192

static	void	usage()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
	_puterrmes_cr(" [-at] [FILES...]");
	exit(1);
}

main(ac, av)
int	ac;
char	*av[];
{
	extern	int	optind, opterr;
	extern	char	*optarg;

	static	char	buf[XBUFSIZ], mode[] = "wb";
	int	i, c, iosize;
	FILE	**fs;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifdef stdaux
	fclose(stdaux), fclose(stdprn);
#endif

	opterr = 0;
	while(EOF != (c = getopt(ac, av, "at"))){
		cswitch(c){
		case 'a':
			*mode = 'a'; break;
		case 't':
			mode[1] = '\0'; break;
		default:
			usage();
		}
	}
	av += optind, ac -= optind;
	if(mode[1]) fsetbin(stdin), fsetbin(stdout);

	(fs = chk_malloc(sizeof(FILE *) * (ac + 1)))[ac] = stdout;
	for(i = 0; i < ac; i++){
		if(NULL == (fs[i] = fopen(av[i], mode))){
			if(errno == EMFILE){
				_cmdputerrmes_cr("Too many open files");
			} else {
				_cmdputerrmes(conv_to_unix_format(av[i]));
				_puterrmes_cr(": Can't open");
			}
			exit(1);
		}
	}

	while(0 < (iosize = fread(buf, 1, XBUFSIZ, stdin))){
		for(i = 0; i <= ac; i++){
			if(iosize > fwrite(buf, 1, iosize, fs[i])){
				_cmdputerrmes(i == ac ? "(stdout)" :
					   conv_to_unix_format(av[i]));
				_puterrmes_cr(": Write failed");
				exit(1);
			}
		}
	}
	return 0;
}
