#include <stdio.h>
#include "tools.h"

#ifdef NOWILDEX /* backward compati. */
#  define NOWILD
#endif

#ifdef MK_EXPARG_NOWILD /* `expand_arg_nowild()ł */
#  define NOWILD
#endif

#ifdef W95ONLY
#  define w95chk() if(!chk_lfnsupp()) \
		_puterrmes_cr("This program requires Windows 95."), exit(-1)
#else
#  define w95chk()
#endif

#ifdef TINYMAIN
int	expand_arg_tiny(av0, arg, navp)
char	*av0, *arg, ***navp;
{
	int	nac;
#ifdef LOOK_CMDLINE
	char	**nav;
#else
	static	char	*nav[MAXARGS + 2]; /* ̔ẑ܂ܕԂ */
#endif

	w95chk();
	expand_hook();

	if(av0 == NULL) av0 = NULSTR;

#ifdef LOOK_CMDLINE
	nac = split_word_alloc(av0, get_long_arg(arg), &nav);
#else
	nac = split_word(av0, arg, nav);
#endif
	unquote_arguments(nac, nav);

	*navp = nav;
	setcmdname(*nav);
	return nac;
}
#else /* TINYMAIN */
#ifdef MK_EXPARG_NOWILD
int	expand_arg_nowild(av0, arg, navp)
#else
int	expand_arg(av0, arg, navp)
#endif
char	*av0, *arg, ***navp;
 /* ̏ꍇ3char **ւ̃|C^łAꂽXg
    w֓ */
{
	register int	nac;
	char	**nav, **nnav;
#if !defined(EXPAND_ENVVAR) && !defined(LOOK_CMDLINE)
	char	*avbuf[MAXARGS + 2]; /* ̔z͈ꎞgpłA
			̂܂ܕԂƂ͂Ȃ̂staticłȂĂ悢 */
#endif

	w95chk();
	expand_hook();

	if(av0 == NULL) av0 = NULSTR;

#define free_prev_allocated_argv(x) /* none */
#define free_allocated_arg(x) /* none */

	/* CMDLINE̒̎擾 */
#ifdef LOOK_CMDLINE
	arg = get_long_arg(arg); /* ̒łmalloc()͂ĂȂ */
#endif

	/* $ */
#ifdef EXPAND_ENVVAR
	arg = expand_envvar(arg);
#undef free_allocated_arg
#define free_allocated_arg(x) free(x)
#endif

	/* ̕ */
#if defined(EXPAND_ENVVAR) || defined(LOOK_CMDLINE)
	/* arg͒\̂split_word_alloc()̕gp */
	nac = split_word_alloc(av0, arg, &nav);
#undef free_prev_allocated_argv
#define free_prev_allocated_argv(x) discard_argv(x)
#else
	/* arg127oCg܂łȂ̂split_word()ŏ\ */
	nac = split_word(av0, arg, nav = avbuf);
	 /* split_wordnav̒g̊ë抄蓖ĂȂ */
#endif
	free_allocated_arg(arg);

	/* @ */
	nac = expand_indirects(nac, nav, &nnav);
	free_prev_allocated_argv(nav);
#undef free_prev_allocated_argv
#define free_prev_allocated_argv(x) discard_argv(x)
	nav = nnav;

	/* ` ` -> " " */
#ifdef EXPAND_BQUOTE
	nac = expand_bquote(nac, nav, &nnav);
	free_prev_allocated_argv(nav);
#undef free_prev_allocated_argv
#define free_prev_allocated_argv(x) discard_argv(x)
	nav = nnav;
#endif /* EXPAND_BQUOTE */

	/* { } */
	nac = expand_braces(nac, nav, &nnav);
	free_prev_allocated_argv(nav);
#undef free_prev_allocated_argv
#define free_prev_allocated_argv(x) discard_argv(x)
	nav = nnav;

	/* ~ -> " " */
#ifdef EXPAND_TILDE
	nac = expand_home(nac, nav, &nnav);
	free_prev_allocated_argv(nav);
#undef free_prev_allocated_argv
#define free_prev_allocated_argv(x) discard_argv(x)
	nav = nnav;
#endif /* EXPAND_TILDE */

	/* (*?[] and) unquote */
#ifndef NOWILD
	nac = expand_wild(nac, nav, &nnav);
	free_prev_allocated_argv(nav);
#undef free_prev_allocated_argv
#define free_prev_allocated_argv(x) discard_argv(x)
	nav = nnav;
#else /* NOWILD */
	unquote_arguments(nac, nav);
#endif /* NOWILD */

	*navp = nav;
	setcmdname(*nav);
	return nac;
}
#endif /* TINYMAIN */

#ifdef ALONETEST
main(ac, av)
char	**av;
{
	int	i, nac;
	char	**nav;

#ifdef TINYMAIN
	nac = expand_arg_tiny(av[0], ac > 1 ? av[1] : NULL, &nav);
#else
	nac = expand_arg(av[0], ac > 1 ? av[1] : NULL, &nav);
#endif

	for(i = 0; i < nac; i++) fprintf(stderr, "%d <%s>\n", i, nav[i]);
	fprintf(stderr, "%s\n", nav[nac] == NULL ? "Ok" : "Bad");
	return 0;
}
#endif /* ALONETEST */
