-- libr header start.
 /* WJCu */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <signal.h>
#ifndef UX_COMPILE_TEST
#  include <dos.h>
#else
#  include <sys/types.h>
#  include <sys/stat.h>
#  include <dirent.h>
#  define STAT_H_INCLUDED
#endif
#include <fcntl.h>
#include <errno.h>
#ifdef LSI_C
#  include <farstr.h>
#endif
#include <stdlib.h>
#include "tools.h"

#ifdef UX_COMPILE_TEST
#  undef NULL
#  define NULL ((void *)0)
#endif /* UX_COMPILE_TEST */

#ifdef DEBUG3
static	void	*test_malloc(i)
int	i;
{
	void	*p;

	p = malloc(i);
	fprintf(stderr, "!malloc %x\n", p);
	return p;
}
static	void	*test_realloc(q, i)
void	*q;
int	i;
{
	void	*p;

	p = re_alloc(q, i);
	fprintf(stderr, "!realloc %x -> %x\n", q, p);
	return p;
}
static	void	test_free(p)
void	*p;
{
	fprintf(stderr, "!free %x\n", p);
	free(p);
}
static	char	*test_strdup(p)
char	*p;
{
	p = strdup(p);
	fprintf(stderr, "!malloc %x\n", p);
	return p;
}
#  define malloc test_malloc
#  define realloc test_realloc
#  define free test_free
#  define strdup test_strdup
#endif /* DEBUG3 */

#ifdef UX_COMPILE_TEST
#  define CON "/dev/tty"
#else
#  define CON "con"
#endif

#if defined(__WATCOMC__) && defined(IMPLICIT_EXPARG)
#  define getenv(n) eseg_getenv(n)
extern	char	*eseg_getenv(char *ename);
extern	void	free_eseg_env(void);
#endif

-tlexpctl.c
void	expand_hook()
{
	expand_hook_default();
	 /* defined(SUPP_LFN) && !defined(UX_COMPILE_TEST)̏ꍇȊO
	    defineĂ */
}

#ifdef UX_COMPILE_TEST /* eXgpCuAɓ */
int	_dos_findnext(f)
struct	find_t	*f;
{
	struct	dirent	*ent;
	char	namebuf[500];
	struct	stat	statbuf;

	if(NULL == (ent = readdir(f -> dirent_for_test))){
		closedir(f -> dirent_for_test);
		return -1;
	}
	sprintf(f -> name, "%.12s", ent -> d_name);
	sprintf(f -> lname, "%.259s", ent -> d_name);
	sprintf(namebuf, "%s/%s", f -> dirname_to_search, ent -> d_name);
	f -> attrib = (0 == stat(namebuf, &statbuf) &&
		(statbuf . st_mode & S_IFMT) == S_IFDIR ? _A_SUBDIR : 0);
	return 0;
}

int	_dos_findfirst(s, a, f)
char	*s; /* ꂪu*.*vŏIꍇ̂ݍl */
unsigned int	a;
struct	find_t	*f;
{
	s = strcpy(f -> dirname_to_search, s), s[strlen(s) - 3] = '\0';
	if(!*s) strcpy(s, ".");
	f -> dirent_for_test = opendir(s);
	if(NULL == f -> dirent_for_test) return -1;
	return _dos_findnext(f);
}

int	_dos_getfileattr(s, a)
char	*s;
unsigned int	*a;
{
	struct	stat	statbuf;

	if(0 != stat(s, &statbuf)) return -1;
	*a = ((statbuf . st_mode & S_IFMT) == S_IFDIR) ? _A_SUBDIR : 0;
	return 0;
}
#endif /* UX_COMPILE_TEST */

-tlextvar.c
int	_expand_abendcode = 1;

#ifdef MSDOS
char	NULNAME[] = NULNAME_content;
char	ALLNAME[] = ALLNAME_content;
#endif

-tlextva2.c
#ifdef WILD_NOHIDDEN
int	_dosfind_param = 0x31; /* tools2ォ炸0x35 */
#else
int	_dosfind_param = 0x37; /* B/VXet@CS܂ */
#endif
int	_wildcard_match = 0;
int	_wildcard_exist = 0;
int	_wildcard_add_nomatch = -1;
int	_wildcard_check_nomatch = 0;
int	_wildcard_check_nomatch_all = 1;

-tlcmdnm.c
char	*cmdname = "cmdname";

-tlputmes.c
#ifdef MSDOS
void	_puterrmes_cr(s)
char	*s;
{
	_puterrmes(s);
#  ifdef LSI_C
	_puterrmes("\r\n");
#  else
	_puterrmes("\n");
#  endif
}

void	_putnomemmes()
{
	_puterrmes_cr("Memory exhausted");
}
#endif /* MSDOS */

void	nomem_exit()
{
	_putnomemmes(), exit(_expand_abendcode);
}

-tlputms2.c
void	errquote_exit(c)
char	c;
{
	static	char	msg[] = "Unmatched X.";

	msg[sizeof("Unmatched ") - 1] = c;
	_puterrmes_cr(msg), exit(_expand_abendcode);
}

-tliskanj.c
#ifdef KANJI
#  ifdef UX_COMPILE_TEST
int	iskanji(c)
int	c;
{
	return c & 0x80;
}
#  else /* UX_COMPILE_TEST */
int	iskanji(c)
int	c;
{
	static	int	flag = -1;
	static	char	tmpbase[ ] = "a\201\\";
	char	fcbbuf[37];
	unsigned char	b;
	union	REGS	in, out;
	struct	SREGS	segreg;

	if(flag < 0){
		in . x . ax = 0x2900;
		in . x . si = FP_OFF(tmpbase);
		in . x . di = FP_OFF(fcbbuf);
		segreg . ds = FP_SEG((void far *)tmpbase);
		segreg . es = FP_SEG((void far *)fcbbuf);
		intdosx(&in, &out, &segreg);
		flag = (fcbbuf[3] == '\\');
	}
	return flag && 0x81 <= (b = (unsigned char)c) &&
		(b <= 0x9f || 0xe0 <= b && b <= 0xfc);
}
#  endif /* UX_COMPILE_TEST */
#else /* KANJI */
int	iskanji(c) /* ARGSUSED */
{
	return 0;
}
#endif /* KANJI */

#ifdef MSDOS
int	iskanjipos(p)
char	*p;
{
	return iskanji(*p) && p[1];
}
#endif /* else iskanjipos() is a macro */

-tlpathlw.c
char	*pathname_lower(s, convmode)
char	*s; /* s𒼐ڏđ啶ɂAsgԂ */
int	convmode; /* rbg01:0Ȃu\vu/v  02:LFNl */
{
	char	*p;

#ifdef SUPP_LFN
	if((convmode & 2) && _lfnsupp_level > LFN_NONE){
		char	*q;
		bool	flg;

		for(flg = 0, q = p = s; ; ++p){
			switch(*p){
			case PATH_SEP:
				if(convmode & 1) *p = PATH_SEP1;
				 /* FALLTHROUGH */
			case PATH_SEP1:	case DRIVE_SEP:	case DOT: case '\0':
				if(!flg){
					for(; q < p; ++q){
						if(iskanjipos(q)) ++q;
						else *q = to_lower(*q);
					}
				} else flg = 0, q = p;
				if(!*p) return s;
				continue;
			}
			if(iskanjipos(p)) ++p; else if(is_lower(*p)) flg = 1;
		}
	}
#endif

	for(p = s; ; ++p){
		switch(*p){
		case '\0':
			return s;
		case PATH_SEP:
			if(convmode & 1) *p = PATH_SEP1;
			break;
		default:
			if(iskanjipos(p)) ++p; else *p = to_lower(*p);
		}
	}
}

-tlparstk.c
#ifdef ANNOYING_PROTO
static	void	store_char_if_nonNULL ARGDECL((char **, char));
#endif
static	void	store_char_if_nonNULL(pp, c)
 /* parse_token()ŎgpB*ppnon-NULLȂ炻c|C^i߂ */
char	**pp, c;
{
	if(pp != NULL) *(*pp)++ = c;
}

char	*parse_token(s, pp)
 /* swPAu'vu" "vu` `v̏Iӏ̎(*s0Ȃs)ԂB
    ܂AppNULLȂAu'vu" "vAu` `v̓́u'vu" "v
    ̂*ppȍ~ɓBu` `v͏ȂB*ppsƕʂȂƂwĂ
    *pp <= sł邱ƁBO҂邢ppNULL̏ꍇs̒g͕ςȂB
    *ppȍ~̍Ō'\0'͓Ȃ̂ŁAKvȂŌ*pp'\0'邱 */
char	*s, **pp;
{
	int	c, i, d;

	switch(*s){
	case '\0':
		break;
	case ESCAPE:
		if(!(d = s[1])) goto normal; /*  */
		s += 2; /* śu'v̎w */
		switch(d){
		case 'n':
			c = '\n'; goto specials;
		case 't':
			c = '\t'; goto specials;
		case 'b':
			c = '\b'; goto specials;
		case 'r':
			c = '\r'; goto specials;
		case 'f':
			c = '\f'; goto specials;
		case 'a':
			c = 0x7; goto specials;
		case 'v':
			c = 0xb; goto specials;
		case 'e':
			c = '\033'; goto specials;
		case 'x':
			c = 0, i = 2;
			for(; i && (d = *s, is_xdigit(d)); --i, ++s){
				c <<= 4;
				c |= to_lower(d) -
						(isdigit(d) ? '0' : 'a' - 10);
			}
			goto specials;
		case 'q':
			c = '"'; goto specials;
		case 'l':
			c = '<'; goto specials;
		case 'g':
			c = '>'; goto specials;
		case 'p':
			c = '|'; goto specials;
		default:
			--s;
			if(is_octal(d)){
				c = 0, i = 3;
				do{
					c <<= 3, c |= d - '0';
					--i, ++s;
				} while(i && (d = *s, is_octal(d)));
			specials:
				store_char_if_nonNULL(pp, (char)c);
				goto fin;
			} else {
				goto knormal; /* ̏ꍇ܂ */
			}
		}
	case ESC_STRING:
		for(++s; ;){
			switch(*s){
			case '\0':
				errquote_exit(ESC_STRING);
				 /* NOTREACHED */
			case ESC_STRING:
				++s;
				goto fin;
			default:
				if(iskanjipos(s))
					store_char_if_nonNULL(pp, *s++);
				store_char_if_nonNULL(pp, *s++);
			}
		}
	case BQUOTE_CHR:
		for(store_char_if_nonNULL(pp, *s++); ;){
			switch(*s){
			case '\0':
				errquote_exit(BQUOTE_CHR);
				 /* NOTREACHED */
			case BQUOTE_CHR:
				goto normal; /* Ṓu`v𐶂 */
			default:
				s = parse_token(s, pp);
			}
		}
	default:
	knormal:
		if(iskanjipos(s)) store_char_if_nonNULL(pp, *s++);
	normal:
		store_char_if_nonNULL(pp, *s++);
	}
fin:
	return s;
}

-tletokch.c
char	*end_of_token_chain(s)
char	*s; /* s͋󔒂łu\0vłȂ̂wĂ邱 s̓e͕s */
{
	do s = reach_to_end_of_token(s); while(*s && !is_space(*s));
	return s;
}

-tlskipsp.c
char	*skip_spaces(s)
char	*s;
{
	for(; is_space(*s); ++s);
	return s;
}

-tlsplitw.c
int	split_word(av0, s, av)
 /* s[hɕAav[1]ɓAԂBmalloc͂A
    s𒼐ڏĕBav̌ */
char	*av0, *s, **av;
{
	int	nac = 1;

	*av++ = conv_to_unix_format(av0);
	 /* SUPP_LFNłĂADOS݊̎s`Ԃ̏ꍇ̓R}h
	    SFNŗ^ */
	for(;;){
		if(!*(s = skip_spaces(s))){
			*av = NULL; return nac;
		}

		++nac, *av++ = s;
		if(*(s = end_of_token_chain(s))) *s++ = '\0';
	}
}

-tlspltw2.c
int	split_word_alloc(av0, s, navp)
 /* s[hɕAV蓖Ă̔z̓Y1ȌɓAԂBs͏
    ւȂBsplit_word()ƈقȂA|C^̔zgVmalloc */
char	*av0, *s, ***navp;
{
	int	nac = 0, maxnac = 64, n;
	register char	*p, *q;

	*navp = chk_malloc(sizeof(char *) * maxnac);
	register_arg(conv_to_unix_format(chk_strdup(av0)),
						nac++, 1, &maxnac, navp);
	 /* argv[0]͓WJBSUPP_LFNłĂADOS݊̎s`Ԃ̏ꍇ
	    R}hSFNŗ^ */

	for(;;){
		if(!*(p = skip_spaces(s))){
			register_arg(NULL, nac, 1, &maxnac, navp);
			*navp = chk_realloc(*navp, sizeof(char *) * (nac + 1));
			return nac;
		}

		n = (s = end_of_token_chain(p)) - p;
		(strncpy(q = chk_malloc(n + 1), p, n))[n] = '\0';
		register_arg(q, nac++, 10, &maxnac, navp);
	}
}

-tlchkalc.c
void	*chk_realloc(p, n)
void	*p;
unsigned int	n;
{
	if(NULL == (p = re_alloc(p, n))) nomem_exit();
	return p;
}

char	*chk_strdup(p)
char	*p;
{
	if(NULL == (p = strdup(p))) nomem_exit();
	return p;
}

char	*chk_strdupcat(p, q)
char	*p, *q;
{
	int	l;
	char	*s = chk_malloc((l = strlen(p)) + strlen(q) + 1);

	return (strcpy(strcpy(s, p) + l, q), s);
}

#ifdef OLD_C
char	*strdup(s)
{
	char	*p;

	return NULL == (p = malloc(strlen(s) + 1)) ? NULL : strcpy(p, s);
}
#endif

-tldisarg.c
void	discard_argv(w)
char	**w;
{
	char	**p;

	for(p = w; *p != NULL; p++) free(*p);
	free(w);
}

-tlnextpd.c
char	*next_pathsep(s)
char	*s; /* ́u/vu\v̈ʒu(ȂƖ̎)Ԃ */
{
	for(; ; ++s){
		switch(*s){
		case '\0':
		case PATH_SEP: case PATH_SEP1:
			return s;
		default:
			if(iskanjipos(s)) ++s;
		}
	}
}

char	*next_nonpathsep(s) /* ʃW[ɂׂ? */
char	*s; /* ́u/vu\vȊÖʒu(ȂƖ̎)Ԃ */
{
	while(ispathsep(*s)) ++s;
	return s;
}

-tllastpd.c
char	*last_pathsep(s, pp)
char	*s, **pp;
 /* ԂĺAs̍Ōオu/vu\v̗Ȃ炻̍ŏAȂƍŌ̒
    ̒Óu/vu\v̎̈ʒu*ppɓ(pp!=NULL̎̂)
    suc:/vȂǂ̏ꍇ*pp̓pX؂蕶ɂȂ邱Ƃ */
{
	char	*p, *q;

	if(drive_headed(s)) s += 2;
	while(*(s = next_nonpathsep(q = next_pathsep(p = s))));
	if(pp != NULL) *pp = p;
	return q;
}

-tlregarg.c
void	register_arg(s, ac, incac, maxacp, avp)
int	incac, ac, *maxacp;
char	*s, ***avp;
 /* (*avp)[ac]sBsȂincac₷B*maxacp */
{
	if(ac >= *maxacp){
		*maxacp = ac + incac;
		*avp = chk_realloc(*avp, sizeof(char *) * *maxacp);
	}
	(*avp)[ac] = s;
}

-tlexevfl.c
#define ENVFLG_SEP ','
int	expenv_flg() /* foreach.cłg */
 /* ϐ̓WJsۂ̃tOԂBrbg01WJsۂA
    02͕ϐ̑啶̓ꎋ߂邩A04͕ϐȂ̃G[
    ߂邩B̂Ƃ0204́A01Ă鎞̂ݗ */
{
	static	int	do_expenv = -1;
	char	*p;

	if(do_expenv < 0){
		do_expenv = 1;

		if(NULL == (p = getenv("TL_EXPENV"))){
			/*  do_expenv = 0; ƏĂ
			   ȑO̔łƓlATL_EXPENVɉlݒ
			   ĂȂϐWJȂ */
		} else {
			static	struct	{
				char	*name;
				int	len, flg;
			} expenvflg[] = {
#define name_len_pair(s) (s), (sizeof(s) - 1)
				{name_len_pair("casesens"), 2},
				{name_len_pair("noundef"), 4},
			};
			int	i;
#define numberof(s) (sizeof(s) / sizeof(*(s)))

			for(;;){
				for(i = 0; i < numberof(expenvflg); ++i){
					if(!strnicmp(expenvflg[i].name, p,
							expenvflg[i].len) &&
					   (!p[expenvflg[i].len] ||
					    p[expenvflg[i].len]== ENVFLG_SEP)){
						do_expenv |= expenvflg[i].flg;
						break;
					}
				}
				if(NULL == (p = strchr(p, ENVFLG_SEP))) break;
				++p;
			}
		}
	}
	return do_expenv;
}

-tlstrupr.c
char	*strtoupper(s) /* strtolower is a macro defined in tools.h */
char	*s;
{
	char	*p;

	for(p = s; *p; ++p){
		if(iskanjipos(p)) ++p; else *p = to_upper(*p);
	}
	return s;
}

-tlexpenv.c
char	*expand_envvar(str)
char	*str;
 /* str$env, ${env}, $"env"WJʂV蓖Ă̗̈ɓԂB
    expenv_flg()&010̏ꍇstrdup()Ɠ */
{
	register char	*p, *q, *r;
	char	*ret, *envvar, *envtail, tmpc, envkind;
	int	alc, alc_need, envflag;

	if(!((envflag = expenv_flg()) & 01)) return chk_strdup(str);

	ret = chk_malloc(alc = 128), alc_need = 1;
	for(p = str, q = ret; ;){
		switch(*p){
		case ENV_CHR:
			switch(envkind = *++p){
			case ENV_LBR:
				tmpc = ENV_RBR;
				goto quoted_env;
			case ESC_STRING:
				tmpc = ESC_STRING;
			quoted_env:
				for(r = ++p; *r != tmpc; ++r)
					if(!*r) goto illvar;
				/* ̎_*r == tmpc */
				goto env_common;

			case ' ':
			case '\t':
			case '\0':
			case_spc:
				--p;
				goto normal;
#define KSPC 0x8140
#define KSPC1 ((char)(KSPC >> 8))
#define KSPC2 ((char)KSPC)
			case KSPC1:
				if(iskanji(KSPC1) && p[1] == KSPC2)
					goto case_spc;
				 /* FALLTHROUGH */

			default:
				if(!is_alpha(*p) && *p != '_') goto illvar;
				r = p;
				do ++r; while(tmpc = *r,
						is_alnum(tmpc) || tmpc == '_');

			env_common: /* ̎_*r == tmpc */
				*r = '\0'; /* Ōɖ߂ */
				if(!*p){
				illvar:
					_puterrmes_cr("Illegal variable name.");
					exit(_expand_abendcode);
				}

				if(envflag & 02){ /* casesens */
					envvar = getenv(p);
				} else {
					char	*envtmpnm;

					envtmpnm = strtoupper(chk_strdup(p));
					envvar = getenv(envtmpnm);
					free(envtmpnm);
				}
				*r = tmpc; /* ɖ߂ */

				if(envvar == NULL){
					if(envflag & 04){ /* noundef */
						envvar = NULSTR;
					} else {
						_puterrmes_cr(
						    "Undefined variable.");
						exit(_expand_abendcode);
					}
				}
				switch(envkind){
				case ESC_STRING:
					envvar = quote_str(envvar);
					/* ̏ꍇƂŉ˂΂ȂȂ */

					/* FALLTHROUGH */
				case ENV_LBR:
					++r;
				}
			}
			p = envvar, envtail = p + strlen(p);
			goto common;

		case '\0':
			*q = '\0';
			return chk_realloc(ret, alc_need);
		default:
		normal:
			envkind = '\0';
			envtail = r = reach_to_end_of_token(p);
		common:
			if(alc < (alc_need += envtail - p)){
				char	*newret;

				newret = chk_realloc(ret, alc = alc_need + 80);
				q = newret + (q - ret), ret = newret;
			}
			for(; p < envtail; ++p, ++q) *q = *p;
			 /* TL_EXPENV=noundef̏ꍇAŏ̎_*p0
			    Ƃ */
			if(envkind == ESC_STRING) free(envvar);
			p = r;
			break;
		}
	}
}

-tlexpbr.c
#ifdef ANNOYING_PROTO
static	char	*find_rbrace ARGDECL((char *));
#endif
static	char	*find_rbrace(s)
char	*s; /* s'{'̎̒n_B'}'̎̒n_Ԃ */
{
	char	*p;
	int	braces_level = 1;

	for(p = s; ; p = reach_to_end_of_token(p)){
		switch(*p){
		case '\0':
			errquote_exit(LBRACE);
			 /* NOTREACHED */
		case RBRACE:
			if(--braces_level) break;
			return ++p;
		case LBRACE:
			++braces_level;
		} /* kanjireach_to_end_of_token() */
	}
}

#ifdef ANNOYING_PROTO
static	void	expand_braces1
	ARGDECL((char *, char *, char *, int *, int *, char ***));
#endif
static	void	expand_braces1(pre, s, post, nacp, maxnacp, navp)
 /* expand_brace()ŎgpBśu{ }vWJʂ̑OpreApost
    ȂAnavpɓo^Ă */
char	*pre, *s, *post, ***navp;
int	*nacp, *maxnacp;
{
	register char	*p;

	for(p = s; ;){
		switch(*p){
		case '\0':
			p = chk_strdupcat(pre, s); /* newly allocated */
			if(!*post){
				register_arg(p, (*nacp)++, 10, maxnacp, navp);
			} else {
				expand_braces1(
					p, post, NULSTR, nacp, maxnacp, navp);
				free(p);
			}
			return;
		case LBRACE:
			if(p[1] == RBRACE){ p += 2; break; }
			goto found_lbrace;
		default:
			p = reach_to_end_of_token(p);
		} /* kanjireach_to_end_of_token() */
	}

found_lbrace:
	*p++ = '\0'; /* Ōɖ߂ */
	{
		register char	*r, *q, c;

		pre = chk_strdupcat(pre, s);
		post = chk_strdupcat(find_rbrace(p), post);
		 /* Ήu}v */
		for(q = r = p; ;){
			switch(c = *r){ /* c'\0'ɂ͂ȂȂBȂ
					O'}'','͂ */
			case BRACE_CONTENTS_SEP:
			case RBRACE:
				*r = '\0'; /* Ōɖ߂ */
				expand_braces1(
					pre, q, post, nacp, maxnacp, navp);
				if((*r = c  /* ɖ߂ */) == RBRACE)
					goto each_fin;

				q = ++r;
				break;
			case LBRACE:
				r = find_rbrace(++r);
				break;
			default:
				r = reach_to_end_of_token(r);
			} /* kanjireach_to_end_of_token() */
		}
each_fin:
		free(pre); free(post);
	}
	p[-1] = LBRACE; /* ɖ߂ */
}

int	expand_braces(ac, av, navp)
int	ac;
char	**av, ***navp;
 /* u{ }vWJĐVȈXg(NULLŏI)AnavpɓA
    ԂBnavpт̓e͑SĐVKallocBavNULLŏI邱Ƃ͉
    ȂB܂av̓e͕ύXȂ(ꎞIɂ͏) */
{
	int	nac = 0, maxnac = ac + 1, i;
	char	*s;

	*navp = chk_malloc(sizeof(char *) * maxnac);
	register_arg(chk_strdup(av[0]), nac++, 1, &maxnac, navp);
	 /* argv[0]͓WJ */

	for(i = 1; i < ac; i++){
		s = av[i];
		if(*s == LBRACE && !s[1]){
		 /* PƁu{v̓ */
			register_arg(chk_strdup(s), nac++, 10, &maxnac, navp);
		} else {
			expand_braces1(
				NULSTR, s, NULSTR, &nac, &maxnac, navp);
		}
	}
	register_arg(NULL, nac, 1, &maxnac, navp);
	*navp = chk_realloc(*navp, sizeof(char *) * (nac + 1));
	return nac;
}

-tlendpd.c
int	ends_with_pathdelimiter_p(s)
char	*s; /* Ƀt@Cǉɂu/vvȂ0AsvȂ1
		[gfBNgu\\vȂǂ̏ꍇ2Ԃ */
{
	char	*p;

	if(drive_headed(s)) s += 2;
	return *s ? (*(s = last_pathsep(s, &p)) ? (p == s ? 2 : 1) : 0) : 1;
}

-tlptcat.c
char	*chk_strduppathcat(dir, pd, f)
char	*dir, *f;
int	pd; /* expand_path()ƈႢԂɂ͂ރpX؂w */
{
	int	need_pd = 0, len, dlen;
	char	*buf, *p;

	switch(ends_with_pathdelimiter_p(dir)){
	case 0:
		if(*f && !ispathsep(*f)) ++need_pd;
		break;
	case 2:
		f = next_nonpathsep(f);
		break;
	}
	len = (dlen = strlen(dir)) + strlen(f) + need_pd;
	p = strcpy(buf = chk_malloc(++len), dir) + dlen;
	if(need_pd) *p++ = (char)pd; /* cast added by kohno@nikon */
	strcpy(p, f);
	return buf;
}

-tlrdall.c
char	*read_all_file_contents(fh)
int	fh; /* DOS filehandle, ǂݏoŃI[vĂ邱 */
 /* malloc̈Ƀt@CŜǂݍ݁AŌ'\0'ɂĕԂ
    \r\n1gy^Z͍폜 Ō̃N[Y͂Ȃ
    ǂav[n]nearȂ̂farmalloc͂Ȃ
    mallocsexitNULLԂ fhreadłȂꍇ̓G[exit */
{
	char	*buf;
	unsigned bufsiz, bytes, curpos = 0;
#define RDUNIT 0x400

	if(NULL == (buf = malloc(bufsiz = RDUNIT))) return NULL;
	for(;;){
		if(0 != _dos_read(fh, (char far *)buf+curpos, RDUNIT, &bytes)){
			_puterrmes_cr("? Unknown err");
			exit(_expand_abendcode);
		}
		curpos += bytes;
		if(bytes < RDUNIT){
			if(curpos && buf[curpos - 1] == '\032') --curpos;
			if(curpos && buf[curpos - 1] == '\n'){
				if(--curpos && buf[curpos - 1] == '\r')
					--curpos;
			}
			buf[curpos] = '\0';
			return realloc(buf, ++curpos);
		}
		if(NULL == (buf = realloc(buf, bufsiz += RDUNIT))) return NULL;
	}
}

-tlexpind.c
int	expand_indirects(ac, av, navp)
int	ac;
char	**av, ***navp;
 /* u@vWJĐVȈXg(NULLŏI)AnavpɓA
    ԂBnavpт̓e͑SĐVKallocBavNULLŏI邱Ƃ͉
    ȂB܂av̓e͕ύXȂ */
{
	int	nac = 0, maxnac = ac + 1, i;
	char	*p;

	*navp = chk_malloc(sizeof(char *) * maxnac);
	register_arg(chk_strdup(av[0]), nac++, 1, &maxnac, navp);
	 /* argv[0]͓WJ */

	for(i = 1; i < ac; i++){
		if(INDIRECT_ARG == *(p = av[i]) && INDIRECT_ARG != *++p){
			char	*contents, *q, *r;
			int	fh;

			if(*p == '-' && !p[1]){
				contents = read_all_file_contents(0);
						/* NULL`FbN */
				_dos_close(0);
				if(0 != _dos_open(CON, O_RDONLY, &fh)){
					_puterrmes_cr("? can't open CON");
					exit(_expand_abendcode);
				} /* fh must be 0 */
			} else {
				if(0 != _dos_open(p, O_RDONLY, &fh)){
					_puterrmes_cr(
						"Can't open indirect file.");
					exit(_expand_abendcode);
				}
				contents = read_all_file_contents(fh);
				_dos_close(fh);
			} /* _dos_close()ŃG[͋NȂ͂
			     read_all_file_contents̕Ԃ̂CR
			     ĂɖȂ */
			if(contents == NULL) nomem_exit();
			for(q = contents; ;){
				if(!*(r = q = skip_spaces(q))) break;
				if(*(q = end_of_token_chain(q))) *q++ = '\0';
				register_arg(chk_strdup(r), nac++, 10,
							&maxnac, navp);
			}
			free(contents);
		} else {
			register_arg(chk_strdup(p), nac++, 10, &maxnac, navp);
		}
	}
	register_arg(NULL, nac, 1, &maxnac, navp);
	*navp = chk_realloc(*navp, sizeof(char *) * (nac + 1));
	return nac;
}

-tlexpchl.c
char	*expand_tilde(s)
char	*s;
 /* 擪u~vHOMEΓWJʂ蓖Ă̈AłȂΈ
    ̂܂܂ԂBԂ͎̂ɂ̊֐ĂԂƂ̂Œ
    (ߋ̎dlɍ킹邽)Bs͏Ȃ(ꎞIɂ͏) */
{
	static	char	*buf = NULL;
	char	*p, *q, *r, t, t1;
	char	*home, *uname, *home_uname, *home_uname_end;
	int	uname_len;

	if(buf != NULL)	free(buf), buf = NULL;
	if(*s != HOMEDIR_CHR || NULL == (home = getenv("HOME"))) return s;

	if(++s, s == next_pathsep(s)){
		 /* u~uservȊÕP[XB*śu/vu\vu\0vB
		    ɉ̂߁AbufɑĂԂKv */
		return buf = chk_strduppathcat(home, PATH_SEP1, s);
	}

	uname_len = (NULL == (uname = getenv("LOGNAME")) &&
		     NULL == (uname = getenv("USER")) || !*uname) ? -1 :
			strlen(uname);
	 /* !*name̔fDOSł͕svƎv邪Ô */
	if(p = home, drive_headed(p)) p += 2;
	for(home_uname = NULL, p = next_nonpathsep(p); ; ){
		r = next_nonpathsep(q = next_pathsep(p));
		if(uname_len == q - p && !kstrnicmp(uname, p, uname_len) ||
		   home_uname == NULL && !*r)
			home_uname = p, home_uname_end = q;
		if(!*r) break;
		p = r;
	}
	p = next_pathsep(s);
	t = *home_uname, t1 = *p, *home_uname = *p = '\0'; /* Ōɖ߂ */
	q = chk_strdupcat(home, s);
	*home_uname = t, *p = t1; /* ɖ߂ */
	 /* getenv()̕ԂlꎞIɏĂBvȂ */
	if(*home_uname_end)
		r = chk_strdupcat(q, home_uname_end), free(q), q = r;
	buf = chk_strduppathcat(q, PATH_SEP1, p), free(q);
	return buf;
}

-tlexphom.c
int	expand_home(ac, av, navp)
int	ac;
char	**av, ***navp;
 /* u~vWJĐVȈXg(NULLŏI)AnavpɓA
    ԂBnavpт̓e͑SĐVKallocBavNULLŏI邱Ƃ͉
    ȂB܂av̓e͕ύXȂ(ꎞIɂ͏) */
{
	char	**nav;
	int	i;

	*navp = nav = chk_malloc(sizeof(char *) * (ac + 1));
	*nav = chk_strdup(*av);
	for(i = ac - 1; i; --i) *++nav = chk_strdup(expand_tilde(*++av));
	*++nav = NULL;
	return ac;
}

-tlquostr.c
#ifdef ANNOYING_PROTO
char	*quote_str ARGDECL((char *));
#endif
char	*quote_str(s)
char	*s;
 /* Vmۗ̈ɁAsNH[ĝĕԂBNH[gׂs
    ĂȂꍇ(ɁAs̏ꍇ)͒PȂchk_strdup */
{
	char	*p, *q;
	bool	need_dq_flg;
	unsigned int	dqcnt;

	for(dqcnt = 0, need_dq_flg = 0, p = s; ; ++p){/*changed by kohno@nikon*/
		switch(*p){
		case '\0':
			goto fin;
		case ESC_STRING:
			++dqcnt; goto need_dq;
		case PATH_SEP: case PATH_SEP1: case DRIVE_SEP:
		case '.': case '_':
			break;
		default:
			if(iskanjipos(p)){
#define KSPC 0x8140
#define KSPC1 ((char)(KSPC >> 8))
#define KSPC2 ((char)KSPC)
				++p;
				if(p[-1] == KSPC1 && *p == KSPC2)
					goto need_dq; /* 2byte SPC */
				break;
			}
			if(is_alnum(*p)) break; /* else through */
		need_dq:
			need_dq_flg = 1;
		}
	}
fin:
	if(!need_dq_flg) return chk_strdup(s);
	p = q = chk_malloc((p - s) + ++dqcnt * 3);
	for(*p = ESC_STRING; ; ++s){
		switch(*s){
		case '\0':
			*++p = ESC_STRING;
			*++p = '\0';
			return q;
		case ESC_STRING:
			*++p = ESC_STRING, *++p = ESCAPE, *++p = ESC_STRING;
			 /* FALLTHROUGH */ /* s is not kanji position */
		default:
			if(iskanjipos(s)) *++p = *s++;
			*++p = *s;
		}
	}
}

-tlexpbq.c
#ifdef UX_COMPILE_TEST
#  define dup_fhandle dup
#  define dup2_fhandle dup2
#else /* UX_COMPILE_TEST */
#ifdef ANNOYING_PROTO
static	int	dup_fhandle ARGDECL((int));
#endif
static	int	dup_fhandle(fh)
int	fh; /* ُ펞-1 */
{
	union	REGS	in, out;

	in . h . ah = 0x45;
	in . x . bx = fh;
	intdos(&in, &out);
	return out . x . cflag ? -1 : out . x . ax;
}

#ifdef ANNOYING_PROTO
static	int	dup2_fhandle ARGDECL((int, int));
#endif
static	int	dup2_fhandle(fh, nfh)
int	fh, nfh; /* ُ펞-1 */
{
	union	REGS	in, out;

	in . h . ah = 0x46;
	in . x . bx = fh;
	in . x . cx = nfh;
	intdos(&in, &out);
	return out . x . cflag ? -1 : nfh;
}
#endif /* UX_COMPILE_TEST */

static	char	*bq_tmpfname = NULL;
static	int	bq_tmpfh = -1;

#ifdef ANNOYING_PROTO
static	void	rmtmp_exit ARGDECL((void));
#endif
static	void	rmtmp_exit()
{
	if(bq_tmpfh >= 0){
		_dos_close(bq_tmpfh);
		unlink(bq_tmpfname);
	}
	exit(-1);
}

#ifdef ANNOYING_PROTO
static	char	*read_output ARGDECL((char *));
#endif
static	char	*read_output(s)
char	*s;
 /* system(s)̎sʂSǂŐVmۗ̈ɓԂ ꎞt@C
    Ȃ胁Ȃ肷exit 荞܂ꂽƂexit */
{
	char	*ret;
	void	(*osig)();
	int	o_stdofh;

	if(bq_tmpfname == NULL){
		char	*tmp;
		int	dummy;

		if(NULL == (tmp = getenv("TMP")) &&
		   NULL == (tmp = getenv("TEMP")))
#ifdef UX_COMPILE_TEST
			tmp = "/tmp";
#else
			tmp = NULSTR;
#endif

#ifndef UX_COMPILE_TEST
		bq_tmpfname = chk_strduppathcat(tmp, PATH_SEP1, NULNAME);
		if(0 != _dos_open(bq_tmpfname, O_WRONLY, &dummy)){
			_puterrmes_cr("Can't create tmpfile");
			exit(_expand_abendcode);
		}
		_dos_close(dummy), free(bq_tmpfname);
#endif
		bq_tmpfname= chk_strduppathcat(tmp, PATH_SEP1, "_tl00000.$$$");
	}

	if(0 >= (o_stdofh = dup_fhandle(1))) goto err;
	 /* o_stdofh0ɂȂꍇs */
	_dos_close(1);

	if(SIG_IGN != (osig = signal(SIGINT, SIG_IGN)))
		signal(SIGINT, rmtmp_exit);
	for(;;){
		int	i;
		char	*p;

		if(0 == _dos_creatnew(p = bq_tmpfname, _A_NORMAL, &bq_tmpfh))
			break;
		bq_tmpfh = -1; /* Ô */
		for(p += strlen(p) - 5, i = 5; ; --i, --p){
			if(!i) goto err;
			if(++*p <= '9') break; else *p = '0';
		}
	} /* bq_tmpfh1̂͂ */
#ifdef DEBUG2
	_puterrmes("tmpfile: <"), _puterrmes(bq_tmpfname),
	_puterrmes("> cmd: ["), _puterrmes(s), _puterrmes_cr("]");
#endif
	system(s);
	signal(SIGINT, SIG_IGN);
	_dos_close(bq_tmpfh);
	if(0 != _dos_open(bq_tmpfname, O_RDONLY, &bq_tmpfh)){
		unlink(bq_tmpfname);
		goto err;
	}
	if(osig != SIG_IGN) signal(SIGINT, rmtmp_exit);
	if(NULL == (ret = read_all_file_contents(bq_tmpfh))) nomem_exit();
	signal(SIGINT, SIG_IGN);
	_dos_close(bq_tmpfh);
	unlink(bq_tmpfname);
	bq_tmpfh = -1; /* Ô */
	signal(SIGINT, osig);

	if(0 > dup2_fhandle(o_stdofh, 1)) goto err;
	close(o_stdofh); /* thanks to kohno */
	return ret;

err:
	_puterrmes_cr("Backquote expanding err");
	exit(_expand_abendcode);
	/* NOTREACHED */
}

 /* plan: ` `̃s */
int	expand_bquote(ac, av, navp)
int	ac;
char	**av, ***navp;
 /* u` `vWJĐVȈXg(NULLŏI)AnavpɓA
    ԂBnavpт̓e͑SĐVKallocBavNULLŏI邱Ƃ͉
    ȂB܂av̓e͕ύXȂ(ꎞIɂ͏) */
{
	int	nac = 0, maxnac = ac + 1, i;
	char	*p, *q, *r, *s, *t, *arg, *newarg;
	bool	escmode_flg, preargused_flg, endout_flg, argnoreg_flg;

	*navp = chk_malloc(sizeof(char *) * maxnac);
	register_arg(chk_strdup(av[0]), nac++, 1, &maxnac, navp);
	 /* argv[0]͓WJ */

	for(i = 1; i < ac; i++){
#ifdef DEBUG4
		_puterrmes("expand_bquote loop "), _puterrmes_cr(av[i]);
#endif
		for(argnoreg_flg = 0, arg = p = av[i]; ; ){
		 /* ȌAargmallocꂽ̈悩av[i] i̓[vł͕s*/
			switch(*p){
			case '\0':
				goto fin_each;
			case BQUOTE_CHR:
				p = reach_to_end_of_token(r = q = p);
				*q++ = p[-1] = '\0'; /* Ōɖ߂ */

				t = s = chk_malloc(
					    strlen(r = skip_spaces(++r)) + 1);
				escmode_flg = (bool)isquotechar(*r);
						/* changed by kohno@nikon */
				while(*r) r = parse_token(r, &t); *t = '\0';
				/* s͎sׂR}h */
				r = read_output(s), free(s);
				 /* rɂ͎s q, parĝɖ߂ׂ
				    ʒu s, t͎g */

				for(endout_flg = preargused_flg = 0, t = r; ;){
					if(!escmode_flg){
						for(t = s = skip_spaces(t);
						    *t && !is_space(*t); ++t);
					} else {
						for(s = t;
						    *t && *t != '\n'; ++t);
					}
					if(*t){
						t[(r < t && t[-1] == '\r' &&
						   *t == '\n')? -1 : 0] = '\0';
						 /* escmode_flg0̏ꍇt[-1]
						    '\r'ł͂肦ʂ͂ */
						++t;
					} else {
						++endout_flg;
						if(!*s && !*p && !escmode_flg)
							argnoreg_flg =
							  preargused_flg;
						 /* ̐if(!endout_flg)
						    [vEo */
					}

					s = quote_str(s);
					if(!preargused_flg){
						char	*u;

						u = chk_strdupcat(arg, s);
						free(s), s = u;
						++preargused_flg;
					} /* smallocꂽ̈ŁA
					     R}hsʂ1܂肩
					     ̑OargȂ̂ */

					if(!endout_flg){ /* s`tPƓo^ */
						if(*s) register_arg(s, nac++,
							  10, &maxnac, navp);
						 /* 󃏁[h͖ */
					} else { /* s`tqȍ~ɂȂEo */
						newarg = chk_strdupcat(s, p);
						free(s);
						break;
					}
				} /* [v𔲂ƂAnewargmalloc
				     mۂ̈ */
				free(r);
				q[-1] = p[-1] = BQUOTE_CHR; /* ɖ߂ */
				if(arg != av[i]) free(arg);
				if(!*(p = arg = newarg)) argnoreg_flg = 1;
				 /* 󃏁[h͖ */
				break;
			default:
				p = reach_to_end_of_token(p);
			}
		}
	fin_each:
		if(argnoreg_flg){
			if(arg != av[i]) free(arg);
		} else {
			register_arg(arg != av[i] ? arg : chk_strdup(arg),
				    nac++, 10, &maxnac, navp);
		}
	}
	register_arg(NULL, nac, 1, &maxnac, navp);
	*navp = chk_realloc(*navp, sizeof(char *) * (nac + 1));
	return nac;
}

-tlksicmp.c
int	kstricmp(p, q)
char	*p, *q;
{
	int	c, d;

	for(;; ++p, ++q){
		c = to_lower(*p) - (d = to_lower(*q));
		if(c || !d) return c;
		if(!iskanji(d)) continue;

		c = *++p - (d = *++q);
		if(c || !d) return c;
	}
}

-tlksnicm.c
int	kstrnicmp(p, q, n)
char	*p, *q;
unsigned int	n; /* bytes */
{
	int	c, d;

	for(;; ++p, ++q){
		if(!n) return 0; else --n;
		c = to_lower(*p) - (d = to_lower(*q));
		if(c || !d) return c;
		if(!iskanji(d)) continue;

		if(!n) return 0; else --n;
		c = *++p - (d = *++q);
		if(c || !d) return c;
	}
}

-tltopdot.c
int	topdot_nomatch(ref, intrep_p, us_nospcl)
char	*ref;
WILD_INTERNAL	*intrep_p;
int	us_nospcl;
 /* ref̐擪u.vu_vŁAintrepu*vu?vȂǂ̃ChJ[hŎn܂
    Aintrep_pNULLȂ^Bus_nospcl'_'̓ʈ߂邩ǂ
    tOŁAȂ(_lfnsupp_level > LFN_NOWILD)̒lg */
{
	char	*internal;
#ifdef IGNORE_UNDERSCORE_FILES
	static	int	do_ign_us = -1;
#endif

	switch(*ref){
#ifdef IGNORE_UNDERSCORE_FILES
	case UNDERSCORE:
#ifdef SUPP_LFN
		if(us_nospcl > 0 ||
		   us_nospcl < 0 && _lfnsupp_level > LFN_NOWILD) break;
#endif
		if(do_ign_us < 0) do_ign_us = (NULL == getenv("TL_NOIGN_US"));
		if(!do_ign_us) break;
		 /* FALLTHROUGH */
#endif
	case DOT:
		if(intrep_p == NULL) goto ret1;

		switch(*(internal = intrep_p -> unquoted)){
		case LBRACKET:
			if(internal[1] != CHARSET_INVERT) break;
			 /* FALLTHROUGH */
		case ANYSTRING:
		case ANYCHAR:
			if(!*(intrep_p -> wildmark)) break;
		ret1:
			return 1;
		}
		break;
	}
	return 0;
}

-tlnmatch.c
#ifdef ANNOYING_PROTO
static	unsigned int	pick_wch ARGDECL((char **, char **));
#endif
static	unsigned int	pick_wch(strp, markp)
char	**strp, **markp;
{
	unsigned char	*str, *mark;
	int	c;

	c = *(str = (unsigned char *)*strp);
	mark = (unsigned char *)(markp == NULL ? NULSTR - 1 : *markp);
	if(istrulykanjipos(str, mark)){
		c <<= 8, c |= *++str, ++mark;
	} else c = to_lower(c);
	*strp = (char *)++str;
	if(markp != NULL) *markp = (char *)++mark;
	return (unsigned int)c;
}

int	name_match_pure(ref, intrep_p)
char	*ref;
WILD_INTERNAL	*intrep_p;
 /* ref(t@CȂǂ̕)Aintrep_p(parse_wild()œAu" "v
    ȂǂChJ[ht@CL@ƁAeChJ[h
    ۂ̎ʂi[ꂽ̈̃yA)Ƀ}b`邩ԂB
    PATH_SEP, PATH_SEP1̓ꈵ͂ĂȂ̂ŁA1x̃}b`Oɂ̂
    gƁBrefinternalĂȂĂvB*internal0A
    *ref0ł^ƂȂ肤B'.''_'̓ʈ̓}Nname_match()ōs */
{
	unsigned int	c, d, e;
	int	inv_flg, range_ok;
	WILD_INTERNAL	intrep_npair;
	char	*internal, *mark;

	internal = intrep_p -> unquoted, mark = intrep_p -> wildmark;
	while(*internal){
#ifdef DEBUG
		char	*p, *q;

		fprintf(stderr, "compare '%s' '%s'\nmark:", ref, internal);
		for(q = internal, p = mark; *q; ++q, ++p)
			fprintf(stderr, " %d", *p);
		fputc('\n', stderr);
#endif
		if(!*mark){
			if(pick_wch(&ref, NULL) != pick_wch(&internal, &mark))
				return 0;
			continue;
		} /* *ref0łOK */
		switch(++mark, *internal++){
		case ANYCHAR:
			if(!pick_wch(&ref, NULL)) return 0;
			break;
		case ANYSTRING:
			if(!*internal) return 1; /* for speed up */
			for(intrep_npair . unquoted = internal,
			    intrep_npair . wildmark = mark; ; ){
				if(name_match_pure(ref, &intrep_npair))
					return 1;
				if(!pick_wch(&ref, NULL)) return 0;
			} /* NOTREACHED */
		default: /* case LBRACKET: */
			c = pick_wch(&ref, NULL);
			if(inv_flg = (*mark && (*internal == CHARSET_INVERT)))
				++internal, ++mark;
			for(range_ok = 0; !*mark; ){
			 /* ł']'ȊOmark0ɂȂ邱Ƃ͂Ȃ͂ */
				d = pick_wch(&internal, &mark);
				if(*mark && *internal == CHARSET_RANGE){
					++internal, ++mark;
					e = pick_wch(&internal, &mark);
					if(d <= c && c <= e){
						++range_ok; break;
					}
				} else {
					if(c == d){
						++range_ok; break;
					}
				}
			}
			if(inv_flg == range_ok) return 0;
			while(!(*mark && *internal == RBRACKET))
				++internal, ++mark; /* kanji͍lȂĂ */
			++internal, ++mark;
		}
	}
	return !*ref;
}

-tllnmatc.c
#ifdef SUPP_LFN
int	lname_match(name, lname, intrep_p)
char	*name, *lname;
WILD_INTERNAL	*intrep_p;
 /* t@Clongnameshortnamẽ̗}b`BlnameɃ}b`2A
    nameȂ1A}b`Ȃ0Ԃ */
{
	if(_lfnsupp_level > LFN_NOWILD){
#  ifdef DEBUG5
		fprintf(stderr, "LFN is: <%s>\n", lname);
#  endif
		if(name_match(lname, intrep_p))	return *name ? 2 : 1;
		if(!*name) return 0;
	}
	if(_lfnsupp_level != LFN_WILD){
		if(!topdot_nomatch(lname, intrep_p, -1) &&
		   name_match_pure(*name ? name : lname, intrep_p)) return 1;
	}
	return 0;
}
#endif

-tlparsew.c
int	parse_wild(pat, intrep_p)
char	*pat;
WILD_INTERNAL	*intrep_p;
 /* patunquotêintrep_p -> unquotedɓÅeCh
    J[hǂ̎ʂintrep_p -> wildmarkɓ(}[N1B̂Ƃ
    expand_wild1()ŎgB[ ]̈Ӗ̂u^vu-vɂ}[N)Bpat
    ͏ȂBOҗpstrlen(pat)+1ԂAҗpstrlen(pat)Ԃ̗̈
    mہB̉ɂdiscard_internal()gBChJ[h̗LԂ */
{
	char	*p, *q, *t;
	int	wildflg;
	char	*unq, *mark;
	unsigned l;

	intrep_p -> wildmark = mark = chk_malloc(l = strlen(pat));
	memset(mark, 0, l);
	intrep_p -> unquoted = unq = chk_malloc(++l);

	for(wildflg = 0, p = unq; ;){
		switch(*pat){
		case '\0':
			*p = '\0';
			return wildflg;
		case ANYSTRING:
		case ANYCHAR:
			goto have_wild;
		case LBRACKET:
			if(pat[1] == RBRACKET) goto normal;
			mark[p - unq] = 1;
			for(q = p, t = parse_token(pat, &q); ;){
				switch(*t){
				case '\0':
				reset_to_normal:
					memset(mark + (p - unq), 0, q - p);
					goto normal;
				case RBRACKET:
					pat = t, p = q;
					goto have_wild;
				case CHARSET_INVERT:
					if(t == pat + 1){
						if(t[1] == RBRACKET)
							goto reset_to_normal;
						mark[q - unq] = 1;
						goto common;
					} /* else through */
				default:
					t = parse_token(t, &q);
					if(!(*t == CHARSET_RANGE &&
					     t[1] && t[1] != RBRACKET)) break;
					mark[q - unq] = 1;
					t = parse_token(t, &q); /* eat '-' */
				common:
					t = parse_token(t, &q);
				}
			}
		have_wild:
			wildflg = mark[p - unq] = 1; /* through */
		normal:
		default:
			pat = parse_token(pat, &p);
		}
	}
}

-tlnetbug.c
#ifdef MSDOS
 /* Win95DOSt@NV4eh, 714ehA_A_VOLIDƂȊO̗
    ĂꍇAlbg[NhCuɑ΂铮ɃoO(714eh
    {[xA4eh̓{[xȂ)Ƃ̑΍
    ̂ƂDOS7lĂȂBDOS6ȑOłoON蓾邾낤?

    name̓pX̍\vf̍Ōオu*.*vł悤ȕB͏Ȃ
    (ꎞIɂ͏)BԒl
	{[xȂ[głȂꍇ-1
		̏ꍇ_A_VOLID𗎂ƂĒT
	{[xlbg[NhCũ[g̏ꍇ1
		̏ꍇ{[xƂȊOʁXɒT
	{[xlbg[NhCũ[g̏ꍇ0
		̏ꍇ̂܂܌
    ADOS6ȑȌꍇ̂Ƃ0Ԃ

    ꓖYoOꍇ(҂͂Ȃ)ɎIɐ퓮삷邱Ƃ
    Ӑ}āA4409hŃ[ghCuǂ𒲂ׂ@͍̂Ȃ */
int	netdrv_bug(name)
char	*name;
{
	char	*base;
	int	retval;
	struct	find_t	dmy;

	if(_osmajor < 7) return 0;
	retval = _dos_findfirst(name, _A_VOLID, &dmy);
	last_pathsep(name, &base);
	strcpy(base, "."); /* ꎞIɁu*.*vu.vɏ */
	retval = (retval || !_dos_findfirst(name, _A_SUBDIR, &dmy) ?
			-1 : !_dos_findfirst(name, _A_VOLID, &dmy));
	strcpy(base, ALLNAME); /* u*.*vɖ߂ */
	return retval;
}
#endif /* MSDOS */

-tlexwild.c
#ifdef ANNOYING_PROTO
static	void	expand_wild1
	ARGDECL((char *, char *, char *, int, int *, int *, char ***));
#endif
static	void	expand_wild1(origin, arg, mark, attr, nacp, maxnacp, navp)
char	*origin, *arg, *mark, ***navp;
 /* expand_wild()ŎgpBorigiñpXargȍ~̃ChJ[hWJ
    ̂navpɓo^ĂBɃChJ[hĂꍇ̂݌Ă΂
    markargȍ~̃ChJ[h(parse_wild()œ)Ă邱
    origin̓e͏Ȃ(ꎞIɂ͏) attrɂ͌Ƃ
    _dosfind_param^邪A{[x֌WWin95DOSt@NV
    oO΍̂ߗO */
int	attr, *nacp, *maxnacp;
{
	char	found_wild_flg;
	 /* 1: wild邩 2: LFNT|[g1ȏǂ񂾂 */

	char	*p, *q, *next_to_last_pathsep, *last_nonsep;

#ifdef DEBUG5
	fprintf(stderr, "origin = '%s' arg = '%s'\nmark =", origin, arg);
	for(q = arg, p = mark; *q; ++q, ++p)
		fprintf(stderr, " %d", *p);
	fputc('\n', stderr);
#endif
	for(found_wild_flg = 0, last_nonsep = NULL,
	    next_to_last_pathsep = p = arg, q = mark; ; ++p, ++q){
		switch(*p){
		case '\0':
			if(found_wild_flg) goto found_wild;

			if(last_nonsep != NULL){
				char	tmpc;
				int	getattr_val;
				unsigned int	dummyatr;

				tmpc = *++last_nonsep;
				*last_nonsep = '\0';
				 /* ňꎞIorigin̓e(arg
				    ) */
				getattr_val = _dos_getfileattr(
							origin, &dummyatr);
				*last_nonsep = tmpc; /* ɖ߂ */
				if(getattr_val) return;
			}
			p = chk_strdup(origin);
#ifdef SUPP_LFN
			if(_lfnsupp_level > LFN_NOWILD){
				if(drive_headed(p)) *p = tolower(*p);
			} else
#endif
				pathname_lower(p, 0);
			register_arg(p, (*nacp)++, 10, maxnacp, navp);
			return;
		case PATH_SEP:
		case PATH_SEP1:
			if(found_wild_flg) goto found_wild;
			next_to_last_pathsep = p + 1;
			break;
		case LBRACKET: /* *q0̏ꍇ肤 */
			if(*q) do ++p, ++q; while(!(*q && *p == RBRACKET));
			 /* [ ]̈Ӗ̂u^vu-vɑ΂Ă*q1ɂȂ
			    邪A΂ĂȂƁu[^a/b]vȂǂ
			    Ȃ */
			 /* FALLTHROUGH */
		default: /* ̏ꍇ܂(̎*p']'A*q1) */
			last_nonsep = p;
#ifdef SUPP_LFN
			if(_lfnsupp_level > LFN_NOWILD && is_alpha(*p))
				found_wild_flg |= 2;
			 /* p܂܂ꍇ́AChJ[hȂĂ
			    召̒̂_dos_Findfirst()Ńt@C
			    TB璷ȏꍇĂAA
			    ȂƂu./v̏ꍇ͏ȂȂƁA[gfB
			    Ngł́u./*vȂǂWJłȂȂ */
#endif
			found_wild_flg |= *q;
			if(istrulykanjipos(p, q)) ++p, ++q;
		}
	}
found_wild: /* found_wild_flg0(1`3)łɗ */
	{
		int	findval, n;
		char	*buf, *bufmid, *name, tmpc;
		struct	Find_t	findbuf;
		WILD_INTERNAL	new_intrep;
		int	namelen;

		tmpc = *next_to_last_pathsep;
		*next_to_last_pathsep = '\0'; /* Ōɖ߂ */
		buf = chk_strdupcat(origin, ALLNAME);
		 /* SUPP_LFN̏ꍇAu*.*v(=ALLNAME)͔CӂSFNɃ}b`B
		    eiKŃChJ[hȂĂʂɑSt@C
		    }b`͍̂P */
		*next_to_last_pathsep = tmpc; /* ɖ߂ */

#ifdef SUPP_LFN
		if(!(found_wild_flg & 1) && attr != _A_VOLID) attr |= 0x37;
		 /* found_wild_flg2̏ꍇ̕ɃChJ[h͊܂܂
		    ȂA召̒̂_dos_Findfirst()Ńt@C
		    TsĂ */
#endif

		 /* lbg[NhCȕꍇDOSVXeR[̃oO΍ */
		if((attr & _A_VOLID) && (attr & 0x16)) switch(netdrv_bug(buf)){
		case 1: /* origin̓e͌ɖ߂Ă */
			expand_wild1(origin, arg, mark,
						_A_VOLID, nacp, maxnacp, navp);
			 /* FALLTHROUGH */
		case -1:
			attr &= ~_A_VOLID; /* != 0 */
		}

		findval = _dos_Findfirst(buf, attr, &findbuf);
		free(buf);

		tmpc = *p; /* tmpc͌Ŏg(ꂪ0ȂWJdir) */
		*p = '\0'; /* Ōɖ߂ */
		name = chk_strdup(next_to_last_pathsep);
		*p = tmpc; /* ɖ߂ */
		n = next_to_last_pathsep - origin;
		bufmid = strncpy(buf = chk_malloc(
			n + SNAMELENGTH + strlen(p) + 1), origin, n) + n;
		for(; !findval; findval = _dos_Findnext(&findbuf)){
			if(!((char)findbuf . attrib & _A_SUBDIR) && tmpc)
				continue;
			 /* LFNΉ̏ꍇVFATGg̔r
			    _dos_Findnext()Ɋ܂܂ */

			new_intrep . unquoted = name;
			new_intrep . wildmark = mark +
						(next_to_last_pathsep - arg);
#ifndef SUPP_LFN
			if(!name_match(findbuf . name, &new_intrep)) continue;
			namelen = strlen(q = strcpy(bufmid, findbuf . name));
			 /* ͌ */
#else
			switch(lname_match(findbuf . name, findbuf . lname,
								&new_intrep)){
			case 0: /* unmatched */
				continue;
			case 1: /* sfn match */
				q = findbuf . name;
				namelen = strlen(q = strcpy(bufmid,
						  *q ? q : findbuf . lname));
#  ifdef DEBUG5
				fprintf(stderr, "LFN match, <%s>\n", q);
#  endif
				if(_lfnsupp_level > LFN_NOWILD)
					pathname_lower(q, 0);
				 /* _lfnsupp_level <= LFN_NOWILD̏ꍇɌ
				    ł̏s */
				break;
			default: /* lfn match */
				if(SNAMELENGTH < (namelen =
						strlen(q = findbuf . lname))){
					bufmid = (buf = chk_realloc(buf,
					    n + namelen + strlen(p) + 1)) + n;
				}
#  ifdef DEBUG5
				fprintf(stderr, "LFN match, <%s>\n", q);
#  endif
				q = strcpy(bufmid, q);
			}
#endif /* !SUPP_LFN */
			expand_wild1(buf, strcpy(q + namelen, p),
			 mark + (p-arg), _dosfind_param, nacp, maxnacp, navp);
		}
		_dos_Findclose(&findbuf);
		free(buf), free(name);
	}
}

#ifdef SORT_ENTRY
#  ifdef ANNOYING_PROTO
static	int	cmp_string ARGDECL((void *, void *));
#  endif
static	int	cmp_string(p, q)
void	*p, *q;
{
#  ifdef SUPP_LFN
#    ifdef LSI_C
	return (_lfnsupp_level > LFN_NOWILD ? kstricmp : strcmp)
						(*(char **)p, *(char **)q);
 /* ݂̂ƂAkstricmpŔrēꍇstrcmpł͂Blsł\[g
    ̍ۂOɂĂBAႤꍇ̑召strcmpƈقȂ邱Ƃ */
#    else
	return _lfnsupp_level > LFN_NOWILD ?
	  kstricmp(*(char **)p, *(char **)q): strcmp(*(char **)p, *(char **)q);
#    endif /* LSI_C */
#  else
	return strcmp(*(char **)p, *(char **)q);
#  endif /* SUPP_LFN */
}
#endif /* SORT_ENTRY */

#ifdef ANNOYING_PROTO
static	void	nomatch_exit ARGDECL((void));
#endif
static	void	nomatch_exit()
{
	_puterrmes_cr("No match."), exit(_expand_abendcode);
}

int	expand_wild(ac, av, navp)
int	ac;
char	**av, ***navp;
 /* ChJ[hWJĐVȈXg(NULLŏI)AnavpɓA
    ԂBnavpт̓e͑SĐVKallocBavNULLŏI邱Ƃ
    肵ȂB܂av̓e͕ύXȂ(ꎞIɂ͏) */
{
	int	nac = 0, maxnac = ac + 1, i, wildflg, o_nac;
	char	*p, *q;
	WILD_INTERNAL	intrep;

	*navp = chk_malloc(sizeof(char *) * maxnac);
	register_arg(chk_strdup(av[0]), nac++, 1, &maxnac, navp);
	 /* argv[0]͓WJ */

	for(i = 1; i < ac; i++){
		if(!(wildflg = parse_wild(av[i], &intrep))){
			register_arg(chk_strdup(intrep . unquoted),
						nac++, 10, &maxnac, navp);
		} else {
			q = intrep . wildmark, p = intrep . unquoted;
			if(drive_headed(p)) p += 2, q += 2;
			o_nac = nac;

			expand_wild1(intrep . unquoted, p, q, _dosfind_param,
							&nac, &maxnac, navp);
			_wildcard_exist = 1;
			if(o_nac != nac){
#ifdef SORT_ENTRY
				static	int	do_sort = -1;

				if(do_sort < 0)
					do_sort = (NULL== getenv("TL_NOSORT"));
				if(do_sort) qsort(*navp + o_nac, nac - o_nac,
						sizeof(char *), cmp_string);
#endif
				_wildcard_match = 1;
			} else {
				if(_wildcard_check_nomatch) nomatch_exit();
				if(_wildcard_add_nomatch < 0){
					_wildcard_add_nomatch =
					    (getenv("TL_BSHWILD") != NULL);
				}
				if(_wildcard_add_nomatch){
					register_arg(
					  chk_strdup(intrep . unquoted),
					  nac++, 10, &maxnac, navp);
					_wildcard_match = 1;
				}
			}
		}
		discard_internal(&intrep);
	}
	if(_wildcard_check_nomatch_all && _wildcard_exist && !_wildcard_match)
		nomatch_exit();
	register_arg(NULL, nac, 1, &maxnac, navp);
	*navp = chk_realloc(*navp, sizeof(char *) * (nac + 1));
	return nac;
}

-tlunqarg.c
void	unquote_arguments(ac, av)
int	ac;
char	**av;
 /* av[1]ȍ~av[ac-1]܂ł́u'vu" "vBav[0]͂̂܂ */
{
	char	*p, *q;

	for(--ac, ++av; ac; --ac, ++av){
		for(p = q = *av; *p; p = parse_token(p, &q));
		*q = '\0';
	}
}

-tlstcmdn.c
#if defined(MSDOS) && !defined(UX_COMPILE_TEST)
#  ifdef ANNOYING_PROTO
void	setcmdname ARGDECL((char *));
#  endif
void	setcmdname(av0)
char	*av0;
{
	char	*p;
	static	char	_cmdname[CMDNMLEN+1];

	if(*av0){
		(void)last_pathsep(av0, &av0);
		for(p = cmdname = _cmdname; *av0 && *av0 != '.'; ++p, ++av0)
			*p = *av0;
		 /* DOS݊̎s`ԂłLFNT|[gł
		    R}ht@C'.'͍ō1 */
		*p = '\0';
	} /* else(DOS2̏ꍇ), cmdname͌̒l̂܂ */
}
#endif

-tlpsparg.c
#ifndef UX_COMPILE_TEST
char	*get_psp_arg()
 /* 񓯂obt@Ԃ */
{
	unsigned char	psparg_len;
	static	char	arg[0x80];
	char	far	*psp_arg;

	psp_arg = MK_FP(_psp, 0x80);
	psparg_len = *psp_arg;
	far_strncpy((char far *)arg, ++psp_arg, psparg_len);
	arg[psparg_len] = '\0';
	return arg;
}
#endif

#ifdef DEBUG
 /* ARGSUSED */
main(argc, argv)
int	argc;
char	**argv;
{
	int	i;

	argc = expand_arg(argv[0], get_psp_arg(), &argv);
	for(i = 0; i < argc; i++){
		printf("argv[%d] = '%s'\n", i, argv[i]);
	}
	return 0;
}
#endif

-tllkcmdl.c
#ifndef UX_COMPILE_TEST
char	*get_long_arg(arg)
char	*arg;
 /* R}hsAꂪCMDLINEœnĂƎvꍇA
    argւBłȂarĝ܂ܕԂ */
{
	char	*cmdl, *p, *q;
	bool	qflg;
	char	far	*psp_arg;

	if(*(psp_arg = MK_FP(_psp, 0x80)) != 0x7f || psp_arg[0x7f] != 0x0d ||
	   NULL == (cmdl = getenv("CMDLINE"))) return arg;

	for(qflg = 0, cmdl = skip_spaces(cmdl);
	    *cmdl && (qflg || !is_space(*cmdl)); ++cmdl)
		if(*cmdl == '"') qflg ^= 1;
	 /* u"v̂parse_token()gȂ
	    cmdlɑ΂skip_spaces()͕svƎv邪Ô */

	for(p = skip_spaces(arg), q = skip_spaces(cmdl);
	    *p && *p != 0x0d; ++p, ++q)
		if(*p != *q) return arg; /* ̃`FbNÔ */
	return cmdl; /* _osmajor͂킴ƃ`FbNĂȂ */
}
#endif

-tlsfnd1s.c
unsigned _dos_sfindfirst(s, a, f)
char	*s;
unsigned a;
struct	find_t	*f;
 /* LFNT|[gDOSLFN܂ރfBNgT[`LFNGg
    ̂r邽 */
{
	if(!(a = _dos_findfirst(s, a, f))){
		while(isVFATattr(f -> attrib) && !(a = _dos_findnext(f)));
	}
	return a;
}

-tlsfndnx.c
unsigned _dos_sfindnext(f)
struct	find_t	*f;
{
	int	a;

	while(!(a = _dos_findnext(f)) && isVFATattr(f -> attrib));
	return a;
}

-tllfnvar.c
#ifdef SUPP_LFN
#  ifndef UX_COMPILE_TEST
int	_lfnsupp_level = LFN_NOSUPP; /* ŏLFNT|[gOS */
#  else
int	_lfnsupp_level = LFN_FULL;
#  endif
int	_norestore21_onexec = 0; /* boolean, user modifiable */
#endif

-tlchklfn.c
#ifdef SUPP_LFN
#  ifndef UX_COMPILE_TEST
int	chk_lfnsupp()
{
	union	REGS	in, out;
	struct	SREGS	segreg;
	static	char	dmyroot[] = "?:\\";

	if(*dmyroot != '?') return (int)*dmyroot;

	in . h . ah = 0x19;
	intdos(&in, &out);
	*dmyroot = out . h . al + 'a';

	in . x . ax = 0x71a0;
	in . x . si = FP_OFF(dmyroot);
	segreg . ds = FP_SEG((char far *)dmyroot);
	in . x . cx = 0; /* ̏ꍇesdi͐ݒsvcƎv */
	intdosx(&in, &out, &segreg);
	return *dmyroot = (char)(out . x . ax != 0x7100);
	 /* ̂ƂA啶ʌǂ͖̏ */
}
#  endif
#endif

-tlprelfn.c
/* int 21h̃t@NVR[̂71xxhɂւ
cgroup	group	text
text	cseg
	rs	100h

_oint21:
	db	0eah	; jmpf
_oint21_addr:
	db	0,0,0,0

_chk_norestore21: ; esƃtO int21؂ւȂcyŖ߂
		  ; dsςĂĂv
	push	si
	db	0beh
	db	0,0		; mov si,XXXXh
	mov	es,si
	db	26h,83h,3eh
	db	0,0
	db	01h		; cmp es:[XXXX].w,1
	pop	si
	ret

_fin_repl:
	pushf
	call	_restore21
	popf
	db	0eah	; jmpf
_ofin_addr:
	db	0,0,0,0

_get_ip: ; si_ip_originBsiȊOs(tO)
	call	_ip_origin
_ip_origin:
	pop	si
	ret

_int21_repl: ; jump to here
	push	si
	push	bx
	pushf

	cmp	ah,39h
	jz	_type2
	cmp	ah,3ah
	jz	_type2
	cmp	ah,3bh
	jz	_type2
	cmp	ah,41h
	jz	_type2

	cmp	ah,43h
	jnz	_cont1
	cmp	al,1
	jna	_type2
_cont1:

	cmp	ah,56h
	jz	_type2
	; cmp	ah,60h		; 60h͏ʌ݊łȂ̂Œu͂Ȃ
	; jz	_type3

	cmp	ah,3ch
	jz	_type6
	cmp	ah,3dh
	jz	_type5
	cmp	ah,5bh
	jz	_type7

	cmp	ah,4bh
	jnz	_cont2
	cmp	al,1h
	jna	_type1
	cmp	al,3h
	jz	_type1
_cont2:

	cmp	ah,6ch
	jnz	_pop_then_o21

	; 6ch
	mov	ax,716ch
_pop_then_o21:
	popf
	pop	bx
	pop	si
	jmp	_oint21

_type3:	; 60h
	; popf
	; xchg	ax,bx
	; call	_conv_sfn
	; jmp	_chk_axerr

_type2:	; 39h-3bh, 41, 4300h, 4301h, 56h
	xor	si,si	; for 41h
	popf
	xchg	ax,bx	; for 43h, move al to bl
	mov	al,bh
	mov	ah,71h
	int	21h	; original ax is now in bx (maybe preserved by these
			; funcs: 7139-3bh 7141h 714300-01h 7156h 716001h)
_chk_axerr:
	jc	_type2_iret
	xchg	ax,bx	; restore ax if not err
_type2_iret:
	jmp	_iret_common

_type5:	; 3dh
	mov	ah,al
	mov	al,1h
	jmp	_716ch_common
_type6:	; 3ch
	mov	ax,0212h
	jmp	_716ch_common
_type7:	; 5bh
	mov	ax,0210h
_716ch_common:
	xchg	ax,dx
	xchg	ax,si
	xor	bx,bx
	xchg	bl,dh
	mov	ax,716ch
	popf
	push	cx
	int	21h
	pop	cx
	mov	dx,si	; maybe si is preserved by 716ch

_iret_common: ; X^bNcfɌʂ𔽉fAbx sȉpopiret
	mov	si,sp
	jc	_cy_iret
	and	ss:[si+8].b,0feh
	jmp	_pop_iret
_cy_iret:
	or	ss:[si+8].b,1
_pop_iret:
	pop	bx
	pop	si
	iret

_type1:
	popf
	; ŃX^bNɂ͏ォbx si
	xchg	ax,si
	mov	ah,48h
	push	bx
	mov	bx,11h	; PATHNAMELENGTH / 16h
	 ; short filename80byteszꍇ܂ɂ??
	int	21h
	pop	bx
	jnc	_alloc_ok
	mov	ax,8		; 璷?
	jmp	_iret_common
_alloc_ok:
	push	di
	push	es
	mov	es,ax
	xor	di,di
	xchg	si,dx
	call	_conv_sfn
	xchg	ax,di
	xchg	ax,dx

	mov	di,ds
	push	es
	pop	ds		; dsς!

	jnc	_exec_main	; _conv_sfňʂŕ
	mov	ax,2
_exec_fin:
	mov	ds,di		; dsA
	mov	dx,si
	push	ax
	pushf
	mov	ah,49h
	int	21h
	popf
	pop	ax
	pop	es
	pop	di
	jmp	_iret_common
_exec_main: ; ɗ鎞ds͕ςĂ
	call	_chk_norestore21
	pop	es
	jnc	_call_exec
	call	_restore21
_call_exec:
	pushf
	push	cs
	cli
	call	_oint21	; ȏ4Xebvint21h̑

	push	es
	pushf
	call	_chk_norestore21
	jnc	_exec_pop_ret
	call	_sw21
_exec_pop_ret:
	popf
	push	ds
	pop	es
	jmp	_exec_fin

_restore21:
	clc
_sw21:	; cyŌĂԂint21uAncŌĂԂƌ߂BWX^s
	; dsςĂĂv
	push	ds
	push	si
	push	ax
	pushf
	mov	si,0
	mov	ds,si
	call	_get_ip
	cli
	jc	_repl21	; ܂ł̓L[ۑĂȂĂ͂ȂȂ
	mov	ax,cs:[si+(_oint21_addr-_ip_origin)]
	mov	[84h],ax	; ds0ɂȂĂ
	mov	ax,cs:[si+(_oint21_addr-_ip_origin)+2]
	mov	[86h],ax
	jmp	_sw21_common
_repl21:
	mov	ax,si
	add	ax,(_int21_repl-_ip_origin)
	xchg	ax,[84h]
	mov	cs:[si+(_oint21_addr-_ip_origin)],ax
	mov	ax,cs
	xchg	ax,[86h]
	mov	cs:[si+(_oint21_addr-_ip_origin)+2],ax
_sw21_common:
	popf		; restore intr flg also
	pop	ax
	pop	si
	pop	ds
	ret

_conv_sfn:		; ax
	mov	ax,7160h
	push	cx
	mov	cx,1
	int	21h
	pop	cx
	ret

	end
*/
#if defined(SUPP_LFN) && !defined(UX_COMPILE_TEST)
static	char	repl_int21[] = {
	0xea, 0,    0,	  0,	0,    0x56, 0xbe, 0,
	0,    0x8e, 0xc6, 0x26, 0x83, 0x3e, 0,	  0,
	0x01, 0x5e, 0xc3, 0x9c, 0xe8, 0xef, 0x00, 0x9d,
	0xea, 0,    0,	  0,	0,    0xe8, 0x00, 0x00,
	0x5e, 0xc3, 0x56, 0x53, 0x9c, 0x80, 0xfc, 0x39,
	0x74, 0x46, 0x80, 0xfc, 0x3a, 0x74, 0x41, 0x80,
	0xfc, 0x3b, 0x74, 0x3c, 0x80, 0xfc, 0x41, 0x74,
	0x37, 0x80, 0xfc, 0x43, 0x75, 0x04, 0x3c, 0x01,
	0x76, 0x2e, 0x80, 0xfc, 0x56, 0x74, 0x29, 0x80,
	0xfc, 0x3c, 0x74, 0x39, 0x80, 0xfc, 0x3d, 0x74,
	0x2e, 0x80, 0xfc, 0x5b, 0x74, 0x34, 0x80, 0xfc,
	0x4b, 0x75, 0x08, 0x3c, 0x01, 0x76, 0x51, 0x3c,
	0x03, 0x74, 0x4d, 0x80, 0xfc, 0x6c, 0x75, 0x03,
	0xb8, 0x6c, 0x71, 0x9d, 0x5b, 0x5e, 0xeb, 0x90,
	0x33, 0xf6, 0x9d, 0x93, 0x8a, 0xc7, 0xb4, 0x71,
	0xcd, 0x21, 0x72, 0x01, 0x93, 0xeb, 0x1e, 0x8a,
	0xe0, 0xb0, 0x01, 0xeb, 0x08, 0xb8, 0x12, 0x02,
	0xeb, 0x03, 0xb8, 0x10, 0x02, 0x92, 0x96, 0x33,
	0xdb, 0x86, 0xde, 0xb8, 0x6c, 0x71, 0x9d, 0x51,
	0xcd, 0x21, 0x59, 0x8b, 0xd6, 0x8b, 0xf4, 0x72,
	0x07, 0x36, 0x80, 0x64, 0x08, 0xfe, 0xeb, 0x05,
	0x36, 0x80, 0x4c, 0x08, 0x01, 0x5b, 0x5e, 0xcf,
	0x9d, 0x96, 0xb4, 0x48, 0x53, 0xbb, 0x11, 0x00,
	0xcd, 0x21, 0x5b, 0x73, 0x05, 0xb8, 0x08, 0x00,
	0xeb, 0xdb, 0x57, 0x06, 0x8e, 0xc0, 0x33, 0xff,
	0x87, 0xf2, 0xe8, 0x75, 0x00, 0x97, 0x92, 0x8c,
	0xdf, 0x06, 0x1f, 0x73, 0x13, 0xb8, 0x02, 0x00,
	0x8e, 0xdf, 0x8b, 0xd6, 0x50, 0x9c, 0xb4, 0x49,
	0xcd, 0x21, 0x9d, 0x58, 0x07, 0x5f, 0xeb, 0xb5,
	0xe8, 0x1a, 0xff, 0x07, 0x73, 0x03, 0xe8, 0x15,
	0x00, 0x9c, 0x0e, 0xfa, 0xe8, 0x09, 0xff, 0x06,
	0x9c, 0xe8, 0x09, 0xff, 0x73, 0x03, 0xe8, 0x06,
	0x00, 0x9d, 0x1e, 0x07, 0xeb, 0xd2, 0xf8, 0x1e,
	0x56, 0x50, 0x9c, 0xbe, 0x00, 0x00, 0x8e, 0xde,
	0xe8, 0x0a, 0xff, 0xfa, 0x72, 0x10, 0x2e, 0x8b,
	0x44, 0xe1, 0xa3, 0x84, 0x00, 0x2e, 0x8b, 0x44,
	0xe3, 0xa3, 0x86, 0x00, 0xeb, 0x17, 0x8b, 0xc6,
	0x05, 0x02, 0x00, 0x87, 0x06, 0x84, 0x00, 0x2e,
	0x89, 0x44, 0xe1, 0x8c, 0xc8, 0x87, 0x06, 0x86,
	0x00, 0x2e, 0x89, 0x44, 0xe3, 0x9d, 0x58, 0x5e,
	0x1f, 0xc3, 0xb8, 0x60, 0x71, 0x51, 0xb9, 0x01,
	0x00, 0xcd, 0x21, 0x59, 0xc3,
}; /* ̃[`ł̐Έʒuwł̃WvR[Ȃ */
#define orig_int21_adr (repl_int21 + 0x1)
#define r21onexf_seg (repl_int21 + 0x7)
#define r21onexf_off (repl_int21 + 0xe)
#define modified_pend (repl_int21 + 0x13)
#define orig_pend_adr (repl_int21 + 0x19)
#define modified_int21 (repl_int21 + 0x22)

void	expand_hook_default()
 /* chk_lfnsupp()̒lyъϐTL_USELFNɂ_lfnsupp_levelύXA
    KvȂLFNT|[g̏ */
{
	union	REGS	in, out;
	struct	SREGS	segreg;
	char	*lfnenv;
	void	(*osig)();

	if(_lfnsupp_level != LFN_NOSUPP || !chk_lfnsupp()) return;
	 /* chk_lfnsupp()UȂ_lfnsupp_level͏lLFN_NOSUPP̂܂ܖ߂B
	    ̑O2xĂт̖h~ */

	if((lfnenv = getenv("TL_USELFN")) == NULL) _lfnsupp_level = LFN_FULL;
	else if(!stricmp(lfnenv, "nowild")) _lfnsupp_level = LFN_NOWILD;
	else if(!stricmp(lfnenv, "wild")) _lfnsupp_level = LFN_WILD;
	else if(!stricmp(lfnenv, "full")) _lfnsupp_level = LFN_FULL;
	else { /* case of "none" */
		_lfnsupp_level = LFN_NONE;
		return;
	}

	in . x . ax = 0x3521;
	intdosx(&in, &out, &segreg);

	/* ȉ΂炭̕ł́Adata alignment̖͂ȂƑO񂵂Ă */
	 /* IWiint21h̃AhXL2[`֖ߍ */
	*(us_short *)&orig_int21_adr[0] = out . x . bx;
	*(us_short *)&orig_int21_adr[2] = segreg . es;

	 /* ϐ_norestore21_onexec̃AhXL2[`֖ߍ */
	*(us_int *)r21onexf_seg = FP_SEG((char far *)&_norestore21_onexec);
	*(us_int *)r21onexf_off = FP_OFF(&_norestore21_onexec);

	/* psp̃IWĩvOIAhXL[`֖ߍ */
	*(us_long far *)orig_pend_adr = *(us_long far *)MK_FP(_psp, 0xa);

	 /* psp̃vOIAhXAint21h𕜋ďI
	    [`֕ύX */
	osig = signal(SIGINT, SIG_IGN);
	*(us_long far *)MK_FP(_psp, 0xa) = (us_long)(char far *)modified_pend;
	signal(SIGINT, osig);

	 /* int21h̒u */
	in . x . dx = FP_OFF(modified_int21);
	segreg . ds = FP_SEG((char far *)modified_int21);
	in . x . ax = 0x2521;
	intdosx(&in, &out, &segreg);
}
#endif /* SUPP_LFN && !UX_COMPILE_TEST */

-tllfnwld.c
#if defined(SUPP_LFN) && !defined(UX_COMPILE_TEST)
struct	ioreg {
	struct	lfind_t	*fbuf;
	unsigned datefmt;
	union	REGS	in, out;
	struct	SREGS	segreg;
};

#ifdef ANNOYING_PROTO
static	unsigned _dos_lfindsub
	ARGDECL((struct lfind_t *, unsigned, struct ioreg *));
#endif
static	unsigned _dos_lfindsub(fbuf, datefmt, regsp)
struct	lfind_t	*fbuf;
unsigned datefmt;
struct	ioreg	*regsp;
{
	unsigned ret;

	regsp -> in . x . si = datefmt;
	regsp -> in . x . di = FP_OFF(&fbuf -> attrib);
	regsp -> segreg . es = FP_SEG((char far *)(&fbuf -> attrib));

	if(0x7100 == (ret = intdosx(&regsp->in, &regsp->out, &regsp->segreg))
	   && !chk_lfnsupp()){
		errno = EINVAL;
		return ret;
	}
	 /* LFNT|[g̏ꍇƁAIănhƂ0x7100Ԃꍇ
	    ʂ̂chk_lfnsupp()gpBSTCĂINT21΂̕Kv͂Ȃ
	    ACŁAnėpł@Ȃ */

	if(regsp -> out . x . cflag){
		errno = ENOENT;
		return ret;
	}
	fbuf -> replflg = regsp -> out . x . cx;
	return 0;
}

unsigned _dos_lfindfirst(path, attr, mattr, fbuf, datefmt)
char	*path;
unsigned char attr, mattr;
struct	lfind_t	*fbuf;
unsigned datefmt;
{
	struct	ioreg	regs;
	unsigned ret;

	regs . in . x . ax = 0x714e;
	regs . in . h . ch = mattr;
	regs . in . h . cl = attr;
	regs . in . x . dx = FP_OFF(path);
	regs . segreg . ds = FP_SEG((char far *)path);
	if(!(ret = _dos_lfindsub(fbuf, datefmt, &regs))) /* errno changes */
		fbuf -> handle = regs . out . x . ax;
		 /* This handle must be closed afterward */
	return ret;
}

unsigned _dos_lfindnext(fbuf, datefmt)
struct	lfind_t	*fbuf;
unsigned datefmt;
{
	struct	ioreg	regs;

	regs . in . x . ax = 0x714f;
	regs . in . x . bx = fbuf -> handle;
	return _dos_lfindsub(fbuf, datefmt, &regs); /* errno changes */
}

unsigned _dos_lfindclose(fbuf)
struct	lfind_t	*fbuf;
 /* ĂԑOfbuf̓e͕ςȂcƎv */
{
	union	REGS	in, out;
	unsigned ret;

	in . x . ax = 0x71a1;
	in . x . bx = fbuf -> handle;
	if(0x7100 == (ret = intdos(&in, &out)) || out . x . cflag){
		errno = EINVAL;
		return ret;
	}
	return 0;
}

#ifdef ANNOYING_PROTO
static	void	_dos_Findsub_l ARGDECL((struct lfind_t *));
#endif
static	void	_dos_Findsub_l(fbuf) /* LFNT|[g̏ꍇ̂݌Ă */
struct	lfind_t	*fbuf;
{
	union	REGS	in, out;
	struct	SREGS	segreg;
	char	*s;
	int	i;

	for(s = fbuf -> ctime, i = 3; i; --i, s += 8){
		in . x . ax = 0x71a7;
		in . h . bl = 0;
		in . x . si = FP_OFF(s);
		segreg . ds = FP_SEG((char far *)s);
		if(0x7100 == intdosx(&in, &out, &segreg) || out . x . cflag){
			memset(s, '\0', 8);
		} else {
			((us_short *)s)[0] = out . x . cx;
			((us_short *)s)[1] = out . x . dx;
			s[4] = out . h . bh; /* tools[Jg:-) */
			memset(s + 5, '\0', 3);
		}
	}
	if(_lfnsupp_level == LFN_NOWILD){
	 /* SFNɂT͕ */
		if(*fbuf -> name){
			strcpy(fbuf -> lname, fbuf -> name);
			*fbuf -> name = '\0';
		}
		memset(fbuf -> ctime, '\0', 16); /* clear ctime, atime */
	}
}
#endif /* SUPP_LFN && !UX_COMPILE_TEST */

#ifdef SUPP_LFN
#define lft2ft(p) ((struct find_t *)((char *)&(p -> attrib) + 0x100))
 /* lfind_t̒̈ʒuKɌ߁Afind_t̑pɂ */
#ifdef ANNOYING_PROTO
static	void	_dos_Findsub_s ARGDECL((struct lfind_t *));
#endif
static	void	_dos_Findsub_s(fbuf)
struct	lfind_t	*fbuf;
{
	*(char *)&(fbuf -> attrib) = lft2ft(fbuf) -> attrib;
	memcpy(&(fbuf -> mtime[0]), &(lft2ft(fbuf) -> wr_time), 4);
	fbuf -> lsize = lft2ft(fbuf) -> size;
	strcpy(fbuf -> lname, lft2ft(fbuf) -> name);
}

unsigned _dos_Findfirst(path, attr, fbuf)
char	*path;
unsigned attr;
struct	lfind_t	*fbuf;
{
	unsigned ret;

#  ifndef UX_COMPILE_TEST
	if(_lfnsupp_level > LFN_NONE){
		if(!(ret = _dos_lfindfirst(path, (us_char)attr,
							(us_char)0, fbuf, 0))){
			_dos_Findsub_l(fbuf);
		} /* atime[2], ctime[2]͔T|[g̏ꍇ0(T|[gȂ
		     Œł0x21) */
	} else
#  endif /* !UX_COMPILE_TEST */
	{
		if(!(ret = _dos_sfindfirst(path, attr, lft2ft(fbuf)))){
			memset(fbuf, fbuf -> name[0] = '\0', 0x24);
			 /* hsize܂ł̃NABmemset񂵂ĂȂ
			    ̂_dos_Findclose()ĂԂ܂łFind_t̒g
			    ɏĂ͂ȂȂ _lfnsupp_level̓rύX
			     handlereplflgȂǂ0NAĂȂ */
			_dos_Findsub_s(fbuf);
		}
	}
	return ret;
}

unsigned _dos_Findnext(fbuf)
struct	lfind_t	*fbuf;
{
	unsigned ret;

#  ifndef UX_COMPILE_TEST
	if(_lfnsupp_level > LFN_NONE){
		if(!(ret = _dos_lfindnext(fbuf, 0))) _dos_Findsub_l(fbuf);
	} else
#  endif /* !UX_COMPILE_TEST */
	{
		if(!(ret = _dos_sfindnext(lft2ft(fbuf)))) _dos_Findsub_s(fbuf);
	}
	return ret;
}

unsigned _dos_Findclose(fbuf)
struct	lfind_t	*fbuf;
{
#  ifndef UX_COMPILE_TEST
	return _lfnsupp_level > LFN_NONE ? _dos_lfindclose(fbuf) : 0;
#  else
	return 0;
#  endif
}
#endif /* SUPP_LFN */

-tlcompat.c
 /* old tools compatible routines */
char	**expand_wildcard(name)
char	*name;
{
	char	*argv[2], **ret;
	int	i;

	argv[0] = "", argv[1] = name;
	i = expand_wild(2, argv, &ret);
	free(*ret);
	bcopy(ret + 1, ret, sizeof(char *) * i);
	return ret;
}

char	**expand_wildcards(names)
char	**names;
{
	int	ac;

	for(ac = 0; names[ac] != NULL; ++ac);
	expand_wild(ac, names, &names);
	return names;
}

int	string_match(ref, ptn)
char	*ref, *ptn;
{
	int	ret;
	WILD_INTERNAL	intrep;

	parse_wild(ptn, &intrep);
	ret = name_match(ref, &intrep);
	discard_internal(&intrep);
	return ret;
}

-tl4wcimp.c
 /* WATCOM CIMPLICIT_EXPARG̏ꍇAWATCOM̃X^[gAbv[`ł
    ϐݒ肳ĂȂ(炵)getenv()s邱Ƃւ̑΍
    jR͖̉삳ɂ(Afree()ȂĂ悢悤ύX) */
#if defined(__WATCOMC__) && defined(IMPLICIT_EXPARG)
#  undef getenv /* ł getenv()  eseg_getenv() ɂȂĂ͂Ȃ */
/**  WATCOM łgȂ̂ Prototype `ŋLq  **/

static	char	*envptr = NULL;
 /* NULLc蓖 NULSTRcȌ͕ʂgetenv()g */

void	free_eseg_env(void)
{
	if(envptr != NULSTR){
		if(envptr != NULL) free(envptr);
		envptr = NULSTR;
	}
}

char	*eseg_getenv(char *ename)
{
	char	*ep;
	int	enamelen;

	if(envptr == NULSTR) return getenv(ename);

	if(envptr == NULL){
		char	far	*farenvptr = NULL, far	*farp;
		union	REGS	regs;

		regs . h . ah = 0x62;	/* get Program-segment adrs */
		intdos(&regs, &regs);
		farenvptr = MK_FP(
			*(WREGTYPE far *)MK_FP(regs . x . bx, 0x2c), 0);
		for(farp = farenvptr; *farp; farp += far_strlen(farp) + 1);
		farp++;
		envptr = chk_malloc(farp - farenvptr); /* 64KȂ͂ */
		far_memcpy((char far *)envptr, farenvptr, farp - farenvptr);
	}

	for(enamelen = strlen(ename), ep = envptr; *ep; ep += strlen(ep) + 1)
		if(!strncmp(ename, ep, enamelen) && *(ep += enamelen) == '=')
			return ++ep;
	return NULL;
}
#endif /* __WATCOMC__ && IMPLICIT_EXPARG */

-- libr header for MSC misc
#ifdef MSC51
#  include <dos.h>
#  include <stddef.h>
#endif
/* do not #include "tools.h" */

-tlformsc.c
  /* MSCȊȌꍇ͂̃t@Cł̒`͂Ȃ */

#ifdef MSC51
  /* MSC 5.1FP_OFF, FP_SEG̒`I{Ȃ߂̑[uB
     邪AMSCI{Ȃ̂:-p */
unsigned fpoff4msc(void far *p)
{
	return FP_OFF(p);
}
unsigned fpseg4msc(void far *p)
{
	return FP_SEG(p);
}

  /* MSC 5.1pfarstrncpy֐ȂǁBjR͖̉삳ɂ */
size_t	fstrlen(const char far *s)
{
	size_t	ret = 0;

	while(*s++) ret++;
	return ret;
}

char	far	*fstrncpy(char far *s, const char far *t, size_t n)
{
	char	far	*ret = s;
	size_t	ts = fstrlen(t);

	while(n--){
		if(ts){
			*s++ = *t++;
			ts--;
		} else {
			*s++ = '\0';
		}
	}
	return ret;
}

char	far	*fstrcpy(char far *dst, const char far *src)
{
	register char	far	*dist = dst;

	do {
		*dist++ = *src;
	} while (*src++);
	return dst;
}

int	fstrncmp(const char far *s1, const char far *s2, size_t n)
{
	size_t	j;

	for(j = 0; j < n; j++, s1++, s2++){
		if((*s1 && *s2) && (*s1 == *s2))
			continue;
		if(*s1 < *s2)
			return -1;
		else
			return 1;
	}
	return 0;
}

void	far	*fmemmove(void far *dst, void far *src, size_t len)
{
	char	dir = 0;
	register char	huge	*dist = dst;
	register char	huge	*source = src;
	size_t	j;

	if((source < dist) && (dist < (source + len))){
		dir = 1;
		source += len - 1;
		dist += len - 1;
	}
	if(dir == 0){
		for(j = 0; j < len; j++){
			*dist++ = *source++;
		}
	} else {
		for(j = 0; j < len; j++){
			*dist-- = *source--;
		}
	}
	return dst;
}

# ifdef DEMO
#  include	<stdio.h>
#  include	<string.h>
char	*s11 = "abcdef";
char	*s12 = "abcDEF";
char	*s21 = "abc";

int	main(void)
{
	printf("strncmp(%s, %s, 3)= %d\n", s11, s21, strncmp(s11, s21, 3));
	printf("strncmp(%s, %s, 4)= %d\n", s11, s12, strncmp(s11, s12, 4));
	printf("strncmp(%s, %s, 4)= %d\n", s21, s11, strncmp(s21, s11, 4));
	printf("fstrncmp(%s, %s, 3) = %d\n", s11, s21, fstrncmp(s11, s21, 3));
	printf("fstrncmp(%s, %s, 4) = %d\n", s11, s12, fstrncmp(s11, s12, 4));
	printf("fstrncmp(%s, %s, 4) = %d\n", s21, s11, fstrncmp(s21, s11, 4));

	return 0;
}
# endif /* DEMO */
#endif /* MSC51 */
#ifdef LSI_C /* `󂾂ƕ */
typedef	int	dummy;
#endif
