#ifdef MSDOS /*	DOStouch */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <dos.h>
#include "tools.h"

char	*cmdname = "touch";

#define FATALEXIT 1 /* -1? */

#define CANNOT	    1 /* ̎擾ݒɎs */
#define CANNOT_DIR  2 /* AAΏۂDirł邱Ƃ̏ꍇ */
#define CANNOT_VOL  3 /* TufBNgVol̎ݒ肵悤ƂĎs */
#define FAIL_NOMORE 4 /* nomoreɎs */
#define CANNOT_LOCK 5 /* LockĂȂƂ̎s */

#define DIRSIZ 32

struct	dt_str {
#ifdef SUPP_LFN
	char	c_tm[7], a_tm[7], m_tm[7];
	 /* each y, m, d, h, m, s, s/100 */
#else
	char	m_tm[7];
#endif
};

static	struct dt_ms1 {
	us_short date, time;
	us_char	s100;
} curtime;
struct	dt_msfmt {
#ifdef SUPP_LFN
	struct	dt_ms1	c_tm, a_tm, m_tm;
#else
	struct	dt_ms1	m_tm;
#endif
};

static	int	time_mode = 0; /* 1:mtime 2:atime 4:ctime 8:noopt */

static	void	cmd_errmsg(s)
char	*s;
{
	fputs(cmdname, stderr), fputs(": ", stderr), fputs(s, stderr);
}

static	istimestring(s)
 /* 8/10/12+u.v+2/4Ȃ1A4/14Ȃ2AȊO0 */
char	*s;
{
	char	*p, *q;

	for(p = s; is_digit(*p); p++);
	switch(p - s){
	case 12: case 10: case 8:
		switch(*p){
		case '\0':
			return 1;
		case '.':
			for(q = ++p; is_digit(*q); q++);
			if(!*q) switch(q - p){case 2: case 4: return 1;}
		}
		break;
	case 4: case 14:
		if(!*p) return 2;
	}
	return 0;
}

static	void	dtconv_sub(dt_string, dt_ms1_buf, flag)
char	*dt_string; /* y, m, d, h, m, s, s/100 */
struct	dt_ms1	*dt_ms1_buf;
int	flag;
{
	if(flag){
		dt_ms1_buf -> date =
			(dt_string[0] << 9) |
			(dt_string[1] << 5) | dt_string[2];
		dt_ms1_buf -> time =
			(dt_string[3] << 11) |
			(dt_string[4] << 5)  | (dt_string[5] >> 1);
		dt_ms1_buf -> s100 =
			(dt_string[5] & 1) * 100 + dt_string[6];
	} else {
		dt_string[0] = (char)( (dt_ms1_buf -> date >> 9) & 0x7f);
		dt_string[1] = (char)( (dt_ms1_buf -> date >> 5) & 0xf);
		dt_string[2] = (char)( (dt_ms1_buf -> date)	 & 0x1f);
		dt_string[3] = (char)( (dt_ms1_buf -> time >> 11)& 0x1f);
		dt_string[4] = (char)( (dt_ms1_buf -> time >> 5) & 0x3f);
		dt_string[5] = (char)(((dt_ms1_buf -> time << 1) & 0x3f) +
				      ( dt_ms1_buf -> s100 / 100));
		dt_string[6] = (char)(	dt_ms1_buf -> s100 % 100);
	}
}

static	void	dtconv(dt_buf, dt_ms_buf, flag)
struct	dt_str	*dt_buf;
struct	dt_msfmt *dt_ms_buf;
int	flag;
{
#ifdef SUPP_LFN
	dtconv_sub(dt_buf -> c_tm, &(dt_ms_buf -> c_tm), flag);
	dtconv_sub(dt_buf -> a_tm, &(dt_ms_buf -> a_tm), flag);
#endif
	dtconv_sub(dt_buf -> m_tm, &(dt_ms_buf -> m_tm), flag);
}

static	void	fbufdtconv_sub(dt_ms1_buf, fbuf_tm_pos)
struct	dt_ms1	*dt_ms1_buf;
char	*fbuf_tm_pos;
{
	dt_ms1_buf -> time = ((us_short *)fbuf_tm_pos)[0];
	dt_ms1_buf -> date = ((us_short *)fbuf_tm_pos)[1];
	dt_ms1_buf -> s100 = fbuf_tm_pos[4];
}

static	void	fbufdtconv(dt_buf, fbuf)
struct	dt_str	*dt_buf;
struct	Find_t	*fbuf;
{
	struct	dt_msfmt dt_ms_tmpbuf;

#ifdef SUPP_LFN
	fbufdtconv_sub(&dt_ms_tmpbuf . m_tm, fbuf -> mtime);
	fbufdtconv_sub(&dt_ms_tmpbuf . a_tm,
			fbuf -> atime[2] ? fbuf -> atime : fbuf -> mtime);
	fbufdtconv_sub(&dt_ms_tmpbuf . c_tm,
			fbuf -> ctime[2] ? fbuf -> ctime : fbuf -> mtime);
#else
	fbufdtconv_sub(&dt_ms_tmpbuf . m_tm, (us_char *)&fbuf -> wr_time);
		/* wr_timewr_dateAoCgɂ邱Ƃ͉ */
#endif
	dtconv(dt_buf, &dt_ms_tmpbuf, 0);
}

static	char	*delimfind(s)
char	*s;
 /* ́u\v̈ʒuBȂΖ */
{
	for(; *s; s++){
		if(iskanjipos(s)){s++; continue;}
		if(*s == '\\' || *s == '/') break;
	}
	return s;
}

static	nomore(fnm, hndl) /* hndl must be opened. returns 0 if success */
char	*fnm;
int	hndl;
{
	union	REGS	in, out;
	int	drv;
	long	fre;

	if(0 >= (drv = getfullpath_drv(NULL, fnm, -1))) return -1;
	in . h . dl = (us_char)drv;
	in . h . ah = 0x36;
	if(-1 == intdos(&in, &out)) return -1;

	fre = (long)(out . x . ax) * out . x . bx * out . x . cx;
	in . x . dx = (int)fre;
	in . x . cx = (int)(fre >> 16);
	in . x . ax = 0x4200;
	in . x . bx = hndl;
	intdos(&in, &out);
	if(out . x . cflag) return -1;

	in . h . ah = 0x40;
	in . x . cx = 0;
	in . x . bx = hndl;
	intdos(&in, &out);
	return (out . x . cflag) ? -1 : 0;
	 /* hndl̓I[v܂ */
}

#ifndef NOMODDIR
static	void	uk_error(n)
int	n;
{
	static	char	msg[] = "Unknown error 0\n";

	msg[sizeof(msg) - 3] += (char)n, cmd_errmsg(msg), exit(1);
}

static	fbasecmp(s, p)
char	*s, *p;
 /* vȂΔ0Bs̓VXeR[0x60œpẌꕔAp
    fBNgGg̒gBƂɑ啶̂͂ */
{
	char	*q, c;

	if(c = p[0xb], isVFATattr(c)) return 1;
	for(q = p; p < q + 8; p++){
		if((c = *p) == ' ') continue;
		if((us_char)c < ' ' && !(c == 5 && p == q)) uk_error(9);
		if(c != *s++) return 1;
	}
	if((c = *s) != '\0' && (++s, c != '.')) return 1;
	for(; p < q + 11; p++){
		if((c = *p) == ' ') continue;
		if((us_char)c < ' ') uk_error(9);
		if(c != *s++) return 1;
	}
	return *s;
}

static	void	diskreset()
{
	union	REGS	in;

	in . h . ah = 0xd;
	intdos(&in, &in);
}

static	moddirsub(drv, s, cluno, rwbuf, farp,
		secsiz, attr, old_mdate, old_mtime, new_dt)
int	drv;
us_int	cluno, secsiz;
char	*s, attr, *rwbuf;
char	far	*farp;
us_short old_mdate, old_mtime; /* fBNgGgƂ̔rp */
struct	dt_str	*new_dt;
{ /* moddirdatěĂяoɌcluno0 */
	us_long	fatsec, secno, seclast;
	us_int	fatkind;
	us_long	newcluno;
	char	*p, *delimpos;
	struct	dt_msfmt new_msdt;

	delimpos = delimfind(s);
	if(*delimpos) *delimpos++ = '\0';
	 /* delimpoś͎u\v̎AȂΖ */
	if(*s == 0xe5) *s = 5;

	for(;;){
		if(cluno){
			secno = (((us_long)(cluno - 2)) << farp[5]) +
						*(us_int far *)(farp + 0xb);
			seclast = secno + farp[4] + 1;
		} else {
			secno = *(int far *)(farp +
					     (_osmajor >= 4 ? 0x11 : 0x10));
			 /* secnoɃ[g̃ZN^ԍ */
			seclast = *(int far *)(farp + 0xb);
		}
		for(; secno < seclast; secno++){
			if(absdiskrw(0, drv, (char far *)rwbuf, secno, 1) >> 8)
				uk_error(1);
			 /* drv, secnoabsdiskrwł݂̏܂ŕۑ
			    rwbufKvӏȊOȂ */
			for(p = rwbuf; p < rwbuf + secsiz; p += DIRSIZ){
			 /* fBNg̃TCYłGgԁc */
				if(!*p) uk_error(2);
				if(fbasecmp(s, p)) continue;
				 /* *p == 0xe5 ̔f͂Ɋ܂܂ */

				if(*delimpos){
					if(!(p[0xb] & _A_SUBDIR)) continue;

					cluno = *(us_int *)(p + 0x1a);
					if(cluno < 2) /* always -2? */
						uk_error(3);
					 /* ̃t@CȂ炱cluno0
					    Ȃ̂AfBNgȂ̂
					    `.'`..'̃Gg͕KA
					    0ɂ͂ȂȂ */
					return moddirsub(drv, delimpos, cluno,
						rwbuf, farp, secsiz, attr,
						old_mdate, old_mtime, new_dt);
				}
				if(p[0xb] != attr) continue;

				if(*(us_short *)(p + 0x16) != old_mtime ||
				   *(us_short *)(p + 0x18) != old_mdate ||
				   *(long *)(p + 0x1c))
					uk_error(4);
				 /* ɂ̂̓fBNgƃ{[
				    xTCY0̂͂ */

				dtconv(new_dt, &new_msdt, 1);
				 /* ڏ݂Őݒ */
				if(time_mode & (1|8)){ /* mtime */
					*(us_short *)(p + 0x16) =
						new_msdt . m_tm . time;
					*(us_short *)(p + 0x18) =
						new_msdt . m_tm . date;
				}
#ifdef SUPP_LFN
				if(time_mode & (2|8)){ /* atime */
					*(us_short *)(p + 0x12) =
						new_msdt . a_tm . date;
				} /* time not supported */
				if(time_mode & 4){ /* ctime */
					p[0xd]=	new_msdt . c_tm . s100;
					*(us_short *)(p + 0xe) =
						new_msdt . c_tm . time;
					*(us_short *)(p + 0x10) =
						new_msdt . c_tm . date;
				}
#endif
				if(no_diskwrt(drv + 1))	return CANNOT_LOCK;
				if(absdiskrw(1, drv, (char far *)rwbuf,
						secno, 1) >> 8)	return CANNOT;
				diskreset();
				return 0;
			}
		}

		if(cluno){
			if(_osmajor >= 4){
				if(absdiskrw(0, drv, (char far *)rwbuf,
								0L, 1) >> 8)
					uk_error(5);
				fatkind = rwbuf[0x39] * 10 + rwbuf[0x3a] -
					  '0' * 11;
				if(fatkind != 12 && fatkind != 16)
					uk_error(6);
			} else fatkind = 12;

			fatsec = *(int far *)(farp + 6);
			if(absdiskrw(0, drv, (char far *)rwbuf, fatsec +
			     (us_long)cluno * fatkind / 8 / secsiz, 2) >> 8)
				uk_error(7);
			 /* secsiz2{̃obt@ŕKvB
			    FAT12, 16̂ǂ炩 */
			newcluno = *(us_long *)(rwbuf +
			    (us_int)(((us_long)cluno * fatkind / 8) % secsiz));
			newcluno >>= ((us_long)cluno * fatkind) % 8;
			cluno = (us_int)newcluno;
			cluno &= (us_int)(-1) >> (-fatkind % 16);
			if(cluno < ((us_int)(-1) >> (-fatkind % 16)) - 7 &&
			   cluno >= 2) continue;
		}
		uk_error(8);
	}
}

static	moddirdate(s, attr, old_mdate, old_mtime, new_dt)
char	*s, attr;
struct	dt_str	*new_dt;
us_short old_mdate, old_mtime;
 /* Ԃl0, CANNOT, CANNOT_VOL, CANNOT_LOCK̂ǂꂩB
    Win95ł̓fBNgtouch̏ꍇɂ͂͌Ă΂Ȃ͂ */
{
	union	REGS	in, out;
	struct	SREGS	segreg;
	char	pbuf[PATHNAMELENGTH];

	char	far	*farp;
	int	drv;
	static	char	*rwbuf = NULL;
	us_int	secsiz;

	if(0 != absolute_pathname(s, pbuf) || !is_alpha(*pbuf)) return CANNOT;
	 /* pbuf: ΃pXBWin95̏ꍇ{[xtouchł
	    Ȃ̂ŏSFNabsolute pathname߂΂͂ */
	s = pbuf + 3;
	if((attr & _A_VOLID) && s != filename_base(s)) return CANNOT_VOL;

	in . h . ah = 0x32;
	in . h . dl = (us_char)(drv = tolower(*pbuf) - 'a') + 1;
	 /* drv: hCu A=0 B=1c */
	if((char)intdosx(&in, &out, &segreg)) return CANNOT;
	farp = MK_FP(segreg . ds, out . x . bx);
	secsiz = *(us_int far *)(farp + 2);
	rwbuf = chk_realloc(rwbuf, secsiz * 2);
	 /* ̓ssecsiz2{قǊm */

	return moddirsub(drv, s, 0, rwbuf, farp, secsiz,
				attr, old_mdate, old_mtime, new_dt);
}
#endif

static	filedate(s, flag, dt_buf, diralso)
char	*s;
int	flag;
struct	dt_str	*dt_buf;
bool	diralso;
 /* flag: -1c擾A0cݒA1cݒ(Ȃ΍쐬Ă)A2cݒ(Ȃ
    쐬EnomoreĂ)B0 sCANNOT, CANNOT_DIR, FAIL_NOMORE,
    CANNOT_LOCKԂBdiralso0ȂfBNg{[xɂ
    ݒBdiralso0łfBNg{[x̎擾͍s */
{
	int	hndl, status = 0;
	union	REGS	in, out;
	struct	SREGS	segreg;
	struct	Find_t	fbuf;
	struct	dt_msfmt new_msdt;
#ifdef SUPP_LFN
	us_int	orig_adate = 0;
#endif

	if(!contains_nowild(s)) return CANNOT;
	 /* DOSɂ*?܂ރt@C݂͑Ȃ̂ */

	in . x . dx = FP_OFF(s);
	segreg . ds = FP_SEG((char far *)s);
#ifdef SUPP_LFN
	 /* utimeݒ̏ꍇutimeςʂ悤AI[vOɌutime
	    ۑĂ */
	if(!(time_mode & (2|8)) && _lfnsupp_level >= LFN_NONE){
		in . x . ax = 0x7143;
		in . h . bl = 6;
		intdosx(&in, &out, &segreg);
		if(!out . x . cflag) orig_adate = out . x . di; /* >=0x21 */
	}
#endif

	in . x . ax = 0x3d00; /* t@C̃I[v */
	if(!_dos_xFind_soonclose(s, 0x37, &fbuf)){
	 /* ʏt@CorfBNg */
		if(flag < 0){ /* 擾 */
			fbufdtconv(dt_buf, &fbuf);
			return 0;
		} else { /* ݒ */
			flag = 0;
			if((char)fbuf . attrib & _A_SUBDIR){
			 /* fBNgł */
#ifndef NOMODDIR
				if(!diralso) return CANNOT_DIR;
#  ifdef SUPP_LFN
				if(_lfnsupp_level >= LFN_NONE){
					int	retstat = 0;

					dtconv(dt_buf, &new_msdt, 1);

					 /* fBNgւ̐ݒ(Win95) */
					in . x . ax = 0x7143;
					if(time_mode & (1|8)){ /* mtime */
						in . h . bl = 3;
						in . x . di =
							new_msdt . m_tm . date;
						in . x . cx =
							new_msdt . m_tm . time;
						intdosx(&in, &out, &segreg);
						if(out . x . cflag)
							retstat = CANNOT;
					}
#ifdef TOUCH_ATIME_DIR_IF_NOOPT
					if(time_mode & (2|8))
#else
					if(time_mode & 2)
#endif
					{ /* atimeBWin95ł́AamC̖w肪
					     ȂfBNg̏ꍇatime͐ݒ
					     Ȃ */
						in . h . bl = 5;
						in . x . di =
							new_msdt . a_tm . date;
						 /* time not supported */
						intdosx(&in, &out, &segreg);
						if(out . x . cflag)
							retstat = CANNOT;
					}
					if(time_mode & 4){ /* ctime */
						in . h . bl = 7;
						in . x . di =
							new_msdt . c_tm . date;
						in . x . cx =
							new_msdt . c_tm . time;
						in . x . si =
							new_msdt . c_tm . s100;
						intdosx(&in, &out, &segreg);
						if(out . x . cflag)
							retstat = CANNOT;
					}

					return retstat;
				}
				return moddirdate(s, (char)fbuf . attrib,
				    *(us_short *)&fbuf . mtime[2],
				    *(us_short *)&fbuf . mtime[0], dt_buf);
#  else
				return moddirdate(s, (char)fbuf . attrib,
				    fbuf . wr_date, fbuf . wr_time, dt_buf);
#  endif /* SUPP_LFN */
#else
				return CANNOT_DIR;
#endif /* !NOMODDIR */
			} /* łȂΕʂɐݒ */
		}
	} else if(!_dos_Find_soonclose(s, _A_VOLID, &fbuf)){
	 /* ʏt@CorfBNg݂Ȃ {[xȂ炠 */
		if(flag < 0){ /* 擾 */
			fbufdtconv(dt_buf, &fbuf);
			return 0;
		} else {
#ifndef NOMODDIR
			if(diralso){
				int	ret;

#  ifdef SUPP_LFN
				ret = moddirdate(s, (char)fbuf . attrib,
				    *(us_short *)&fbuf . mtime[2],
				    *(us_short *)&fbuf . mtime[0], dt_buf);
#  else
				ret = moddirdate(s, (char)fbuf . attrib,
				    fbuf . wr_date, fbuf . wr_time, dt_buf);
#  endif /* SUPP_LFN */
				if(ret != CANNOT_VOL) return ret;
			}
			 /* TufBNgɂ̓{[x̎̂͂ȂB
			    ̎̓t@CƂƂȂꍇƓ
			    B܂(flag>0Ȃ)쐬ݒɈڍs */
#endif /* !NOMODDIR */
			goto notexist;
		}
	} else { /* {[xȂ */
	notexist:
		if(flag > 0){
			in . h . ah = 0x5b; /* VK쐬ɕύX */
			in . x . cx = 0x20;
		} else {
			return CANNOT;
		}
	}

	 /* ɗ̂͐ݒ肩쐬ݒ̎B̎_flaǵAݒ݂̂
	    ꍇ0Aۂɍ쐬Đݒ̏ꍇ1(nomoreȂ2) */
	intdosx(&in, &out, &segreg);
	if(out . x . cflag) return CANNOT;

	in . x . bx = hndl = out . x . ax;
	if(flag > 1 && 0 != nomore(s, hndl)) status = FAIL_NOMORE;
	dtconv(dt_buf, &new_msdt, 1);
	 /* ݒBstatusCANNOTFAIL_NOMORED */
	in . x . ax = 0x5701;
	if(time_mode & (1|8)){ /* mtime */
		in . x . dx = new_msdt . m_tm . date;
		in . x . cx = new_msdt . m_tm . time;
	set_mtime_common:
		intdos(&in, &out);
		if(out . x . cflag) status = CANNOT;
	} else if(flag){ /* VKt@C̏ꍇZbg */
		in . x . dx = curtime . date;
		in . x . cx = curtime . time;
		goto set_mtime_common;
	}
#ifdef SUPP_LFN /* 5705h 5707h71xxhlAWin95̂ݗp */
	if(_lfnsupp_level >= LFN_NONE){ /* LFNT|[gOSflagorig_adate
	 ^̏ꍇset_[ac]time_common֔570[57]hŝh~ */
		if(time_mode & (2|8)){ /* atime */
			in . x . dx = new_msdt . a_tm . date;
		set_atime_common:
			in . x . cx = /* new_msdt . a_tm . time */ 0;
			in . h . al = 0x05; /* ax5705h */
			intdos(&in, &out); /* LFN support environment only */
			if(out . x . cflag) status = CANNOT;
		} else if(flag){ /* VK쐬 */
			in . x . dx = curtime . date;
			goto set_atime_common;
		} else if(orig_adate){
		 /* I[vatimeς̂Ō̂̂Zbg */
			in . x . dx = orig_adate;
			goto set_atime_common;
		} /* else G[ɂׂ? */

		if(time_mode & 4){ /* ctime */
			in . x . dx = new_msdt . c_tm . date;
			in . x . cx = new_msdt . c_tm . time;
			in . x . si = new_msdt . c_tm . s100;
		set_ctime_common:
			in . h . al = 0x07; /* ax5707h */
			intdos(&in, &out); /* LFN support environment only */
			if(out . x . cflag) status = CANNOT;
		} else if(flag){ /* VK쐬 */
			in . x . dx = curtime . date;
			in . x . cx = curtime . time;
			in . x . si = curtime . s100;
			goto set_ctime_common;
		}
	}
#endif
	in . h . ah = 0x3e;
	in . x . bx = hndl;
	intdos(&in, &out);
	return status;
}

static	void	illdate()
{
	cmd_errmsg("Illegal date.\n");
	exit(FATALEXIT);
}

#undef ctoi
#define ctoi(c) ((c) - '0') /* cłƂ킩Ă鎞 */
#define c2toi(p) (ctoi(*(p)) * 10 + ctoi(*((p) + 1)))

static	void	readtime(str, dt_buf, mode) /* str: \ */
char	*str;
struct	dt_str	*dt_buf;
int	mode;
{
	union	REGS	in, out;
	int	c, y, m = 1, d = 1, h = 0, mn = 0, s = 0, s100 = 0;
	int	cget = 0, yget = 0;
	char	*p;

	for(p = str; *p; p++){
		if(*p == '.'){
			s = c2toi(p + 1);
			if(p[3]) s100 = c2toi(p + 3);
			break;
		}
	} /* p: strɁu.v΂̈ʒu Ȃstr */
	switch(mode){
	case 0: /* str MMDD[hhmm[[ss[SS]]YY]]  MMDDhhmm[[CC]YY].ss[SS] 
		   ꂩ(ς) */
		switch(p - str){
		case 14:s100=c2toi(str + 10); /* through */
		case 12: *p ? (c = c2toi(str + 8), cget = 1) :
			(s = c2toi(str + 8)); /* through */
		case 10: y = c2toi(p - 2); yget = 1; /* through*/
		case 8:	mn = c2toi(str + 6);
			 h = c2toi(str + 4); /* through */
		case 4:	 d = c2toi(str + 2);
			 m = c2toi(str);
			 break;
		default:
			illdate();
		}
		break;
	default: /* str [[CC]YY]MMDDhhmm[.ss[SS]] (ς) */
		switch(p - str){
		case 12: c = c2toi(str); cget = 1; /* through */
		case 10: y = c2toi(p - 10); yget = 1; /* through */
		default:mn = c2toi(p - 2);
			 h = c2toi(p - 4);
			 d = c2toi(p - 6);
			 m = c2toi(p - 8);
			 break;
		}
		break;
	}
	if(!yget){
		in . h . ah = 0x2a;
		intdos(&in, &out);
		y = out . x . cx;
	} else {
		if(!cget) c = (y >= 80) ? 19 : 20;
		y += c * 100;
	} /* xycaldateŎg */

	if(!(1 <= m && m <= 12 &&
	     1 <= d && caldate(y, m, d) < caldate(y, m + 1, 1) &&
				/* caldate13 */
	     0 <= h && h < 24 && 0 <= mn && mn < 60 &&
	     0 <= s && s < 60 && 0 <= s100 && s100 < 100)) illdate();

	p = dt_buf -> m_tm;
	*p   = (char)(y - 1980);
	*++p = (char)m;
	*++p = (char)d;
	*++p = (char)h;
	*++p = (char)mn;
	*++p = (char)s;
	*++p = (char)s100;
#ifdef SUPP_LFN
	memcpy(dt_buf -> a_tm, dt_buf -> m_tm, 7);
	memcpy(dt_buf -> c_tm, dt_buf -> m_tm, 7);
#endif
}

static	void	getcurtime(dt_buf)
struct	dt_str	*dt_buf;
{
	union	REGS	in, out1, out2;
	int	d = 0;
	char	*p;

	for(;;){
		in . h . ah = 0x2a;
		intdos(&in, &out1);
		if(d == out1 . h . dl) break;
		d = out1 . h . dl;
		in . h . ah = 0x2c;
		in . h . dl = 0; /* ԂldlĝŔÔ */
		intdos(&in, &out2);
	}

	p = dt_buf -> m_tm;
	*p   = (char)(out1 . x . cx - 1980);
	*++p =	      out1 . h . dh;
	*++p = (char) d;
	*++p =	      out2 . h . ch;
	*++p =	      out2 . h . cl;
	*++p =	      out2 . h . dh;
	*++p =	      out2 . h . dl;
#ifdef SUPP_LFN
	memcpy(dt_buf -> a_tm, dt_buf -> m_tm, 7);
	memcpy(dt_buf -> c_tm, dt_buf -> m_tm, 7);
#endif
}

static	void	usage_exit()
{
	fputs("Usage:\t", stderr), fputs(cmdname, stderr);
	fputs(" [-amCcfn] [MMDD[hhmm[[ss[SS]]YY]]] file...\n\t", stderr);
	fputs(cmdname, stderr);
	fputs(" [-amCcfn] [MMDDhhmm[[CC]YY]].ss[SS] file...\n\t", stderr);
	fputs(cmdname, stderr);
	fputs(" [-amCcfn] [-t [[CC]YY]MMDDhhmm[.ss[SS]]] file...", stderr);
	fputs("\t(SS: 1/100sec)\n\t", stderr);
	fputs(cmdname, stderr);
	fputs(" [-amCcfn] [-r filename] file...\n", stderr);
	exit(FATALEXIT);
}

main(ac, av)
int	ac;
char	*av[];
{
	int	c;
	extern	int	optind, opterr;
	extern	char	*optarg;

#ifdef NEED_D_OPT
	bool	diralso = 0;
#else
	bool	diralso = 1;
	 /* o[Wł-dw肵ȂĂŃfBNgtouch
	    s悤ɂȂBNEED_D_OPTdefineĂ-dIvV
	    w肳ꂽƂs */
#endif
	bool	force = 0;
	int	fmake = 1, status = 0, ecode;
	char	*fromfnm = NULL, *tmstring = NULL;
	struct	dt_str	datetime;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif
	opterr = 0;

	while(EOF != (c = getopt(ac, av, "amCcfr:t:nd"))){
		cswitch(c){
		case 'd':
#ifndef NOMODDIR
#  ifdef NEED_D_OPT
			diralso = 1;
#  else
			cmd_errmsg("Warning: -d option is now obsolete\n");
#  endif
			break;
#else
			cmd_errmsg(
			    "option `-d' can't be used on this version.\n");
			exit(FATALEXIT);
#endif
		case 'f': force = 1; break;
		case 'c': fmake = 0; break;
		case 'n': fmake = 2; break;
		case 'r': fromfnm = optarg; break;
		case 'a': time_mode |= 2; break;
		case 'm': time_mode |= 1; break;
		case 'C': time_mode |= 4; break;
		case 't': tmstring = optarg; break;
		default:  usage_exit(); break;
		}
	}
#ifdef SUPP_LFN
	if(!time_mode) time_mode = 8; /* atime, mtime */
	if(_lfnsupp_level <= LFN_NONE)
#endif
		time_mode = 1; /* mtime only */
	ac -= optind, av += optind;
	if(!ac || tmstring != NULL && fromfnm != NULL)	usage_exit();

	getcurtime(&datetime), dtconv_sub(datetime . m_tm, &curtime, 1);
	if(fromfnm != NULL){
		if(0 != filedate(fromfnm, -1, &datetime, FALSE)){
			cmd_errmsg(conv_to_unix_format(fromfnm));
			fputs(": Can't get date\n", stderr);
			exit(1);
		}
	} else
	if(tmstring != NULL){
		if(istimestring(tmstring) != 1) usage_exit();
		readtime(tmstring, &datetime, 1);
	} else
	if(/* ac && */ istimestring(*av)){
		readtime(*av, &datetime, 0);
		--ac, ++av;
		if(!ac) usage_exit();
	} /* else datetime͌̂܂ */

	for(; ac; --ac, ++av){
		ecode = filedate(*av, fmake, &datetime, diralso);
		if(!ecode) continue;

		cmd_errmsg(conv_to_unix_format(*av));
		switch(ecode){
		case CANNOT:
			fputs(": Can't touch\n", stderr);
		fail:
			if(!force) exit(1);
		fail_noexit:
			status = 1;
			break;
		case FAIL_NOMORE:
			fputs(": Failed to fill disk\n", stderr);
			goto fail_noexit;
		case CANNOT_LOCK:
			fputs(": Can't touch: Drive not locked\n", stderr);
			goto fail;
		default:
			fputs(": Directory\n", stderr);
		}
	}

	return status;
}

#else /* !MSDOS */
/* ----------------- ȉUNIXƋp̃\[Xɂ鋌 ----------------- */

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>
#include "tools.h"
#ifdef MSDOS
#  include <dos.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
struct	utimbuf {
	time_t	actime, modtime;
};

#define FATALEXIT 1 /* -1? */

char	*cmdname = "touch";

/* caldate_u(y2,m2,d2) - caldate_u(y1,m1,d1)  y1Nm1d1y2Nm2d2
   ܂ł̓vZłBcaldate_u(y,m,d) % 7 ŗj܂(0jA6
   yj) */
static	us_long	caldate_u(y, m, d)
int	y, m, d;
{
	if(m <= 2) --y, m += 12;
	return (us_long)y * 1461 / 4 - y / 100 + y / 400 +
	       (306 * m + 17) / 10 + d - 719558L;
	 /* 1970/1/1̓+4܂ */
}

static	us_long	caltime_u(y, m, d, h, mn, s)
 /* toolslib.l̂ƈcaldate_u()g */
int	y, m, d, h, mn, s;
{
	return (caldate_u(y, m, d) - 4) * 3600L * 24L +
					    (us_long)h * 3600L + mn * 60 + s;
}

static	void	cmd_errmsg(s)
char	*s;
{
	fputs(cmdname, stderr), fputs(": ", stderr), fputs(s, stderr);
}

static	istimestring(s)
 /* 8/10/12+u.v+2Ȃ1A4Ȃ2AȊO0 */
char	*s;
{
	char	*p, *q;

	for(p = s; is_digit(*p); p++);
	switch(p - s){
	case 12: case 10: case 8:
		switch(*p){
		case '\0':
			return 1;
		case '.':
			for(q = ++p; is_digit(*q); q++);
			if(!*q && q - p == 2) return 1;
		}
		break;
	case 4:
		if(!*p) return 2;
	}
	return 0;
}

#ifdef MSDOS
static	setattr(s, a)
char	*s;
unsigned a;
 /* ɂ0 sɂ-1Ԃ */
{
	union	REGS	in, out;
	struct	SREGS	segreg;

	in . x . ax = 0x4301;
	in . x . cx = a;
	in . x . dx = FP_OFF(s);
	segreg . ds = FP_SEG((char far *)s);
	intdosx(&in, &out, &segreg);
	return out . x . cflag ? -1 : 0;
}
#endif

#undef ctoi
#define ctoi(c) ((c) - '0') /* cłƂ킩Ă鎞 */
#define c2toi(p) (ctoi(*(p)) * 10 + ctoi(*((p) + 1)))

static	long	tb_timezone()
 /* timezoněvZBtzset()̎s̗LŒl͕ς */
{
	time_t	t = (time_t)1000000;
	struct	tm	*ltm;

	ltm = localtime(&t);
	return (long)(t - caltime_u(ltm -> tm_year + 1900, ltm -> tm_mon + 1,
		ltm -> tm_mday, ltm -> tm_hour, ltm -> tm_min, ltm -> tm_sec));
}

static	void	illdate()
{
	cmd_errmsg("Illegal date.\n");
	exit(FATALEXIT);
}

static	void	readtime(str, timebuf, mode) /* str: \ */
char	*str;
time_t	*timebuf;
int	mode;
{
	int	c, y, m = 1, d = 1, h = 0, mn = 0, s = 0;
	int	cget = 0, yget = 0;
	char	*p;
	us_long	datetime;

	for(p = str; *p; p++){
		if(*p == '.'){
			s = c2toi(p + 1);
			break;
		}
	} /* p: strɁu.v΂̈ʒu Ȃstr */
	switch(mode){
	case 0: /* str MMDD[hhmm[[ss]YY]]  MMDDhhmm[[CC]YY].ss (ς)*/
		switch(p - str){
		case 12: *p ? (c = c2toi(str + 8), cget = 1) :
			(s = c2toi(str + 8)); /* through */
		case 10: y = c2toi(p - 2); yget = 1; /* through */
		case 8:	mn = c2toi(str + 6);
			 h = c2toi(str + 4); /* through */
		case 4:  d = c2toi(str + 2);
			 m = c2toi(str);
			 break;
		default:
			illdate();
		}
		break;
	default: /* str [[CC]YY]MMDDhhmm[.ss] (ς) */
		switch(p - str){
		case 12: c = c2toi(str); cget = 1; /* through */
		case 10: y = c2toi(p - 10); yget = 1; /* through */
		default:mn = c2toi(p - 2);
			 h = c2toi(p - 4);
			 d = c2toi(p - 6);
			 m = c2toi(p - 8);
			 break;
		}
		break;
	}
	if(!yget){
		time_t	ltime;
		struct	tm	*timeptr;

		time(&ltime);
		timeptr = localtime(&ltime);
		y = timeptr -> tm_year + 1900;
	} else {
		if(!cget){
#ifdef MSDOS
			c = (y >= 80) ? 19 : 20;
#else
			c = (y >= 70) ? 19 : 20;
#endif
		}
		y += c * 100;
	}
	datetime = caldate_u(y, m, d);

	if(!(1 <= m && m <= 12 &&
	     1 <= d && datetime <
		(m == 12 ? caldate_u(y + 1, 1, 1) : caldate_u(y, m + 1, 1)) &&
	     0 <= h && h < 24 &&
	     0 <= mn && mn < 60 &&
	     0 <= s && s < 60)) illdate();

	datetime -= caldate_u(1970, 1, 1);
	datetime *= 24L * 60L * 60L;
	datetime += (us_long)h * 3600L + (us_long)mn * 60L + (us_long)s;
	datetime += tb_timezone();
	*timebuf = (time_t)datetime;
}

static	void	usage_exit()
{
	fputs("Usage:\t", stderr), fputs(cmdname, stderr);
	fputs(" [-amcf] [MMDD[hhmm[[ss]YY]]] file...\n\t", stderr);
	fputs(cmdname, stderr);
	fputs(" [-amcf] [MMDDhhmm[[CC]YY].ss] file...\n\t", stderr);
	fputs(cmdname, stderr);
	fputs(" [-amcf] [-t [[CC]YY]MMDDhhmm[.ss] file...\n\t", stderr);
	fputs(cmdname, stderr);
	fputs(" [-amcf] [-r filename] file...\n", stderr);
	exit(FATALEXIT);
}

main(ac, av)
int	ac;
char	*av[];
{
	int	c;
	extern	int	optind, opterr;
	extern	char	*optarg;

	int	fmake = 1, force = 0, status = 0, tmpfd;
	int	time_mode = 0; /* 1:mtime 2:atime */
	char	*fromfnm = NULL, *tmstring = NULL;

	struct	utimbuf utimestr;
	time_t	curtime;
	struct	stat	statstr;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif
	opterr = 0;

	tzset(); /* CnɂĂ͕KvȂ */
	while(EOF != (c = getopt(ac, av, "cfr:amt:"))){
		switch(c){
		case 'f': force = 1; break;
		case 'c': fmake = 0; break;
		case 'r': fromfnm = optarg; break;
		case 'a': time_mode |= 2; break;
		case 'm': time_mode |= 1; break;
		case 't': tmstring = optarg; break;
		default:  usage_exit(); break;
		}
	}
#ifndef MSDOS
	if(!time_mode)
#endif
		time_mode = 3; /* DOSła, mIvV */

	ac -= optind, av += optind;
	if(!ac || tmstring != NULL && fromfnm != NULL)	usage_exit();

	time(&curtime);
	if(fromfnm != NULL){
		if(0 != stat(fromfnm, &statstr)){
			cmd_errmsg(conv_to_unix_format(fromfnm));
			fputs(": Can't stat\n", stderr), exit(1);
		}
#ifdef LSI_C
		((time_t *)&utimestr)[1] = statstr . st_mtime;
#else
		utimestr . modtime = statstr . st_mtime;
		utimestr . actime = statstr . st_atime;
#endif
	} else
	if(tmstring != NULL){
		if(istimestring(tmstring) != 1) usage_exit();
#ifdef LSI_C
		readtime(tmstring, &(((time_t *)&utimestr)[1]), 1);
#else
		readtime(tmstring, &utimestr . modtime, 1);
		utimestr . actime = utimestr . modtime;
#endif
	} else
	if(/* ac && */ istimestring(*av)){
#ifdef LSI_C
		readtime(*av, &(((time_t *)&utimestr)[1]), 0);
#else
		readtime(*av, &utimestr . modtime, 0);
		utimestr . actime = utimestr . modtime;
#endif
		--ac, ++av;
		if(!ac) usage_exit();
	} else {
#ifdef LSI_C
		((time_t *)&utimestr)[1] = curtime;
#else
		utimestr . actime = utimestr . modtime = curtime;
#endif
	}

	for(; ac; --ac, ++av){
		if(0 != stat(*av, &statstr)){
			if(!fmake){
				cmd_errmsg(conv_to_unix_format(*av));
				fputs(": Not found\n", stderr);
				goto err;
			}
			if(0 > (tmpfd = open(*av, O_CREAT | O_EXCL, 0644))){
				cmd_errmsg(conv_to_unix_format(*av));
				fputs(": Can't open\n", stderr);
				goto err;
			}
			close(tmpfd);
#ifdef MSDOS
			setattr(*av, _A_ARCH);
#endif
			statstr . st_atime = statstr . st_mtime = curtime;
		}
		if(!(time_mode & 1)) utimestr . modtime = statstr . st_mtime;
		if(!(time_mode & 2)) utimestr . actime = statstr . st_atime;

#ifdef LSI_C
		if(0 != utime(*av, (time_t *)&utimestr))
#else
		if(0 != utime(*av, &utimestr))
#endif
		{
			cmd_errmsg(conv_to_unix_format(*av));
			fputs(": Can't touch\n", stderr);
		err:
			if(!force) exit(1); else status = 1;
		}
	}
	return status;
}

#endif /* !MSDOS */
