/* tr [-cds] [string1 [string2]], no wildcards */
#include <stdio.h>
#include <ctype.h>
#include <fcntl.h>
#ifdef MSDOS
#  include <dos.h>
#  include <string.h> /* for memset() */
#endif
#ifdef LSI_C
#  include <farstr.h>
#endif
#include "tools.h"
#define LBUFSIZ	8192

#ifndef MSDOS
#  define EUCJMODE
#  define far
#  define farmalloc malloc
#  define far_memset memset

void	nomem_exit()
{
	_putnomemmes(), exit(1);
}

void	*chk_realloc(p, i)
void	*p;
unsigned int	i;
{
	if(NULL == (p = re_alloc(p, i))) nomem_exit();
	return p;
}
#endif

#define SS2 0x8e
#define SS3 0x8f /* SS3Ή͌v撆 */
#define iskana(c) \
	(0xa1 <= (c) && (c) <= 0xdf)
#define ismsknj1(c) \
	(0x81 <= (c) && ((c) <= 0x9f || 0xe0 <= (c) && (c) <= 0xfc))
#define ismsknj2(c) \
	(0x40 <= (c) && (c) <= 0xfc && 0x7f != (c))
#define iseucj(c) \
	(0xa1 <= (c) && (c) <= 0xfe)
#define isSS2(c) \
	(SS2 == (c))

char	*cmdname = "tr";

struct	argchar {
	us_char	*arg;
	int	next, step;
	us_long	count;	/* ̂ƂintTCYŏ\Ƃ͎v */
};

#ifdef EUCJMODE
#  define KTBLSIZ (0x100 + 63 + 94 * 94) /* includes 1byte-kana */
#else
#  define KTBLSIZ (0x100 + 60 * 188)
#endif

static	bool	cmplmnt = 0, delete = 0, supdup = 0, treatz = 0;
static	bool	ibinary = 0, obinary = 0, jmode = 0;
static	int	*near_cnvtbl,	far	*cnvtbl;
static	bool	*near_duptbl,	far	*duptbl;
static	char	*ibigbuf, *obigbuf;
static	us_int	tblsiz = 0x100;

#define DELCHR	(us_int)(0x01010101)
#define NOCONV	(us_int)(0x02020202) /* ȏAR[hƏdȂʐ */

#define EOARGC	(-1) /* End of argchar. cnvtblduptblindexƏdȂʐ */

/* ԐڈLFNT|[gv̉\̂
   exparg_hook()̒`͂Ȃ */

static	void	usage()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
	_puterrmes_cr(" [-cdsIOzj] [string1 [string2]]"), exit(1);
}

static	void	cantbuf()
{
	_cmdputerrmes_cr("Can't set I/O buffer"), exit(1);
}

static	void	badstr()
{
	_cmdputerrmes_cr("Bad string"), exit(1);
}

static	c2idx(c)
 /* cnvtbl, duptblindexւ̃}bvBc͐ȕł邱(EOF
    )Bϊ̌ʓindex͍ŏʃrbg0͈͓̔B1oCgR[h
    ΂Ăidentical map */
int	c;
{
	us_char	h = (us_char)(c >> 8), l;

	if(!h) return c;
	l = (us_char)c;
#ifdef EUCJMODE
	return isSS2(h) ? (l - 0xa1 + 0x100) :
		(h * 94 + l - 0xa1 * 94 - 0xa1 + (0xdf - 0xa1) + 0x101);
#else
	if(0xe0 <= h) h -= 0x40;
	if(0x80 <= l) --l;
	return h * 188 + l - 0x81 * 188 - 0x40 + 0x100;
#endif
}

static	idx2c(i) /* idx2c()œꂽ̂̋tϊ */
int	i;
{
#ifdef EUCJMODE
	if(i < 0x100) return i;
	i -= 0xdf - 0xa1 + 0x101;
	return i < 0 ? (i + (SS2 << 8) + 0xdf + 1) :
		(((i / 94) << 8) + (i % 94) + 0xa1a1);
#else
	int	j = i - 0x100;

	if(j < 0) return i;
	i = j % 188, j /= 188;
	if(0x9f - 0x81 < j) j += 0x40;
	if(0x7e - 0x40 < i) ++i;
	return (j << 8) + i + 0x8140;
#endif
}

static	void	init_argchar(p, s)
struct	argchar *p;
us_char	*s;
{
	p -> count = 0L, p -> arg = s;
}

static	get1char(pp)
us_char	**pp; /* R[hł͂ȂcnvtblduptblindexԂ悤ɂȂ */
{
	us_char	*p;
	int	c, i;

#ifdef EUCJMODE
#  define is_kvalid(h, l) \
	(iseucj(h) && iseucj(l) || isSS2(h) && iskana(l))
#else
#  define is_kvalid(h, l) \
	(ismsknj1(h) && ismsknj2(l))
#endif /* hlEOFł͐^ɂȂȂ */

	c = *(p = *pp), ++p;
	if(!c) return EOARGC;

#ifdef MSDOS
	if(c != '\\' && c != ESCAPE)
#else
	if(c != '\\')
#endif
	{ /* c != '\0' */
	normal:
		if(jmode && is_kvalid(c, *p)) c <<= 8, c |= *p, ++p;
	} else
	if(c = *p, ++p, is_octal(c)){
		for(c -= '0', i = 3 - 1; i && is_octal(*p); --i, ++p){
			c <<= 3, c |= *p - '0';
		}
	} else {
		switch(c){
		case 'n': c = '\n'; break;
		case 't': c = '\t'; break;
		case 'b': c = '\b'; break;
		case 'r': c = '\r'; break;
		case 'f': c = '\f'; break;
		case 'v': c = 0xb; break;
		case 'a': c = 0x7; break;
		case 'e': c = '\033'; break;
		case 'x':
			c = '\0';
			for(i = (jmode ? 4 : 2); i && is_xdigit(*p); --i, ++p){
				c <<= 4, c |= *p - (isdigit(*p) ? '0' :
					islower(*p) ? 'a' - 10 : 'A' - 10);
			}
			if(!(i = ((us_int)c) >> 8) ||
			   is_kvalid(i, (us_char)c)) break;
			badstr();
		default: goto normal;
		}
	}
	*pp = p;
	return c2idx(c);
}

static	getargchar(p)
struct	argchar *p;
{
	int	i, j;
	us_char	*s;

	if(p -> count){
		p -> count--;
		 /* -1łĂ -- Ȃgetargcharpair()܂Ȃ */
		i = p -> next;
		p -> next += p -> step;
		return i;
	}
	i = *(s = p -> arg);
	if(!i) return EOARGC;

	if(i != '['){
		i = get1char(&s);
	} else { /* non-escaped '[' */
		++s;
		if(EOARGC == (i = get1char(&s))) badstr();
		switch(*s++){
		case '-':
			if(EOARGC == (j = get1char(&s))) badstr();
			if(0 < (j -= i)){
				p -> step = 1, p -> count = j;
			} else {
				p -> step = -1, p -> count = -j;
			}
			p -> next = i + p -> step;
			break;
		case '*':
			j = 0;
			if(*s == '0'){
				while(is_octal(*s)) (j <<= 3, j |= *s++ - '0');
			} else {
				while(is_digit(*s)) (j *= 10, j += *s++ - '0');
			} /* jintŏ\BnumꂽꍇOK */
			p -> count = --j; /* 0Ȃ(us_long)(-1)==HugeɂȂ */
			p -> step = 0, p -> next = i;
			break;
		default:
			badstr();
		}
		if(*s++ != ']')	badstr();
	}

	p -> arg = s;
	return i;
}

static	getargchar_nodup(p)
struct	argchar *p;
{
	int	i;

	i = getargchar(p);
	if(!p -> step) p -> count = 0L;
	return i;
}

static	void	getargcharpair(p1, ip, p2, jp)
struct	argchar *p1, *p2;
int	*ip, *jp;
{
	us_long	count_min;

	*ip = getargchar(p1);
	*jp = getargchar(p2);
	if(!p1 -> step && !p2 -> step){
		count_min = (p1 -> count < p2 -> count ? p1 : p2) -> count;
		p1 -> count -= count_min;
		p2 -> count -= count_min;
	}
}

static	void	trmain(from, to)
us_char	*from, *to;
{
	struct	argchar	fromstr, tostr;
	int	i, k, j;

	if(!cmplmnt){
		far_memset(cnvtbl, (char)NOCONV, sizeof(int) * tblsiz);
		 /* int2oCgł4oCgłv */
		if(supdup) far_memset(duptbl, 0, tblsiz);

		if(!treatz) cnvtbl[0] = DELCHR;
		init_argchar(&fromstr, from);
		if(!delete){
			init_argchar(&tostr, to);
			while(getargcharpair(&fromstr, &i, &tostr, &j),
			      EOARGC != i && (treatz || i) &&
			      EOARGC != j && (treatz || j)){
				cnvtbl[i] = idx2c(j);
			}
			while(EOARGC != i && (treatz || i)){
				cnvtbl[i] = NOCONV;
				i = getargchar_nodup(&fromstr);
			}
		} else {
			while(EOARGC != (i = getargchar_nodup(&fromstr)) &&
			      (treatz || i)){
				cnvtbl[i] = DELCHR;
			}
		}
	} else { /* complement */
		far_memset(cnvtbl, (char)DELCHR, sizeof(int) * tblsiz);
		if(supdup) far_memset(duptbl, 0, tblsiz);

		init_argchar(&fromstr, from);
		while(EOARGC != (i = getargchar_nodup(&fromstr)) &&
		      (treatz || i)){
			cnvtbl[i] = NOCONV;
		}
		if(!delete){
			init_argchar(&tostr, to), i = (treatz ? 0 : 1);
			while(EOARGC != (j = getargchar(&tostr)) &&
			      (treatz || j)){
				while(cnvtbl[i] != DELCHR){
					if(++i >= tblsiz) goto nomorecnv;
				}
				cnvtbl[i] = idx2c(j);
			}
			for(; i < tblsiz; ++i){
				if(cnvtbl[i] == DELCHR) cnvtbl[i] = NOCONV;
			}
		}
	}
nomorecnv:
	init_argchar(&tostr, to);
	if(supdup){
		while(EOARGC != (j = getargchar_nodup(&tostr)) &&
		      (treatz || j)){
			duptbl[j] = 1;
		}
	}

#ifdef DEBUG
	for(i = 0; i < tblsiz; ++i){
		if(cnvtbl[i] != NOCONV)	printf(
			"(0x%x) cnvtbl[0x%x]=0x%x\n", idx2c(i), i, cnvtbl[i]);
	}
	if(supdup) for(i = 0; i < tblsiz; ++i){
		if(duptbl[i]) printf(
			"(0x%x) duptbl[0x%x]=%d\n", idx2c(i), i, duptbl[i]);
	}
#endif

	k = EOF;
	if(jmode){
		int	m, n;

		j = getchar();
		while(EOF != (i = j)){
			j = getchar();
			if(is_kvalid(i, j)) i <<= 8, i |= j, j = getchar();
			switch(n = cnvtbl[m = c2idx(i)]){
			case DELCHR: continue;
			case NOCONV: n = i;
			default: if(supdup) m = c2idx(n);
			}
			if(supdup && duptbl[m] && k == n) continue;
			if((m = ((us_int)n) >> 8) != '\0') putchar(m);
			putchar(k = n);
		}
	} else {
		while(EOF != (i = getchar())){
			switch(j = near_cnvtbl[i]){
			case DELCHR: continue;
			case NOCONV: j = i;
			}
			if(supdup && near_duptbl[j] && k == j) continue;
			putchar(k = j);
		}
	}
}

main(ac, av)
int	ac;
char	*av[];
{
#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif /* support indirect argument only */
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	if(++av, --ac && **av == '-'){
		char	*p;

		for(p = *av + 1; *p; ++p){
			switch(*p){
			case 'c': cmplmnt = 1; break;
			case 'd': delete = 1; break;
			case 's': supdup = 1; break;
			case 'I': ibinary = 1; break;
			case 'O': obinary = 1; break;
			case 'z': treatz = 1; break;
			case 'j': jmode = 1; break;
			default: usage();
			}
		}
		--ac, ++av;
	}
	if(jmode){
		tblsiz = KTBLSIZ;
		cnvtbl = (int far *)farmalloc(tblsiz *
			(supdup ? sizeof(bool) + sizeof(int) : sizeof(int)));
		 /* supdupłȂƂduptbl͊蓖ĂȂ */
		if(NULL == cnvtbl) (_putnomemmes(), exit(1));
		duptbl = (void far *)&cnvtbl[tblsiz];
	} else {
		cnvtbl = near_cnvtbl = chk_malloc(
			tblsiz * (sizeof(bool) + sizeof(int)));
		duptbl = near_duptbl = (void *)&near_cnvtbl[tblsiz];
	}

	if(NULL != (ibigbuf = malloc(LBUFSIZ)) &&
	   0 != setfbuf(stdin, ibigbuf, LBUFSIZ) ||
	   NULL != (obigbuf = malloc(LBUFSIZ)) &&
	   0 != setfbuf(stdout, obigbuf, LBUFSIZ)) cantbuf();
	ibinary ? fsetbin(stdin) : fsettext(stdin);
	obinary ? fsetbin(stdout) : fsettext(stdout);

	if(ac > 2) usage();
	trmain(ac ? av[0] : NULSTR, ac > 1 ? av[1] : NULSTR);
	return 0; /* exit from main() */
}
