#include <stdio.h>
#include <ctype.h>
#include "tools.h"
#ifndef MSDOS
#  define EUCJMODE
#  define iskanji(c) ((c) & 0x80) /* ꉞ */
#endif

#ifdef EUCJMODE
#  define KSPC	0xa1a1
#  define SS2	0x8e
#else
#  define KSPC	0x8140
#endif

#define	COLLISTMAX 512

char	*cmdname = "unexpand";

static	int	tabcol = 8;
static	int	tabcols[COLLISTMAX];
static	bool	elimsp = 0, unexpall = 0, kspc = 0;

struct	charstock {
	char	*buf;
	unsigned int	bufsiz, bufpos;
};

#ifndef MSDOS
void	*chk_realloc(p, n)
void	*p;
unsigned int	n;
{
	if(NULL == (p = (p == NULL ? malloc(n) : realloc(p, n)))){
		fputs("Memory exhausted\n", stderr), exit(1);
	}
	return p;
}
#  define chk_malloc(n) chk_realloc(NULL, (n))
#endif

#define	charstockinit(cs) ((cs) . buf = chk_malloc((cs) . bufsiz = 100))
 /* bufpos0ɂ͂Ȃ */

static	void	stockchar(c, p)
char	c;
struct	charstock	*p;
{
	unsigned int	i;

	if((i = p -> bufpos) >= p -> bufsiz){
		p -> buf = chk_realloc(p -> buf, p -> bufsiz += 100);
	}
	p -> buf[i] = c;
	p -> bufpos = ++i;
}

struct	spinfo {
	struct	charstock sptabseq;
	int	pos, tabidx;
	bool	non_init;
};

static	void	usage()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
	_puterrmes_cr(" [-aks] [-tablist] [file...]");
	exit(1);
}

static	void	do_opt(opt)
char	*opt;
{
	int	tabidx = 0, prevcol = 0;

	for(;;){
		if(tabidx == COLLISTMAX - 1){
			_cmdputerrmes_cr("Tabstop list too long");
			exit(1);
		}
		tabcols[tabidx] = atoi(opt);
		if(prevcol >= tabcols[tabidx]){
			_cmdputerrmes_cr("Bad tab stop spec");
			exit(1);
		} else prevcol = tabcols[tabidx++];
		while(is_digit(*opt)) opt++;
		if(!*opt) break;
		if(*opt++ != ',') usage();
	}
	tabcols[tabidx] = 0;
	tabcol = (tabcols[1] ? 0 : tabcols[0]);
}

static	void	outspc(spdatp)
struct	spinfo	*spdatp;
{
	char	*p;
	int	i, pos, tabpos, tabidx;

	stockchar('\0', &spdatp -> sptabseq);
	tabpos = pos = spdatp -> pos, tabidx = spdatp -> tabidx;
	p = spdatp -> sptabseq . buf;
	do{
		if(*p == ' '){
			pos++;
			if(!unexpall && spdatp -> non_init){
				putchar(' '), ++tabpos;
			}
			continue;
		}

		 /* else *p must be '\t' or '\0' */
		if(tabcol){
			while((i = (tabpos / tabcol + 1) * tabcol) <= pos){
				putchar(i - tabpos > 1 ? '\t' : ' ');
				tabpos = i;
			}

			if(*p == '\t'){
				pos = tabpos = (tabpos / tabcol + 1) * tabcol;
				/* previously pos = (tabpos += tabcol); */
				putchar('\t');
			} else {
				for(; tabpos < pos; tabpos++) putchar(' ');
			}
		} else {
			while((i = tabcols[tabidx]) > 0 && i <= tabpos)
				tabidx++;
			 /* now i == tabcols[tabidx] and tabcols[tabidx - 1] is
			    the maximum tabcol <= tabpos */
			if(i){
				while((i = tabcols[tabidx]) > 0 && i <= pos){
					putchar(i - tabpos > 1 ? '\t' : ' ');
					tabpos = i;
					tabidx++;
				}
				 /* tabcols[tabidx - 1] is always kept
				    < current pos (if tabidx > 0) */
			}

			if(!i){
				for(; tabpos < pos; tabpos++) putchar(' ');
				if(*p == '\t'){
					putchar('\t');
					pos = ++tabpos;
				}
			} else {
				if(*p == '\t'){
					putchar('\t');
					pos = tabpos = i;
				} else {
					for(; tabpos < pos; tabpos++)
						putchar(' ');
				}
			}
		}
	} while(*p++);
	spdatp -> sptabseq . bufpos = 0;
	spdatp -> pos = pos, spdatp -> tabidx = tabidx;
}

static	void	unexpand(f)
FILE	*f;
{
	int	c, d;
	static	struct	spinfo	 sppresv;
	static	bool	first = 1;

	if(first){
		charstockinit(sppresv . sptabseq);
		first = 0;
	} /* sptabseq . buf ɂ ' '  '\t' ΂肪Ă */
	sppresv . pos = sppresv . tabidx = sppresv . sptabseq . bufpos = 0;
	sppresv . non_init = 0;

	while(EOF != (c = getc(f))){
		if(iskanji(c)){
			if(EOF == (d = getc(f))){
				outspc(&sppresv);
				putchar(c);
				return;
				 /* tabidx, pos, non_init
				    ǂ̂ōXVsv */
			}
			if(kspc && ((c << 8) | d) == KSPC &&
			   (unexpall || !sppresv . pos)){
				stockchar(' ', &sppresv . sptabseq);
				stockchar(' ', &sppresv . sptabseq);
			} else {
				outspc(&sppresv);
				putchar(c), putchar(d);
#ifdef EUCJMODE
				sppresv . pos++;
				if(c != SS2) sppresv . pos++;
#else
				sppresv . pos += 2;
#endif
			}
			sppresv . non_init = 1;
		} else
		if(c == '\b'){
#ifndef ORIG
			outspc(&sppresv);
#endif
			putchar(c);
			if(sppresv . pos) sppresv . pos--;
			if(sppresv . tabidx)
				sppresv . tabidx--; /* ō1߂΂悢 */
		} else
		if(c == '\n' || c == '\r' || c == '\f'){
			if(!elimsp) outspc(&sppresv);
			putchar(c);
			sppresv . pos = sppresv . tabidx =
				sppresv . sptabseq . bufpos = 0;
			sppresv . non_init = 0;
		} else
		if(c == '\t' || c == ' '){
			stockchar(c, &sppresv . sptabseq);
		} else {
			outspc(&sppresv);
			putchar(c), ++sppresv . pos, sppresv . non_init = 1;
		}
	}

	if(!elimsp) outspc(&sppresv);
}

main(ac, av)
int	ac;
char	**av;
{
	FILE	*inf;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	--ac, ++av;
	while(ac && av[0][0] == '-' && av[0][1]){
		char	*p;

		for(p = *av + 1; *p && !is_digit(*p); p++){
			switch(*p){
			case 'k':
				kspc = 1; break;
			case 's':
				elimsp = 1; break;
			case 'a':
				unexpall = 1; break;
			default:
				usage();
			}
		}
		if(*p) do_opt(p);
		--ac, ++av;
	}
	if(!ac){
		unexpand(stdin);
	} else {
		for(; ac; --ac, ++av){
			if(av[0][0] == '-' && !av[0][1]){
				unexpand(stdin);
				clearerr(stdin);
			} else {
				if(NULL == (inf = fopen(*av, "r"))){
					_cmdputerrmes(
						s_conv_to_unix_format(*av));
					_puterrmes_cr(": Can't open");
					exit(1);
				}
				unexpand(inf);
				fclose(inf);
			}
		}
	}
	return 0;
}
