#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "tools.h"
#ifdef ORIG
#  define LINMAX (1024*4)
#endif

char	*cmdname = "uniq";

#ifdef ORIG
static	char	linbuf[2][LINMAX];
#else
static	char	*linbuf[2] = {NULL, NULL};
#endif
static	int	ignf = 0, ignc = 0;
static	bool	outlcnt = 0, outdup = 0, outndup = 0;

static	void	usage()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
	_puterrmes_cr(" [-cdu] [{+|-}n] [file]"), exit(1);
}

static	void	longintout(w, n)
int	w;
unsigned long	n;
{
	if(n >= 10) longintout(--w, n / 10); else while(--w > 0) putchar(' ');
	putchar((int)(n % 10) + '0');
}

static	void	out(buf, cnt)
char	*buf;
long	cnt;
{
	if(buf != NULL && (cnt == 1L ? outndup : outdup)){
		if(outlcnt) (longintout(4, cnt), putchar(' '));
		 /* instead of printf("%4ld ", cnt); */
		puts(buf);
	}
}

static	void	uniq(ac, av)
int	ac;
char	**av;
{
	FILE	*f;
	int	i, len;
	long	dupcnt = 0L;
	char	*bufcur, *cmpcur, *bufprv = NULL, *cmpprv = NULL;
	char	*fnm, sw = 0;

	if(ac > 1) usage();
	if(!ac || **av == '-' && !av[0][1]){
		f = stdin, fnm = "(stdin)";
	} else if(NULL == (f = fopen(fnm = conv_to_unix_format(*av), "r"))){
		_cmdputerrmes(fnm), _puterrmes_cr(": Can't open");
		exit(1);
	}

#ifdef ORIG
	while(NULL != fgets(bufcur = linbuf[sw], LINMAX, f)){
#else
	while(NULL != (bufcur = linbuf[sw] = getline(linbuf[sw], f))){
#endif
		if(!bufcur[0]){ /* nothing */
		} else
		if(bufcur[(len = strlen(bufcur)) - 1] != '\n'){
			_cmdputerrmes(fnm);
#ifdef ORIG
			if(len == LINMAX - 1){
				_puterrmes_cr(": line too long");
				exit(1);
			}
#endif
			_puterrmes_cr(": missing line-feed character added \
at EOF");
		} else {
			bufcur[len - 1] = '\0';
		}

		cmpcur = bufcur;
		for(i = ignf; i--;){
			while(is_space(*cmpcur)) cmpcur++;
			while(!is_space(*cmpcur)){
				if(!*cmpcur) goto contin;
				cmpcur++;
			}
		}
	contin: for(i = ignc; i--;){
			if(!*cmpcur) break;
			cmpcur++;
		}

		if(cmpprv == NULL || strcmp(cmpprv, cmpcur)){
			out(bufprv, dupcnt);
			dupcnt = 1L;
			sw ^= 1, cmpprv = cmpcur, bufprv = bufcur;
		} else {
			dupcnt++;
		}
	}
	out(bufprv, dupcnt);
}

main(ac, av)
int	ac;
char	*av[];
{
	char	*p;
	int	optend;
	bool	udopt = 0;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif
	for(optend = 0; ++av, --ac; ){
		switch(p = *av, *p++){
		case '+':
			if(!*p) usage();
			ignc = atoi(p);
			break;
		case '-':
			if(!*p){optend++; break;}
			if(is_digit(*p)){
				ignf = atoi(p);
				break;
			}
			for(; *p; p++){
				switch(*p){
				case 'c':
					outlcnt = 1; break;
				case 'd':
					outdup = udopt = 1; break;
				case 'u':
					outndup = udopt = 1; break;
				default:
					usage();
				}
			}
			break;
		default:
			optend++; break;
		}
		if(optend) break;
	}
	if(!udopt) outdup = outndup = 1;

	uniq(ac, av);
	return 0;
}
