#include <stdio.h>
#include <fcntl.h>
#include <ctype.h>
#include <string.h>
#ifdef MSDOS
#  include <io.h>
#endif
#include "tools.h"
#define RBUFSIZ 32768

#ifndef MSDOS
#  define EUCJMODE
#endif

#define issjis1(c) \
	(0x81 <= (c) && ((c) <= 0x9f || 0xe0 <= (c) && (c) <= 0xfc))
#define iseuc(c) \
	(0xa1 <= (c) && (c) <= 0xfe)
#define isSS2(c) \
	(0x8e == (c))

#ifdef EUCJMODE
#  define isk1byte(c) (iseuc(c) || isSS2(c))
#  define KSPC 0xa1a1
#else
#  define isk1byte(c) issjis1(c)
#  define KSPC 0x8140
#endif

#ifdef MSDOS
#  define RDMODE "rb"
#else
#  define RDMODE "r"
#endif

char	*cmdname = "wc";

static	bool	print_line = 0, print_word = 0, print_char = 0, jmode = 0,
		tmode = 0;
static	long	total_l = 0L, total_w = 0L, total_c = 0L;

static	void	longintout(w, n)
int	w;
unsigned long	n;
{
	if(n >= 10) longintout(--w, n / 10); else while(--w > 0) putchar(' ');
	putchar((int)(n % 10) + '0');
}

static	void	wcout(flg, n)
bool	flg;
unsigned long	n;
{
	if(flg) (longintout(7, n), putchar(' '));
}

static	void	wcmain(f)
FILE	*f;
{
	register unsigned char	*p;
	register unsigned int	n;
	long	file_l = 0L, file_w = 0L, file_c = 0L;
	static	char	readbuf[RBUFSIZ];
	bool	word_cont = 0;
	int	kchar = '\0';

	while((n = fread(readbuf, 1, RBUFSIZ, f)) > 0){
		if(!jmode){
			file_c += (long)n;
			if(print_word || print_line){ /* svȏꍇȂ */
				for(p = readbuf; n; --n, ++p){
					if(is_space(*p)){
						word_cont = 0;
						if(*p == '\n') file_l++;
					} else if(!word_cont){
						word_cont++;
						file_w++;
					}
				}
			}
		} else { /* jmode */
			for(p = readbuf; n; --n, ++p){
				if(kchar){ /* 2oCgڂ͌Ȃ */
					kchar <<= 8, kchar |= (int)*p;
				} else {
					kchar = (int)*p;
					if(isk1byte(kchar)) continue;
				}

				file_c++;
				if((kchar & ~0xff) ?
				    (kchar == KSPC) : is_space(kchar)){
					word_cont = 0;
					if(kchar == '\n') file_l++;
				} else if(!word_cont){
					word_cont++;
					file_w++;
				}
				kchar = '\0';
			}
		}
	}
#if 0
	if(kchar){ /* only when jmode */
		file_c++;
		if(!word_cont) file_w++;
	}
#endif

	wcout(print_line, file_l);
	wcout(print_word, file_w);
	wcout(print_char, file_c);
	total_l += file_l;
	total_w += file_w;
	total_c += file_c;
}

 /* opens\̏ꍇ1 IȂ0Ԃ */
static	wc(fnm, nmdisp)
char	*fnm;
int	nmdisp;
{
	FILE	*f;

	if(fnm == NULL || !strcmp("-", fnm)){
		fnm = NULL;
		if(!tmode) fsetbin(stdin);
		wcmain(stdin);
	} else {
		if(NULL == (f = fopen(conv_to_unix_format(fnm),
						    tmode ? "r" : RDMODE))){
			_cmdputerrmes(fnm), _puterrmes_cr(": Can't open");
			return(1);
		}
		wcmain(f), fclose(f);
	}
	if(nmdisp) fputs(fnm == NULL ? "(stdin)" : fnm, stdout);
	putchar('\n');
	return(0);
}

static	void	help_exit()
{
	_puterrmes("Usage: "), _puterrmes(cmdname),
	_puterrmes_cr(" [-lwcjt] [files...]"), exit(1);
}

main(ac, av)
int	ac;
char	**av;
{
	extern	int	optind, opterr;
	int	c, errstat = 0;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif
	opterr = 0;

	while(EOF != (c = getopt(ac, av, "lwcjt"))){
		cswitch(c){
		case 'l':
			print_line = 1; break;
		case 'w':
			print_word = 1; break;
		case 'c':
			print_char = 1; break;
		case 'j':
			jmode = 1; break;
		case 't':
			tmode = 1; break;
		default:
			help_exit();
		}
	}
	ac -= optind, av += optind;
	if(!print_line && !print_word && !print_char)
		print_line = print_word = print_char = 1;

	switch(ac){
	case 0:
		return wc(NULL, 0);
	case 1:
		return wc(*av, 0);
	default:
		for(; ac; --ac, ++av) errstat |= wc(*av, 1);
		wcout(print_line, total_l);
		wcout(print_word, total_w);
		wcout(print_char, total_c);
		 /* instead of printf("%7ld ", ...) */
		puts("total");
		return errstat;
	}
}
