#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include "tools.h"

#ifdef MSDOS
#  define RBIN "rb"
#  define EOLMARK "\r\n"
#else
#  define RBIN "r"
#  define EOLMARK "\n"
#endif

static	char	*eolmark = EOLMARK;
char	*cmdname = "what";

static	int	what(f, flg) /* returns 1 if found, 0 otherwise */
FILE	*f; /* always in binary mode */
int	flg; /* single mode flg */
{
	int	c, found = 0;
	static	char	mark[] = "@(#)";
	char	*p;

	for(;;){
		for(p = mark; *p; ++p){
			if((int)*p != (c = getc(f))) break;
		}
		if(!*p){
			putchar('\t');
			while(EOF != (c = getc(f)) && c &&
			      NULL == strchr("\r\n\"\\>", c)){
				putchar(c);
				if(iskanji(c)) putchar(getc(f));
			}
			fputs(eolmark, stdout);
			found = 1;
			if(flg) return 1;
		}
		if(c == EOF) return found;
		if(c == mark[0]) ungetc(c, f);
	}
}

static	void	usage_exit()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
	_puterrmes_cr(" [-s] [file ...]"), exit(1);
}

main(ac, av)
int	ac;
char	**av;
{
	int	single = 0, found = 0;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	for(--ac, ++av; ac; --ac, ++av){
		if(**av == '-'){
			if(av[0][1] == 's' && !av[0][2]) single = 1;
			 else usage_exit();
		} else break;
	}
	fsetbin(stdout);
	if(!ac){
		fsetbin(stdin);
		found = what(stdin, single);
	} else {
		FILE	*f;

		for(; ac; ++av, --ac){
			conv_to_unix_format(*av); /* xȂ͂ */
			if(NULL == (f = fopen(*av, RBIN))){
				_cmdputerrmes("Can't open ");
				_puterrmes(*av), _puterrmes_cr(NULSTR);
			} else {
				fputs(*av, stdout), fputs(":", stdout);
				fputs(eolmark, stdout);
				if(what(f, single)) ++found;
				fclose(f);
			}
		}
	}
	return !found;
}
