#include <stdio.h>
#include <string.h>
#ifndef UX_COMPILE_TEST
#  include <dos.h> /* to typedef find_t */
#endif
#include "tools.h"

char	*cmdname = "which";

#ifdef UX_COMPILE_TEST
#  define ends_with_pathdelimiter_p(s) (!*(s) || (s)[strlen(s) - 1] == '/')
char	*chk_strduppathcat(d, p, f)
char	*d, *f;
int	p;
{
	static	char	buf[500];

	strcpy(buf, d);
	if(!ends_with_pathdelimiter_p(d) && *f) strcat(buf, "/");
	strcat(buf, f);
	return buf;
}
#endif

static	int	display_all = 0, msdos_format_p = 0;
static	int	pathsep = PATH_SEP1;

#ifdef UX_COMPILE_TEST
#include <sys/stat.h>
int	is_normalfile(s)
char	*s;
{
	struct	stat	sbuf;

	return !stat(s, &sbuf) && ((sbuf . st_mode & S_IFMT) == S_IFREG);
}
#else
int	is_normalfile(s)
char	*s;
{
	struct	Find_t	dmy;

	return !_dos_Find_soonclose(s, 0x27, &dmy);
}
#endif

#ifdef DEBUG
int	is_nf_debug(s)
char	*s;
{
	printf("searching <%s>\n", s);
	return is_normalfile(s);
}
#  define is_normalfile is_nf_debug
#endif

static	void	_puterrmes1(c)
int	c;
{
	static	char	s[2] = "\0";

	*s = (char)c, _puterrmes(s);
}

static	void	usage_exit()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
	_puterrmes_cr(" [-am] [-w windir] commandname...");
	exit(1);
}

static	bool	search_file(path, file, flg)
char	*path, *file;
char	flg; /* 1: for windows  2: with ext */
{
	char	*fnamebuf, *p;
	bool	found_p = 0;
	int	plen, flen;

	fnamebuf = chk_malloc(
			(plen = strlen(path)) + (flen = strlen(file)) + 6);
				/* 5 for "/" + ".com" + '\0' */
	p = strcpy(fnamebuf, path) + plen;
	if(!ends_with_pathdelimiter_p(path)) *p++ = (char)pathsep;
	p = strcpy(p, file) + flen;

	if(flg & 2){ /* '.'͊2oCgڂɂȂȂ */
	 /* FILE already had the extention. */
		if(is_normalfile(fnamebuf)){
			fputs(fnamebuf, stdout), putchar('\n');
			found_p = 1;
		}
	} else {
		static	char	*exts[] = {"com", "exe", "bat", "pif", "dll"};
		int	i;

		*p++ = '.';
		for(i = 0;
		    i < ((flg & 1) ? sizeof(exts) / sizeof(*exts) : 3);
		    ++i){
			strcpy(p, exts[i]);
			if(is_normalfile(fnamebuf)){
				fputs(fnamebuf, stdout), putchar('\n');
				found_p = 1;
				if(!display_all) break;
			}
		}
	}
	free(fnamebuf);
	return found_p;
}

static	int	which_a_file(name, pathlist, windir)
char	*name, *pathlist, *windir;
{
	int	found = 0, i;
	char	*one_path, *one_path_w, *base, flg;
	static	char	*wdirs[] = {"system32", "system", NULSTR};

	if(msdos_format_p) conv_to_dos_format(name);
	 else conv_to_unix_format(name);
	last_pathsep(name, &base);
 
	flg = (NULL != windir);
	if(NULL != strchr(base, '.')) flg |= 2;
	 /* '.'͊2oCgڂɂȂȂ */

	if(name != base){
		if(search_file(NULSTR, name, flg)) return 0;
		_cmdputerrmes(name), _puterrmes_cr(": not found");
		return 1;
	}

	if((flg & 1) && *windir){
		bool	result;

		pathscan_init(windir);
		while(NULL != (one_path = pathscan(msdos_format_p))){
			for(i = 0; i < sizeof(wdirs) / sizeof(*wdirs); ++i){
				one_path_w = chk_strduppathcat(one_path,
							pathsep, wdirs[i]);
				result = search_file(one_path_w, name, flg);
				free(one_path_w);
				if(result){
					found = 1;
					if(!display_all) return 0;
				}
			}
		}
	}

	if(search_file(".", name, flg)){
		found = 1;
		if(!display_all) return 0;
	}

	pathscan_init(pathlist);
	while(NULL != (one_path = pathscan(msdos_format_p))){
		if(search_file(one_path, name, flg)){
			found = 1;
			if(!display_all) return 0;
		}
	}

	if(found) return 0;

	/* not found */
	 /* stderrɏoƂɂĂ݂BUNIXƂ͈قȂ邪 */
	_cmdputerrmes(name), _puterrmes(" not found in");
	if(flg & 1){
		pathscan_init(windir);
		while(NULL != (one_path = pathscan(msdos_format_p))){
			for(i = 0; i < sizeof(wdirs) / sizeof(*wdirs); ++i){
				_puterrmes1(' '), _puterrmes(one_path);
				if(!ends_with_pathdelimiter_p(one_path) &&
				   *wdirs[i]) _puterrmes1(pathsep);
				_puterrmes(wdirs[i]);
			}
		}
	}
	_puterrmes(" .");
	pathscan_init(pathlist);
	while(NULL != (one_path = pathscan(msdos_format_p))){
		_puterrmes1(' '), _puterrmes(one_path);
	}
	_puterrmes_cr(NULSTR);
	return 1;
}

main(ac, av)
int	ac;
char	**av;
{
	char	*path, *windir = NULL;
	extern	int	optind, opterr;
	extern	char	*optarg;
	int	errcode, c, i;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg_tiny(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	if(NULL == (path = getenv("PATH"))) path = NULSTR;

	opterr = 0;
#ifdef UX_COMPILE_TEST /* use normal getopt */
	while((c = getopt(ac, av, "amw:")) != EOF)
#else
	while((c = egetopt(ac, av, "amw;")) != EOF)
#endif
	{
		cswitch(c){
		case 'a':
			display_all = 1;
			break;
		case 'm':
			msdos_format_p = 1, pathsep = PATH_SEP;
			break;
		case 'w':
			if(NULL == (windir = optarg) &&
			   NULL == (windir = getenv("windir")))
				windir = NULSTR;
#ifdef DEBUG
			fprintf(stderr, "windir = [%s]\n", windir);
#endif
			break;
		default:
			usage_exit();
		}
	}
	if(!(av += optind, ac -= optind)) usage_exit();

	for(errcode = i = 0; i < ac; ++i)
		if(0 != which_a_file(av[i], path, windir)) errcode = 1;
	return errcode;
}
