#include <stdio.h>
#include <ctype.h>
#ifndef UX_COMPILE_TEST
#  include <dos.h>
#  include <process.h>
#  if defined(__WATCOMC__) || defined(MSC51)
#    include <conio.h>			/* for kbhit() */
#  endif
#endif
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include "tools.h"

#define INFILECHR '^'
#define REMCHR ':'

char	*cmdname = "xeq";

#ifdef UX_COMPILE_TEST
#  define EZERO 0
#  define P_WAIT 0
#  define P_OVERLAY 2
#  define fcloseall() 0
#endif

#define	getch()	(bdos(7, 0, 0) & 0xff)

static	void	notmpf_exit()
{
	_cmdputerrmes_cr("Can't create tmpfile"), exit(-1);
}

static	void	ukerr_exit()
{
	_cmdputerrmes_cr("? Unknown err"), exit(-1);
}

static	void	nowrite_exit(f, flg) /* check not done when f is terminal */
FILE	*f;
bool	flg;
{
	if(!isatty(fileno(f))){
		_cmdputerrmes(NULSTR);
		if(flg) _puterrmes("tmpfile: ");
		_puterrmes_cr("Write error"), exit(-1);
	}
}

static	void	writetext(fd, s)
register int	fd;
register char	*s;
 /* [o͗pBLSI_C̏ꍇAŌȊO'\n'ƂCRLFɂȂȂ */
{
	register int	l = strlen(s);

#ifdef LSI_C
	if(l-- && s[l] == '\n'){
		write(fd, s, l);
		write(fd, "\r\n", 2);
	} else {
		write(fd, s, ++l);
	}
#else
	write(fd, s, l);
#endif
}

static	void	noopen_exit(fd, s)
int	fd;
char	*s;
{
	writetext(fd, cmdname), writetext(fd, ": Can't open ");
	writetext(fd, conv_to_unix_format(s)), writetext(fd, ".\n");
	close(fd), exit(-1); /* close()sv? */
}

static	void	toolongl_exit(s)
char	*s;
 /* fgetsœǂ񂾍s߂ꍇBs͓ǂ񂾍sȂt@C */
{
	_cmdputerrmes(s), _puterrmes_cr(": Line too long."), exit(-1);
}

static	void	toolonga_exit()
{
	_cmdputerrmes_cr("Argument too long."), exit(-1);
}

#ifdef MSDOS
void	expand_hook()
{
	_expand_abendcode = -1;
	expand_hook_default();
}
#endif

static	struct	{
	int	alloced, used;
	char	**name;
} tmpfnmbuf = {0, 0, NULL};
 /* rm_tmpfȊOŃt@C폜ꍇYname󕶎ɂĂ */

static	void	rm_tmpf()
 /* atexit()Aysignal()rmtmpf_exit()2ӏŌĂ΂ */
{
	fcloseall(); /* fdopen()ꂽt@CvƎv */
	while(tmpfnmbuf . used){
		if(*tmpfnmbuf . name[--tmpfnmbuf . used])
			unlink(tmpfnmbuf . name[tmpfnmbuf . used]);
	} /* Ōtmpfnmbuf . used == 0Ŕ */
}

static	void	rmtmpf_exit()
{
	rm_tmpf(), exit(-1);
}

static	FILE	*reopen_tmpf(orgf)
FILE	*orgf;
 /* ꎞt@C̃I[vʂԂBʂȈꎞt@CI[v܂ł
    ꎞt@C̖tmpfnmbuf . name[tmpfnmbuf . used - 1] */
{
	static	char	*tmpdir = NULL; /* rputenv()Ȃ */
	char	*fnmbuf, *p;
	int	retfd, i;
	FILE	*retf;
	void	(*origint)();

	if(NULL == (tmpdir = getenv("TMP")) &&
	   NULL == (tmpdir = getenv("TEMP"))){
#ifdef UX_COMPILE_TEST
		tmpdir = "/tmp";
#else
		tmpdir = NULSTR;
#endif
	}

#ifndef UX_COMPILE_TEST
	fnmbuf = chk_strduppathcat(tmpdir, PATH_SEP, NULNAME);
	retfd = open(fnmbuf, O_WRONLY), free(fnmbuf);
	if(retfd < 0) return NULL; else close(retfd);
#endif

	fnmbuf = chk_strduppathcat(tmpdir, PATH_SEP, "_xeq0000.$$$");
	 /* Ԃɂ͂ރpX؂́u\v*/

	if(orgf != NULL) fflush(orgf), close(fileno(orgf));
	for(;;){
		origint = signal(SIGINT, SIG_IGN);
		retfd = open(fnmbuf, O_WRONLY | O_CREAT | O_EXCL, 0644);
		if(retfd >= 0){
			if(tmpfnmbuf . alloced <= tmpfnmbuf . used)
				tmpfnmbuf . name= chk_realloc(tmpfnmbuf . name,
				  sizeof(char *) * (tmpfnmbuf . alloced += 5));
			tmpfnmbuf . name[tmpfnmbuf . used++] = fnmbuf;
			if(NULL == (retf = fdopen(retfd, "w"))) close(retfd);
			signal(SIGINT, origint);
			return retf;
		}
		signal(SIGINT, origint);

		for(p = fnmbuf + strlen(fnmbuf) - 5, i = 4; ; --i, --p){
			if(!i) return NULL;
			if(++*p <= '9') break; else *p = '0';
		}
	}
}

#define open_tmpf() reopen_tmpf(NULL)

static	int	isexecok(cmd) /* errnoɉeȂ */
char	*cmd;
{
	char	*p, *q;

	for(q = NULL, p = cmd; *p; p++){
		if(iskanjipos(p)) p++; else
		if(*p == '.') q = p; else
		if(*p == '\\' || *p == '/') q = NULL;
	}
	return(q++ == NULL || !stricmp(q, "exe") || !stricmp(q, "com"));
}

#ifndef UX_COMPILE_TEST
static	int	xspawnvp(mode, cmd, av)
int	mode;
char	*cmd, **av;
 /* LSI Cexecvp()ɂ́Aa.bat݂鎞execvp("a.bat", c)Ƃ
    \Ƃς?̂ŁẢBԂl-1Ȃ玸sB
    errnoɂ͕KAIُIlZbg */
{
	int	ret;

/* LSI Cspawnvp()͐IĂerrnoZbg邱Ƃ?? */
	if(!isexecok(cmd)) return errno = ENOENT, -1;
	if(-1 != (ret = spawnvp(mode, cmd, av))) errno = EZERO;
	return ret;
}
#else
static	int	xspawnvp(mode, cmd, av)
int	mode;
char	*cmd, **av;
{
	errno = EZERO;
	printf("mode = %d, cmd = <%s>\narg =", mode, cmd);
	for(; *av != NULL; ++av) printf(" [%s]", *av);
	putchar('\n');
	if(mode == P_OVERLAY) exit(0);
	return 0;
}
#endif

static	int	xexecvp(cmd, av)
char	*cmd, **av;
{
	int	ret;

	if(!tmpfnmbuf . used){
		return xspawnvp(P_OVERLAY, cmd, av); /* ͋AĂȂ */
	} else {
		ret = xspawnvp(P_WAIT, cmd, av);
		if(errno == EZERO) exit(ret); /* ꎞt@C폜s */
		return ret;
	} /* return͎̂sꍇɌ errno0ɃZbg͂ */
}

#ifndef UX_COMPILE_TEST
static	void	dexec(ac, av)
int	ac; /* >0 */
char	**av; /* ̊֐̓t@NV0x4cŒڔĂ܂ */
{
	int	i, len;
	char	*p, *q, *buf;
	/*	0100 b8****	mov	ax,****h
		0103 be****	mov	si,****h
		0106 8ed8	mov	ds,ax
		0108 cd2e	int	2eh
		010a b44c	mov	ah,4ch
		010c cd21	int	21h
	*/
	static	unsigned char call2e_routin[] = {
		0xb8, 0,    0,	  0xbe, 0,    0,    0x8e, 0xd8,
		0xcd, 0x2e, 0xb4, 0x4c, 0xcd, 0x21
	};
	void	(far *call2e)();

	for(len = 0, i = ac; i--; ) len += strlen(av[i]), ++len;
	if(len > 127) toolonga_exit();

	p = buf = chk_malloc(len + 1);
	*p++ = (char)--len;
	for(i = 0; i < ac; i++){
		strcpy(p, q = av[i]), p += strlen(q), *p++ = ' ';
	}
	*--p = '\r';

	*(unsigned int *)(call2e_routin + 1) = FP_SEG((char far *)buf);
	*(unsigned int *)(call2e_routin + 4) = FP_OFF(buf);
	call2e = (void (far *)())call2e_routin, call2e(); /* ߂ĂȂ */
}
#else
#  define dexec(ac, av) xspawnvp(ac, "dexec", av)
#endif

static	void	shell_arg(dst, src, ac)
char	**dst, **src;
int	ac;
{
	static	char	defcmd[] = "command";
	static	char	slashc[] = "/C"; /* 񓯂̂Ԃ */

	for(; ac >= 0; --ac) dst[ac + 2] = src[ac];
	 /* tȂ̂dstsrcɓ̂nĂv */
	*(dst[1] = slashc) = (char)swchar();
	if(NULL == (dst[0] = getenv("COMSPEC"))) dst[0] = defcmd;
}

/***
 ***  set COMSPEC to *argvp[0], and set "/C" to *argvp[1]
 ***/
static	int	make_comspec(argvp)
char	***argvp; /* assumes that *argvp terminates with NULL */
{
	char	**pp;
	char	**argv = *argvp;
	int	ac;

	for(ac = 0; argv[ac] != NULL; ++ac);
	*argvp = pp = chk_malloc(sizeof(char *) * (ac + 3));
	shell_arg(pp, argv, ac);
	return ac + 2;
}

static	int	do_execvp(cmd, av)
char	*cmd, **av;
{
	int	ret;

	ret = xexecvp(*av, av);
	if(errno == ENOENT) make_comspec(&av), ret = xexecvp(*av, av);
	 /* ǂ炩Ő͕ԂĂȂ */
	return ret;
	 /* return͎̂sꍇɌ 0errnoZbg͂ */
}

static	int	do_spawnvp(mode, cmd, av)
int	mode;
char	*cmd, **av;
{
	int	ret;

	ret = xspawnvp(mode, *av, av);
	if(errno == ENOENT) make_comspec(&av), ret = xspawnvp(mode, *av, av);
	return ret;
	 /* ret-1Ȃ玸s errno͐s𔽉flɃZbg */
}

static	int	try_exec(av)
char	**av;
{
	/* av[0] = COMSPEC, av[1] = "/C" */
	int	ret;

	ret = xspawnvp(P_WAIT, av[2], &av[2]);
#ifdef UX_COMPILE_TEST
	errno = ENOENT;
#endif
	 /* try 'av[2]'.bat */
	if(errno == ENOENT) ret = xspawnvp(P_WAIT, av[0], av);
			/* av[2] ݂ȂƂ ret == 0 Ԃ */
	return ret;
}

static	void	disp_cmd_line(av)
char	**av;
{
	while(*av != NULL){
		fputs(*av, stdout);
		putchar(*++av == NULL ? '\n' : ' ');
	}
}

static	enum {
	NORMAL,
	INT2EH,		/* -r */
	INDIRECT,	/* -@ */
	EACHARG,	/* -s */
	ARGPACK,	/* -m */
} xeqmode = NORMAL;
static	int	optnum = 0;		/* '-c num' option */
static	enum {
	NONE,
	MINUS_OPT,
	SLUSH_OPT,
} optcmode = NONE;
static	char	disp_only = 0;		/* -n option */
static	char	ign_err = 0;		/* -i option */
static	char	batmode = 0;		/* -b option */
static	char	*quote_args = NULL;
static	char	*ovwrfnm = NULL;

static	int	countcopt(i, ac, av)
int	i, ac;
char	*av[];
{
	char	*p;

	if(optcmode != NONE){	/**  '-c[-/]num' option  **/
		while(i < ac){
			p = av[i];
			if(!(p[0] == '-' && p[1] ||
			     p[0] == '/' && optcmode == SLUSH_OPT))
				break;
			++i;
			if(!strcmp("--", p)) break;
		}
	}
	return (i += optnum) >= ac ? ac : i;
}

/**  exec -s/-m option	**/
static	int	exec_multi(av)
char	**av; /* assumes that av terminates with NULL */
{
	int	ret = 0;
	int	argc, avi, j;
	int	len0;

	argc = make_comspec(&av); /* av[0] = COMSPEC, av[1] = "/C" */
	len0 = /* strlen(av[0]) + 1 + */ strlen(av[1]) + strlen(av[2]) + 2;

	avi = countcopt(3, argc, av);
	for(j = 3; j < avi; j++){
		len0 += strlen(av[j]) + 1;
	}
	while(avi < argc){
		int	argi, len;
		char	*save_arg;

		argi = avi;
		if(xeqmode == EACHARG){		/** -s **/
			argi++;
		} else {			/** -m **/
			for(len = len0; argi < argc; argi++){
				if(av[argi] == NULL) break;
				len += strlen(av[argi]) + 1;
				if(len >= 127) break;
			}
		}
		if(argi < argc){
			save_arg = av[argi];
			av[argi] = NULL;
		}
		if(disp_only){
			disp_cmd_line(av + 2);
			ret = 0;
		} else {
			ret = try_exec(av);
			if(ign_err ? (errno != EZERO) : ret)
				break;		/* some error */
		}
		av[argi] = save_arg;
		for(j = 0; j + argi <= argc; j++){
			av[j + avi] = av[j + argi];
		}
		argc -= argi - avi;
#ifndef UX_COMPILE_TEST
		while(kbhit()){
			if(getch() == 0x03){
				ret = -1;
				break;
			}
		}
#endif
		if(ret == -1) break;
	} /* while(avi < argc) */
	return ret;
}

static	char	*argquote(s, str)
char	*s, *str; /* s" "quotêԂBstrc'"'ɕϊ邩 */
{
	char	*p, *q, *r, need_dq;
	int	l, dq_count;

	need_dq = (char)!*s, dq_count = 0;
	for(p = s; *p; ++p){
		switch(*p){
		case '"':
			++dq_count, need_dq = 1;
			break;
		case '-': case PATH_SEP: case PATH_SEP1: case DRIVE_SEP:
		case '_': case '.':
#if 0
		case '$': /* used in tempfile name on DOS */
#endif /* u$envvL@T|[ĝߔp~ */
			break;
		default:
			if(iskanjipos(p)){
				++p; break;
			}
			if(is_alnum(*p)) break;
			need_dq = 1;
		}
	}
	if(!need_dq) return s;

	q = r = chk_malloc(strlen(s) + 3 + dq_count * ((l = strlen(str)) - 1));
	*q++ = '"';
	for(p = s; *p; ++p){
		if(*p == '"'){
			strcpy(q, str), q += l;
		} else {
			if(iskanjipos(p)) *q++ = *p++;
			*q++ = *p;
		}
	}
	*q = '"', *++q = '\0';
	return r;
}

static	void	usage_exit()
{
	_puterrmes("Usage: "), _puterrmes(cmdname);
	_puterrmes_cr(
		" [-e file] [-ar@sminbl] [-c [/-]num] [-q string] [-v file]");
	exit(-1);
}

 /* inbatp֐Q */
static	char	*spcpass(s)
char	*s;
{
	while(is_space(*s)) ++s;
	return s;
}

static	char	*wordafter(line, word, len)
 /* ŏlenwordƂŎn܂Ȃ㑱̔󔒁AłȂNULLԂ
    啶ʂȂ */
char	*line, *word;
int	len;
{
	return (kstrnicmp(line, word, len) ||
		*(line += len) && !is_space(*line)) ? NULL : spcpass(line);
}
#define strconstlen(s) (sizeof(s) - 1)
#define wordconstafter(line, word) wordafter((line), (word), strconstlen(word))

static	char	*inbatchk(s)
char	*s;
{
#define LBUFSIZ 512
	char	*p, *q, *r, *t, *buf, lbuf[LBUFSIZ];
	int	labellen;
	FILE	*f, *g;

	if(*(p = s) != INFILECHR) return s;
	if(*++p == INFILECHR) return ++s;

	for(q = p, ++q; *q != INFILECHR && *q; ++q) if(iskanjipos(q)) ++q;
	if(!*q) return s; else *q = '\0';
	labellen = strlen(++q);	/* p:t@C q:x */

	if(NULL == (f = batsearch(p, &buf))) noopen_exit(2, p);
	 else if(buf != NULL) p = buf;
	if(NULL == (g = open_tmpf())) notmpf_exit();
	 else r = tmpfnmbuf . name[tmpfnmbuf . used - 1];

	while(NULL != fgets(lbuf, LBUFSIZ, f)){
		if(*lbuf && (lbuf - 1)[strlen(lbuf)] != '\n') toolongl_exit(p);
		if(NULL == (t = wordconstafter(spcpass(lbuf), "goto")))
			continue;
		if(*t == REMCHR) ++t;
		if(NULL == wordafter(t, q, labellen)) continue;

		while(NULL != fgets(lbuf, LBUFSIZ, f)){
			if(*lbuf && (lbuf - 1)[strlen(lbuf)] != '\n')
				toolongl_exit(p);
			if(REMCHR == *(t = spcpass(lbuf)) &&
			   NULL != wordafter(spcpass(++t), q, labellen))
				break;
			fputs(lbuf, g);
		}
		break;
	}

	free(buf), fclose(f);
	if(0 != fclose(g)) nowrite_exit(g, TRUE);
	return r;
}

static	void	tmp2out(tmpfn, ofn)
char	*tmpfn, *ofn;
{
	FILE	*f, *g;
	int	c;

	nonshare_chk_unlink(ofn);
	if(0 == rename(tmpfn, ofn)){
		*tmpfn = '\0';
		return;
	}

	if(NULL == (f = fopen(tmpfn, "rb"))) ukerr_exit();
	if(NULL == (g = fopen(ofn, "wb"))){
		_cmdputerrmes(ofn), _puterrmes_cr(": Can't write"), exit(-1);
	}
	while(EOF != (c = getc(f))) putc(c, g);
	if(0 != fclose(g)) nowrite_exit(g, FALSE);
}

static	int	xeqmain(ac, av)
int	ac;
char	**av;
{
	int	ret, i, j;
	FILE	*indf;
	char	*tmpofn;

	if(ovwrfnm != NULL && !disp_only && xeqmode != INT2EH){
		close(1);
		if(NULL == reopen_tmpf(stdout)) notmpf_exit();
		tmpofn = tmpfnmbuf . name[tmpfnmbuf . used - 1];
	}

	switch(xeqmode){
	case INT2EH:
		if(disp_only){
			fputs("INT_2EH: ", stdout);
			disp_cmd_line(av);
			exit(0);
		}
		dexec(ac, av); /* ߂ĂȂ */
		 /* NOTREACHED */
	case INDIRECT:
		if((i = countcopt(1, ac, av)) >= ac) goto case_NORMAL;

		if(NULL == (indf = open_tmpf())) notmpf_exit();
		for(j = i; j < ac; ++j) fputs(av[j], indf), putc('\n', indf);
		if(0 != fclose(indf)) nowrite_exit(indf, TRUE);

		 /* avmain()nꂽ́BĂxȂ͂(tools
		    ̓WJroutineŎOmalloc̃GAɃZbgĂ邩) */
		av[i] = chk_strdupcat("@", tmpfnmbuf.name[tmpfnmbuf.used - 1]);
		av[++i] = NULL; /* tools̓WJroutineav[ac]݂̑ۏ؁B
		  㒼ڔ̂av[i]free͕KvȂ */
		if(disp_only) disp_cmd_line(av), exit(0);

		ret = xspawnvp(P_WAIT, *av, av);
		if(errno == ENOENT){
		 /* ob`u@filenamevƂ󂯕t\ɂ
		    Ă\lcommand.comł̎s
		    㒼ڔ̂tmpavfree͕KvȂ */
			char	**tmpav;

			tmpav = chk_malloc(sizeof(char *) * (i + 3));
			shell_arg(tmpav, av, i);
			ret = xspawnvp(P_WAIT, *tmpav, tmpav);
		}
		break;
	case NORMAL:
	case_NORMAL:
		if(disp_only){
			disp_cmd_line(av), exit(0);
		}
		if(ovwrfnm == NULL){
			ret = do_execvp(*av, av); /* ͕ԂĂȂ */
		} else {
			ret = do_spawnvp(P_WAIT, *av, av);
		}
		if(errno == E2BIG) toolonga_exit();
		break;
	default: /* -s/-m option */
		ret = exec_multi(av);
		if(disp_only) exit(0);
	}

	 /* xeqmode == INT2EHdisp_only̏ꍇ͂ɂ͗Ȃ */
	switch(ret){
	case -1:
		_cmdputerrmes(conv_to_unix_format(*av));
		_puterrmes_cr(": Exec failed.");
		break;
	case 0:
		if(ovwrfnm != NULL){
			if(0 != fclose(stdout)) nowrite_exit(stdout, TRUE);
			tmp2out(tmpofn, ovwrfnm);
		}
	}
	return ret;
}

main(ac, av)
int	ac;
char	*av[];
{
	int	fd, c, i;
	char	addmode = 0;
	char	*stderrfnm = NULL;
	extern	int	optind, opterr;
	extern	char	*optarg;

#ifdef EXPLICIT_EXPARG
	ac = expand_arg(av[0], get_psp_arg(), &av);
#endif
#ifndef MSDOS
	setcmdname(av[0]);
#endif

	opterr = 0;
	if(SIG_IGN != signal(SIGINT, SIG_IGN)) signal(SIGINT, rmtmpf_exit);
	 /* SIG_IGÑ`FbN͔Ô */
	atexit(rm_tmpf); /* G[`FbNĂȂc܂ */

	while(EOF != (c = getopt(ac, av, "larsmc:nie:v:@q:b"))){
		cswitch(c){
		case 'a':
			addmode = 1;
			break;
		case 'e':
			stderrfnm = optarg;
			break;
		case 'v':
			ovwrfnm = optarg;
			break;
		case 'r':
			xeqmode = INT2EH;
			break;
		case '@':
			xeqmode = INDIRECT;
			break;
		case 's':
			xeqmode = EACHARG;
			break;
		case 'm':
			xeqmode = ARGPACK;
			break;
		case 'n':
			disp_only = 1;
			break;
		case 'i':
			ign_err ^= 1;
			break;
		case 'c':
			switch(*optarg++){
			case '-':
				optcmode = MINUS_OPT; break;
			case '/':
				optcmode = SLUSH_OPT; break;
			default:
				optcmode = NONE, --optarg;
			}
			optnum = atoi(optarg);
			break;
		case 'q':
			if('0' <= *optarg && *optarg <= '2' && !optarg[1]){
				static	char	*defquo[ ] = {
					"\"'q\"", "^\"", "\\\"",
				};

				quote_args = defquo[*optarg - '0'];
			} else quote_args = optarg;
			break;
		case 'b':
			batmode = 1;
			break;
		case 'l':
#ifdef SUPP_LFN
			_norestore21_onexec = 1;
#endif
			break;
		default: /* 'h' 'H'܂ */
			usage_exit();
		}
	}

	for(ac -= optind, av += optind;
	    ac && strchr(*av, '=') != NULL; --ac, ++av){
		if(putenv(*av) != 0){
			_cmdputerrmes(*av), _puterrmes_cr(": Can't putenv.");
			exit(-1);
		}
	} /* Ȍputenv()͂Ȃ */
	if(!ac){
		usage_exit();
	}

	if(stderrfnm != NULL){
		if(-1 == (fd = dup(2))){
			_cmdputerrmes_cr("Can't dup stderr.");
			exit(-1);
		}
		close(2);

		if(*stderrfnm == '-' && !stderrfnm[1]){
			if(2 != dup(1)){
				writetext(fd, "Can't dup stdout.\n");
				close(fd), exit(-1);
			}
		} else {
			if(2 != open(stderrfnm, O_WRONLY | O_CREAT |
				     (addmode? O_APPEND : O_TRUNC), 0644) ||
			   !isatty(2) && -1L == lseek(2, 0L, 2)/*Why*/)
				noopen_exit(fd, stderrfnm);
		}

		close(fd);
	}

	if(!stricmp("exit", *av)){ /* ʈ */
		if(disp_only){
			if(av[1] != NULL) av[2] = NULL; /* xȂ͂ */
			disp_cmd_line(av);
			exit(0);
		}
		exit(--ac ? atoi(av[1]) : 0);
	}

	 /* av͎̏xȂ͂Btools̓WJ[`
	    Omalloc̃GAɃZbgĂ񂾂 */
	if(batmode){
		for(i = 1; i < ac; ++i) av[i] = inbatchk(av[i]);
	}
	if(NULL != quote_args){
		for(i = 1; i < ac; ++i) av[i] = argquote(av[i], quote_args);
	}

	i = xeqmain(ac, av);
	if(0 != fclose(stderr)) nowrite_exit(stderr, FALSE);
	return i;
}
